 ; Ŀ
 ;   ABC - Put text entities in alphabetical order (vertically).           
 ;   Copyright 1991, 2002, 2018 by Rocket Software Ltd.                    
 ;   Give hindsight the leverage it needs.                                 
 ; 

 ; Ŀ
 ;   Locar - find the string with the lowest character at position Pos.    
 ;   Check each string, compare its substr pos character to the previous   
 ;   one. If it's lower, it becomes the new first one.                     
 ;   Optionally Strcase the comparison characters so it's not case         
 ;   sensitive.                                                            
 ;   Arguments: Listr, a list of strings.                                  
 ;              Pos, the compare position.                                 
 ;              Casa, T = case sensitive, nil = not.                       
 ;   Returns a list: (Lowest_string  Rest_of_list)                         
 ;   Note that a list may contain duplicate strings.                       
 ;   Will crash on an empty list.                                          
 ;   ("aaa") returns ("aaa" nil), which is what it should.                 
 ; 
 (defun locar (listr pos casa / num suba chra iowa curchr)
  (setq num 0)
  (while (setq suba (nth num listr))
         (setq num (1+ num))
         (setq chra (substr suba pos 1))
         (if casa (setq chra (strcase chra)))
         (if (or (null curchr)
                 (< chra curchr))
             (progn
                  (setq iowa suba)
                  (setq curchr chra))))
  (setq listr (remove iowa listr))
 (list iowa listr))
 ; Ŀ
 ;   Locar end.                                                            
 ; 

 ; Ŀ
 ;   Remove - remove the first occurrence of an element from a list.       
 ;   Arguments: Remora, the element to remove.                             
 ;              Lista, a list.                                             
 ;   Returns a list, without Remora if it was found.                       
 ; 
 (DEFUN REMOVE (remora lista / suba gnu)
  (while (setq suba (car lista))
         (setq lista (cdr lista))
         (if (equal suba remora)
             (progn
                  (setq gnu (append gnu lista))
                  (setq lista ()))
             (setq gnu (append gnu (list suba)))))
 gnu)
 ; Ŀ
 ;   Remove end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Tize - alphabetize a list of strings.                      
 ;   Arguments: Strlis, a list of strings.                                 
 ;              Pos, the 1 based substring position, for recursion.        
 ;                   This should be 1.                                     
 ;              Casa, Case sensitive - t or nil.                           
 ;   Calls Locar.                                                          
 ;   Recursive (2x).                                                       
 ;   Returns an ordered list.                                              
 ; 
 (DEFUN TIZE (strlis pos casa / strls0 curr suba chra gnu lass lassa chra0)
  (setq strls0 strlis)
  (while (and strlis (setq curr (locar strlis pos casa)))
         (setq suba (car curr))                 ; 1st string
         (setq strlis (cadr curr))              ; save the rest back to strlis
         (setq chra (substr suba pos 1))        ; current index character
 ; Ŀ
 ;   If gnu is nil, make it from suba.                                     
 ; 
         (cond ((null gnu)
                (setq gnu (list suba)))
 ; Ŀ
 ;   If the index character is the same as the previous one, add suba to   
 ;   the last list in gnu.                                                 
 ; 
               ((equal chra0 chra)
                (setq gnu (reverse gnu))
                (setq lass (car gnu))
                (if (= (type lass) 'list)
                    (setq lass (append lass (list suba)))
                    (setq lass (list lass suba)))
                (setq gnu (reverse (cons lass (cdr gnu)))))
 ; Ŀ
 ;   If we're starting a new sublist gnu but the previous sublist had >1   
 ;   member, increment the index pos, and recurse to reorder it.           
 ; 
               ((and (not (equal chra0 chra))
                     (= (type (setq lassa (last gnu))) 'list))
                (setq lassa (tize lassa (1+ pos) casa))
                (setq gnu (reverse (cdr (reverse gnu))))
                (setq gnu (append gnu lassa))
                (setq gnu (append gnu (list suba))))
 ; Ŀ
 ;   Otherwise add suba to gnu.                                            
 ; 
               (t
                (setq gnu (append gnu (list suba)))))
         (setq chra0 chra))
 ; Ŀ
 ;   There still might be a sublist to append here ... or to recurse into. 
 ;   Can it be both?                                                       
 ; 
  (if (= (type (setq lassa (last gnu))) 'list)
      (progn
           (if (not (equal lassa strls0))
               (setq lassa (tize lassa (1+ pos) casa)))
           (setq gnu (reverse (cdr (reverse gnu))))
           (setq gnu (append gnu lassa))))
 gnu)
 ; Ŀ
 ;   Tize end.                                                             
 ; 

 ; Ŀ
 ;   ABC.                                                                  
 ; 
 (DEFUN C:ABC (/ ss ma lll lln num zz cc)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   Make a list of all text strings.                                      
 ; 
 ; Make a list of all text strings.
  (write-line "Select some text entities:")
  (setq ss (ssget (list (cons 0 "text"))))
  (setq num 0)
  (while (setq lll (ssname ss num))
         (setq lln (entget lll))
         (setq num (1+ num))
         (setq ma (cons (cdr (assoc 1 lln)) ma)))
 ; Ŀ
 ;   Sort the text list alphabetically.                                    
 ; 
  (setq ma (tize ma 1 t))
 ; Ŀ
 ;   Find the highest text insertion.                                      
 ; 
  (while (ssname ss 0)
         (setq num 0)
         (setq zz "(max ")
         (while (setq lll (ssname ss num))
                (setq lln (entget lll))
                (setq num (1+ num))
                (setq zz (strcat zz " " (rtos (caddr (assoc 10 lln)) 2 8))))
         (setq zz (strcat zz ")"))
         (setq hh (eval (read zz)))
 ; Ŀ
 ;   Find & modify the highest text.                                       
 ; 
         (setq num 0)
         (while (setq lll (ssname ss num))
                (setq lln (entget lll))
                (setq num (1+ num))
                (setq nn (caddr (assoc 10 lln)))
                (if (equal nn hh 0.000001)
                    (progn
                          (ssdel lll ss)
                          (setq cc (car ma))
                          (setq ma (cdr ma))
                          (entmod (subst (cons 1 cc) (assoc 1 lln) lln))))))
 (princ))