 ; Ŀ
 ;   Abcat - put blocks in alphabetical order vertically by the value      
 ;   of their first attribute.                                             
 ;   Copyright 1996, 2006, 2009, 2018 by Rocket Software Ltd.              
 ;   Palindrome spelled backwards isn't palindrome.                        
 ; 

 ; Ŀ
 ;   Abcerr - error handler.                                               
 ; 
 (DEFUN ABCERR (shk / pos entt enam sublst vall)
  (setq *error* esav)
  (if (/= shk "Function cancelled") (write-line shk))
 (princ))
 ; Ŀ
 ;   Abcerr end.                                                           
 ; 

 ; Ŀ
 ;   Kat - reinstall a list of attribute values into a set of blocks.      
 ;   Takes two arguments: the ordered list of blocks and the list of       
 ;   attribute value strings.  Returns the unused portion of the latter.   
 ; 
 (DEFUN KAT (ss straw / pos entt enam sublst vall)
 ; Ŀ
 ;   Order the Cbltag inserts by vertical position.                        
 ; 
           (setq ordlst (vtol ss "y" t))
           (setq num 0)
 ; Ŀ
 ;   Reinstall the data into the Cbltag inserts.                           
 ; 
           (while (and (setq str (car straw))
                       (setq esav (setq enam (nth num ordlst)))
                       (grtext -2 (itoa (setq num (1+ num)))))
                  (if (/= str "")
                      (progn
                           (setq straw (cdr straw))
                           (setq attlst (splat "|" str))
                           (setq attnum 0)
                           (while (/= (cdr (assoc 0 (setq entt (entget
                                      (setq enam (entnext enam)))))) "SEQEND")
                                  (setq newval (cons 1 (nth attnum attlst)))
                                  (setq attnum (1+ attnum))
                                  (entmod (subst newval (assoc 1 entt) entt)))
                           (entupd esav))))
 straw)
 ; Ŀ
 ;   Kat end.                                                              
 ; 

 ; Ŀ
 ;   Locar - find the string with the lowest character at position Pos.    
 ;   Check each string, compare its substr pos character to the previous   
 ;   one. If it's lower, it becomes the new first one.                     
 ;   Optionally Strcase the comparison characters so it's not case         
 ;   sensitive.                                                            
 ;   Arguments: Listr, a list of strings.                                  
 ;              Pos, the compare position.                                 
 ;              Casa, T = case sensitive, nil = not.                       
 ;   Returns a list: (Lowest_string  Rest_of_list)                         
 ;   Note that a list may contain duplicate strings.                       
 ;   Will crash on an empty list.                                          
 ;   ("aaa") returns ("aaa" nil), which is what it should.                 
 ; 
 (defun locar (listr pos casa / num suba chra iowa curchr)
  (setq num 0)
  (while (setq suba (nth num listr))
         (setq num (1+ num))
         (setq chra (substr suba pos 1))
         (if casa (setq chra (strcase chra)))
         (if (or (null curchr)
                 (< chra curchr))
             (progn
                  (setq iowa suba)
                  (setq curchr chra))))
  (setq listr (remove iowa listr))
 (list iowa listr))
 ; Ŀ
 ;   Locar end.                                                            
 ; 

 ; Ŀ
 ;   Spit - returns the insertion point of the text entity whose data was  
 ;   passed as its sole argument.  Note that this is not necessarily the   
 ;   same as the 10 association code.                                      
 ; 
 (DEFUN SPIT (entt / xjust yjust)
  (setq xjust (cdr (assoc 72 entt)))
  (if (= (cdr (assoc 0 entt)) "ATTDEF")
      (setq yjust (cdr (assoc 74 entt)))
      (setq yjust (cdr (assoc 73 entt))))
  (if (or (/= xjust 0) (/= yjust 0))
      (cdr (assoc 11 entt))
      (cdr (assoc 10 entt))))
 ; Ŀ
 ;   Spit end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Splat - divide a text string into a list of substrings.    
 ;   Arguments: Sepchr, the field separator character.                     
 ;              Linn, the text string.                                     
 ;   Returns a list of field values, removes leading and trailing spaces.  
 ;                                                                         
 ;   Completely rewritten 11.19.2000.                                      
 ; 
 (DEFUN SPLAT (sepchr linn / pos len name1 strlst)
  (while (/= (strlen linn) 0)
 ; Ŀ
 ;   Find the first separator character, save everything before it into    
 ;   the Name1 variable, remove it from the start of the string Linn.      
 ; 
         (setq pos 1)
         (setq len (strlen linn))
         (while (and (/= (substr linn pos 1) sepchr)
                     (>= len pos))
                (setq pos (1+ pos)))
         (setq name1 (substr linn 1 (1- pos)))
         (setq linn (substr linn (1+ pos)))
 ; Ŀ
 ;   Remove spaces from the front and back of Name1.                       
 ; 
         (while (and (> (strlen name1) 0)
                     (= (substr name1 (setq len (strlen name1))) " "))
                (setq name1 (substr name1 1 (1- len))))
         (while (and (> (strlen name1) 0)
                     (= (substr name1 1 1) " "))
                (setq name1 (substr name1 2)))
 ; Ŀ
 ;   Add Name1 to the substring list Strlst.                               
 ; 
         (setq strlst (append strlst (list name1))))
 ; Ŀ
 ;   If the string contained no separator characters then Strlst will be   
 ;   nil, so return a list containing the original string.                 
 ; 
  (if (null strlst) (setq strlst (list linn)))
 strlst)
 ; Ŀ
 ;   Splat end.                                                            
 ; 

 ; Ŀ
 ;   Remove - remove the first occurrence of an element from a list.       
 ;   Arguments: Remora, the element to remove.                             
 ;              Lista, a list.                                             
 ;   Returns a list, without Remora if it was found.                       
 ; 
 (DEFUN REMOVE (remora lista / suba gnu)
  (while (setq suba (car lista))
         (setq lista (cdr lista))
         (if (equal suba remora)
             (progn
                  (setq gnu (append gnu lista))
                  (setq lista ()))
             (setq gnu (append gnu (list suba)))))
 gnu)
 ; Ŀ
 ;   Remove end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Tize - alphabetize a list of strings.                      
 ;   Arguments: Strlis, a list of strings.                                 
 ;              Pos, the 1 based substring position, for recursion.        
 ;                   This should be 1.                                     
 ;              Casa, Case sensitive - t or nil.                           
 ;   Calls Locar.                                                          
 ;   Recursive (2x).                                                       
 ;   Returns an ordered list.                                              
 ; 
 (DEFUN TIZE (strlis pos casa / strls0 curr suba chra gnu lass lassa chra0)
  (setq strls0 strlis)
  (while (and strlis (setq curr (locar strlis pos casa)))
         (setq suba (car curr))                 ; 1st string
         (setq strlis (cadr curr))              ; save the rest back to strlis
         (setq chra (substr suba pos 1))        ; current index character
 ; Ŀ
 ;   If gnu is nil, make it from suba.                                     
 ; 
         (cond ((null gnu)
                (setq gnu (list suba)))
 ; Ŀ
 ;   If the index character is the same as the previous one, add suba to   
 ;   the last list in gnu.                                                 
 ; 
               ((equal chra0 chra)
                (setq gnu (reverse gnu))
                (setq lass (car gnu))
                (if (= (type lass) 'list)
                    (setq lass (append lass (list suba)))
                    (setq lass (list lass suba)))
                (setq gnu (reverse (cons lass (cdr gnu)))))
 ; Ŀ
 ;   If we're starting a new sublist gnu but the previous sublist had >1   
 ;   member, increment the index pos, and recurse to reorder it.           
 ; 
               ((and (not (equal chra0 chra))
                     (= (type (setq lassa (last gnu))) 'list))
                (setq lassa (tize lassa (1+ pos) casa))
                (setq gnu (reverse (cdr (reverse gnu))))
                (setq gnu (append gnu lassa))
                (setq gnu (append gnu (list suba))))
 ; Ŀ
 ;   Otherwise add suba to gnu.                                            
 ; 
               (t
                (setq gnu (append gnu (list suba)))))
         (setq chra0 chra))
 ; Ŀ
 ;   There still might be a sublist to append here ... or to recurse into. 
 ;   Can it be both?                                                       
 ; 
  (if (= (type (setq lassa (last gnu))) 'list)
      (progn
           (if (not (equal lassa strls0))
               (setq lassa (tize lassa (1+ pos) casa)))
           (setq gnu (reverse (cdr (reverse gnu))))
           (setq gnu (append gnu lassa))))
 gnu)
 ; Ŀ
 ;   Tize end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Vtol: returns a list of enames ordered entity position.    
 ;   Arguments: Ss, a selection set of entities to order.                  
 ;              Dir, a direction - if this is either "X" or "Y" then the   
 ;                   entities are assumed to be arrayed in that direction, 
 ;                   if anything else then the routine uses the direction  
 ;                   in which they are most spread out.                    
 ;              Insa, if T and the entity is text or an attribute then     
 ;                    sort based on the insertion point rather than the    
 ;                    ten point.                                           
 ;                                                                         
 ;   This is the latest version: 2006.10.05, which sorts text by           
 ;   insertion point rather than ten point and in which setting the        
 ;   direction to nil doesn't cause a crash.                               
 ;   Also it works with attdefs as well as text.                           
 ;   It should replace all other uses of Vtol and Stol.                    
 ;                                                                         
 ;   Revamped 2009.07.28 to use Apply rather than Eval Cons 'Max List etc. 
 ;   This is less elegant but removes the 256 entity limitation.           
 ;   Also added the ability to sort by either ten point or insertion.      
 ;                                                                         
 ; 
 (DEFUN VTOL (ss dir insa / xposnam yposnam numm ent entt ten xpos ypos xx yy
                            pn maxx minx maxy miny xdif ydif poslst posnam
                                                       direct pos lastt order)
  (setq xposnam ())                      ; initialize (xpos & name list) list
  (setq yposnam ())                      ; initialize (ypos & name list) list
 ; Ŀ
 ;   Now see if the entities are arranged horizontally or vertically.      
 ; 
  (setq numm 0)                             ; start at the ss beginning again
  (while (setq ent (ssname ss numm))
         (setq entt (entget ent))
         (if (and insa (member (cdr (assoc 0 entt)) '("TEXT" "ATTDEF")))
             (setq ten (spit entt))
             (setq ten (cdr (assoc 10 entt))))
         (setq xpos (car ten))
         (setq ypos (cadr ten))
         (setq xx (append xx (list xpos)))  ; add x insert to list
         (setq yy (append yy (list ypos)))  ; and y to y list
 ; Ŀ
 ;   Also make the position and name list.  Have to make one for the X     
 ;   values and one for the Ys and use the appropriate one later.          
 ; 
         (setq pn (cons xpos ent))
         (setq xposnam (append xposnam (list pn)))
         (setq pn (cons ypos ent))
         (setq yposnam (append yposnam (list pn)))
         (setq numm (1+ numm)))             ; next entity
 ; Ŀ
 ;   Now evaluate the four lists.  The result will be the max and min      
 ;   values for the X and Y lists.                                         
 ; 
  (setq maxx (apply 'max xx))
  (setq minx (apply 'min xx))
  (setq maxy (apply 'max yy))
  (setq miny (apply 'min yy))
  (setq xdif (- maxx minx))
  (setq ydif (- maxy miny))
 ; Ŀ
 ;   Set direction variables to match whichever direction was given in     
 ;   the argument, if it was nil then deduce a direction.                  
 ; 
  (cond ((and (= (type dir) 'STR)
              (= (strcase dir) "X"))
          (setq poslst xx)                ; positions from X coord list
          (setq posnam xposnam)           ; position & ename list with X coord
          (setq direct 'min))             ; edit from smallest to largest X
        ((and (= (type dir) 'STR)
              (= (strcase dir) "Y"))
         (setq poslst yy)
         (setq posnam yposnam)
         (setq direct 'max))
        (T
 ; Ŀ
 ;   The default case: figure it out yourself.                             
 ;   Set vert to T if vertical, nil if horizontal.                         
 ;   If not sure, assume vertical.                                         
 ;   Could set strip to Quit and thus do so...                             
 ; 
         (cond ((> xdif ydif)             ; if (Xmax - Xmin) > (Ymax - Ymin)
                (setq poslst xx)          ; positions from X coord list
                (setq posnam xposnam)     ; position & ename list with X coord
                (setq direct 'min))       ; edit from smallest to largest X
               ((< xdif ydif)
                (setq poslst yy)
                (setq posnam yposnam)
                (setq direct 'max))
               (T                         ; if not sure then call it vertical
                (setq poslst yy)
                (setq posnam yposnam)
                (setq direct 'max)))))
 ; Ŀ
 ;   Now make the list of enames in order by increasing X or decreasing Y  
 ;   coordinate depending on whether the array is horizontal or vertical.  
 ;   Already Have Posnam: a list of (list position ename).                 
 ;   Using the original list of either x or y positions, get the first or  
 ;   last as appropriate, extract the ename from Posnam using              
 ;   (cdr (assoc (largest Y or smallest X) posnam))                        
 ;   and append the ename to the end of the enames in order list: Order.   
 ;   Then remove that position from the position list.                     
 ; 
  (while (> (length poslst) 0)
 ; Ŀ
 ;   Get the largest Y or smallest X value in the position list.           
 ; 
         (setq maxx (apply direct poslst))
 ; Ŀ
 ;   Having found Maxx, want to remove that value from poslst.             
 ;   Get the list from Maxx on, and the position of Maxx within the list.  
 ; 
         (setq pos (- (length poslst)
                      (length (setq lastt (member maxx poslst)))))
 ; Ŀ
 ;   Get the list after maxx.                                              
 ; 
         (setq lastt (cdr lastt))
 ; Ŀ
 ;   And add the list members before maxx.                                 
 ;   One could use (cdr (member (reverse poslist))) but if there were two  
 ;   values the same in the list this would result in a longer rather      
 ;   than a shorter poslist.                                               
 ; 
         (setq pos (1- pos))     ; subtract one: nth is zero based
         (while (>= pos 0)
                (setq lastt (append (list (nth pos poslst)) lastt))
                (setq pos (1- pos)))
         (setq poslst lastt)      ; poslst becomes lastt
 ; Ŀ
 ;   Now get the matching ename from posnam and add it to the end of the   
 ;   order list.                                                           
 ; 
         (setq order (append order (list (cdr (assoc maxx posnam)))))
 ; Ŀ
 ;   If there are two entities with the same position then assoc will      
 ;   always return the first one.  Must delete the first one each time -   
 ;   subst (nil) for it.                                                   
 ; 
         (setq posnam (subst (list nil) (assoc maxx posnam) posnam)))
 order)
 ; Ŀ
 ;   Vtol end.                                                             
 ; 

 ; Ŀ
 ;   Abcat - one of the few with stomach muscles.                          
 ; 
 (DEFUN C:ABCAT (/ esav *error* ss num enam attstr entt attval strlst straw
                                            ordlst str attlst attnum newval)
  (setq esav *error*)                    ; save the previous error handler
  (setq *error* abcerr)                  ; and install the new one
  (if (setq ss (ssget (list (cons 0 "INSERT"))))
      (progn
           (setq num 0)
           (while (setq esav (setq enam (ssname ss num)))
                  (setq attstr "")
                  (grtext -2 (itoa (setq num (1+ num))))
                  (while (/= (cdr (assoc 0 (setq entt (entget (setq enam
                                                  (entnext enam)))))) "SEQEND")
                         (setq attval (cdr (assoc 1 entt)))
                         (setq attstr (strcat attstr attval "|")))
                  (if (= attstr "||||||||||||||")
                      (entdel esav)
                      (setq strlst (append strlst (list attstr)))))))
 ; Ŀ
 ;   Now have a list of values from the block insertions, alphabetise it.  
 ; 
  (setq straw (tize strlst 1 nil))
 ; Ŀ
 ;   Refill the blocks.                                                    
 ; 
  (setq straw (kat ss straw))
  (if (> (length straw) 0)
      (write-line "*** Warning: excess data - blocks lost."))
  (setq *error* esav)
 (princ))