 ; Ŀ
 ;   Acad2.lsp - secondary lisp load file.                                 
 ;   Copyright 1993-2017 by Rocket Software Ltd.                           
 ;   Rocket: Software that works, for people who'd rather not.             
 ; 

 ; Ŀ
 ;   Timer end and display: load and then initialize.                      
 ; 
 (DEFUN CT1 ()
  (setq s (getvar "date"))
  (setq t2 (* 86400.0 (- s (fix s))))
  (write-line (setq te (strcat "\nRocket load time: "
                                (rtos (- t2 t1) 2 1) " seconds.")))
 (princ))

 ; Ŀ
 ;   Rload preloads lisp files to allow them to be loaded as required      
 ;   without wasting an inordinate amount of time.                         
 ;   Loading rload turns off load logging, loading rloadt turns it on.     
 ; 
;(lawn "rload" ())                  ; load but don't run
(lawn "rloadt" ())                  ; load but don't run
 ; Ŀ
 ;   Each routine included with Rocketcad is listed below, with a brief    
 ;   description.  A few are commented out, if you wish to preload one     
 ;   then remove the semicolon from the beginning of that line.            
 ; 
(rload "~"       '("~"))         ; line break symbol installer
(rload "19"      '("19"))        ; pipe break installer
(rload "99"      '("99"))        ; plot from data in the block 99
(rload "3t"      '("3t"))        ; make a stack of text into one line
(rload "abc"     '("abc"))       ; alphabetise text vertically
(rload "abg"     '("abg"))       ; renumber text in sets with suffixes
(rload "above"   '("above"))     ; add text above an existing entity
(rload "ac"      '("ac"))        ; copy attribute values from block to block
(rload "acla"    '("acla"))      ; area class generator
(rload "addtext" '("addtext"))   ; add text below an existing entity
;(rload "asc"     '("asc"))      ; import an ascii art file
(rload "atcase"  '("atcase"))    ; change attr. prompt strings to lower case
(rload "attinc"  '("attinc"))    ; incr one or all att vals in selected blocks
(rload "axe"     '("axe"))       ; text last/first word add/remove
(rload "ba"      '("ba"))        ; last letter a/b toggle
(rload "ball"    '("ball"))      ; search and replace Bom tag numbers
(rload "bar"     '("bar"))       ; scale bar inserter
(rload "beaker" '("beaker" "txkill")) ; erase invisible and useless crap
(rload "bean"    '("bean"))      ; sequentially renumber blocks or text
(rload "bf"      '("bf"))        ; break utility - snap control, first point
(rload "bfg"     '("bfg"))       ; remove big fonts from text styles
(rload "bic"     '("bic"))       ; insert lights by rows and columns
(rload "bingo"   '("bingo"))     ; rotate text 180 around centre point
;(rload "bisk"   '("bisk"))      ; remove a block from other blocks
(rload "bk"      '("bk"))        ; draw a break line
(rload "black"   '("black"))     ; colour everything in the drawing white
(rload "blam"    '("blam"))      ; explode a block, replace atts with text
(rload "bldg"    '("bldg"))      ; make a cut-and-fold building
(rload "bliz"    '("bliz"))      ; mark everything with snowflakes
(rload "blockout" '("blockout")) ; wblock all blocks in a drawing
(rload "blora" '("blora" "blor")); vertically reshuffle block insertions
(rload "blunt"   '("blunt"))     ; update all of one block, no options
(rload "blur"    '("blur"))      ; replace all inserts of a block w. another
(rload "blurss"  '("blurss"))    ; block replace, only selected blocks
(rload "boo"     '("boo"))       ; zoom previous, mark original view
(rload "bock"    '("bock"))      ; cloud text and/or attributes in blocks
(rload "bolt" '("bolt" "salt" "blot" "blit")) ; make lightning bolts
(rload "bomb"    '("bomb"))      ; rotate text/atts 180 round common centre
(rload "bomin"   '("bomin"))     ; suck a csv into BOM blocks
(rload "bounce"  '("bounce"))    ; purge a drawing down to the bare metal
(rload "box"     '("box"))       ; draw a box, allows drag or measurements
(rload "boxer"   '("boxer"))     ; put ascii boxes around code comments
(rload "bp"      '("bp"))        ; bind permalta if it is an xref
(rload "brac"    '("brac"))      ; draw a bracket
(rload "bracket" '("bracket"))   ; draw a bracket on the end of two lines
(rload "brat"    '("brat"))      ; derotate attributes in all of one block
(rload "brot"    '("brot"))      ; rotate all of one block type 180
(rload "bsa"     '("bsa"))       ; beaker, splurge, audit
(rload "btray"   '("btray"))     ; draw and hatch a straight tray section
(rload "bullet"  '("bullet"))    ; suck data from all of one block to a .cdf
 ; Ŀ
 ;   Bungee saves layer settings to an internal list and a data file,      
 ;   Splash restores them from the list and Flash restores them from the   
 ;   external data file.                                                   
 ; 
(rload "bungee"  '("bungee" "splash" "flash"))
(rload "c"       '("c"))         ; enhanced copy
(rload "ca"      '("ca"))        ; continue an existing arc, either direction
(rload "cable"   '("cable"))     ; import a .csv into a cable schedule
(rload "candy"   '("candy"))     ; suck any .csv into any blocks
(rload "cat"     '("cat"))       ; convert loose attdefs to text
(rload "centre"  '("centre"))    ; centre justify a text entity
(rload "cf"      '("cf"))        ; vertically rearrange text in a box
(rload "cdat"    '("cdat"))      ; update existing blocks from a .csv file
(rload "chall"   '("chall"))     ; text search and replace for drawings
(rload "chart"   '("chart"))     ; make a chart from a text file
(rload "chat"    '("chat"))      ; explode and reblock an insert
(rload "chg"     '("chg"))       ; directly modify entity data
(rload "chgtext" '("chgtext"))   ; everybody's favourite
(rload "clk"     '("clk"))       ; simple clock maker
(rload "cls"     '("cls"))       ; like Dos
(rload "cm" '("cb" "cbn" "cm" "cmr" "cn" "cs" "cx")) ; cloud makers
(rload "cma"     '("cma"))       ; flatter cloud maker
(rload "curl"    '("curl"))      ; move entities to current layer
(rload "coil"    '("coil"))      ; coil and tape block/text inserter
(rload "cols"    '("cols"))      ; change entities to colour of selected one
(rload "cr"      '("cr"))        ; circle repair - make an arc into a circle
(rload "crab"    '("crab"))      ; realign a line and two blocks
(rload "crypt"   '("crypt"))     ; encryptor
(rload "csv"     '("csv"))       ; import csv/cdf into loose text entities
(rload "curl"    '("curl"))      ; move entities to the current layer
(rload "cw"      '("cw"))        ; rewidth cloud polylines
(rload "cyl"     '("cyl"))       ; 2D cylinder maker
(rload "dart"    '("dart"))      ; derotate all of one type of block
;(rload "daub"    '("daub"))     ; make a lisp to copy dimvars from dwg to dwg
(rload "dc"      '("dc"))        ; dcl (dialogue box) file editor
(rload "ddd"     '("ddd" "dddd")); swap empty att. values with "..."
(rload "ddx"     '("ddx"))       ; select text/attdef, use matching editor
(rload "dent"    '("dent"))      ; search and replace block/attr. prompts
(rload "deep"    '("deep"))      ; direct text edit with dialog box
(rload "derot"   '("derot"))     ; derotate - doesn't work on circles
;(rload "descale" '("descale"))   ; descale a drawing
(rload "detitle" '("detitle"))   ; insert a detail tag
(rload "dg"      '("dg"))        ; destroy all groups containing an entity
 ; Ŀ
 ;   Diaper: search & replace layer names.                                 
 ;   Lance: convert all layer names to upper/lowercase.                    
 ; 
(rload "diaper"  '("diaper" "lance"))
(rload "dif"     '("dif" "tl"))  ; measure distances, running total, temp lines
(rload "dimf"    '("dimf"))      ; restore the default text in a dimension
(rload "dimp"    '("dimp"))      ; change dimension leg endpoints
(rload "dm"      '("dm"))        ; remove a mask from text, kill the group
(rload "dn"      '("dn"))        ; show nesting for a block
(rload "dna"     '("dna"))       ; show nesting for all blocks
(rload "dogbite" '("dogbite"))   ; chop around a circular block
(rload "doglite" '("doglite"))   ; chop around a light block
(rload "doon"    '("doon"))      ; install a conduit down symbol
(rload "door"    '("door"))      ; install a door
(rload "drawlist" '("drawlist")) ; suck a .csv file into a drawing list dwg
(rload "dread"   '("dread" "mf")); erase/fix the _Redline_ layer
(rload "dtr"     '("dtr"))       ; make stacks of blocks (mostly terminals)
(rload "du"      '("du"))        ; write a block updater lisp
(rload "duck"    '("duck"))      ; erase duplicate superimposed text
(rload "dul"     '("dul" "ul"))  ; remove or add underlining
(rload "dupe"    '("dupe"))      ; find duplicate text strings
(rload "dx"      '("dx"))        ; remove overrides from dimensions
(rload "earth"   '("earth"))     ; draw an earth sized circle
(rload "ecen"    '("ecen"))      ; horizontally centre an ss of entities
;(rload "emu"     '("emu"))      ; write a lisp to make selected entities
(rload "eno"     '("eno"))       ; text to incr. numbers with pre & suffix
(rload "end"     '("end"))       ; replaces the discontinued command
(rload "elsp"    '("elsp"))      ; spiral: ellipt./circ., straight/expon.
(rload "epi"     '("epi"))       ; epicycle generator
(rload "exget"   '("exget"))     ; get extended entity data, other utils
(rload "extro"   '("extro"))     ; extract selected text to a file
(rload "ezlay"   '("ezlay"))     ; same as Reptile, see below
(rload "ezo"     '("ezo"))       ; move block subentities to layer 0
(rload "fand"    '("fand"))      ; text search - see also chall
(rload "fang"    '("fang"))      ; vampiric script file write and run
(rload "fbt"     '("fbt"))       ; find text and blocks which are upside down
(rload "fibl"    '("fibl"))      ; find block by name or all blocks
(rload "filo"    '("filo"))      ; write ent. data to a file - see also Lox
(rload "filk"    '("filk"))      ; search & replace the last char in ss
(rload "filthy"  '("filthy"))    ; mark insertions of any or all entities
(rload "ffind"   '("ffind"))     ; find files in the acad search path
(rload "fint"    '("fint"))      ; find entities by insertion point
(rload "fifty"   '("fifty"))     ; increment line numbers etc. - whole dwg.
(rload "firk"    '("firk"))      ; search & replace the first char in ss
(rload "fist"    '("fist"))      ; list styles, font files, block fonts etc.
(rload "fixwit"  '("fixwit"))    ; find and optionally fix overly-wide text
(rload "flame"   '("flame"))     ; select layers, freeze others, or thaw all
(rload "flat"    '("flat"))      ; remove elevation from entities
(rload "flay"    '("flay"))      ; freeze all layers except the selected one
(rload "flip"    '("flip"))      ; flip single/double sided wire tag
(rload "flood"   '("flood"))     ; floodlight maker
(rload "fluke"   '("fluke"))     ; chop around text/attributes
(rload "front"   '("front" "fronts")) ; bring an entity to the front
(rload "gc"      '("ga" "gc"))   ; install a ground arc or line
(rload "get"     '("get"))       ; get entity data listing
(rload "gepta"   '("gepta"))     ; insert a terminal block, save ins point
(rload "getq"    '("getq"))      ; extract variables from a routine
(rload "gnd"     '("gnd"))       ; put a ground grid around a building
(rload "gostak"  '("gostak"))    ; suck a stack of text into text or blocks
(rload "gouge"   '("gouge"))     ; extract block subentity data
(rload "gox"     '("gox"))       ; open an xref - sets SDI to 0
(rload "gr"      '("gr"))        ; find groups to which an entity belongs
(rload "grak"    '("grak"))      ; explode all groups
(rload "grayat"  '("grayat" "gray" "oc")) ; gray attributs/everything/un-gray
(rload "gremp"   '("gremp"))     ; destroy all empty groups
(rload "grl"     '("grl"))       ; select entity, change its layer to grey
(rload "ground"  '("ground"))    ; insert a ground symbol, ideally on a line
(rload "grpid"   '("grpid"))     ; count, highlight and list all groups
(rload "gyc"     '("gyc" "gy"))  ; centre selected entities in a box
(rload "hatch"   '("slatch" "xhatch" "thatch")) ; hatch installers
(rload "hd"      '("hd"))        ; disassociate a hatch
(rload "hl"      '("hl"))        ; hatch last entity created (typ. a cloud)
(rload "hose"    '("hose"))      ; replace solids with hatches
(rload "hoss"    '("hoss"))      ; make an index drawing of a dir of dwgs
(rload "ht"      '("ht"))        ; change selected text height
(rload "hvb"     '("hvb"))       ; move/rejustify text along a horiz line
(rload "idle"    '("idle"))      ; remove all rev clouds and blocks
(rload "igloo"   '("igloo"))     ; draw a line in mspace from points in ps
 ; Ŀ
 ;   Inc: increment the first number in a selected text string.            
 ;   Ink: increment all numbers in all selected text strings and blocks.   
 ;   Dec: decrement the first number in a selected text string.            
 ;   Dek: decrement all numbers in all selected text strings and blocks.   
 ; 
(rload "inc"     '("inc" "ink" "dec" "dek"))
(rload "incend"  '("incend"))    ; insert a block on the end of a line/pline
(rload "inf"     '("inf"))       ; print useful information about the dwg
(rload "ins"     '("ins"))       ; simple insulation maker
(rload "insu"    '("insu"))      ; insulation maker
(rload "intbreak" '("intbreak" "ib")) ; break a line at two intersections
(rload "irg"     '("irg"))       ; regen one or more entities or screen
(rload "j"       '("j"))         ; join lines/plines into one pline
(rload "jumper"  '("jumper"))    ; install a jumper on terminal blocks
(rload "junc"    '("junc"))      ; make a junction box
(rload "kibl"    '("kibl"))      ; erase all insertions of one block type
(rload "klat"    '("klat"))      ; turn off a selected attribute
(rload "klob"    '("klob"))      ; erase overlap in 2 sets of cabletags
(rload "klim"    '("klim"))      ; remove all images from the drawing
(rload "ladd"    '("ladd"))      ; make two lines of text into one
(rload "lake"    '("lake"))      ; erase only things from a selected layer
(rload "lash"    '("lash"))      ; swap pline linetype gen: vertices/overall
(rload "lcb"     '("lcb"))       ; change layer, ltype and colour bylayer
(rload "lch"     '("lch"))       ; change layer by example/name input
(rload "ldr"     '("ldr"))       ; load and run a lisp
(rload "lea"     '("lea" "larn")); layer name case adjusters
(rload "leda"    '("leda"))      ; non-associativeleader
(rload "left"    '("left"))      ; left justify a text entity
(rload "lent"    '("lent"))      ; read a line from a .csv into a block
(rload "lf"      '("lf"))        ; find stuff in a given linetype
(rload "lin"     '("lin"))       ; linetype edit utility
(rload "lineup"  '("lineup"))    ; make sure lines with text are upright
(rload "lix"     '("lix"))       ; set limits to extents
(rload "lld"     '("lld"))       ; lisp loader with dialog box
(rload "lldr"    '("lldr"))      ; lisp load and run with dialog box
(rload "lms"     '("lms"))       ; move stuff to a layer, make it current
(rload "look"    '("look"))      ; trim everything out of a rectangular area
(rload "lox"     '("lox"))       ; write assoc groups from ss to a file
(rload "lsc"     '("lsc" "lsn")) ; adjust entity ltscale; set to bylayer
(rload "lset"    '("lset"))      ; set layer to that of a selected entity
(rload "lt"      '("lt"))        ; change linetype to match another entity
(rload "ltl"     '("ltl"))       ; reload all linetypes from acad.lin
(rload "ltr"     '("ltr"))       ; dump text to a file from the command line
(rload "lump"    '("lump"))      ; move contents of one layer onto another
(rload "lx"      '("lx"))        ; pull an attribute out of a block
(rload "lwt"     '("lwt" "ln"))  ; adjust entity lineweight; set to bylayer
(rload "lxx"     '("lxx"))       ; like xx - editor load with dialog box
(rload "mach"    '("mach"))      ; attribute search/replace - with windowing
(rload "mada"    '("mada"))      ; erase only entities from redline layers
(rload "map"     '("map"))       ; file editor load - like xx, narrower cols
(rload "marmot"  '("marmot"))    ; multi-attribute squash
(rload "mash"    '("mash"))      ; multi-attribute replace with windowing
(rload "mattress"'("mattress"))  ; align text with matchlines, pw, lt, layer
(rload "mex"     '("mex"))       ; explode all mtext
(rload "middle"  '("middle"))    ; middle justify a text entity
(rload "min"     '("min"))       ; minsert editor
(rload "miss"    '("miss"))      ; a more interesting explode command
(rload "mm"      '("mm"))        ; make text into mtext - a dubious ability
(rload "mn"      '("mn"))        ; reload the current menu
(rload "mold"    '("mold"))      ; mark every entity in the drawing...
(rload "moo"     '("moo"))       ; partial (pop 16) menu loader
(rload "moss"    '("moss"))      ; suck entities from model into paper space
(rload "mp"      '("mp"))        ; match props - layer, colour, and linetype
(rload "mull"    '("mull"))      ; reorder cable tags by type (attributes)
(rload "mullet"  '("mullet"))    ; reorder cable tags by type (text)
(rload "mva"     '("mva"))       ; move lower left of dwg to 0,0 Stockholm
(rload "mx"      '("mx"))        ; edit the current menu file - obsolete?
(rload "n"       '("n"))         ; list entity information, no flipscreen
(rload "nail"    '("nail"))      ; make Notes text
(rload "nch"     '("nch"))       ; directly change entity/subentity
(rload "nepo"    '("nepo"))      ; a strange point connector
(rload "next"    '("next" "nex")); go to the next dwg in the dir, save/don't
(rload "nn"      '("nn"))        ; list subentity information, no flipscreen
(rload "np"      '("np" "bap"))  ; plot utility
(rload "nt"      '("nt"))        ; incremented numbers with optional text
(rload "numf"    '("numf"))      ; write series of numbers to a file
(rload "nxlay"   '("nxlay"))     ; go to the next layer, freeze all others
(rload "obl"     '("obl"))       ; kill all inserts of any blocks in an ss
(rload "ofc"     '("ofc"))       ; 2D sphere maker
(rload "pac"     '("pac" "cap")) ; copy two lines of text into one, vice versa
(rload "pang"    '("pang"))      ; screen shaker
(rload "panic"   '("panic"))     ; distribution panel maker
(rload "pc"      '("pc"))        ; draw a circle in ps over one in ms
(rload "pcl"     '("pcl"))       ; close a polyline
(rload "penguin" '("penguin"))   ; multiple line/polyline intersec breaker
(rload "pfp"     '("pfp"))       ; full screen text editor
(rload "phd"     '("phd"))       ; remove big font text styles
(rload "phdel"   '("phdel"))     ; delete all frozen layers
(rload "pid"     '("pid"))       ; add pre/suffix to text
(rload "pit"     '("pit"))       ; rotate text into the next isoplane
(rload "pivot"   '("pivot"))     ; rotate text & atts into the next isoplane
(rload "pj"      '("pj"))        ; join two noncontinuous polylines
(rload "pkill"   '("pkill"))     ; erase all points
(rload "pollar"  '("pollar" "pol" "polo")) ; brushstroke exisitng pline clouds
(rload "play"    '("play"))      ; see why you can't purge an empty layer
(rload "plim"    '("plim"))      ; reset target and camera points
(rload "pog"     '("pog" "pag")) ; ground line or arc with end blocks as 1 ent
 ; Ŀ
 ;   Pulp - make selected blocks auto-updating.  The update is done by     
 ;   C:Blup which is loaded and run automatically.  Note that this         
 ;   doesn't duplicate xrefs - it is a better approach.                    
 ; 
(rload "pulp"    '("blix" "pulp" "dpulp" "epulp" "hpulp"))
(rload "punk"    '("punk"))      ; insert multiple blocks, increment, break
(rload "pur"     '("pur"))       ; repostion leaders/blocks/lines/circles
(rload "pw"      '("pw"))        ; rewidth a polyline to half of dimscale
(rload "qeb"     '("qeb"))       ; wblock an existing block
(rload "rain"    '("rain"))      ; rain
(rload "raj"     '("raj"))       ; suck superimposed text into a block
(rload "rat"     '("rat"))       ; make text into an attdef
(rload "ratt"    '("ratt"))      ; fast ss of text to attdefs converter
(rload "reco"    '("reco"))      ; recolour n/(n+1) entities in order
(rload "repall"  '("repall"))    ; text search & replace for batch files
(rload "repo"    '("repo"))      ; reinsert all available blocks
(rload "reptile" '("reptile"))   ; cold blooded layer rehasher
(rload "reset"   '("reset"))     ; reset common problem system variables
(rload "right"   '("right"))     ; right justify a text entity
(rload "rl"      '("rl"))        ; relayer with subentities
(rload "rocket"  '("rocket"))    ; reformat text for Rocket.shx
(rload "scabl" '("scabl" "prop" "p1")); rescale blocks, scale to dimscale, to 1
(rload "sch"     '("sch"))       ; restyle text
(rload "scream"  '("scream"))    ; replace one att in a number of blocks
(rload "scrub"   '("scrub"))     ; chgtext for multiple blocks
(rload "sd"      '("sd"))        ; i/o schematic text extractor for s/d keys
(rload "sdel"    '("sdel"))      ; delete one type of entity from selected
(rload "sec"     '("sec"))       ; section arrow maker
(rload "sev"     '("sev" "ves")) ; save sysvars, see changes
(rload "shag"    '("shag"))      ; find shapes as entities & subentities
(rload "shield"  '("shield"))    ; install a shield on jb wires
(rload "shark"   '("shark"))     ; kill entities under a certain size
;(rload "shift"  '("shift"))     ; search & replace with goto & confirm
(rload "shuffle" '("shuffle"))   ; vertically arrange text between two points
(rload "shutdown"'("shutdown"))  ; import an excel file into a shutdown key
(rload "sklork"  '("sklork"))    ; vert. alphabetize att vals between blocks
(rload "snake"   '("snake"))     ; put entities on snap
(rload "sname"   '("sname"))     ; put the drawing name in the screen menu
(rload "sort"    '("sort"))      ; export loose text into a csv by position
(rload "snat"    '("snat"))      ; toggle snap dimscale - 2.5 x dimscale
(rload "snort"   '("snort"))     ; export loose text into a csv by location
(rload "spam"    '("spam"))      ; suck entities from paper into model space
(rload "spk" '("spc" "spk" "spak")); kill start, end, extra spaces, text/blocks
(rload "splurge" '("splurge"))   ; automatic purge to completion
(rload "spyr"    '("spyr"))      ; pattern maker
(rload "squid"   '("squid"))     ; squash shutdown atts to fit in cells
(rload "squish"  '("squish"))    ; squash text to no more than desired width
(rload "squab"   '("squab"))     ; rewidth attributes in a variety of blocks
(rload "ssq"     '("ssq"))       ; edit multiple text ents in order by pos
(rload "stand"   '("stand"))     ; standard detail tag installer
(rload "stlay"   '("stlay"))     ; rehash layers
(rload "stoat"   '("stoat"))     ; write all text/atts from dwg to text file
(rload "strafe"  '("strafe"))    ; break text entities at spaces
(rload "styx"    '("styx"))      ; reset standard text styles
(rload "sun"     '("sun"))       ; print subentity data list, direct select
(rload "sundog"  '("sundog"))    ; turn a cloud inside out
(rload "surv"    '("surv"))      ; colour/lt explicitly, move to one layer
(rload "swat"    '("swat"))      ; swap devices open/closed etc. etc.
(rload "switch"  '("switch"))    ; reinsert i/o switch device blocks
(rload "swx"     '("swx"))       ; swap positions of two sets of entities
(rload "sz"      '("sz"))        ; reduce the width of text or attribute
(rload "t"       '("t"))         ; trim with snap control
(rload "t3"      '("t3"))        ; split a text line into a stack
;(rload "tafi"   '("tafi"))      ; find blocks with given attr. strings
(rload "tater"   '("tater"))     ; change text even if it's in a block
(rload "tar"     '("tar" "tal")) ; center or left rejustify multiple text in boxes
(rload "tarc"    '("tarc"))      ; move a circle to be tangent to two others
 ; Ŀ
 ;   Tb - switch tag blocks for ones with breaks for oversized text.       
 ;   Bt - replace all chopped blocks with the unchopped version.           
 ;   Twa - set all attributes in a block to 0.9 width.                     
 ; 
(rload "tb"      '("tb" "bt" "twa"))
(rload "tbone"   '("tbone"))     ; fillet lines without trimming
(rload "tch"     '("tch"))       ; replace multiple text strings
(rload "tea"     '("tea" "trot")); centre text in a box
(rload "teal"    '("teal"))      ; left justify and align text in a box
(rload "tear"    '("tear"))      ; right justify and align text in a box
(rload "tech"    '("tech"))      ; chgtext for text, atts, attdefs, etc.
(rload "term"    '("term"))      ; put an arrowhead on a line
(rload "tess"    '("tess"))      ; tesseract (4D cube in 3D) maker
(rload "texas"   '("texas"))     ; multiple text/attr/etc. change
(rload "tg"      '("tg"))        ; draw polyline and insert cable tag block
(rload "tga"     '("tga"))       ; draw polyline and insert cable tag block
(rload "tic"     '("tic"))       ; reposition any text in selected circles
(rload "tiger"   '("tiger"))     ; rejoin lines if they are colinear
(rload "tk"      '("tk"))        ; suck text, destroy source
(rload "tlen"    '("tlen"))      ; measure heat trace lines
(rload "tmx"     '("tmx"))       ; align wiring with terminals
(rload "tork"    '("tork"))      ; derotate multi text around common centre
(rload "tota"    '("tota"))      ; total all numbers in text strings and blocks
(rload "tray"    '("tray"))      ; draw a tray bend
(rload "trayhach" '("trayhach")) ; hatch cable tray
(rload "trg"     '("trg"))       ; ground cable tray
(rload "trouble" '("trouble"))   ; diagnostic information
(rload "trx"     '("trx"))       ; draw a vertical tray section
(rload "ts"      '("ts"))        ; draw 35mm rail between terminals
(rload "ttb"     '("ttb"))       ; suck grid text into blocks
(rload "tv"      '("tv"))        ; centre text in a box, fix line spacing
(rload "txkill"  '("txkill"))    ; kill empty text strings
(rload "txs"     '("txs"))       ; selective global text height change
(rload "txtt"  '("txtt" "txpp" "txd" "txdd")) ; text to dwg name or date
(rload "twip"    '("twip"))      ; draw twisted pair conductors
(rload "typ"     '("typ"))       ; swap the Typ. tag from side to side
 ; Ŀ
 ;   Uct: uppercase a single text line or attribute.                       
 ;   Lc: lowercase a single text line or attribute.                        
 ;   Ic: initial capitalise single text line or attribute.                 
 ;   Uc: uppercase all selected text and attributes in selected blocks.    
 ;   Fcase: initial capitalise all selected text.                          
 ; 
(rload "uc"      '("uc" "uct" "ic" "lc" "fcase"))
(rload "upright" '("upright"))   ; *** rotate text which is at a bad angle
(rload "us"      '("us"))        ; cycle through superimposed entities
(rload "uv"      '("uv"))        ; uv=display user sysvars, kuv=empty them
(rload "vb"      '("vb"))        ; multiple text fit rejustify
(rload "vbc"     '("vbc"))       ; multiple text centre rejustify
(rload "vbl"     '("vbl"))       ; multiple text left rejustify
(rload "vbr"     '("vbr"))       ; multiple text right rejustify
(rload "vbml"    '("vbml"))      ; multiple text middle left rejustify
(rload "vbmr"    '("vbmr"))      ; multiple text middle right rejustify
(rload "vbm"     '("vbm"))       ; multiple text middle rejustify
(rload "vess"    '("vess"))      ; vessel maker
(rload "vino"    '("vino"))      ; incremental vertical attribute renumber
(rload "vis"     '("vis"))       ; turn invisible attributes on
(rload "vl"      '("vl" "vu"))   ; lock/unlock viewports
(rload "vvb"     '("vvb"))       ; text line vertical respacer
(rload "wir"     '("wir"))       ; jb wiring installer
(rload "wireline" '("wireline")) ; change all line numbers in a block
(rload "wiretag" '("wiretag"))   ; insert a horizontal or vertical wire tag
(rload "wiretagr"'("wiretagr"))  ; insert horiz. or vert. wire tag on right
(rload "wiz"     '("wiz"))       ; put a wipeout under selected entities
(rload "wm"      '("wm"))        ; move words from one text line to another
(rload "wobble"  '("wobble"))    ; draw wiggly heat trace lines
(rload "wog"     '("wog"))       ; draw wiggly heat trace lines
(rload "wolf"    '("wolf"))      ; join lines if they are ~ colinear
(rload "wormdog" '("wormdog"))   ; move attributes
(rload "wt"   '("wt" "ww" "w9")) ; multi text width change, input/ example
(rload "xa"      '("xa"))        ; search & replace attdef tags and prompts
(rload "xing"    '("xing"))      ; multiple line intersection breaker
(rload "xl"      '("xl"))        ; extendo-trim
(rload "xnames"  '("xnames"))    ; place/update the xref list block
 ; Ŀ
 ;   Xswitch is obsolete with 2005 and SDI - see Gox.lsp                   
 ; 
(rload "xswitch" '("xswitch" "xback")) ; XSwitch: go to xref, XBack: return
(rload "xx"      '("xx"))        ; file editor load - shares name with ld
(rload "xt"      '("xt"))        ; explode text, or probably anything else
(rload "yalf"    '("yalf"))      ; freeze a layer by entity selection
(rload "yang"    '("yang"))      ; pipe end drawer
(rload "zc"      '("zc"))        ; zoom to the extents of what is onscreen
(rload "ze"      '("ze"))        ; zoom extents without regen
(rload "zing"    '("zing"))      ; multiple directional line intersec break
(rload "zlin"    '("zlin"))      ; polyline pattern drawer
(rload "zp"      '("zp"))        ; zoom previous
(rload "zx"      '("zx"))        ; zoom to extents of what is on screen
(rload "zz"      '("zz"))        ; file editor load - like xx, diff. file
 ; Ŀ
 ;   Calculate elapsed time, print the value.                              
 ; 
(ct1)
