 ; Ŀ
 ;   Ak1 - convert a terminal block to both attributes on top style.       
 ;   Ak0 - put them back - up and down.                                    
 ;   Ak2 - move them a bit closer (both on top.)                           
 ;   Ak3 - move them a bit closer (up and down.)                           
 ;   Ak47 - both on top, order reversed.                                   
 ;   And others.                                                           
 ;   Copyright 1990 - 2012 by Rocket Software Ltd.                         
 ;   Please use responsibly - think of the children.  And the sane.        
 ; 

 ; Ŀ
 ;   Subroutine Alt.                                                       
 ; 
 (DEFUN ALT (poaz / snapp *error* ss num)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
  (defun *error* (shk)
   (setvar "snapmode" snapp)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (write-line shk))
  (princ))
 ; Ŀ
 ;   Get some terminal block insertions.                                   
 ; 
  (prompt "\nSelect Terminal Blocks: ")
  (setq ss (ssget (list (cons 2 "term*,fuse"))))
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq num (1+ num))
         (milk enam poaz))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
   (*error* nil)
 (princ))
 ; Ŀ
 ;   Subroutine Alt end.                                                   
 ; 

 ; Ŀ
 ;   Amor - convert all numbers in a string to roman numerals.             
 ; 
 (DEFUN AMOR (str / str strls sub num gnulis)
  (setq strls (monster str))
  (setq strls (splelt strls))
  (setq num 0)
  (while (setq str (nth num strls))
         (setq num (1+ num))
         (if (and (/= str ".")
                  (member (type (read str)) '(INT REAL)))
             (setq str (roman str)))
         (setq gnulis (cons str gnulis)))
  (setq gnulis (reverse gnulis))
  (setq str "")
  (setq num 0)
  (while (setq sub (nth num gnulis))
         (setq num (1+ num))
         (setq str (strcat str sub)))
 str)
 ; Ŀ
 ;   Amor end.  Sad.                                                       
 ; 

 ; Ŀ
 ;   Anap.                                                                 
 ; 
 (DEFUN ANAP (prestr / str strlst sub)
  (setq str "")
  (setq strlst (splat "
" prestr))
  (while (setq sub (car strlst))
         (setq strlst (cdr strlst))
         (if (= str "")
             (setq str sub)
             (setq str (strcat str sub))))
 str)
 ; Ŀ
 ;   Anap.                                                                 
 ; 

 ; Ŀ
 ;   Bluh - replace a terminal block with a happy face terminal block.     
 ;   Arguments: Pa, te insertion point.                                    
 ;              Blnam, the new block name.                                 
 ;              Enam, the old block ename.                                 
 ;              Liss, the list of two new attribute valuse.                
 ;   Assumes scale 1, rotation 1.                                          
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN BLUH (pa blnam enam liss / *error* atrq osm layy entt vala)
  (setq atrq (getvar "attreq"))
  (setvar "attreq" 0)
  (setq osm (getvar "osmode"))
  (setvar "osmode" 0)
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
  (defun *error* (shk)
   (setvar "attreq" atrq)
   (setvar "osmode" osm)
   (if shk (write-line shk))
  (princ))
 ; Ŀ
 ;   Get the existing block layer name.                                    
 ; 
  (setq layy (assoc 8 (entget enam)))
 ; Ŀ
 ;   Erase the old block and insert the new one.                           
 ; 
  (entdel enam)
  (command "insert" blnam pa 1 "" 0)
  (setq enam (entlast))
 ; Ŀ
 ;   Put the block on the correct layer.                                   
 ; 
  (setq entt (entget enam))
  (entmod (subst layy (assoc 8 entt) entt))
 ; Ŀ
 ;   And reapply the attribute values.                                     
 ; 
  (while (and (setq enam (entnext enam))
              (/= (cdr (assoc 0 (setq entt (entget enam)))) "SEQEND"))
         (setq vala (car liss))
         (setq main (cdr liss))
         (entmod (subst (cons 1 vala) (assoc 1 entt) entt)))
  (*error* nil)
 (princ))
 ; Ŀ
 ;   Bluh end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Cstar - draw an individual grstar (centred).               
 ;   Takes four arguments: centre point, side length, rotation (radians),  
 ;   and colour.  Returns nothing, but draws a star.                       
 ; 
 (DEFUN CSTAR (pa sidlen rota colo / anginc angg hafang pb)
  (setq px pa)
  (setq pa (polar pa (+ rota (/ pi 2)) (* sidlen 1.37638192)))
  (setq anginc (* 1.6 pi))
  (setq angg (+ rota (* 1.6 pi)))
  (setq hafang (* 0.8 pi))
  (repeat 5
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg anginc))
         (setq pa pb)
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg hafang))
         (setq pa pb))
 (princ))
 ; Ŀ
 ;   Subroutine Cstar end.                                                 
 ; 

 ; Ŀ
 ;   Mark - mark a point.                                                  
 ;   Arguments: Pa - the point to mark.                                    
 ;              Rad - the marker segment length.                           
 ;              Colo - the marker grdraw line colour.                      
 ; 
 (DEFUN MARK (pa rad colo /)
  (grdraw (polar pa (/ pi 4) rad) (polar pa (* 1.25 pi) rad) colo)
  (grdraw (polar pa (* pi 0.75) rad) (polar pa (* pi 1.75) rad) colo)
 (princ))
 ; Ŀ
 ;   Mark end.                                                             
 ; 

 ; Ŀ
 ;   Malt - middle rejustify an attribute (in a block) on a new point.     
 ;   Arguments: Enam, an entity name.                                      
 ;              Pa, the new insertion point.                               
 ;              Juz, the new justification - 4 = Middle, 1 = Centre.       
 ;   Calls nothing, Returns nothing.                                       
 ; 
 (DEFUN MALT (enam pa juz / entt)
  (setq entt (entget enam))
 ; Ŀ
 ;   Middle justification for an Attrib: (72 . 4) (74 . 0).                
 ;   Centre is: (72 . 1) (74 . 0).                                         
 ;   74 may be absent, this is equivalent to 0.                            
 ; 
  (if (assoc 74 entt)                                      ; vert. rejustify
      (setq entt (subst (cons 74 0) (assoc 74 entt) entt)))
  (setq entt (subst (cons 72 juz) (assoc 72 entt) entt))   ; horiz rejustify
  (entmod entt)
 ; Ŀ
 ;   Get its entity data again.                                            
 ; 
  (setq entt (entget enam))
  (entmod (subst (cons 11 pa) (assoc 11 entt) entt))
 ; Ŀ
 ;   Call mark to mark the new insertion point.                            
 ; 
  (cstar pa (/ (getvar "viewsize") 95) 0 1)
 (princ))
 ; Ŀ
 ;   Malt end.                                                             
 ; 

 ; Ŀ
 ;   Milk - reposition and rejustify both attributes in a block.           
 ;   Arguments: Enam, an entity name.                                      
 ;              Poaz, 1 = put both attributes above the block,             
 ;                    2 = one above and one below.                         
 ;   Calls nothing, Returns nothing.                                       
 ; 
 (DEFUN MILK (enam poaz / pa enam1 enam2 pa1 pa2)
  (setq pa (cdr (assoc 10 (entget enam))))
  (if (and (setq enam1 (entnext enam))
           (= (cdr (assoc 0 (entget enam1))) "ATTRIB")
           (setq enam2 (entnext enam1))
           (= (cdr (assoc 0 (entget enam2))) "ATTRIB")
           (= (cdr (assoc 0 (entget (entnext enam2)))) "SEQEND"))
      (cond ((= poaz 0)
             (setq pa1 (polar pa (* pi 0.5) 5))
             (setq pa2 (polar pa (* pi 1.5) 7.5))
             (malt enam1 pa1 1)
             (malt enam2 pa2 1)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt)))
            ((= poaz 1)
             (setq pa1 (polar pa (* pi 0.5) 8.75))
             (setq pa2 (polar pa (* pi 0.5) 5))
             (malt enam1 pa1 4)
             (malt enam2 pa2 4))
            ((= poaz 2)
             (setq pa1 (polar pa (* pi 0.5) 10))
             (setq pa2 (polar pa (* pi 0.5) 5.875))
             (malt enam1 pa1 4)
             (malt enam2 pa2 4))
            ((= poaz 3)
             (setq pa1 (polar pa (* pi 0.5) 5))
             (setq pa2 (polar pa (* pi 1.5) 5))
             (malt enam1 pa1 4)
             (malt enam2 pa2 4))
            ((= poaz 4)
             (setq pb (polar pa (/ pi 2) 5))
             (repat enam1 "R" (polar pb pi 2.5))
             (repat enam2 "L" (polar pb 0 2.5)))
            ((= poaz 5)
             (setq pb (polar pa 0 5))
             (repat enam1 "ML" (polar pb (/ pi 2) 2))
             (repat enam2 "ML" (polar pb (* pi 1.5) 2)))
            ((= poaz 6)
             (setq pb (polar pa pi 5))
             (repat enam1 "MR" (polar pb (/ pi 2) 2))
             (repat enam2 "MR" (polar pb (* pi 1.5) 2)))
            ((= poaz 7)
             (setq pb (polar pa (/ pi 2) 5))
             (repat enam1 "MR" (polar pb pi 2.5))
             (repat enam2 "ML" (polar pb 0 2.5)))
            ((= poaz 8)
             (setq pb (polar pa (* pi 1.5) 7.5))
             (repat enam1 "R" (polar pb pi 2.5))
             (repat enam2 "L" (polar pb 0 2.5)))
            ((= poaz 9)
             (setq pb (polar pa (* pi 1.5) 5))
             (repat enam1 "MR" (polar pb pi 2.5))
             (repat enam2 "ML" (polar pb 0 2.5)))
            ((= poaz 10)
             (setq pb (polar (polar pa (* pi 1.5) 5) pi 5))
             (setq pc (polar (polar pa (* pi 0.5) 5) 0 5))
             (repat enam1 "MR" pb)
             (repat enam2 "ML" pc)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 (/ pi 4)) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 (/ pi 4)) (assoc 50 entt) entt)))
            ((= poaz 11)
             (setq pb (polar (polar pa (* pi 0.5) 5) pi 5))
             (setq pc (polar (polar pa (* pi 1.5) 5) 0 5))
             (repat enam1 "MR" pb)
             (repat enam2 "ML" pc)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 (* pi 1.75)) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 (* pi 1.75)) (assoc 50 entt) entt)))
            ((= poaz 12)
             (setq pb (polar (polar pa (* pi 0.5) 5) 0 5))
             (setq pc (polar (polar pa (* pi 1.5) 5) 0 5))
             (repat enam1 "ML" pb)
             (repat enam2 "ML" pc)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 (/ pi 4)) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 (* pi 1.75)) (assoc 50 entt) entt)))
            ((= poaz 13)
             (setq pb (polar (polar pa (* pi 0.5) 5) pi 5))
             (setq pc (polar (polar pa (* pi 1.5) 5) pi 5))
             (repat enam1 "MR" pb)
             (repat enam2 "MR" pc)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 (* pi 1.75)) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 (* pi 0.25)) (assoc 50 entt) entt)))
            ((= poaz 14)
             (setq pb (polar pa (* pi 0.5) 5))
             (setq pc (polar pa (* pi 0.5) 7.5))
             (malt enam1 pb 4)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt))
             (repat enam2 "ML" pc)
             (setq entt (entget enam2))
             (entmod (subst (cons 50 (* pi 0.5)) (assoc 50 entt) entt)))
            ((= poaz 15)
             (setq pa1 (polar pa (* pi 0.5) 5))
             (malt enam1 pa 4)
             (malt enam2 pa1 4)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt)))
            ((= poaz 16)
             (setq pa1 (polar pa (* pi 0.5) 5))
             (malt enam1 pa1 4)
             (malt enam2 pa 4)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt)))
            ((= poaz 17)
             (setq pa1 (polar pa (* pi 0.5) 5))
             (malt enam1 pa 4)
             (malt enam2 pa1 1)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt)))
            ((= poaz 18)
             (setq pa1 (polar pa (* pi 0.5) 5))
             (malt enam1 pa1 1)
             (malt enam2 pa 4)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt)))
            ((= poaz 19)
             (setq pa1 (polar pa (* pi 0.5) 5))
             (setq pa2 (polar pa (* pi 1.5) 7.5))
             (malt enam1 pa2 1)
             (malt enam2 pa1 1)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 0) (assoc 50 entt) entt)))
            ((= poaz 20)
             (setq pa1 (polar pa (* pi 0.5) 5))
             (setq pa2 (polar pa (* pi 1.5) 5))
             (malt enam1 pa2 4)
             (malt enam2 pa1 4))
            ((= poaz 21)
             (repat enam1 "ML" (polar pa 0 5))
             (repat enam2 "MR" (polar pa pi 5)))
            ((= poaz 22)
             (setq entt (entget enam1))
             (setq vis (cdr (assoc 70 entt)))   ; get att flags
             (setq vis (logior 1 vis))          ; turn visibility off
             (entmod (subst (cons 70 vis) (assoc 70 entt) entt))
             (setq entt (entget enam2))
             (setq vis (cdr (assoc 70 entt)))   ; get att flags
             (setq vis (logior 1 vis))          ; turn visibility off
             (entmod (subst (cons 70 vis) (assoc 70 entt) entt)))
            ((= poaz 23)
             (setq entt (entget enam1))
             (setq vis (cdr (assoc 70 entt)))   ; get att flags
             (setq vis (logand 14 vis))         ; turn visibility on
             (entmod (subst (cons 70 vis) (assoc 70 entt) entt))
             (setq entt (entget enam2))
             (setq vis (cdr (assoc 70 entt)))   ; get att flags
             (setq vis (logand 14 vis))         ; turn visibility on
             (entmod (subst (cons 70 vis) (assoc 70 entt) entt)))
            ((= poaz 24) ; mirrored in X
             (setq entt (entget enam1))
             (setq mir (logior 2 (cdr (assoc 70 entt))))
            (print (entmod (subst (cons 71 mir) (assoc 71 entt) entt)))
             (setq entt (entget enam2))
             (setq mir (logior 2 (cdr (assoc 71 entt))))
             (entmod (subst (cons 71 mir) (assoc 71 entt) entt)))
            ((= poaz 25) ; mirrored in Y
             (setq entt (entget enam1))
             (setq mir (logior 4 (cdr (assoc 71 entt))))
             (entmod (subst (cons 71 mir) (assoc 71 entt) entt))
             (setq entt (entget enam2))
             (setq mir (logior 4 (cdr (assoc 71 entt))))
             (entmod (subst (cons 71 mir) (assoc 71 entt) entt)))
            ((= poaz 26) ; not mirrored
             (setq entt (entget enam1))
             (entmod (subst (cons 71 0) (assoc 71 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 71 0) (assoc 71 entt) entt)))
            ((= poaz 27) ; blue
             (setq entt (entget enam1))
             (if (assoc 62 entt)
                 (setq entt (subst (cons 62 5) (assoc 62 entt) entt))
                 (setq entt (append entt (list (cons 62 5)))))
             (entmod entt)
             (setq entt (entget enam2))
             (if (assoc 62 entt)
                 (setq entt (subst (cons 62 5) (assoc 62 entt) entt))
                 (setq entt (append entt (list (cons 62 5)))))
             (entmod entt))
            ((= poaz 28) ; red and blue
             (setq entt (entget enam1))
             (if (assoc 62 entt)
                 (setq entt (subst (cons 62 1) (assoc 62 entt) entt))
                 (setq entt (append entt (list (cons 62 1)))))
             (entmod entt)
             (setq entt (entget enam2))
             (if (assoc 62 entt)
                 (setq entt (subst (cons 62 5) (assoc 62 entt) entt))
                 (setq entt (append entt (list (cons 62 5)))))
             (entmod entt))
            ((= poaz 29) ; italic
             (setq anga (/ pi 9))
             (setq entt (entget enam1))
             (if (assoc 51 entt)
                 (setq entt (subst (cons 51 anga) (assoc 51 entt) entt))
                 (setq entt (append entt (list (cons 51 anga)))))
             (entmod entt)
             (setq entt (entget enam2))
             (if (assoc 51 entt)
                 (setq entt (subst (cons 51 anga) (assoc 51 entt) entt))
                 (setq entt (append entt (list (cons 51 anga)))))
             (entmod entt))
            ((= poaz 30) ; reverse italic
             (setq anga (- (/ pi 9)))
             (setq entt (entget enam1))
             (if (assoc 51 entt)
                 (setq entt (subst (cons 51 anga) (assoc 51 entt) entt))
                 (setq entt (append entt (list (cons 51 anga)))))
             (entmod entt)
             (setq entt (entget enam2))
             (if (assoc 51 entt)
                 (setq entt (subst (cons 51 anga) (assoc 51 entt) entt))
                 (setq entt (append entt (list (cons 51 anga)))))
             (entmod entt))
            ((= poaz 31) ; no italic
             (setq entt (entget enam1))
             (if (assoc 51 entt)
                 (setq entt (subst (cons 51 0) (assoc 51 entt) entt)))
             (entmod entt)
             (setq entt (entget enam2))
             (if (assoc 51 entt)
                 (setq entt (subst (cons 51 0) (assoc 51 entt) entt)))
             (entmod entt))
            ((= poaz 32) ; star
             (if (load "astra" ())
                 (progn
                      (setq rad (/ (getvar "viewsize") 65))
                      (setq rota (/ pi 3))
                      (setq entt (entget enam1))
                      (setq pa (spit entt))
                      (astra pa rad 0.125 1.09
                           (list "A" 10 240 12 242 14 244 16 246 18 248 5) 25)
                      (setq entt (entget enam2))
                      (setq rota (/ pi 4))
                      (setq pa (spit entt))
                      (astra pa rad 0.125 1.09
                           (list "A" 50 51 52 53 54 55 56 57 58 59 1) 25))
                 (prompt "Unable to load Astra.lsp.")))
            ((= poaz 33) ; skull
             (if (load "sk" ())
                 (sk pa 0.25)
                 (prompt "Unable to load Sk.lsp.")))
            ((= poaz 34)
             (setq pb pa)
             (repeat 4 (setq pb (polar pb (* pi 1.75) (sqrt 2)))
                       (command ".copy" enam "" pa pb)))
            ((= poaz 35)
             (setq liss (list (cdr (assoc 1 (entget enam1)))
                              (cdr (assoc 1 (entget enam1)))))
             (bluh pa "termchf" enam liss))
            ((= poaz 36)
             (if c:pang (repeat 10 (c:pang))))
            ((= poaz 37)
             (if (load "stad" ())
                 (cvox pa)
                 (prompt "Unable to load Cvox.lsp.")))
            ((= poaz 38)
             (setq liss (list (cdr (assoc 1 (entget enam1)))
                              (cdr (assoc 1 (entget enam1)))))
             (bluh pa "termsqhf" enam liss))
            ((= poaz 39)
             (setq entt (entget enam1))
             (setq str (retx (cdr (assoc 1 entt))))
             (entmod (subst (cons 1 str) (assoc 1 entt) entt))
             (setq entt (entget enam2))
             (setq str (retx (cdr (assoc 1 entt))))
             (entmod (subst (cons 1 str) (assoc 1 entt) entt)))
            ((= poaz 40)
             (if (load "python" ())
                 (progn
                      (setq entt (entget enam1))
                      (setq str (python (cdr (assoc 1 entt))))
                      (entmod (subst (cons 1 str) (assoc 1 entt) entt))
                      (setq entt (entget enam2))
                      (setq str (python (cdr (assoc 1 entt))))
                      (entmod (subst (cons 1 str) (assoc 1 entt) entt)))
                 (prompt "\nUnable to load Python.lsp")))
            ((= poaz 41)
             (setq entt (entget enam1))
             (setq str (pana (cdr (assoc 1 entt))))
             (entmod (subst (cons 1 str) (assoc 1 entt) entt))
             (setq entt (entget enam2))
             (setq str (pana (cdr (assoc 1 entt))))
             (entmod (subst (cons 1 str) (assoc 1 entt) entt)))
            ((= poaz 42)
             (setq entt (entget enam1))
             (setq str (anap (cdr (assoc 1 entt))))
             (entmod (subst (cons 1 str) (assoc 1 entt) entt))
             (setq entt (entget enam2))
             (setq str (anap (cdr (assoc 1 entt))))
             (entmod (subst (cons 1 str) (assoc 1 entt) entt)))
            ((= poaz 43)
             (setq entt (entget enam1))
             (setq str (amor (cdr (assoc 1 entt))))
             (entmod (subst (cons 1 str) (assoc 1 entt) entt))
             (setq entt (entget enam2))
             (setq str (amor (cdr (assoc 1 entt))))
             (entmod (subst (cons 1 str) (assoc 1 entt) entt)))
            ((= poaz 44)
             (vbf enam1 5 nil)
             (vbf enam2 5 nil))
            ((= poaz 45)
             (setq entt (entget enam1))
             (setq pa (cdr (assoc 10 entt)))
             (malt enam1 (spit entt) 4)
             (setq entt (entget enam1))
             (setq pb (cdr (assoc 10 entt)))
             (setq p11 (cdr (assoc 11 entt)))
             (setq pc (polar p11 (angle pb pa) (distance pb pa)))
             (entmod (subst (cons 11 pc) (assoc 11 entt) entt))
             (setq entt (entget enam1))
             (entmod (subst (cons 50 pi) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (setq pa (cdr (assoc 10 entt)))
             (malt enam2 (spit entt) 4)
             (setq entt (entget enam2))
             (setq pb (cdr (assoc 10 entt)))
             (setq p11 (cdr (assoc 11 entt)))
             (setq pc (polar p11 (angle pb pa) (distance pb pa)))
             (entmod (subst (cons 11 pc) (assoc 11 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 pi) (assoc 50 entt) entt)))
            ((= poaz 46)
             (setq pa1 (polar pa (* pi 1.5) 6.5))
             (malt enam1 pa1 4)
             (malt enam2 pa1 4)
             (setq entt (entget enam1))
             (entmod (subst (cons 50 (/ pi 7.5)) (assoc 50 entt) entt))
             (setq entt (entget enam2))
             (entmod (subst (cons 50 (- (/ pi 7.5))) (assoc 50 entt) entt)))
            ((= poaz 47)
             (setq pa1 (polar pa (* pi 0.5) 5.875))
             (setq pa2 (polar pa (* pi 0.5) 10))
             (malt enam1 pa1 4)
             (malt enam2 pa2 4))
            (t
             (prompt "\nUnknown arrangement - Program Error."))))
 (princ))
 ; Ŀ
 ;   Milk end.                                                             
 ; 

 ; Ŀ
 ;   Monster - returns a list of strings, alternating between numbers and  
 ;   letters. The first string is always a character string - if the       
 ;   first character is a number then the first string will be empty (""). 
 ;   A period is a decimal point if preceded by a number.                  
 ; 
 (DEFUN MONSTER (string / chastr pre ascnum posi this asc last strlist)
  (setq chastr "")
  (setq pre "c")
  (setq ascnum (list 48 49 50 51 52 53 54 55 56 57))
  (setq posi 1)
  (while (/= "" (setq this (substr string posi 1)))
       (setq asc (ascii this))
       (cond ((member asc ascnum)         ; if char is a number
              (setq last "n"))
             ((= asc 46)                  ; if char is a .
              (if (= last "c")
                  (setq last "c")
                  (setq last "n")))
             (T                           ; otherwise it must be a letter
               (setq last "c")))
 ; Ŀ
 ;   If pre = last then strcat This onto chastr.                           
 ;   If not then append chastr onto strlist and set chastr to this.        
 ; 
       (if (equal pre last)
           (setq chastr (strcat chastr this))
           (progn
                (if strlist
                   (setq strlist (append strlist (list chastr)))
                   (setq strlist (list chastr)))
                (setq chastr this)))
       (setq pre last)
       (setq posi (1+ posi)))
  (if chastr (setq strlist (append strlist (list chastr))))
  strlist)
 ; Ŀ
 ;   Monster end.                                                          
 ; 

 ; Ŀ
 ;   Pana.                                                                 
 ; 
 (DEFUN PANA (prestr / str strlst sub)
  (setq str "")
  (setq strlst (stril prestr))
  (while (setq sub (car strlst))
         (setq strlst (cdr strlst))
         (if (= str "")
             (setq str sub)
             (setq str (strcat str "
" sub))))
 str)
 ; Ŀ
 ;   Pana.                                                                 
 ; 

 ; Ŀ
 ;   Pontoon - split a text string at the decimal point (if any).          
 ;   Returns a list of two strings.                                        
 ; 
 (DEFUN PONTOON (aa / pos len bb cc)
  (setq pos 1)
  (setq len (strlen aa))
  (while (>= len pos)
         (setq bb (substr aa pos 1))
         (if (= bb ".")
             (progn
                  (setq cc (substr aa (1+ pos)))
                  (setq aa (substr aa 1 (1- pos)))))
         (setq pos (1+ pos)))
  (list aa cc))
 ; Ŀ
 ;   Pontoon end.                                                          
 ; 

 ; Ŀ
 ;   Repat - Rejustify and reposition an attribute.                        
 ;   Arguments: Enam, the attribute ename.                                 
 ;              LorR, the L, R, ML, or MR justification text string.       
 ;              Pa, the new position.                                      
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN REPAT (enam lorr pa / entt)
  (setq entt (entget enam))
  (setq lorr (strcase lorr))
 ; Ŀ
 ;   Left.                                                                 
 ; 
  (cond ((= lorr "L")
         (setq entt (subst (cons 10 pa) (assoc 10 entt) entt)) ; insertion
         (setq entt (subst (cons 74 0) (assoc 74 entt) entt))
         (setq entt (subst (cons 50 0) (assoc 50 entt) entt))  ; rotation
         (setq entt (subst (cons 73 0) (assoc 73 entt) entt))  ; bottom just.
         (entmod (subst (cons 72 0) (assoc 72 entt) entt)))
 ; Ŀ
 ;   Right.                                                                
 ; 
        ((= lorr "R")
         (setq entt (subst (cons 11 pa) (assoc 11 entt) entt)) ; insertion
         (setq entt (subst (cons 50 0) (assoc 50 entt) entt))  ; rotation
         (setq entt (subst (cons 74 0) (assoc 74 entt) entt))  ; bottom just.
         (entmod (subst (cons 72 2) (assoc 72 entt) entt)))
 ; Ŀ
 ;   Mid-Left.                                                             
 ; 
        ((= lorr "ML")
         (if (assoc 74 entt)
             (setq entt (subst (cons 74 2) (assoc 74 entt) entt))
             (setq entt (append entt (list (cons 74 2)))))
         (setq entt (subst (cons 72 0) (assoc 72 entt) entt))
         (entmod (subst (cons 50 0) (assoc 50 entt) entt))
         (setq entt (entget enam))
         (entmod (subst (cons 11 pa) (assoc 11 entt) entt)))
 ; Ŀ
 ;   Mid-Right.                                                            
 ; 
        ((= lorr "MR")
         (setq entt (subst (cons 11 pa) (assoc 11 entt) entt)) ; insertion
         (setq entt (subst (cons 50 0) (assoc 50 entt) entt))  ; rotation
         (setq entt (subst (cons 74 2) (assoc 74 entt) entt))  ; middle just.
         (entmod (subst (cons 72 2) (assoc 72 entt) entt))))
 (princ))
 ; Ŀ
 ;   Repat end.                                                            
 ; 

 ; Ŀ
 ;   Retx - Text Reverser - resreveR txeT.                                 
 ;   Argument: Zz, a string.                                               
 ;   Calls nothing, returns a string.                                      
 ; 
 (defun retx (zz / zza lena ntxb)
  (setq zza "")
  (setq lena (strlen zz))
  (while (/= 0 lena)
         (setq ntxb (substr zz lena 1))
         (setq lena (1- lena))
         (setq zza (strcat zza ntxb)))
 zza)
 ; Ŀ
 ;   Retx end.                                                             
 ; 

 ; Ŀ
 ;   Roman - translate a number into Roman numerals.                       
 ;   Arguments: nn, the number.  (Integer or string.)                      
 ;   Returns another string.                                               
 ; 
 (DEFUN ROMAN (nn / rom rn)
  (setq typ (type nn))
  (cond ((= typ 'REAL)
         (setq nn (fix nn)))
        ((= typ 'STR)
         (setq nn (read nn))))
  (setq rom "")
  (setq rn (/ nn 1000))
  (repeat rn (setq rom (strcat "M" rom)))
  (setq nn (rem nn 1000))
 ; Ŀ
 ;   Hundreds.                                                             
 ; 
  (setq rn (/ nn 100))
  (if (= rn 9)
      (setq rom (strcat rom "CM"))
      (progn
           (if (= rn 4)
               (setq rom (strcat rom "CD"))
               (progn
                    (setq rn (/ nn 500))
                    (repeat rn (setq rom (strcat rom "D")))
                    (setq nn (rem nn 500))
                    (setq rn (/ nn 100))
                    (repeat rn (setq rom (strcat rom "C")))))))
  (setq nn (rem nn 100))
 ; Ŀ
 ;   Tens.                                                                 
 ; 
  (setq rn (/ nn 10))
  (if (= rn 9)
      (setq rom (strcat rom "XC"))
      (progn
           (if (= rn 4)
               (setq rom (strcat rom "XL"))
               (progn
                    (setq rn (/ nn 50))
                    (repeat rn (setq rom (strcat rom "L")))
                    (setq nn (rem nn 50))
                    (setq rn (/ nn 10))
                    (repeat rn (setq rom (strcat rom "X")))))))
  (setq nn (rem nn 10))
 ; Ŀ
 ;   Ones.                                                                 
 ; 
  (if (= nn 9)
      (setq rom (strcat rom "IX"))
      (progn
           (if (= nn 4)
               (setq rom (strcat rom "IV"))
               (progn
                    (setq rn (/ nn 5))
                    (repeat rn (setq rom (strcat rom "V")))
                    (setq rn (rem nn 5))
                    (repeat rn (setq rom (strcat rom "I")))))))
 rom)
 ; Ŀ
 ;   Roman end.                                                            
 ; 

 ; Ŀ
 ;   Spit - returns the insertion point of the text entity whose data was  
 ;   passed as its sole argument.  Note that this is not necessarily the   
 ;   same as the 10 association code.                                      
 ; 
 (DEFUN SPIT (entt / xjust yjust)
  (setq xjust (cdr (assoc 72 entt)))
  (if (= (cdr (assoc 0 entt)) "ATTDEF")
      (setq yjust (cdr (assoc 74 entt)))
      (setq yjust (cdr (assoc 73 entt))))
  (if (or (/= xjust 0) (/= yjust 0))
      (cdr (assoc 11 entt))
      (cdr (assoc 10 entt))))
 ; Ŀ
 ;   Spit end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Splat - divide a text string into a list of substrings.    
 ;   Arguments: Sepchr, the field separator character.                     
 ;              Linn, the text string.                                     
 ;   Returns a list of field values, removes leading and trailing spaces.  
 ;                                                                         
 ;   This could probably replace Split wherever it is called...            
 ; 
 (DEFUN SPLAT (sepchr linn / len pos name1 strlst)
  (while (/= (strlen linn) 0)
         (while (and (= (substr linn 1 1) " ")
                     (/= (strlen linn) 0))
                (setq linn (substr linn 2)))
         (while (= (substr linn (setq len (strlen linn))) " ")
                (setq linn (substr linn 1 (1- len))))
         (setq pos 1)
         (setq len (strlen linn))
         (while (and (/= (substr linn pos 1) sepchr)
                     (>= len pos))
                (setq pos (1+ pos)))
         (setq name1 (substr linn 1 (1- pos)))
         (while (= (substr name1 (setq len (strlen linn))) " ")
                (setq name1 (substr name1 1 (1- len))))
         (setq linn (substr linn (1+ pos)))
         (setq strlst (append strlst (list name1))))
  (if (null strlst) (setq strlst (list "")))
  strlst)
 ; Ŀ
 ;   Splat end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Splelt - split number strings in a list around "."         
 ;   Argument: Strlis, a list of strings.                                  
 ;   Returns the changed version.                                          
 ; 
 (DEFUN SPLELT (strlis / str num strp gnu)
  (setq num 0)
  (while (setq str (nth num strlis))     ; get next string from list
         (setq num (1+ num))
         (cond ((and (/= str ".")
                     (member (type (read str)) '(INT REAL))
                     (setq strp (pontoon str))
                     (cadr strp))
                (setq gnu (append gnu (list (car strp) "." (cadr strp)))))
                (t
                 (setq gnu (append gnu (list str))))))
 gnu)
 ; Ŀ
 ;   Splelt end.                                                           
 ; 

 ; Ŀ
 ;   Stril - make a string into a list of characters.                      
 ;   Arguments: Str, the string.                                           
 ;   Returns a list.                                                       
 ; 
 (DEFUN STRIL (str / num sub lizz)
  (setq num 1)
  (while (/= (setq sub (substr str num 1)) "")
         (setq num (1+ num))
         (setq lizz (cons sub lizz)))
 (reverse lizz))
 ; Ŀ
 ;   Stril end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Vbf - fit rejustify a textlike entity.                     
 ;   Arguments: Enam, the entity ename.                                    
 ;              Pa, the left point.                                        
 ;              Pb, the right.                                             
 ;   If Pa is a number the entity will be squashed to that width.          
 ;   Caution - has not been tested with the two point option.              
 ;   And really it's a bit dubious overall.                                
 ; 
 (DEFUN VBF (enam pa pb)
  (setq entt (entget enam))
  (setq typ (cdr (assoc 0 entt)))
  (if (= typ "ATTDEF")
      (entmod (subst (cons 74 0) (assoc 74 entt) entt))
      (entmod (subst (cons 73 0) (assoc 73 entt) entt)))
  (setq entt (entget enam))
  (entmod (subst (cons 72 5) (assoc 72 entt) entt))
  (setq entt (entget enam))
  (if (member (type pa) '(INT REAL))
      (progn
           (setq ten (cdr (assoc 10 entt)))
           (setq elv (cdr (assoc 11 entt)))
           (setq angg (angle ten elv))
           (setq disa (distance ten elv))
           (setq pcen (polar ten angg disa))
           (setq pleft (polar pcen (+ angg pi) (/ pa 2.0)))
           (setq pright (polar pcen angg (/ pa 2.0)))
           (setq entt (subst (cons 10 pleft) (assoc 10 entt) entt))
           (setq entt (subst (cons 11 pright) (assoc 11 entt) entt))
           (entmod entt))
      (progn
           (entmod (subst (cons 10 pa) (assoc 10 entt) entt))
           (entmod (subst (cons 11 pb) (assoc 11 entt) entt))
           (entmod entt)))
 (princ))
 ; Ŀ
 ;   Subroutine Vbf end.                                                   
 ; 

 ; Ŀ
 ;   Ak0 - the stock above and below positioning.                          
 ; 
 (DEFUN C:AK0 ()
  (alt 0)
 (princ))

 ; Ŀ
 ;   Ak1 - both attributes above the block.                                
 ; 
 (DEFUN C:AK1 ()
  (alt 1)
 (princ))

 ; Ŀ
 ;   Ak2 - close in and middled, both on top.                              
 ; 
 (DEFUN C:AK2 ()
  (alt 2)
 (princ))

 ; Ŀ
 ;   Ak3 - close in and middled, up and down.                              
 ; 
 (DEFUN C:AK3 ()
  (alt 3)
 (princ))

 ; Ŀ
 ;   Ak4 - both attributes on top, right and left, for a vertical line.    
 ; 
 (DEFUN C:AK4 ()
  (alt 4)
 (princ))

 ; Ŀ
 ;   Ak5 - both attributes on the right.                                   
 ; 
 (DEFUN C:AK5 ()
  (alt 5)
 (princ))

 ; Ŀ
 ;   Ak6 - both attributes on the left.                                    
 ; 
 (DEFUN C:AK6 ()
  (alt 6)
 (princ))

 ; Ŀ
 ;   Ak7 - both attributes on top, right and left, for a vertical line,    
 ;   ml and mr justified, closer -  otherwise like Ak4.                    
 ; 
 (DEFUN C:AK7 ()
  (alt 7)
 (princ))

 ; Ŀ
 ;   Ak8 - both attributes below, right and left, for a vertical line,     
 ;   ml and mr justified, closer -  otherwise like Ak4.                    
 ; 
 (DEFUN C:AK8 ()
  (alt 8)
 (princ))

 ; Ŀ
 ;   Ak9 - both attributes below, right and left, for a vertical line,     
 ;   ml and mr justified, closer -  otherwise like Ak4.                    
 ; 
 (DEFUN C:AK9 ()
  (alt 9)
 (princ))

 ; Ŀ
 ;   Ak10 - diagonal ll and ur.                                            
 ; 
 (DEFUN C:AK10 ()
  (alt 10)
 (princ))

 ; Ŀ
 ;   Ak11 - diagonal ul and lr.                                            
 ; 
 (DEFUN C:AK11 ()
  (alt 11)
 (princ))

 ; Ŀ
 ;   Ak12 - diagonal ur and lr.                                            
 ; 
 (DEFUN C:AK12 ()
  (alt 12)
 (princ))

 ; Ŀ
 ;   Ak13 - diagonal ul and ll.                                            
 ; 
 (DEFUN C:AK13 ()
  (alt 13)
 (princ))

 ; Ŀ
 ;   Ak14 - T top.                                                         
 ; 
 (DEFUN C:AK14 ()
  (alt 14)
 (princ))

 ; Ŀ
 ;   Ak15 - 1 up, one centred in the terminal, close.                      
 ; 
 (DEFUN C:AK15 ()
  (alt 15)
 (princ))

 ; Ŀ
 ;   Ak16 - 1 up, the other one centred in the terminal, close.            
 ; 
 (DEFUN C:AK16 ()
  (alt 16)
 (princ))

 ; Ŀ
 ;   Ak17 - 1 up, one centred in the terminal.                             
 ; 
 (DEFUN C:AK17 ()
  (alt 17)
 (princ))

 ; Ŀ
 ;   Ak18 - 1 up, the other one centred in the terminal.                   
 ; 
 (DEFUN C:AK18 ()
  (alt 18)
 (princ))

 ; Ŀ
 ;   Ak19 - reversed.                                                      
 ; 
 (DEFUN C:AK19 ()
  (alt 19)
 (princ))

 ; Ŀ
 ;   Ak20 - reversed close.                                                
 ; 
 (DEFUN C:AK20 ()
  (alt 20)
 (princ))

 ; Ŀ
 ;   Ak21 - middle left and middle right.                                  
 ; 
 (DEFUN C:AK21 ()
  (alt 21)
 (princ))

 ; Ŀ
 ;   Ak22 - invisible.                                                     
 ; 
 (DEFUN C:AK22 ()
  (alt 22)
 (princ))

 ; Ŀ
 ;   Ak23 - visible.                                                       
 ; 
 (DEFUN C:AK23 ()
  (alt 23)
 (princ))

 ; Ŀ
 ;   Ak24 - mirrored in X.                                                 
 ; 
 (DEFUN C:AK24 ()
  (alt 24)
 (princ))

 ; Ŀ
 ;   Ak25 - mirrored in Y.                                                 
 ; 
 (DEFUN C:AK25 ()
  (alt 25)
 (princ))

 ; Ŀ
 ;   Ak26 - not mirrored.                                                  
 ; 
 (DEFUN C:AK26 ()
  (alt 26)
 (princ))

 ; Ŀ
 ;   Ak27 - blue.                                                          
 ; 
 (DEFUN C:AK27 ()
  (alt 27)
 (princ))

 ; Ŀ
 ;   Ak28 - blue and red.                                                  
 ; 
 (DEFUN C:AK28 ()
  (alt 28)
 (princ))

 ; Ŀ
 ;   Ak29 - italic.                                                        
 ; 
 (DEFUN C:AK29 ()
  (alt 29)
 (princ))

 ; Ŀ
 ;   Ak30 - reverse italic.                                                
 ; 
 (DEFUN C:AK30 ()
  (alt 30)
 (princ))

 ; Ŀ
 ;   Ak31 - no italic.                                                     
 ; 
 (DEFUN C:AK31 ()
  (alt 31)
 (princ))

 ; Ŀ
 ;   Ak32 - stars.                                                         
 ; 
 (DEFUN C:AK32 ()
  (alt 32)
 (princ))

 ; Ŀ
 ;   Ak33 - a skull.                                                       
 ; 
 (DEFUN C:AK33 ()
  (alt 33)
 (princ))

 ; Ŀ
 ;   Ak34 - copies.                                                        
 ; 
 (DEFUN C:AK34 ()
  (alt 34)
 (princ))

 ; Ŀ
 ;   Ak35 - a happier block.                                               
 ; 
 (DEFUN C:AK35 ()
  (alt 35)
 (princ))

 ; Ŀ
 ;   Ak36 - pang.                                                          
 ; 
 (DEFUN C:AK36 ()
  (alt 36)
 (princ))

 ; Ŀ
 ;   Ak37 - cvox.                                                          
 ; 
 (DEFUN C:AK37 ()
  (alt 37)
 (princ))

 ; Ŀ
 ;   Ak38 - square hf.                                                     
 ; 
 (DEFUN C:AK38 ()
  (alt 38)
 (princ))

 ; Ŀ
 ;   Ak39 - esrever.                                                       
 ; 
 (DEFUN C:AK39 ()
  (alt 39)
 (princ))

 ; Ŀ
 ;   Ak40 - numbers.                                                       
 ; 
 (DEFUN C:AK40 ()
  (alt 40)
 (princ))

 ; Ŀ
 ;   Ak41 - levels.                                                        
 ; 
 (DEFUN C:AK41 ()
  (alt 41)
 (princ))

 ; Ŀ
 ;   Ak42 - no levels.                                                     
 ; 
 (DEFUN C:AK42 ()
  (alt 42)
 (princ))

 ; Ŀ
 ;   Ak43 - Holy Roman Empire standards.                                   
 ; 
 (DEFUN C:AK43 ()
  (alt 43)
 (princ))

 ; Ŀ
 ;   Ak44 - not sure yet.                                                  
 ; 
 (DEFUN C:AK44 ()
  (alt 44)
 (princ))

 ; Ŀ
 ;   Ak45 - attributes upside down.                                        
 ; 
 (DEFUN C:AK45 ()
  (alt 45)
 (princ))

 ; Ŀ
 ;   Ak46 - S & C.                                                         
 ; 
 (DEFUN C:AK46 ()
  (alt 46)
 (princ))

 ; Ŀ
 ;   Ak47 - on top in reverse order.                                       
 ; 
 (DEFUN C:AK47 ()
  (alt 47)
 (princ))

(princ)
