 ; Ŀ
 ;   Alxlis - write the names of all referenced xrefs to a file, ignore    
 ;   duplicates.                                                           
 ;   Copyright 1997, 1998, 2000, 2011, 2018 by Rocket Software Ltd.        
 ;   Likes to have tize.lsp.                                               
 ;   Technology - fun stuff you could do if you didn't have more sense.    
 ; 

 ; Ŀ
 ;   Contx - Find all referenced xref definitions in the block tables.     
 ;   Takes no arguments.                                                   
 ;   Returns a list of lists: ((Blockname Filename)...)                    
 ; 
 (DEFUN CONTX (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (and (= 4 (logand 4 sevnt)) (= 32 (logand 32 sevnt)))
             (setq namlst (append namlst (list (list (cdr (assoc 2 bldat))
                                                   (cdr (assoc 1 bldat))))))))
 namlst)
 ; Ŀ
 ;   Contx end.                                                            
 ; 

 ; Ŀ
 ;   Alxlis.                                                               
 ; 
 (DEFUN C:ALXLIS (/ xlst fn sub filnam malist linn)
  (setvar "cmdecho" 0)
  (setq xlst (contx))
  (setq filnam (strcat (getvar "dwgprefix") "xrefs.txt"))
 ; Ŀ
 ;   Read the file into a list of strings.                                 
 ;   Kill any duplicates, just in case.                                    
 ; 
  (if (setq fn (open filnam "r"))
      (progn
           (while (setq linn (read-line fn))
                  (setq linn (strcase linn))
                  (if (not (member linn malist))
                      (setq malist (cons linn malist))))
           (close fn)))
 ; Ŀ
 ;   Add any from xlst which aren't already there.                         
 ; 
  (while (setq sub (car xlst))
         (setq xlst (cdr xlst))
         (setq sub (strcase (car sub))) ;  or cadr to include the path
         (if (not (member sub malist))
             (setq malist (cons sub malist))))
 ; Ŀ
 ;   Alphabetize the list.                                                 
 ; 
  (if (and malist (or tize (load "tize" ())))
      (setq malist (tize malist 1 nil)))
 ; Ŀ
 ;   Write the new list out to the original file name.                     
 ; 
  (setq fn (open filnam "w"))
  (while (setq sub (car malist))
         (setq malist (cdr malist))
         (write-line sub fn))
  (close fn)
 (princ))