 ; Ŀ
 ;   Asdic - find a file in a subdirectory of the current one.             
 ;   Copyright 2008, 2012 by Rocket Software Ltd.                          
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Asdic - search subdirectories for a file.                  
 ;   Arguments: Dirnam, a directory name.                                  
 ;              Filnam, a file name.                                       
 ;   Returns a filename with path or nil.                                  
 ;   Recursive.                                                            
 ; 
 (DEFUN ASDIC (dirnam filnam / sub found foundp dirlis num)
 ; Ŀ
 ;   See if the directory contains the desired file.                       
 ;   The documentation for Vl-directory-files is wrong in several ways:    
 ;   - An empty match pattern crashes and does not default to "*.*".       
 ;   - The returned file list is not - as implied - in upper case.         
 ;   - The number of arguments does not appear to be variable.             
 ;   However, search on a specific file name isn't case sensitive.         
 ; 
  (if (vl-directory-files dirnam filnam 1)
      (setq found (strcat dirnam filnam))
 ; Ŀ
 ;   Else check every subdirectory.                                        
 ; 
      (progn
           (setq dirlis (vl-directory-files dirnam "*.*" -1))
           (setq num 0)
           (while (and (null found)
                       (setq sub (nth num dirlis)))
                  (setq num (1+ num))
                  (if (and (not (member sub '("." "..")))
                           (setq foundp (asdic (strcat dirnam sub "\\")
                                               filnam)))
                      (setq found foundp)))))
 found)
 ; Ŀ
 ;   Subroutine Asdic end.                                                 
 ; 

 ; Ŀ
 ;   Asdic.                                                                
 ; 
 (defun c:asdic (/ dirac filnam)
  (setq dirac (getvar "dwgprefix"))
  (setq filnam "tempxxx.dwg")
  (print (asdic dirac filnam))
 (princ))