 ; Ŀ
 ;   Astra - test - draw some stars.                                       
 ;   Copyright 2011 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Cstar - draw an individual grstar (centred).               
 ;   Takes four arguments: centre point, side length, rotation (radians),  
 ;   and colour.  Returns nothing, but draws a star.                       
 ; 
 (DEFUN CSTAR (pa sidlen rota colo / anginc angg hafang pb)
  (setq px pa)
  (setq pa (polar pa (+ rota (/ pi 2)) (* sidlen 1.37638192)))
  (setq anginc (* 1.6 pi))
  (setq angg (+ rota (* 1.6 pi)))
  (setq hafang (* 0.8 pi))
  (repeat 5
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg anginc))
         (setq pa pb)
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg hafang))
         (setq pa pb))
 (princ))
 ; Ŀ
 ;   Subroutine Cstar end.                                                 
 ; 

 ; Ŀ
 ;   Subroutine Astra - make a multiple star.                              
 ;   Arguments: Pa, the centre point.                                      
 ;              Rad, the initial side length.                              
 ;              Rotinc, the rotation increment.                            
 ;              Inc, the size incremental multiplier.                      
 ;              Colo, the colour or list of colours.                       
 ;                    If this is a list then the colours are used in       
 ;                    sequence, wrapping when the end of the list is       
 ;                    reached.                                             
 ;                    If the first element is "A" then stars are drawn     
 ;                    until the list is used up and the last colour        
 ;                    repeats until reps ends.                             
 ;              Reps, the number of stars to draw.                         
 ;                    If this is 0 and Colo is a list then stars are       
 ;                    drawn until the list is used up.                     
 ;              If Colo starts with an "A" and reps is 0 then nothing      
 ;              will happen.                                               
 ;                                                                         
 ;   Calls Cstar, Returns nothing.                                         
 ; 
 (DEFUN ASTRA (pa rad rotinc inc colo reps / colx num coll len)
  (setq rota (/ pi 3))
  (cond ((and (= (type colo) 'list) (= (car colo) "A"))
         (setq colx (cdr colo))
         (setq coll (last colx))
         (while (< (length colx) reps)
                (setq colx (append colx (list coll))))
         (setq num 0)
         (setq len (length colx))
         (setq colo (car colx)))
        ((= (type colo) 'list)
         (setq len (length colo))
         (if (= reps 0) (setq reps len))
         (setq colx colo)
         (setq num 0)
         (setq colo (car colx))))
 ; Ŀ
 ;   Draw the stars.                                                       
 ; 
  (repeat reps
          (cstar pa rad rota colo)
          (if colx
             (progn
                  (setq num (1+ num))
                  (if (>= num len)
                      (setq num 0)) 
                  (setq colo (nth num colx))))
          (setq rota (+ rota rotinc))
          (setq rad (* rad inc)))
 (princ))
 ; Ŀ
 ;   Subroutine Astra end.                                                 
 ; 

 ; Ŀ
 ;   Astra.                                                                
 ; 
 (DEFUN C:ASTRA ()
 ; (setq rad (/ (getvar "viewsize") 65))
 ; (setq rota (/ pi 3))
 ; (setq pa (getpoint))
 ; (astra pa rad 0.125 1.09 5 25)
 ; (setq rad (/ (getvar "viewsize") 65))
 ; (setq rota (/ pi 3))
 ; (setq pa (getpoint))
 ; (astra pa rad 0.125 1.09 (list 10 240 12 242 14 244 16 246 18 248 250) 0)
 ; (setq rad (/ (getvar "viewsize") 65))
 ; (setq rota (/ pi 3))
 ; (setq pa (getpoint))
 ; (setq rad (/ (getvar "viewsize") 65))
 ; (setq rota (/ pi 3))
 ; (setq pa (getpoint))
 ; (astra pa rad 0.125 1.09 (list 50 51 52 53 54 55 56 57 58 59 250) 0)
 ; (setq rad (/ (getvar "viewsize") 65))
 ; (setq rota (/ pi 3))
 ; (setq pa (getpoint))
 ; (astra pa rad 0.125 1.09 (list "A" 50 51 52 53 54 55 56 57 58 59 5) 25)

  (setq rad (/ (getvar "viewsize") 65))
  (setq rota (/ pi 3))
  (setq pa (getpoint "Point: "))
  (astra pa rad 0.125 1.09 (list "A" 10 240 12 242 14 244 16 246 18 248 5) 25)

  (setq rad (/ (getvar "viewsize") 65))
  (setq rota (/ pi 3))
  (setq pa (getpoint "Point: "))
  (astra pa rad 0.125 1.09 (list "A" 50 51 52 53 54 55 56 57 58 59 1) 25)

  (setq rad (/ (getvar "viewsize") 65))
  (setq rota (/ pi 3))
  (setq pa (getpoint "Point: "))
  (astra pa rad 0.125 1.09 (list "A" 160 150 162 152 164 154 166 156 168 158 1) 25)

  (setq rad (/ (getvar "viewsize") 65))
  (setq rota (/ pi 3))
  (setq pa (getpoint "Point: "))
  (astra pa rad 0.125 1.09 (list "A" 140) 12)

  (setq rad (/ (getvar "viewsize") 65))
  (setq rota (/ pi 3))
  (setq pa (getpoint "Point: "))
  (astra pa rad 0.125 1.09 (list "A" 10 240 12 242 14 244 16 246 18 248 2) 25)

 (princ))