 ; Ŀ
 ;   Atrep - rearrange attributes in block inserts.                        
 ;   Copyright 2012 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Bloop - attribute reorderer.                               
 ;   Arguments: Lizz, a list: block name and new attribute order.          
 ;                    i.e. '("Ablock" 3 2 4 1)                             
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN BLOOP (lizz / blnam lizz num esav enam vals vala)
  (setq blnam (car lizz))
  (setq lizz (cdr lizz))
 ; Ŀ
 ;   Get an ss of blocks by that name.                                     
 ; 
  (if (setq ss (ssget "X" (list (cons 2 blnam))))
      (progn
 ; Ŀ
 ;   The selection set processor loop.                                     
 ; 
           (setq num 0)
           (while (setq esav (setq enam (ssname ss num)))
                  (setq num (1+ num))
 ; Ŀ
 ;   Step through the block and get attribute tags and values.             
 ;   (if there are attributes - the 66 sublist is present.)                
 ; 
                  (setq vals ())
                  (if (assoc 66 (entget enam))
                      (while (and (setq enam (entnext enam))
                                  (/= (cdr (assoc 0 (setq entt (entget enam))))
                                                                     "SEQEND"))
                             (setq vals (cons (cdr (assoc 1 entt)) vals))))
 ; Ŀ
 ;   If vals exists reorder it.                                            
 ;   If not then ... don't touch the block.                                
 ; 
                  (if vals
                      (progn
                           (setq vals (reol (reverse vals) lizz))
 ; Ŀ
 ;   And reapply the attribute values.                                     
 ; 
                           (setq enam esav)
                           (while (and (setq enam (entnext enam))
                                       (/= (cdr (assoc 0 (setq entt
                                                     (entget enam)))) "SEQEND")
                                       (setq vala (car vals)))
                                  (setq vals (cdr vals))
                                  (entmod (subst (cons 1 vala)
                                                 (assoc 1 entt) entt))))))))
 (princ))
 ; Ŀ
 ;   Bloop end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Reol - reorder a list based on a list of positions.        
 ;   Arguments: Lista, a list.                                             
 ;              Posi, a list of zero based position numbers.               
 ;   Calls nothing.                                                        
 ;   Returns a modified list.                                              
 ;   Missing values are replaced with nil.                                 
 ; 
 (DEFUN REOL (lista posi / num pos vala flist)
  (setq num 0)
  (while (setq pos (nth num posi))
         (setq num (1+ num))
         (setq vala (nth pos lista))
         (setq flist (cons vala flist)))
 (reverse flist))
 ; Ŀ
 ;   Subroutine Reol end.                                                  
 ; 

 ; Ŀ
 ;   Atrep.                                                                
 ; 
 (DEFUN C:ATREP (/ blist sub)
  (setvar "cmdecho" 0)
  (command ".undo" "be")
 ; Ŀ
 ;   Make an error handler.                                                
 ; 
  (defun *error* (shk)
   (if shk (print shk))
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
 ; Ŀ
 ;   Make a list of block names and new attribute orders.                  
 ; 
  (setq blist (list (list "left-arr" 2 1 0)))
  (while (setq sub (car blist))
         (setq blist (cdr blist)) 
         (bloop sub))
 ; Ŀ
 ;   End neatly.                                                           
 ; 
  (*error* ())
 (princ))
