 ; Ŀ
 ;   Bada - copy names from one directory to another.                      
 ;   Copyright 2013, 2018 by Rocket Software Ltd.                          
 ;                                                                         
 ; 

 ; Ŀ
 ;   Dirfe - get a list of filenames.                                      
 ;   Arguments: Pat, the file match pattern.                               
 ;              Pref, the directory to search.                             
 ;              Adpa, add a path to each file name.  (T or nil).           
 ;              Noext, remove the extensions.  (Same.)                     
 ;   Returns an alphabetical list of filenames with paths.                 
 ; 
 (DEFUN DIRFE (pat pref adpa noext / fils num fnam nulis)
  (if (setq fils (vl-directory-files pref pat 1))
      (progn
 ; Ŀ
 ;   Put the filename list in alphabetical order.                          
 ; 
           (setq fils (vl-sort fils '<))
           (setq num 0)
           (while (and fils (setq fnam (nth num fils)))
                  (setq num (1+ num))
                  (if adpa (setq fnam (strcat pref fnam)))
                  (if noext (setq fnam (vl-filename-base fnam)))
                  (setq nulis (cons fnam nulis)))))
 (reverse nulis))
 ; Ŀ
 ;   Dirfe end.                                                            
 ; 

 ; Ŀ
 ;   Bada.                                                                 
 ; 
 (DEFUN C:BADA (/ cdir cdira cdirb lista listb num fnama fnamb fgnu)
 ; Ŀ
 ;   Get a list of files in each of the two subdirectories aaa and bbb.    
 ; 
  (setq cdir (getvar "dwgprefix"))
  (setq cdira (strcat cdir "aaa\\"))
  (setq cdirb (strcat cdir "bbb\\"))
  (setq lista (dirfe "*.dwg" cdira  nil t))
  (setq listb (dirfe "*.pdf" cdirb t nil))
 ; Ŀ
 ;   While there are files in each list, rename those in listb.            
 ; 
  (setq num 0)
  (while (and (setq fnama (nth num lista))
              (setq fnamb (nth num listb)))
         (setq num (1+ num))
         (setq fgnu (strcat cdirb fnama ".pdf"))
         (vl-file-rename fnamb fgnu))
 (princ))