 ; Ŀ
 ;   Blam: explode blocks neatly.                                          
 ;   Blamm: explode blocks neatly, colour everything bylayer.              
 ;   Bran: convert attributes to text, kill everything else.               
 ;   Replace attributes with text, move entities on layer 0 to the layer   
 ;   the block was on, set colour and linetype to those of the original    
 ;   block for subentities which were coloured and linetyped byblock.      
 ;   Currently deletes invisible attributes - see (txmake).                
 ;   Copyright 1991, 1995, 1999, 2005, 2008 - 2014 by Rocket Software Ltd. 
 ;   Another subversive program from Rocket.                               
 ; 

 ; Ŀ
 ;   Dslap - replace "\p" in a text entity with a space.                   
 ;   Takes one argument: Enam, the text entity name.                       
 ;   TCalls Chug, returns nothing.                                         
 ; 
 (DEFUN DSLAP (enam / pos chnum changd newlen oldlen chunk)
  (setq entt (entget enam))
  (setq str (cdr (setq asoc1 (assoc 1 entt))))
  (setq strp (chug "\\P" " " str))
  (if (< 0 (cadr strp))
      (entmod (subst (cons 1 (car strp)) asoc1 entt)))
 (princ))
 ; Ŀ
 ;   Dslap end.                                                            
 ; 

 ; Ŀ
 ;   Chug - string substitution engine.  Takes the search string, the      
 ;   replacement string, and the target string as arguments, and returns   
 ;   a list of the (possibly modified) target string and the number of     
 ;   changes made.                                                         
 ; 
 (DEFUN CHUG (oldstr newstr exstr / pos chnum changd newlen oldlen chunk)
  (setq pos 1)
  (setq chnum 0)
  (setq changd ())
  (setq newlen (strlen newstr))
  (setq oldlen (strlen oldstr))
  (while (= oldlen (strlen (setq chunk (substr exstr pos oldlen))))
         (if (= chunk oldstr)
             (progn
                  (setq exstr (strcat (substr exstr 1 (1- pos))
                                       newstr
                                      (substr exstr (+ pos oldlen))))
                  (setq changd t)
                  (setq chnum (1+ chnum))
                  (setq pos (+ pos newlen)))
             (setq pos (1+ pos))))
 (list exstr chnum))
 ; Ŀ
 ;   Chug end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Newent - deal with entities created by Txmake or by        
 ;   exploding the block.  Erase Attdefs and empty text strings, redraw    
 ;   other text (which will have been messed up when the attribute under   
 ;   it was erased), move any entities on layer 0 to the current layer     
 ;   and change any coloured or linetyped entities.                        
 ;   Arguments: Aa, the last entity before the block was exploded.         
 ;              Blay, the layer containin the original block.              
 ;              Bcol, the colour of the original block.                    
 ;              Blt, the linetype of the original block.                   
 ;              Cola, t = if a block is colored byblock, colour it         
 ;                        the block color, else bylayer.                   
 ;                    nil, colour everything bylayer.                      
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN NEWENT (aa blay bcol blt cola / ss del aaa clr vall)
  (setq del 0)                                 ; empty string counter
  (setq ss (ssadd))                            ; text selection set for redraw
  (while (setq aa (entnext aa))                ; while there is another entity
         (setq aaa (entget aa))                ; get its data
 ; Ŀ
 ;   If the entity was on layer 0, move it to the layer the block was on.  
 ; 
         (if (= (cdr (assoc 8 aaa)) "0")
             (progn
                  (entmod (setq aaa (subst (cons 8 blay) (assoc 8 aaa) aaa)))
                  (setq aaa (entget aa))))
 ; Ŀ
 ;   If the entity was linetyped byblock, change it to the block linetype  
 ;   if there was one, else to bylayer.                                    
 ; 
         (if (and (setq ltyp (assoc 6 aaa))
                  (= (strcase (cdr ltyp) t) "byblock"))
             (progn
                  (if blt
                      (entmod (setq aaa (subst (cons 6 blt) ltyp aaa)))
                      (entmod (setq aaa (subst (cons 6 "bylayer") ltyp aaa))))
                  (setq aaa (entget aa))))
 ; Ŀ
 ;   If the entity was coloured byblock, change it to the block colour     
 ;   if there was one, else to bylayer.                                    
 ; 
         (cond ((and cola (= (cdr (setq clr (assoc 62 aaa))) 0))
                (if bcol
                    (entmod (setq aaa (subst (cons 62 bcol) clr aaa)))
                    (entmod (setq aaa (subst (cons 62 256) clr aaa))))
                (setq aaa (entget aa)))

 ; what's with that last line? ... oh - reget changed data just in case.
 ; If an entity is already coloured, and not by block, then don't recolour it.




 ;              ((setq clr (assoc 62 aaa))
 ;               (entmod (setq aaa (subst (cons 62 256) clr aaa))))
)
 ; Ŀ
 ;   If the entity was an attdef, erase it.                                
 ; 
         (cond ((= (cdr (assoc 0 aaa)) "ATTDEF")
                (entdel aa))
 ; Ŀ
 ;   If the entity was an empty text string, erase it.                     
 ; 
               ((= (cdr (assoc 0 aaa)) "TEXT")
                (setq vall (cdr (assoc 1 (entget aa))))
                (if (member vall '("" " " "  "))
                    (progn
                         (setq del (1+ del))
                         (entdel aa))
                    (ssadd aa ss)))))
 ; Ŀ
 ;   Redraw the selection set.                                             
 ; 
  (while (setq aa (ssname ss 0))
         (redraw aa)
         (ssdel aa ss))
 ; Ŀ
 ;   Sum up and end.                                                       
 ; 
  (cond ((= 1 del)
         (write-line "\n1 vacant text string erased."))
        ((< 1 del)
         (write-line (strcat "\n" (itoa del)
                             " empty text strings eradicated."))))
 (princ))
 ; Ŀ
 ;   Newent end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Suck - copy an attribute as a text entity.                 
 ;   Argument: Entt, an entity data list.                                  
 ;   Calls nothing, Returns nothing.                                       
 ;                                                                         
 ;   Programming note: for mtext and multiline attributes the ten and      
 ;   eleven points may not be on the same line, so the new text may        
 ;   be strangely rotated - this seems to take precedence over the fifty   
 ;   sublist.                                                              
 ;   Probably fixing this for mtext would require code to check for        
 ;   alignment and make a new ten or eleven code.                          
 ;   This seems to work fine for all multiline attributes.                 
 ;   I have no idea why it doesn't work for mtext.                         
 ; 
 (DEFUN SUCK (entt / bbf nn sub asonum oklis)
  (setq oklis '(1 7 10 11 40 41 50 51 67 71 72))
  (setq bbf (list (cons 0 "TEXT")))
  (setq nn 0)
  (while (setq sub (nth nn entt))
         (setq asonum (car sub))
         (cond ((member asonum oklis)
                (if (setq suba (assoc asonum bbf))
                    (if (= asonum 1)
                        (setq bbf (subst sub suba bbf)))
                    (setq bbf (cons sub bbf))))
               ((= 74 asonum)
                (setq bbf (cons (cons 73 (cdr sub)) bbf)))
               ((= 8 asonum)
                (if (= (cdr sub) "0")
                    (setq bbf (cons (cons 8 "TEXT") bbf))
                    (setq bbf (cons sub bbf)))))
         (setq nn (1+ nn)))
 (setq bbf (reverse bbf)))
 ; Ŀ
 ;   Suck end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Txmake - duplicate attributes with text entities.          
 ;   Arguments: Blenam, the attribute entity name.                         
 ;              Kilinv, if t then erase invisible attributes.              
 ;   Calls nothing, returns nothing, collects barnacles.                   
 ; 
 (DEFUN TXMAKE (blenam kilinv / conv bb blenam entt)
  (setq conv 0)
  (while (/= (cdr (assoc 0 (setq bb 
             (entget (setq blenam (entnext blenam)))))) "SEQEND")
         (if (not (and kilinv (= 1 (logand 1 (cdr (assoc 70 bb))))))
             (progn
                  (setq conv (1+ conv))
                  (setq entt (suck bb))
                  (entmake entt)
 ; Ŀ
 ;   Remove \P from the text string if necessary.                          
 ;   This is for those wretched multiline attributes.                      
 ; 
                  (dslap (entlast)))))
 ; Ŀ
 ;   Print a summary of what was done.                                     
 ; 
  (prompt (strcat "\n" (itoa conv) " attribute" 
                  (if (/= conv 1) "s" "") " converted."))
 (princ))
 ; Ŀ
 ;   Txmake end.                                                           
 ; 

 ; Ŀ
 ;   Bran - convert attributes to text, kill everything else.              
 ; 
 (DEFUN C:BRAN (/ ss num bbn)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq ss (ssget (list (cons 0 "insert"))))
  (setq num 0)
  (while (and ss (setq bbn (ssname ss num)))
 ; Ŀ
 ;   If the block has attributes call Txmake to replace them with text.    
 ; 
         (if (assoc 66 (entget bbn))
             (txmake bbn t))
         (entdel bbn)          ; erase the block - no need to explode it
         (setq num (1+ num)))
  (command "undo" "end")
 (princ))

 ; Ŀ
 ;   Blamm.                                                                
 ; 
 (DEFUN C:BLAMM (/ ss num bbn bb blay bcol blt aa)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq ss (ssget))
  (setq num 0)
  (while (and ss (setq bbn (ssname ss num)))
         (setq bb (entget bbn))
         (if (= (cdr (assoc 0 bb)) "INSERT")
             (progn                                   ; if it's a block
                  (setq blay (cdr (assoc 8 bb)))      ; block layer
                  (setq bcol (cdr (assoc 62 bb)))     ; block colour
                  (setq blt (cdr (assoc 6 bb)))       ; block linetype
 ; Ŀ
 ;   If the block has attributes call Txmake to replace them with text.    
 ; 
                  (setq aa (entlast))                 ; save last ename
                  (if (assoc 66 bb)
                      (txmake bbn t))
                  (command ".explode" bbn)            ; explode the block
                  (newent aa blay bcol blt nil)))     ; deal with new entities
         (setq num (1+ num)))
  (command "undo" "end")
 (princ))


 ; Ŀ
 ;   Blam - the forebrain.                                                 
 ; 
 (DEFUN C:BLAM (/ ss num bbn bb blay bcol blt aa)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq ss (ssget))
  (setq num 0)
  (while (and ss (setq bbn (ssname ss num)))
         (setq bb (entget bbn))
         (if (= (cdr (assoc 0 bb)) "INSERT")
             (progn                                   ; if it's a block
                  (setq blay (cdr (assoc 8 bb)))      ; block layer
                  (setq bcol (cdr (assoc 62 bb)))     ; block colour
                  (setq blt (cdr (assoc 6 bb)))       ; block linetype
 ; Ŀ
 ;   If the block has attributes call Txmake to replace them with text.    
 ; 
                  (setq aa (entlast))                 ; save last ename
                  (if (assoc 66 bb)
                      (txmake bbn t))
                  (command ".explode" bbn)            ; explode the block
                  (newent aa blay bcol blt t)))       ; deal with new entities
         (setq num (1+ num)))
  (command "undo" "end")
 (princ))