 ; Ŀ
 ;   Bliss - write the names of all blocks to a file, ignore duplicates.   
 ;   Copyright 1997, 1998, 2000, 2011, 2018 by Rocket Software             
 ;   Technology - fun stuff you could do if you didn't have more sense.    
 ; 
 (DEFUN C:BLISS (/ rew bldat xlst filnam fn linn malist sub)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   Get a list of all block names in the block tables.                    
 ; 
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq xlst (append xlst (list (cdr (assoc 2 bldat))))))
 ; Ŀ
 ;   Get a file name.                                                      
 ; 
  (setq filnam (strcat (getvar "dwgprefix") "All Blocks.txt"))
 ; Ŀ
 ;   Read the file into a list of strings.                                 
 ;   Kill any duplicates, just in case.                                    
 ; 
  (if (setq fn (open filnam "r"))
      (progn
           (while (setq linn (read-line fn))
                  (setq linn (strcase linn))
                  (if (not (member linn malist))
                      (setq malist (cons linn malist))))
           (close fn)))
 ; Ŀ
 ;   Add any from xlst which aren't already there.                         
 ; 
  (while (setq sub (car xlst))
         (setq xlst (cdr xlst))
         (setq sub (strcase sub))
         (if (not (member sub malist))
             (setq malist (cons sub malist))))
 ; Ŀ
 ;   Alphabetize the list.                                                 
 ; 
  (if (and malist (or tize (load "tize" ())))
      (setq malist (tize malist 1 nil)))
 ; Ŀ
 ;   Write the new list out to the original file name.                     
 ; 
  (setq fn (open filnam "w"))
  (while (setq sub (car malist))
         (setq malist (cdr malist))
         (write-line sub fn))
  (close fn)
 (princ))