 ; Ŀ
 ;   Cala - make the rocket layer set.                                     
 ;   Copyright 2010, 2012, 2013 by Rocket Software Ltd.                    
 ;   If a layer exists but has the wrong colour or linetype, fix it.       
 ;   If it doesn't exist, make it.                                         
 ;   This calls parts of Malaya, which it must be able to find.            
 ;   If Heisenberg was right, could you make a monitor with such a         
 ;   high resolution that you couldn't see the image?                      
 ; 
 (DEFUN C:CALA (/ clay maclst lanam laydat)
  (setq clay (getvar "clayer"))
 ; Ŀ
 ;   Load Malaya which contains the subroutines.                           
 ; 
  (if (null malaya)
      (if (null (load "malaya" ()))
          (prompt "\n** The File Malaya.lsp Is Not Available. **\n")))
 ; Ŀ
 ;   Make the list of layer names.                                         
 ; 
  (setq maclst (list "Areaclass" "Background" "Border" "Building" "Busbar"
                     "Center" "Cable" "Cableug" "Defpoints" "Dimension"
                     "Equipment" "Field" "Frame" "Future" "Grid" "Ground"
                     "Hatch" "Trace" "Hidden" "Matchline" "Misc" "Panel"
                     "Symbol" "Text" "Text2" "Text3" "Tray" "Viewport"))
 ; Ŀ
 ;   Now step through the desired layer list and call malaya to make or    
 ;   fix each one.                                                         
 ; 
  (while (setq lanam (car maclst))
         (setq maclst (cdr maclst))
         (setq lanam (strcase lanam t))
         (malaya lanam))
  (command ".regenall")
 ; Ŀ
 ;   And make sure all layer names are in initial capitals.                
 ; 
  (if c:lea (c:lea))
  (setvar "clayer" clay)
 (princ))