 ; Ŀ
 ;   Cg - see what xref 70 codes mean.                                     
 ;   Also contains Pbl - print the headers from the block tables.          
 ;   Copyright 2011 by Rocket Software Ltd.                                
 ;   Lisp looks different since emoticons were invented.                   
 ; 

 ; Ŀ
 ;   Block and xref 70 codes:                                              
 ;   1: Anonymous block - hatch, dimension, etc.                           
 ;   2: It has attributes and they're all non-constant.                    
 ;   4: it's an xref.                                                      
 ;   8: It's an overlay - seems to always go with 4.                       
 ;   16: Externally dependent - it's a block in an xref but not an xref.   
 ;   32: Resolved xref or thing from one - set if a thing show up.         
 ;   64: Referenced xref.  No idea.                                        
 ;   Note that overlays in other xrefs don't appear in the block tables.   
 ;   Xrefs which aren't inserted in the dwg are purged when it's closed.   
 ; 

 ; Ŀ
 ;   Bitz - dismantle a number.                                            
 ;   Argument: Numa, an integer.                                           
 ;   Prints a column of numbers, Returns them as a list.                   
 ; 
 (DEFUN BITZ (numa / valist base numlis)
  (setq valist '((1 . "anonymous block")
                 (2 . "non-constant attributes")
                 (4 . "xref")
                 (8 . "which is an overlay")
                 (16 . "externally dependent")
                 (32 . "resolved xref or part of one")
                 (64 . "referenced xref")))
  (write-line (strcat "\nValue: " (itoa numa)))
  (setq base 1)
  (while (>= numa base)
         (if (= base (logand base numa))
             (progn
                  (write-line (strcat (itoa base) " "
                                      (cdr (assoc base valist))))
                  (setq numlis (cons base numlis)))
             (write-line (itoa base)))
         (setq base (* base 2)))
 (reverse numlis))
 ; Ŀ
 ;   Bitz end.                                                             
 ; 

 ; Ŀ
 ;   Gnx - Find all xref definitions in the block tables.                  
 ;   Takes no arguments.                                                   
 ;   Returns a list of block head entity lists.                            
 ; 
 (DEFUN GNX (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (= 4 (logand 4 sevnt))
             (setq namlst (cons bldat namlst))))
 namlst)
 ; Ŀ
 ;   Gnx end.                                                              
 ; 

 ; Ŀ
 ;   Gnox - Find all definitions in the block tables which aren't xrefs.   
 ;   Takes no arguments.                                                   
 ;   Returns a list of block head entity lists.                            
 ; 
 (DEFUN GNOX (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (= 0 (logand 4 sevnt))
             (setq namlst (cons bldat namlst))))
 namlst)
 ; Ŀ
 ;   Gnox end.                                                             
 ; 

 ; Ŀ
 ;   Pbl - print the block table headers.                                  
 ;   Takes no arguments.                                                   
 ;   Returns nothing.                                                      
 ; 
 (DEFUN C:PBL (/ rew bldat malist)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq malist (append malist (list bldat)))
         (print bldat))
 (princ))
 ; Ŀ
 ;   Gnox end.                                                             
 ; 

 ; Ŀ
 ;   Cg.                                                                   
 ; 
 (DEFUN C:CG (/ xnames num sub)
  (write-line "\n\n*** Xrefs ***")
  (setq xnames (gnx))
  (setq num 0)
  (while (setq sub (nth num xnames))  
         (setq num (1+ num))
         (print (cdr (assoc 2 sub)))
         (bitz (cdr (assoc 70 sub))))
  (write-line "\n*** Not Xrefs* ***.")
  (setq xnames (gnox))
  (setq num 0)
  (while (setq sub (nth num xnames))  
         (setq num (1+ num))
         (print (cdr (assoc 2 sub)))
         (bitz (cdr (assoc 70 sub))))
 (princ))