 ; Ŀ
 ;   Circut - insert a block on the intersection of two or more lines,     
 ;   cut an appropriate sized chunk out of each one.                       
 ;   Copyright 1994, 2010, 2013 by Rocket Software Ltd.                    
 ;   Why are there sugar cubes but no milk cubes?                          
 ; 

 ; Ŀ
 ;   Glint - get all entities of a given type crossing a point.            
 ;   Arguments: Pa, a point.                                               
 ;              Diss, the search area size, theoretically dimscale.        
 ;              Etype, the entity type string.  Apparently "line,pline"    
 ;                     etc. can be used.                                   
 ;   Calls nothing, returns an ss.                                         
 ; 
 (DEFUN GLINT (pa diss etype / pa0 pa1)
  (setq pa0 (polar pa (/ pi 4) diss))
  (setq pa1 (polar pa (* 1.25 pi) diss))
 (ssget "c" pa0 pa1 (list (cons 0 etype))))
 ; Ŀ
 ;   Glint end.                                                            
 ; 

 ; Ŀ
 ;   Circut.                                                               
 ; 
 (DEFUN C:CIRCUT (/ *error* osmo rota scal pa pb pc ss xa xb)
  (setq name (getstring))
  (setq dist (getdist))
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq osmo (getvar "osmode"))
  (setvar "osmode" 0)
 ; Ŀ
 ;   Make an error handler.                                                
 ; 
  (defun *error* (shk)
   (setvar "osmode" osmo)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
 ; Ŀ
 ;   Try to load Misps.lsp, which contains the subroutines for scaling     
 ;   differently in model and paper space.                                 
 ; 
  (if (or (null wasp) (null misps))
      (if (null (load "misps" ()))
          (prompt "\n** The File Misps.lsp Is Not Available. **\n")))
 ; Ŀ
 ;   Get the scale, depending on which space we are in and other things.   
 ; 
  (if misps
      (setq scal (misps))
      (setq scal (getvar "dimscale")))
 ; Ŀ
 ;   Figure out the actual cut distance.                                   
 ; 
  (setq dist (* dist scal))
  (setq pa (getpoint "Insertion point:"))
  (setq pb (osnap pa "Intersec"))         ; look for an intersection
  (if pb (setq pa pb)                     ; if an intersec, use it
         (setq pc (osnap pa "nearest")))  ; if no int found, try for nearest
  (if pc (setq pa pc))                    ; if a nearest, go for it
 ; Ŀ
 ;   Call Glint to get anything crossing the point.                        
 ; 
  (setq ss (glint pa (* scal 1.5) "line,polyline"))
  (setq num 0)
 ; Ŀ
 ;   Not used at the current state of the art.                             
 ; 
;  (while (and ss (setq enam (ssname ss num)))
;         (if (/= (cdr (assoc 0 (entget enam))) "LINE")
;             (ssdel enam ss)
;             (setq num (1+ num))))
 ; Ŀ
 ;   CHop each line or polyline.                                           
 ; 
  (if (and ss (> (sslength ss) 0))
      (progn
           (while (setq enam (ssname ss 0))
                  (setq entt (entget enam))
                  (setq rota (angle (cdr (assoc 10 entt))
                                    (cdr (assoc 11 entt))))
                  (if (and (> rota (/ pi 2)) (<= rota (* pi 1.5)))
                      (setq rota (+ rota pi)))
                  (setq xa (polar pa rota dist))
                  (setq xb (polar pa rota (- dist)))
                  (command "break" pa "f" xa xb)
                  (ssdel enam ss))))
 ; Ŀ
 ;   Chop each line or polyline.                                           
 ; 
  (command "insert" name pa scal "" 0)         ; insert, no rotation
  (*error* ())
 (princ))
