 ; Ŀ
 ;   Comb - compare two blocks by attribute name.                          
 ;   Copyright 1994, 2007, 2010 by Rocket Software Ltd.                    
 ;   Hi-diddly-Hey!  (Added by Samuel)                                     
 ; 

 ; Ŀ
 ;   Subroutine Cstar - draw an individual grstar (centred).               
 ;   Takes four arguments: centre point, side length, rotation (radians),  
 ;   and colour.  Returns nothing, but draws a star.                       
 ; 
 (DEFUN CSTAR (pa sidlen rota colo / anginc angg hafang pb)
  (setq pa (polar pa (+ rota (/ pi 2)) (* sidlen 1.37638192)))
  (setq anginc (* 1.6 pi))
  (setq angg (+ rota (* 1.6 pi)))
  (setq hafang (* 0.8 pi))
  (repeat 5
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg anginc))
         (setq pa pb)
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg hafang))
         (setq pa pb))
 (princ))
 ; Ŀ
 ;   Subroutine Cstar end.                                                 
 ; 

 ; Ŀ
 ;   Spit - returns the insertion point of the text entity whose data was  
 ;   passed as its sole argument.  Note that this is not necessarily the   
 ;   same as the 10 association code.                                      
 ; 
 (DEFUN SPIT (entt / xjust yjust)
  (setq xjust (cdr (assoc 72 entt)))
  (if (= (cdr (assoc 0 entt)) "ATTDEF")
      (setq yjust (cdr (assoc 74 entt)))
      (setq yjust (cdr (assoc 73 entt))))
  (if (or (/= xjust 0) (/= yjust 0))
      (cdr (assoc 11 entt))
      (cdr (assoc 10 entt))))
 ; Ŀ
 ;   Spit end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Tapo - make a list of the tag and insertion of each        
 ;   attribute in a block insertion.                                       
 ; 
 (DEFUN TAPO (enam / entt tagg suba ten)
  (while (/= "SEQEND" (cdr (assoc 0 (setq entt
                                (entget (setq enam (entnext enam)))))))
         (setq tagg (cdr (assoc 2 entt)))
         (setq ten (spit entt))
         (setq suba (cons (list tagg ten) suba)))
 (reverse suba))
 ; Ŀ
 ;   Tapo end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Comb - match two blocks.                                   
 ;   Argument: Hau, "o" = order, "t" = tag.                                
 ;   Calls Tapo\Spit, Returns nothing.                                     
 ;   Draws stars and lines.                                                
 ; 
 (DEFUN COMB (hau / rad snapp *error* enama entt enamb alist blist num suba
                                                                       subb)
  (setvar "cmdecho" 0)
  (setq rad (/ (getvar "viewsize") 95))
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
 ; Ŀ
 ;   Make an error handler.                                                
 ; 
  (defun *error* (shk)
   (setvar "snapmode" snapp)
   (if shk (print shk))
  (princ))
 ; Ŀ
 ;   Get two block insertions.                                             
 ; 
  (if (and (setq enama (car (setq enampt (entsel "First Block: "))))
           (setq entt (entget enama))
           (cstar (cadr enampt) rad 0 1)
           (= (cdr (assoc 0 entt)) "INSERT")
           (assoc 66 entt)
           (setq enamb (car (setq enampt (entsel "\nAnother Block: "))))
           (setvar "snapmode" snapp)  ; as soon as possible
           (setq entt (entget enamb))
           (cstar (cadr enampt) rad 1 2)
           (= (cdr (assoc 0 entt)) "INSERT")
           (assoc 66 entt))
 ; Ŀ
 ;   Make the blocks into two lists of attribute tags and locations.       
 ;   The list design is: ((tag point) ...)                                 
 ; 
      (progn
           (setq alist (tapo enama))
           (setq blist (tapo enamb))
 ; Ŀ
 ;   Step through alist, whenever there's a matching tagg in blist grdraw  
 ;   a line connecting them.                                               
 ; 
           (cond ((= hau "t")
                  (setq num 0)
                  (while (setq suba (nth num alist))
                         (setq num (1+ num))
                         (if (setq subb (assoc (car suba) blist))
                             (grdraw (cadr suba) (cadr subb) 4))))
 ; Ŀ
 ;   Or step through both lists, connect attributes in the same position   
 ;   with grdraw lines.                                                    
 ; 
                 ((= hau "o")
                  (setq num 0)
                  (while (and (setq suba (nth num alist))
                              (setq subb (nth num blist)))
                         (setq num (1+ num))
                         (grdraw (cadr suba) (cadr subb) 5))))))
 (princ))
 ; Ŀ
 ;   Subroutine Comb end.                                                  
 ; 

 ; Ŀ
 ;   Comp - by position (i.e. in order.)                                   
 ; 
 (DEFUN C:COMP ()
  (comb "o")
 (princ))

 ; Ŀ
 ;   Comb - by matching attribute tag.                                     
 ; 
 (DEFUN C:COMB ()
  (comb "t")
 (princ))