 ; Ŀ
 ;   Dasho - change 2010.09.09 to 10/09/09 in a whole drawing.             
 ;   See also Oshad which reverses this.                                   
 ;   Copyright 1995, 1997, 1998, 2004, 2010 by Rocket Software Ltd.        
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Dasho - reformat a date.                                   
 ;   Arguments: Tess, a string which may be a date in yyyy.mm.dd format.   
 ;   Calls Splat, returns a new date string or nil.                        
 ; 
 (DEFUN DASHO (tess / liss yy gnudat)
  (if (wcmatch tess "####`.##`.##")
      (progn
           (setq liss (splat "." tess))
           (if (= (strlen (setq yy (car liss))) 4)
               (setq yy (substr yy 3)))
           (setq gnudat (strcat yy "/" (cadr liss) "/" (caddr liss)))))
 gnudat)
 ; Ŀ
 ;   Subroutine Dasho end.                                                 
 ; 

 ; Ŀ
 ;   Mark - mark a point.                                                  
 ;   Arguments: Pa - the point to mark.                                    
 ;              Rad - the marker segment length.                           
 ;              Colo - the marker grdraw line colour.                      
 ; 
 (DEFUN MARK (pa rad colo /)
  (grdraw (polar pa (/ pi 4) rad) (polar pa (* 1.25 pi) rad) colo)
  (grdraw (polar pa (* pi 0.75) rad) (polar pa (* pi 1.75) rad) colo)
 (princ))
 ; Ŀ
 ;   Mark end.                                                             
 ; 

 ; Ŀ
 ;   Nultch - change one substring to another in everything.               
 ;   Arguments: Notouch - the list of block names not to modify.           
 ;              Proog - date reformatter to call.                          
 ;   Returns a list: number of text entities changed, number of            
 ;   number of attributes changed.                                         
 ; 
 (DEFUN NULTCH (notouch proog / chlin chnum rad ss len num strch enam txt entt
                                                       altr pa attch esub chg)
  (setq chlin 0)
  (setq chnum 0)
  (setq rad (/ (getvar "viewsize") 45))
 ; Ŀ
 ;   Change text.                                                          
 ; 
  (setq ss (ssget "X" (list (cons 0 "TEXT"))))
  (if ss (setq len (strcat "/" (itoa (sslength ss)) ":Txt ")))
  (setq num 0)
  (setq strch 0)
  (while (and ss (setq enam (ssname ss num)))
         (grtext -2 (strcat (itoa (setq num (1+ num))) len))
         (setq txt (cdr (assoc 1 (setq entt (entget enam)))))
         (setq altr (proog txt))
         (if altr                          ; if any changes made
             (progn
                  (setq strch (1+ strch))
                  (setq pa (cdr (assoc 10 entt)))
                  (mark pa rad 1)
                  (entmod (subst (cons 1 altr) (assoc 1 entt) entt)))))
 ; Ŀ
 ;   Attributes.                                                           
 ; 
  (setq num 0)
  (setq attch 0)
  (setq ss (ssget "X" (list (cons 66 1) (cons 0 "INSERT"))))
  (if ss (setq len (strcat "/" (itoa (sslength ss)) ":Att")))
  (while (and ss (setq enam (ssname ss num)))
         (setq esub (entnext enam))
         (grtext -2 (strcat (itoa (setq num (1+ num))) len))
         (setq chg ())
         (while (and (not (member (cdr (assoc 2 (entget enam))) notouch))
                     (/= "SEQEND" (cdr (assoc 0 (setq entt (entget esub))))))
                (setq txt (cdr (assoc 1 entt)))
                (setq altr (proog txt))
                (if altr                    ; if any changes made
                    (progn
                         (setq chg T)
                         (setq attch (1+ attch))
                         (setq pa (cdr (assoc 10 entt)))
                         (mark pa rad 7)
                         (entmod (subst (cons 1 altr) (assoc 1 entt) entt))))
                (setq esub (entnext esub)))
         (if chg (entupd enam)))
 (list strch attch))
 ; Ŀ
 ;   Nultch end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Splat - divide a text string into a list of substrings.    
 ;   Arguments: Sepchr, the field separator character.                     
 ;              Linn, the text string.                                     
 ;   Returns a list of field values, removes leading and trailing spaces.  
 ;                                                                         
 ;   Completely rewritten 11.19.2000.                                      
 ; 
 (DEFUN SPLAT (sepchr linn / pos len name1 strlst)
  (while (/= (strlen linn) 0)
 ; Ŀ
 ;   Find the first separator character, save everything before it into    
 ;   the Name1 variable, remove it from the start of the string Linn.      
 ; 
         (setq pos 1)
         (setq len (strlen linn))
         (while (and (/= (substr linn pos 1) sepchr)
                     (>= len pos))
                (setq pos (1+ pos)))
         (setq name1 (substr linn 1 (1- pos)))
         (setq linn (substr linn (1+ pos)))
 ; Ŀ
 ;   Remove spaces from the front and back of Name1.                       
 ; 
         (while (and (> (strlen name1) 0)
                     (= (substr name1 (setq len (strlen name1))) " "))
                (setq name1 (substr name1 1 (1- len))))
         (while (and (> (strlen name1) 0)
                     (= (substr name1 1 1) " "))
                (setq name1 (substr name1 2)))
 ; Ŀ
 ;   Add Name1 to the substring list Strlst.                               
 ; 
         (setq strlst (append strlst (list name1))))
 ; Ŀ
 ;   If the string contained no separator characters then Strlst will be   
 ;   nil, so return a list containing the original string.                 
 ; 
  (if (null strlst) (setq strlst (list linn)))
 strlst)
 ; Ŀ
 ;   Splat end.                                                            
 ; 

 ; Ŀ
 ;   Dasho.                                                                
 ; 
 (DEFUN C:DASHO (/ picks *error* notouch chglst)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   This turns off group selection - otherwise entities in groups may     
 ;   be changed twice with bad things happening as a result.               
 ; 
  (setq picks (getvar "pickstyle"))
  (setvar "pickstyle" 0)
 ; Ŀ
 ;   Something is bound to go wrong.                                       
 ; 
  (defun *error* (shk)
   (setvar "pickstyle" picks)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (print shk))
  (princ))
 ; Ŀ
 ;   Do it.                                                                
 ; 
  (setq notouch ())
  (setq chglst (nultch notouch dasho))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
  (*error* ())
 (princ))
