 ; Ŀ
 ;   Dill - preload any .lsp files found in *:\Rocket\Lisp\Load\           
 ;   Dille - load any .lsp files found in *:\Rocket\Lisp\Load\             
 ;   Dyll - preload any .lsp files in the dir containing the current dwg.  
 ;   Dylle - load any .lsp files in the dir containing the current dwg.    
 ;                                                                         
 ;   Copyright 1994, 1995, 2002, 2005, 2011, 2012 by Rocket Software Ltd.  
 ;   Not named after the pickles of the same name.                         
 ;                                                                         
 ;   Stub preloaders assume that files contain only one c:routine and      
 ;   it has the same name as the file.                                     
 ; 

 ; Ŀ
 ;   Dill - lisp loader.                                                   
 ;   Arguments: Pref, the directory to search.                             
 ;              Preloa, T = preload, nil = load.                           
 ;   Calls Dirfe and Plode, Returns nothing.                               
 ; 
 (DEFUN DILL (pref preloa / flist num filnam)
 ; Ŀ
 ;   Get a list of the files in the directory, if any.                     
 ;   This also picks up *.lspx, so be careful.                             
 ; 
  (if (setq flist (dirfe "*.lsp" pref t nil))
      (progn
           (setq num 0)
           (while (setq filnam (nth num flist))
                  (setq num (1+ num))
 ;                (print filnam)
 ; Ŀ
 ;   It initially appeared that calling c:dyll\dill from Local.lsp would   
 ;   reload Local, resulting in a loop.  This seems not to be the case     
 ;   but this protective code is saved.                                    
 ;   Note that if Dyll is run on a directory containg a Local.lsp and      
 ;   local is entered as a command it will loop until Esc is pressed.      
 ; 
 ;                 (if (not (member (strcase (vl-filename-base filnam) t)
 ;                                 '("local" "dill" "dyll" "dille" "dylle")))
                      (if preloa
                          (plode filnam)
                          (load filnam)))))   ; )
 (princ))
 ; Ŀ
 ;   Subroutine Dill end.                                                  
 ; 

 ; Ŀ
 ;   Dirfe - get a list of filenames.                                      
 ;   Arguments: Pat, the file match pattern.                               
 ;              Pref, the directory to search.                             
 ;              Adpa, add a path to each file name.  (T or nil).           
 ;              Noext, remove the extensions.  (Same.)                     
 ;   Returns an alphabetical list of filenames with paths.                 
 ; 
 (DEFUN DIRFE (pat pref adpa noext / fils num fnam nulis)
  (if (setq fils (vl-directory-files pref pat 1))
      (progn
 ; Ŀ
 ;   Put the filename list in alphabetical order.                          
 ; 
           (setq fils (vl-sort fils '<))
           (setq num 0)
           (while (and fils (setq fnam (nth num fils)))
                  (setq num (1+ num))
                  (if adpa (setq fnam (strcat pref fnam)))
                  (if noext (setq fnam (vl-filename-base fnam)))
                  (setq nulis (cons fnam nulis)))))
 (reverse nulis))
 ; Ŀ
 ;   Dirfe end.                                                            
 ; 

 ; Ŀ
 ;   Plode - make a self-loading function from a file name.                
 ;   Preload lisp files without wasting time or memory.                    
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN PLODE (filnam / lspnam)
  (setq lspnam (vl-filename-base filnam))
  (eval (list 'defun (read (strcat "C:" lspnam)) ()
                     (list load filnam)
                     (read (strcat "(C:" lspnam ")"))))
 (princ))
 ; Ŀ
 ;   Plode end.                                                            
 ; 

 ; Ŀ
 ;   Dyll - preload all lisp files in the dir with the current drawing.    
 ; 
 (DEFUN C:DYLL (/ pref)
  (setq pref (getvar "dwgprefix"))
  (dill pref t)
 (princ))

 ; Ŀ
 ;   Dylle - fully load all lisp files in the dir with the current dwg.    
 ; 
 (DEFUN C:DYLLE (/ pref)
  (setq pref (getvar "dwgprefix"))
  (dill pref nil)
 (princ))

 ; Ŀ
 ;   Dill - preload all lisp files in *\Rocket\Lisp\Load.                  
 ; 
 (DEFUN C:DILL (/ pref)
  (if (and (setq pref (findfile "fang.lsp"))
           (setq pref (strcat (substr pref 1 (- (strlen pref) 8)) "load\\")))
      (dill pref t))
 (princ))

 ; Ŀ
 ;   Dille - fully load all lisp files in *\Rocket\Lisp\Load.              
 ; 
 (DEFUN C:DILLE (/ pref)
  (if (and (setq pref (findfile "fang.lsp"))
           (setq pref (strcat (substr pref 1 (- (strlen pref) 8)) "load\\")))
      (dill pref nil))
 (princ))

(princ)
