 ; Ŀ
 ;   Duf - find duplicate files.                                           
 ;   Copyright 1991 - 2013 by Rocket Software Ltd.                         
 ;   I have no recollection of writing this.                               
 ; 

 ; Ŀ
 ;   Duche - check a list ((filename name_and_ path) ...) for duplicates.  
 ;   Arguments: Listn, a list.                                             
 ;   Calls nothing.                                                        
 ;   Returns a list.                                                       
 ; 
 (DEFUN DUCHE (listn / sub nama gnu sublis gnusub duplis)
  (while (setq sub (car listn))
         (setq listn (cdr listn))
         (setq nama (car sub))
         (if (setq gnu (assoc nama listn))
             (progn
                  (if (setq sublis (assoc nama duplis))
                      (progn
                           (setq gnusub (append sublis (list (cadr gnu))))
                           (setq duplis (subst gnusub sublis duplis)))
                      (progn
                           (setq gnusub (append sub (list (cadr gnu))))
                           (setq duplis (cons gnusub duplis)))))))
 duplis)
 ; Ŀ
 ;   Duche end.                                                            
 ; 

 ; Ŀ
 ;   Lime - get a list of files in a directory and its subdirectories.     
 ;   Arguments: Cdir, the directory in which to begin.                     
 ;              Patt, the wild card file name pattern.                     
 ;   Calls nothing, returns a list of filenames, each with a path.         
 ; 
 (DEFUN LIME (cdir patt / delist filist delist nxdir nufils gnulst gnudi dnam
                                                            sport dirp nulist)
  (setq sport t)
  (setq filist (vl-directory-files cdir patt 1))
  (if sport (setq filist (vl-sort filist '<)))
  (setq filist (mapcar '(lambda (fnam) (strcat cdir fnam)) filist))
  (setq delist (vl-directory-files cdir nil -1))
  (if sport (setq delist (vl-sort delist '<)))
  (while (setq dirp (car delist))
         (setq delist (cdr delist))
         (if (not (member dirp '("." "..")))
             (setq gnulst (append gnulst (list dirp)))))
  (setq delist (mapcar '(lambda (dnam) (strcat cdir dnam "\\")) gnulst))
  (while (setq nxdir (car delist))
         (setq delist (cdr delist))
         (setq gnudi (vl-directory-files nxdir nil -1))
         (if sport (setq gnudi (vl-sort gnudi '<)))
         (setq nulist ())
         (while (setq dirp (car gnudi))
                (setq gnudi (cdr gnudi))
                (if (not (member dirp '("." "..")))
                    (setq nulist (append nulist (list dirp)))))
         (setq gnudi (mapcar '(lambda (dnam) (strcat nxdir dnam "\\")) nulist))
         (setq delist (append delist gnudi))
         (setq nufils (vl-directory-files nxdir patt 1))
         (if (and sport nufils) (setq nufils (vl-sort nufils '<)))
         (setq nufils (mapcar '(lambda (fnam) (strcat nxdir fnam)) nufils))
         (setq filist (append filist nufils)))
 filist)
 ; Ŀ
 ;   Lime end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Nopth - remove the path from a filename.                   
 ; 
 (DEFUN NOPTH (tt / pos)
  (setq pos (strlen tt))                          ; start at end of the string
  (while (< 0 pos)
          (if (or (= (substr tt pos 1) (chr 92))  ; if char = \
                  (= (substr tt pos 1) ":"))      ; if char = :
             (progn
                   (setq tt (substr tt (1+ pos))) ; then set tt to all after
                   (setq pos 1)))                 ;  and set pos to first
         (setq pos (1- pos)))                     ; set pos to previous
  tt)
 ; Ŀ
 ;   Nopth end.                                                            
 ; 

 ; Ŀ
 ;   Plinth: print each sublist in a list, one per line.                   
 ;   Arguments: Pint, a list.                                              
 ;   Recursive, returns nothing.                                           
 ; 
 (DEFUN PLINTH (pint / rint num)
  (setq num -1)
  (foreach rint pint
           (if (= (type rint) 'str)
               (if (zerop (setq num (1+ num)))
                   (write-line (strcat "\n" rint))
                   (write-line rint))
               (plinth rint)))
 (princ))
 ; Ŀ
 ;   Plinth end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Pthonl - remove everything but the path from a filename.   
 ; 
 (DEFUN PTHONL (tt / pos)
  (setq pos (strlen tt))                          ; start at end of the string
  (while (< 0 pos)
          (if (or (= (substr tt pos 1) (chr 92))  ; if char = \
                  (= (substr tt pos 1) ":"))      ; if char = :
             (progn
                   (setq tt (substr tt 1 pos))    ; then set tt to all before
                   (setq pos 1)))                 ;  and set pos to first
         (setq pos (1- pos)))                     ; set pos to previous
  tt)
 ; Ŀ
 ;   Pthonl end.                                                           
 ; 

 ; Ŀ
 ;   Splip - make a list of path\name into (name path\name) ...)           
 ;   Arguments: Alist, a list.                                             
 ;   Calls nopth.                                                          
 ;   Returns a list.                                                       
 ; 
 (DEFUN SPLIP (alist / sub nama malist)
  (setq num 0)
  (while (setq sub (nth num alist))
         (setq num (1+ num))
         (setq nama (nopth sub))
         (setq malist (cons (list nama sub) malist)))
 malist)
 ; Ŀ
 ;   Splip end.                                                            
 ; 

 ; Ŀ
 ;   Duf.                                                                  
 ; 
 (DEFUN C:DUF (/ cdir lis gnu)
 ; Ŀ
 ;   Assume we're checkingthe current directory and subdirectories.        
 ; 
  (setq cdir (getvar "dwgprefix"))
  (setq lis (lime cdir "*.dwg"))
  (write-line (strcat "\nSubdirectory List Acquired: "
                      (itoa (length lis)) " Files."))
 ; Ŀ
 ;   Make lis from a flat name list into ((name name_and_path) ...)        
 ; 
  (setq lis (splip lis))
  (write-line "\nName/Path List Constructed.")
 ; Ŀ
 ;   Check for duplicates.                                                 
 ; 
  (setq gnu (duche lis))
 ; Ŀ
 ;   Print a list.                                                         
 ; 
  (plinth gnu)
 (princ))