 ; Ŀ
 ;   Dust - add a new project line to a PCP tb.                            
 ;   Copyright 1997, 2011, 2012 by Rocket Software Ltd.                    
 ;   The only unlimited natural resource.                                  
 ; 

 ; Ŀ
 ;   Nurev - update the rev number in a Pcp title block.                   
 ;   Arguments: Enam,    the title block ename.                            
 ;              Revstr,  the new rev number.                               
 ;   Returns nothing.                                                      
 ;                                                                         
 ;   This is currently not called, since the two rev attributes are        
 ;   updated by puppy when a new rev line is installed, something which    
 ;   is typically done pretty soon after a new project is started.         
 ;   If it is required, the code can be copied from Puppy.lsp.             
 ; 
 (DEFUN NUREV (enam revstr / entt tagg)
  (while (/= (cdr (assoc 0 (setq entt (entget (setq enam (entnext
                                                         enam)))))) "SEQEND")
         (setq tagg (cdr (assoc 2 entt)))
         (cond ((= tagg "RC1")
                (entmod (subst (cons 1 revstr) (assoc 1 entt) entt)))
               ((= tagg "STAMP1")
                (entmod (subst (cons 1 revstr) (assoc 1 entt) entt)))))
 (princ))
 ; Ŀ
 ;   Nurev end.                                                            
 ; 

 ; Ŀ
 ;   MDA - If the Project area of a Pcp Rev block contains eight           
 ;   revisions delete the highest line of data and move the remainder      
 ;   to the top line.                                                      
 ; 
 (DEFUN MDA (/ total ss enam entt val valst pa pa0)
  (setq total 0)
  (if (or (setq ss (ssget "X" (list (cons 2 "T-A002A"))))
          (setq ss (ssget "X" (list (cons 2 "REPL-A1"))))
          (setq ss (ssget "X" (list (cons 2 "T2A"))))
          (setq ss (ssget "X" (list (cons 2 "T2A-3"))))
          (setq ss (ssget "X" (list (cons 2 "T2A-7"))))
          (setq ss (ssget "X" (list (cons 2 "T2A-8"))))
          (setq ss (ssget "X" (list (cons 2 "PCPA1")))))
      (progn
           (setq esav (setq enam (ssname ss 0)))
           (while (/= (cdr (assoc 0 (setq entt (entget (setq enam
                                                 (entnext enam)))))) "SEQEND")
                  (setq val (cdr (assoc 1 entt)))
                  (setq tagg (cdr (assoc 2 entt)))
                  (setq tagbit (substr tagg 1 (1- (strlen tagg))))
                  (if (= tagg "EPCM-NM") (setq tagsav enam))
                  (if (and (member tagbit (list "REV" "PDATE" "DESC" "PROJ-"
                                             "AFE-" "EPCM-C" "EPCM-N" "ENG-"
                                             "ECA-REV" "ECA-DESC" "ECA-PROJ-"
                                             "ECA-AFE-"))
                           (/= tagg "EPCM-NM"))
                      (setq valst (append valst (list val))))
                  (if (and (or (= (substr tagg 1 3) "REV")
                               (= (substr tagg 1 7) "ECA-REV"))
                           (/= val "") (/= val " ") (/= val "."))
                      (setq total (1+ total))))
           (if (< 7 total)
               (progn
                    (setq enam tagsav)
                    (setq valst (cddddr (cddddr valst)))
                    (while (/= (cdr (assoc 2 (setq entt (entget
                                         (setq enam (entnext enam)))))) "RD1")
                           (setq gnuval (car valst))
                           (if (null gnuval) (setq gnuval ""))
                               (setq valst (cdr valst))
                           (entmod (subst (cons 1 gnuval)
                                          (assoc 1 entt) entt)))))))
 (princ))
 ; Ŀ
 ;   MDA end.                                                              
 ; 

 ; Ŀ
 ;   Guppy - places new values into a rev block starting at the first      
 ;   empty rev number attribute found by Gup.  New values are placed in    
 ;   the list Vlasta, once they have all been used the routine ends.       
 ;   Note that it does not check to see if there are attributes            
 ;   available. There are two arguments: Enam, the first attribute to      
 ;   update, and Revsav, the last rev encountered before the empty one.    
 ;   This is incremented by one letter or number and used as the first     
 ;   member of the new values list.                                        
 ;   Returns the new rev number.                                           
 ; 
 (DEFUN GUPPY (enam revsav vlasta / vlasta gnuval entt)
  (cond ((null revsav)
         (setq revsav "1"))
        ((= (strcase revsav) (strcase revsav t))
         (setq revsav (itoa (1+ (read revsav)))))
        (t
         (setq revsav (chr (1+ (ascii revsav))))))
  (setq vlasta (cons revsav vlasta))
 ; Ŀ
 ;   And install the new values from Vlasta into the block.                
 ; 
  (while (setq gnuval (car vlasta))
         (setq vlasta (cdr vlasta))
         (setq entt (entget enam))
         (entmod (subst (cons 1 gnuval) (assoc 1 entt) entt))
         (setq enam (entnext enam)))
 revsav)
 ; Ŀ
 ;   Guppy end.                                                            
 ; 

 ; Ŀ
 ;   Dust.                                                                 
 ; 
 (DEFUN C:DUST (/ revsav ss enam entt val tagg echk eappd stop)
  (setvar "cmdecho" 0)
  (setvar "osmode" 0)
 ; Ŀ
 ;   Make the new project data list Vlasta.                                
 ; 
  (setq vlasta (list "2015.01.06" "GENERATOR HOTSTART ADDITION"
                     "." "14183640" "CATCH" "ECC0060" "."))
 ; Ŀ
 ;   Fix the Project area if there are too many lines.                     
 ; 
  (mda)
 ; Ŀ
 ;   Install the new rev.                                                  
 ; 
  (if (or (setq ss (ssget "X" (list (cons 2 "ENCANA  TITLE BLOCK"))))
          (setq ss (ssget "X" (list (cons 2 "T-A002A"))))
          (setq ss (ssget "X" (list (cons 2 "REPL-A1"))))
          (setq ss (ssget "X" (list (cons 2 "T2A"))))
          (setq ss (ssget "X" (list (cons 2 "T2A-3"))))
          (setq ss (ssget "X" (list (cons 2 "T2A-7"))))
          (setq ss (ssget "X" (list (cons 2 "T2A-8"))))
          (setq ss (ssget "X" (list (cons 2 "PCPA1")))))
      (progn
           (setq esav (setq enam (ssname ss 0)))
           (while (and (null stop)
                       (/= (cdr (assoc 0 (setq entt (entget (setq enam
                                                 (entnext enam)))))) "SEQEND"))
                  (setq val (cdr (assoc 1 entt)))
                  (setq tagg (cdr (assoc 2 entt)))
                  (cond ((and (or (= (substr tagg 1 3) "REV")
                                  (= (substr tagg 1 7) "ECA-REV"))
                              (member val (list "-" "." "" " " "  ")))
                         (setq stop t)
                         (setq revsav (guppy enam revsav vlasta)))
                        ((or (= (substr tagg 1 3) "REV")
                                  (= (substr tagg 1 7) "ECA-REV"))
                         (setq revsav val))))))             ; or save cur. att.
  (entupd esav)
 (princ))