 ; Ŀ
 ;   Dwob - remove wipeouts from blocks.                                   
 ;   Copyright 2002, 2012 by Rocket Software Ltd.                          
 ;   The sound of a large plastic bowl being dropped on edge.              
 ; 

 ; Ŀ
 ;   Fwip - find all blocks containing wipeouts.                           
 ;   Takes no arguments.                                                   
 ;   Calls nothing, returns a list of block names.                         
 ;   Only does one level of nesting, that being all that is needed.        
 ; 
 (DEFUN FWIP (/ rewind blok blnam enam bleent curnam folist stop)
 ; Ŀ
 ;   Step through the block table, look for the block as a subentity.      
 ; 
  (setq rewind t)                                   ; set the rewind flag
  (while (setq blok (tblnext "block" rewind))       ; next block in table
         (setq rewind ())                           ; clear the rewind flag
 ; Ŀ
 ;   Save the block name.                                                  
 ; 
         (setq blnam (cdr (assoc 2 blok)))
 ; Ŀ
 ;   Get the name of the first subentity.                                  
 ; 
         (setq enam (cdr (assoc -2 blok)))          ; entity name
         (setq stop ())
         (while (and (null stop) enam)
               (setq bleent (entget enam))          ; and entity data
               (if (= (cdr (assoc 0 bleent)) "WIPEOUT")
                   (progn
                        (setq stop t)
                        (setq folist (cons blnam folist))))
               (setq enam (entnext enam))))
 folist)
 ; Ŀ
 ;   Fwip.                                                                 
 ; 

 ; Ŀ
 ;   Morloc - explode an entity, return an ss of the new subentities.      
 ;   Takes one argument, an entity name.                                   
 ; 
 (DEFUN MORLOC (enam / aaa ss)
 ; Ŀ
 ;   Find the last entity in the drawing.                                  
 ; 
  (setq aaa (entlast))
  (while (entnext aaa)
         (setq aaa (entnext aaa)))
 ; Ŀ
 ;   Explode the entity.                                                   
 ; 
  (command ".explode" enam)
 ; Ŀ
 ;   Find the debris left by the explosion.                                
 ; 
  (setq ss (ssadd))
  (while (setq aaa (entnext aaa))
         (ssadd aaa ss))
 ss)
 ; Ŀ
 ;   Morloc end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Biske - remanufacture a block.                             
 ;   Arguments: Blnam, a block name.                                       
 ; 
 (DEFUN BISKE (blnam / ss num sub enam)
  (command ".insert" blnam "0,0,0" 1 "")
  (while (= 1 (getvar "cmdactive")) (command ""))
  (setq ss (morloc (entlast)))
  (setq num 0)
  (while (setq sub (ssname ss num))
         (if (= (cdr (assoc 0 (entget sub))) "WIPEOUT")
             (entdel sub))
         (setq num (1+ num)))
  (command ".block" blnam "y" "0,0,0" ss ""))
 ; Ŀ
 ;   Subroutine Biske end.                                                 
 ; 

 ; Ŀ
 ;   Dwob.                                                                 
 ; 
 (DEFUN C:DWOB (/ blist bnum blnam)
  (setvar "cmdecho" 0)
  (setvar "attdia" 0)
  (setq blist (fwip))
  (setq bnum 0)
  (while (and blist (setq blnam (nth bnum blist)))
         (print blnam)
         (setq bnum (1+ bnum))
         (biske blnam))
 (princ))