 ; Ŀ
 ;   Dxr - detach a selected xref.                                         
 ;   Copyright 2011 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Cstar - draw an individual grstar (centred).               
 ;   Takes four arguments: centre point, side length, rotation (radians),  
 ;   and colour.  Returns nothing, but draws a star.                       
 ; 
 (DEFUN CSTAR (pa sidlen rota colo / anginc angg hafang pb)
  (setq px pa)
  (setq pa (polar pa (+ rota (/ pi 2)) (* sidlen 1.37638192)))
 ; (grdraw pa px 5)
  (setq anginc (* 1.6 pi))
  (setq angg (+ rota (* 1.6 pi)))
  (setq hafang (* 0.8 pi))
  (repeat 5
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg anginc))
         (setq pa pb)
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg hafang))
         (setq pa pb))
 (princ))
 ; Ŀ
 ;   Subroutine Cstar end.                                                 
 ; 

 ; Ŀ
 ;   Isxr: see if a given block name refers to an xref.                    
 ;   Argument: Blnam, the block name.                                      
 ;   Returns T: it was an xref, or nil: it wasn't, or no such block is     
 ;   is defined in the drawing.                                            
 ; 
 (DEFUN ISXR (blnam / isxrf xp dat)
  (if (setq dat (tblsearch "block" blnam))
      (progn
           (setq xp (cdr (assoc 70 dat)))
           (setq isxrf4 (logand xp 4))
           (setq isxrf8 (logand xp 8))))
 (if (or (= isxrf4 4)
         (= isxrf8 8))
     T ()))
 ; Ŀ
 ;   Isxr end.                                                             
 ; 

 ; Ŀ
 ;   Dxr.                                                                  
 ; 
 (DEFUN C:DXR (/ blnam enampt isxref ss subnum enam pa rad)
  (setvar "cmdecho" 0)
  (setq rad (/ (getvar "viewsize") 45))
  (setq blnam (cdr (assoc 2 (entget (car (setq enampt
                                            (entsel "\nXref to detach:")))))))
  (princ blnam)
  (setq isxref (isxr blnam))
  (setq ss (ssget "x" (list (cons 2 blnam))))
 ; Ŀ
 ;   If it wasn't an xref then don't do anything.                          
 ; 
  (cond ((null isxref)
         (write-line (strcat "\n" blnam " isn't an xref.")))
 ; Ŀ
 ;   If there is more than one insertion then Autocad won't detach it,     
 ;   so erase them first.                                                  
 ; 
        ((> (sslength ss) 1)
         (setq subnum 0)
         (while (setq enam (ssname ss subnum))
                (setq subnum (1+ subnum))
                (setq pa (cdr (assoc 10 (entget enam))))
                (cstar pa rad (/ pi 3) 1)
                (entdel enam))
         (prompt (strcat "\n" (itoa subnum)
                         " copies of " blnam
                         " deleted."))
         (command "-xref" "d" blnam))
 ; Ŀ
 ;   Otherwise just detach it.                                             
 ; 
        (t
         (cstar (cadr enampt) rad (/ pi 4) 4)
         (command "-xref" "d" blnam)))
 (princ))