 ; Ŀ
 ;   Entlay - split text into letters, put each on a layer named after     
 ;   that letter.  In ascii.  Binary ascii.  But abba rather than 1001.    
 ;   Maybe use odd or even letters vs ones and zeros.                      
 ;   Copyright 2014, 2016 by Rocket Software Ltd.                          
 ;   Anyone can make something useful and brilliant - useful gives you a   
 ;   starting point.  Useless and brilliant is a level higher.             
 ; 

 ; Poont.
 ; encryption - each letter is on a layer, randomly named,
 ; but has a z coord.  Split into layers, higher = a different letter.  In
 ; ascii order.  Maybe the z height is the character number, although that is
 ; too easy.  But use random entities other than text.  Or text but with a
 ; different string ... that makes sense but is camouflage.
 ; but no all withing a layer are at the same height.

 ; Ŀ
 ;   Subroutine Binky - make the binary string representation of a number. 
 ;   Arguments: Numa, a number.                                            
 ;              Digs, the desired number of digits - pad if less.          
 ;   Returns a string.                                                     
 ; 
 (DEFUN BINKY (numa digs / bimun num rema)
 ; Ŀ
 ;   This only works if we start at the big end, so find the largest       
 ;   power of two contained in numa.                                       
 ; 
  (setq num 1)
  (while (> numa num)
         (setq num (* 2 num)))
 ; Ŀ
 ;   Now do a traditional dissection of the number into powers of two.     
 ;   Apologies for not using logand.                                       
 ; 
  (setq binum "")
  (while (>= num 1)
         (setq rema (- numa num))
         (cond ((< rema 0)
                (setq binum (strcat binum "0")))
               ((or (= num numa)
                    (and (< rema num)
                         (> rema 0)))
                (setq binum (strcat binum "1"))
                (setq numa (- numa num)))
               (t
                (setq binum (strcat binum "0"))
                (setq numa (- numa num))))
         (setq num (/ num 2)))
 ; Ŀ
 ;   Pad it to the desired number of digits.                               
 ; 
  (while (< (strlen binum) digs)
         (setq binum (strcat "0" binum)))
 binum)
 ; Ŀ
 ;   Subroutine Binky end.                                                 
 ; 

 ; Ŀ
 ;   MtStr - see if a string contains only spaces.                         
 ;   Arguments: Str, the string.                                           
 ;   Returns T if the string was spaces only, otherwise Nil.               
 ; 
 (DEFUN MTSTR (strp)
  (while (and (/= strp "") (= (substr strp 1 1) " "))
         (setq strp (substr strp 2)))
  (if (= strp "") T ()))
 ; Ŀ
 ;   MtStr end.                                                            
 ; 

 ; Ŀ
 ;   Rile - find the width of a text entity by converting it to right      
 ;   justification and measuring the distance between its ten and eleven   
 ;   points.                                                               
 ;   Arguments: Str - the string to measure.                               
 ;              Enam - the ename of an entity having the properties        
 ;              which we require in the string.                            
 ;   Calls nothing, returns a distance.                                    
 ;   Not as simple as the textbox function, but doesn't return zero as     
 ;   the width of a space, which textbox now does - this must be a new     
 ;   paradigm or something.                                                
 ;   This returns a length of zero for an empty string, by the way.        
 ; 
 (DEFUN RILE (str enam / entt typp dist)
  (setq entt (entget enam))
  (if (member (setq typp (cdr (assoc 0 entt))) '("TEXT" "ATTDEF"))
      (progn
           (command ".copy" enam "" "0,0" "0,0")
           (setq entt (entget (setq enam (entlast))))
           (if (= typp "TEXT")
               (setq entt (subst (cons 1 str) (assoc 1 entt) entt))
               (setq entt (subst (cons 2 str) (assoc 2 entt) entt)))
           (entmod (subst (cons 72 2) (assoc 72 entt) entt))    ; change
           (setq entt (entget enam))                 ; get the changed edata
           (setq dist (distance (cdr (assoc 10 entt)) (cdr (assoc 11 entt))))
           (entdel enam)))
 dist)
 ; Ŀ
 ;   Rile end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Smack - make an ss of any entities after a given one.      
 ;   Takes the marker ename as an argument, returns an ss.                 
 ;   Note: this routine looks overly baroque.                              
 ; 
 (DEFUN SMACK (aaa / ss bbb)
  (setq ss (ssadd (setq bbb (entnext aaa)))) ; put next ent in new ss
 ; Ŀ
 ;   If the entity is an insert and there are attributes:                  
 ; 
  (if (and (= (cdr (assoc 0 (entget bbb))) "INSERT")
           (= (cdr (assoc 66 (entget bbb))) 1))
 ; Ŀ
 ;   Then find the seqend before assuming entnext will give the next ent.  
 ; 
      (progn
           (while (/= (cdr (assoc 0 (entget bbb))) "SEQEND")
                  (setq bbb (entnext bbb)))))
 ; Ŀ
 ;   Find all entities after the marker point, put them in an ss.          
 ; 
  (while (entnext bbb)                  ; while there are entities
         (setq bbb (entnext bbb))       ; find the next new entity
         (ssadd bbb ss)                 ; add it to the selection set
         (if (and (= (cdr (assoc 0 (entget bbb))) "INSERT")
                  (= (cdr (assoc 66 (entget bbb))) 1))
             (progn
                  (while (/= (cdr (assoc 0 (entget bbb))) "SEQEND")
                         (setq bbb (entnext bbb))))))
  ss)
 ; Ŀ
 ;   Smack end.                                                            
 ; 

 ; Ŀ
 ;   Smop - install a string in a text entity, move it to a point.         
 ;   Arguments: Enam, the text entity name.                                
 ;              Str, the string.                                           
 ;              Pa, the point.                                             
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN SMOP (enam str pa / entt ten)
  (setq entt (entget enam))
  (setq entt (subst (cons 1 str) (assoc 1 entt) entt))
  (entmod entt)
  (setq entt (entget enam))
  (setq ten (cdr (assoc 10 entt)))
  (command ".move" enam "" ten pa)
 (princ))
 ; Ŀ
 ;   Smop end.                                                             
 ; 

 ; Ŀ
 ;   Splich - Split a text string in a list of characters.                 
 ;   Argument: Stra, a text string.                                        
 ;   Returns a list characters.                                            
 ; 
 (DEFUN SPLICH (stra / pos len chra lisch)
  (setq pos 1)
  (setq len (strlen stra))
  (while (<= pos len)
         (setq chra (substr stra pos 1))
         (setq lisch (cons chra lisch))
         (setq pos (1+ pos)))
 (reverse lisch))
 ; Ŀ
 ;   Splich end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Strafe - split a text string into individual character     
 ;   text strings.                                                         
 ;   Argument: Enam, a text entity ename.                                  
 ;   Calls Splich, Mtstr, and Smop.                                        
 ;   Returns nothing.                                                      
 ; 
 (DEFUN STRAFE (enam / tent str pll rota strlis allstr nexstr pos)
  (setq tent (entget enam))
  (setq str (cdr (assoc 1 tent)))
  (setq pll (cdr (assoc 10 tent)))
  (setq rota (cdr (assoc 50 tent)))
  (setq strlis (splich str))
  (setq allstr "")
  (while (setq nexstr (car strlis))
         (setq strlis (cdr strlis))
 ; Ŀ
 ;   Get the next lower left point.                                        
 ; 
         (if (/= allstr "")
             (setq pos (polar pll rota (rile allstr enam)))
             (setq pos pll))
 ; Ŀ
 ;   Make the new text entity, install the string, put it at the point.    
 ; 
         (if (not (mtstr nexstr))
             (smop enam nexstr pos))
         (setq allstr (strcat allstr nexstr)))
  (if enam (entdel enam))
 (princ))
 ; Ŀ
 ;   Strafe end.                                                           
 ; 

 ; Ŀ
 ;   Entlay.                                                               
 ; 
 (DEFUN C:ENTLAY (/ osm *error* aaa ss num enam entt laya laydat colo stra
                                                                     lamma)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq osm (getvar "osmode"))
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk)
  (setvar "osmode" osm)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (if shk (write-line shk))
 (princ))
 ; Ŀ
 ;   save the ename of the last entity so we can find new ones.            
 ; 
  (setq aaa (entlast))
  (while (entnext aaa)
         (setq aaa (entnext aaa)))
 ; Ŀ
 ;   Get some text entities.                                               
 ;   Don't do attdefs because ... how would one?                           
 ; 
  (write-line "Text To Individually Layer or <Return> for all: ")
  (if (null (setq ss (ssget (list (cons 0 "text")))))
      (setq ss (ssget "x" (list (cons 0 "text")))))
 ; Ŀ
 ;   Split all text strings into individual characters.                    
 ; 
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq num (1+ num))
         (strafe enam))
 ; Ŀ
 ;   Make an ss of new text entities - this will be the split ones.        
 ; 
  (setq ss (smack aaa))
 ; Ŀ
 ;   Relayer them.                                                         
 ; 
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq num (1+ num))
         (setq entt (entget enam))
         (setq stra (cdr (assoc 1 entt)))
         (setq laya (cdr (assoc 8 entt)))
         (setq laydat (tblsearch "layer" laya))
         (setq colo (cdr (assoc 62 laydat)))
         (setq lamma (binky (ascii stra) 16))
         (if (null (tblsearch "layer" lamma))
             (command ".layer" "n" lamma "c" colo lamma ""))
         (entmod (subst (cons 8 lamma) (assoc 8 entt) entt)))
 ; Ŀ
 ;   Restore sysvars, end.                                                 
 ; 
  (*error* ())
 (princ))
