 ; Ŀ
 ;   Ezo - move subentities in selected blocks to layer 0, and colour      
 ;   them byblock if they are coloured bylayer.                            
 ;   Revised, brutal version - colours subentities byblock no matter what. 
 ;   Byblock is a better subentity colour than bylayer, allowing           
 ;   subentities to be changed with the block, and still leaving blyayer   
 ;   as an option.                                                         
 ;   Copyright 1995, 2009 by Rocket Software Ltd.                          
 ;   Sadly, there are electric eels but no explosive ones.                 
 ; 

 ; Ŀ
 ;   Taze - the mechanical part - written as a subroutine for ease of      
 ;   recursion.                                                            
 ; 
 (DEFUN TAZE (blnam / blok namm entt num gnu nxt hi ss enam asoc62)
  (setq blok (tblsearch "block" blnam))       ; head entity from table
  (setq namm (cdr (assoc -2 blok)))           ; first ename after head
  (while namm
        (setq entt (entget namm))             ; the whole thing
        (if (or (= (cdr (assoc 0 entt)) "INSERT")     ; if it's another block
                (= (cdr (assoc 0 entt)) "DIMENSION")) ; or a dimension
            (taze (cdr (assoc 2 entt))))              ; then recurse
        (setq num 0)
        (setq gnu ())
        (while (setq nxt (nth num entt))
               (setq num (1+ num))
               (cond ((= (car nxt) 8)
                      (setq gnu (append gnu (list (cons 8 "0")))))
                     (t  
                      (setq gnu (append gnu (list nxt))))))
        (if (setq asoc62 (assoc 62 gnu))
            (setq gnu (subst (cons 62 0) asoc62 gnu))
            (setq gnu (append gnu (list (cons 62 0)))))
        (entmod gnu)                         ; change subent in block tables
        (setq namm (entnext namm)))          ; next subentity ename
 ; Ŀ
 ;   Update the individual insertions.                                     
 ; 
  (if (= (substr blnam 1 1) "*")
      (setq blnam (strcat "`" blnam)))
  (setq hi (getvar "highlight"))
  (setq ss (ssget "X" (list (cons 2 blnam))))
  (setvar "highlight" hi)
  (setq num 0)
  (while (and ss (setq esav (setq enam (ssname ss num))))
         (setq num (1+ num))
         (if (assoc 66 (entget enam))
             (progn
                  (while (/= (cdr (assoc 0 (setq entt (entget 
                                      (setq enam (entnext enam)))))) "SEQEND")
                         (setq entt (subst (cons 8 "0") (assoc 8 entt) entt))
                         (if (setq asoc62 (assoc 62 entt))
                             (setq entt (subst (cons 62 0) asoc62 entt))
                             (setq entt (append entt (list (cons 62 0)))))
                         (entmod entt))))
         (entupd esav))
 (princ))
 ; Ŀ
 ;   Taze end.                                                             
 ; 

 ; Ŀ
 ;   Ezo - the only drink made from eels.                                  
 ; 
 (DEFUN C:EZO (/ layy ss enam typ entt blnam blist)
  (setvar "cmdecho" 0)
  (setq layy 0)
  (setq ss (ssget (list (cons 0 "insert,dimension"))))
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq entt (entget enam))
         (setq num (1+ num))
         (setq blnam (cdr (assoc 2 entt)))
         (if (not (member blnam blist))
             (progn
                  (setq blist (append blist (list blnam)))
                  (taze blnam))))
 (princ))