 ; Ŀ
 ;   F6 - extract data for s&r 1 to 6 screwups.                            
 ;   Copyright 1995 - 1998, 2011 - 2013 by Rocket Software Ltd.            
 ;                                                                         
 ; 

 ; Ŀ
 ;   Lisfx - save a list to a file named after the current drawing.        
 ;   Arguments: Liss, a list.                                              
 ;              Exta, the new extension.                                   
 ;   Calls nothing, Returns nothing.                                       
 ; 
 (DEFUN LISFX (liss exta / filnam len fn num sub)
 ; Ŀ
 ;   Make a directory path and name string without the extension.          
 ; 
  (setq filnam (strcat (getvar "dwgprefix") (getvar "dwgname")))
  (if (= (substr (strcase filnam t) (- (setq len (strlen filnam)) 3)) ".dwg")
      (setq filnam (substr filnam 1 (- len 4))))
 ; Ŀ
 ;   Add the new extension.                                                
 ; 
  (if (= substr exta 1 1)
      (setq exta (substr exta 2)))
  (setq filnam (strcat filnam "." exta))
 ; Ŀ
 ;   Save the data to the file.                                            
 ; 
  (setq fn (open filnam "w"))
  (setq num 0)
  (while (setq sub (nth num liss))
         (write-line sub fn)
         (setq num (1+ num)))
  (close fn)
 (princ))
 ; Ŀ
 ;   Lisfx end.                                                            
 ; 

 ; Ŀ
 ;   Get6 - get a list of strings from blocks, text and mtext which        
 ;   follow the pattern *-*-*, are > 12 characters long, contain the       
 ;   the character "1", and don't begin with GD.                           
 ;   Arguments: Notouch - A list of blocks to ignore.                      
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN GET6 (notouch / ss num txt strlis enam entt)
 ; Ŀ
 ;   Find text and mtext.                                                  
 ; 
  (setq ss (ssget "X" '((-4 . "<or")
                         (0 . "text")
                         (0 . "mtext")
                        (-4 . "or>"))))
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq num (1+ num))
         (setq txt (cdr (assoc 1 (setq entt (entget enam)))))
         (if (and (> (strlen txt) 12)
                  (not (wcmatch txt "*GD*"))
                  (wcmatch txt "*-*-*"))
             (setq strlis (cons txt strlis))))
 ; Ŀ
 ;   And blocks.                                                           
 ; 
  (setq num 0)
  (setq ss (ssget "X" (list (cons 66 1) (cons 0 "INSERT"))))
  (while (and ss (setq enam (ssname ss num)))
         (setq blnam (cdr (assoc 2 (entget enam))))
         (setq num (1+ num))
         (while (and (not (member (strcase blnam t) notouch))
                     (/= "SEQEND" (cdr (assoc 0 (setq entt (entget
                                              (setq enam (entnext enam))))))))
                (setq txt (cdr (assoc 1 entt)))
                (if (and (> (strlen txt) 12)
                         (not (wcmatch txt "*GD2*"))
                         (wcmatch txt "*-*-*"))
                    (setq strlis (cons txt strlis)))))
 strlis)
 ; Ŀ
 ;   Get6 end.                                                             
 ; 

 ; Ŀ
 ;   F6.                                                                   
 ; 
 (DEFUN C:F6 (/ picks *error* filnam chlist notouch)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   Turn off group selection.                                             
 ; 
  (setq picks (getvar "pickstyle"))
  (setvar "pickstyle" 0)
 ; Ŀ
 ;   Something is bound to go wrong.                                       
 ; 
  (defun *error* (shk / fnam)
   (setvar "pickstyle" picks)
   (setq fnam (getvar "dwgname"))
   (if regist (regist (strcat "***** Error in F6.lsp, File: " fnam)))
   (if shk (print shk))
  (princ))
 ; Ŀ
 ;   Ignore certain blocks.  The names must be in lower case.              
 ; 
  (setq notouch (list "connacher-tb"))
 ; Ŀ
 ;   Get a list of all strings in the drawing which match the criteria.    
 ; 
  (setq strlis (get6 notouch))
 ; Ŀ
 ;   Remove any which don't contain any ones.                              
 ; 
  (setq num 0)
  (while (and strlis (setq stra (nth num strlis)))
         (setq num (1+ num))
         (if (wcmatch stra "*1*")
             (setq gnulis (cons stra gnulis))))
 ; Ŀ
 ;   If there's anything left, write it out to a file named after the      
 ;   current drawing.                                                      
 ; 
  (if gnulis
      (lisfx gnulis "6fx"))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
  (setvar "pickstyle" picks)
 (princ))