 ; Ŀ
 ;   Fop - find open polylines.                                            
 ;   Copyright 1996, 2006 by Rocket Software Ltd.                          
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Em - mark the ends and vertices of a polyline.             
 ; 
 (DEFUN EM (enam / rad anginc typ num sub plist entt pa)
 ; Ŀ
 ;   Initialize grdraw marker settings.                                    
 ;   Angg should be local.                                                 
 ; 
  (setq rad (/ (getvar "viewsize") 75))
  (if (not (= (type angg) 'real))
      (setq angg 1.5))
  (setq anginc 0.47)
 ; Ŀ
 ;   Get a polyline.                                                       
 ; 
  (redraw enam 3)
  (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
  (cond ((= typ "LWPOLYLINE")
         (setq num 0)
         (while (setq sub (nth num entt))
                (setq num (1+ num))
                (if (= (car sub) 10)
                    (setq plist (cons (cdr sub) plist)))))
        ((= typ "POLYLINE")
         (while (/= "SEQEND" (cdr (assoc 0 (setq entt (entget
                                       (setq enam (entnext enam)))))))
                (setq pa (cdr (assoc 10 entt)))
                (setq plist (cons pa plist)))))
  (setq num 0)
  (while (setq pa (nth num plist))
         (if (or (= num 0)
                 (= num (1- (length plist))))
             (progn
                  (radi pa 0 (* rad 1.25) 6 angg 1)
                  (ci pa (* rad 1.25) 1))
             (progn
                  (radi pa 0 rad 4 angg 4)
                  (ci pa rad 4)))
         (setq num (1+ num)))
 (princ))
 ; Ŀ
 ;   Subroutine Em end.                                                    
 ; 

 ; Ŀ
 ;   Subroutine CI - grdraw circle maker.                                  
 ; 
 (DEFUN CI (pa radd colo / reps pa pa1 pa2 angg)
  (setq reps 32)
  (setq angg 0)
  (setq incr (/ pi (/ reps 2)))
  (setq pa1 (polar pa angg radd))
  (repeat reps
          (setq angg (+ angg incr))
          (setq pa2 (polar pa angg radd))
          (grdraw pa1 pa2 colo)
          (setq pa1 pa2))
 (princ))
 ; Ŀ
 ;   Ci end.                                                               
 ; 

 ; Ŀ
 ;   Subroutine Radi - grdraw radial line set maker.                       
 ;   Does a complete circular set.                                         
 ;   Arguments: Pa, the base point.                                        
 ;              Rin, near end distance.                                    
 ;              Rout, far end distance.                                    
 ;              Reps, number of repetions in 360 degrees.                  
 ;              Stang, the start angle.                                    
 ;              Colo, the colour.                                          
 ;   Calls its mother, returns the empties.                                
 ; 
 (DEFUN RADI (pa rin rout reps stang colo / pa1 pa2)
  (setq incr (/ pi (/ reps 2)))
  (repeat reps
          (setq pa1 (polar pa stang rin))
          (setq pa2 (polar pa stang rout))
          (grdraw pa1 pa2 colo)
          (setq stang (+ stang incr)))
 (princ))
 ; Ŀ
 ;   Radi end.                                                             
 ; 

 ; Ŀ
 ;   Fop.                                                                  
 ; 
 (DEFUN C:FOP (/ ss num enam sev opnum)
 ; Ŀ
 ;   Get an ss of open polylines.                                          
 ; 
  (setq ss (ssget "x" (list (cons 0 "polyline,lwpolyline"))))
  (setq num 0)
  (setq opnum 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq sev (cdr (assoc 70 (entget enam))))
         (if (zerop (logand sev 1))
             (progn
                  (setq num (1+ num))
                  (setq opnum (1+ opnum))
                  (em enam))
             (ssdel enam ss)))
  (prompt (strcat "\nOpen Polylines: " (itoa opnum)))
  (command ".select" ss "")
 (princ))