 ; Ŀ
 ;   Fuq - fix Hocs date strings.                                          
 ;   Copyright 1995, 1997, 1999, 2002 - 2010 by Rocket Software Ltd.       
 ;                                                                         
 ; 

 ; Ŀ
 ;   Sonar - see if a string contains a substring.                         
 ;   Arguments:  Loc, the substring.                                       
 ;               Txt, the string.                                          
 ;               Cas, if this is non-nil then the search                   
 ;                                is non-case-sensitive.                   
 ;   Returns the number of occurrences of the substring.                   
 ; 
 (DEFUN SONAR (loc txt cas / chflg ln sta st)
  (setq chflg 0)
  (if cas 
      (progn
           (setq loc (strcase loc t))
           (setq txt (strcase txt t))))
  (setq ln (strlen loc))
  (setq sta 1)
  (while (= ln (strlen (setq st (substr txt sta ln))))
         (if (= st loc) (setq chflg (1+ chflg)))
         (setq sta (1+ sta)))
 chflg)
 ; Ŀ
 ;   Sonar end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Toad - fix a date string.                                  
 ;   Arguments: Str, the string, in the form dd.mm.yy                      
 ;   Calls Splat.                                                          
 ;   Returns a reformed string.                                            
 ; 
 (DEFUN TOAD (str / dd yy molist mm tempa)
  (cond ((> (sonar "." str t) 0)
         (setq str (splat "." str)))
        ((> (sonar "/" str t) 0)
         (setq str (splat "/" str))))
  (setq dd (car str))
  (setq mm (cadr str))
  (setq yy (caddr str))
 ; Ŀ
 ;   Try to fix strings which are yymmdd rather than ddmmyy.               
 ; 
  (if (> (read yy) 10)
      (progn
           (setq tempa dd)
           (setq dd yy)
           (setq yy tempa)))
 ; Ŀ
 ;   Find the month string.                                                
 ; 
  (setq molist (list "JAN" "FEB" "MAR" "APR" "MAY" "JUN"
                     "JUL" "AUG" "SEP" "OCT" "NOV" "DEC"))
  (setq mm (nth (1- (read mm)) molist))
 (strcat dd " " mm " " yy))
 ; Ŀ
 ;   Splat end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Splat - divide a text string into a list of substrings.    
 ;   Arguments: Sepchr, the field separator character.                     
 ;              Linn, the text string.                                     
 ;   Returns a list of field values, removes leading and trailing spaces.  
 ;                                                                         
 ;   Completely rewritten 11.19.2000.                                      
 ; 
 (DEFUN SPLAT (sepchr linn / pos len name1 strlst)
  (while (/= (strlen linn) 0)
 ; Ŀ
 ;   Find the first separator character, save everything before it into    
 ;   the Name1 variable, remove it from the start of the string Linn.      
 ; 
         (setq pos 1)
         (setq len (strlen linn))
         (while (and (/= (substr linn pos 1) sepchr)
                     (>= len pos))
                (setq pos (1+ pos)))
         (setq name1 (substr linn 1 (1- pos)))
         (setq linn (substr linn (1+ pos)))
 ; Ŀ
 ;   Remove spaces from the front and back of Name1.                       
 ; 
         (while (and (> (strlen name1) 0)
                     (= (substr name1 (setq len (strlen name1))) " "))
                (setq name1 (substr name1 1 (1- len))))
         (while (and (> (strlen name1) 0)
                     (= (substr name1 1 1) " "))
                (setq name1 (substr name1 2)))
 ; Ŀ
 ;   Add Name1 to the substring list Strlst.                               
 ; 
         (setq strlst (append strlst (list name1))))
 ; Ŀ
 ;   If the string contained no separator characters then Strlst will be   
 ;   nil, so return a list containing the original string.                 
 ; 
  (if (null strlst) (setq strlst (list linn)))
 strlst)
 ; Ŀ
 ;   Splat end.                                                            
 ; 

 ; Ŀ
 ;   FUQ.                                                                  
 ; 
 (DEFUN C:FUQ (/ ss enam esav atnam atval entt vala)
  (setvar "cmdecho" 0)
  (if (setq ss (ssget "X" (list (cons 2 "hocs attributes text"))))
      (progn
            (setq esav (setq enam (ssname ss 0)))
           (while (/= "SEQEND" (cdr (assoc 0 (setq entt (entget
                                               (setq enam (entnext enam)))))))
                  (setq atnam (cdr (assoc 2 entt)))
                  (setq atval (cdr (assoc 1 entt)))
                  (if (and (or (and (> (strlen atnam) 9)
                                    (= (substr atnam 1 9) "REV_DATE_"))
                               (member atnam '("DRAWN_DATE" "CHK_DATE"
                                               "APPROVED_DATE")))
                           (zerop (sonar " " atval t))
                           (not (member atval '("" "-" "..." " " "  " "_"))))
                      (progn
                           (setq vala (toad atval))
                           (entmod (subst (cons 1 vala)
                                          (assoc 1 entt) entt)))))
           (if vala (entupd esav))))
 (princ))