 ; Ŀ
 ;   Fux - force xrefs to the correct path - the one the file is at,       
 ;   rather than the location the drawing thinks it's in.                  
 ;   Copyright 2011, 2012 by Rocket Software Ltd.                          
 ;   The following bit of Dos code might be useful:                        
 ;   dir /s *.dwg /b /on /a-d /n > Xinfo.txt                               
 ;                                                                         
 ; 

 ; Ŀ
 ;   Contx - Find all referenced xref definitions in the block tables.     
 ;   Takes no arguments.                                                   
 ;   Returns a list of lists: ((Blockname Filename)...)                    
 ; 
 (DEFUN CONTX (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (and (= 4 (logand 4 sevnt)) (= 32 (logand 32 sevnt)))
             (setq namlst (append namlst (list (list (cdr (assoc 2 bldat))
                                                   (cdr (assoc 1 bldat))))))))
 namlst)
 ; Ŀ
 ;   Contx end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Finxr - find the appropriate line in the xref data file.   
 ;   Arguments: Filnam, the data file name.                                
 ;              Match,  the string used to identify the correct line.      
 ;   If a matching line is found it is returned, else nil.                 
 ; 
 (DEFUN FINXR (filnam match / fn notyet linn strp)
  (setq match (strcase match))
 ; Ŀ
 ;   Open the data file.                                                   
 ; 
  (setq fn (open filnam "r"))
 ; Ŀ
 ;   See if the field contains the search string.                          
 ; 
  (setq notyet T)
  (while (and notyet
              (setq linn (read-line fn)))
         (setq strp (vl-filename-base linn))
         (if (= match (strcase strp))
             (setq notyet ())))
  (close fn)
 (if notyet () linn))
 ; Ŀ
 ;   Finxr end.                                                            
 ; 

 ; Ŀ
 ;   Fux.                                                                  
 ; 
 (DEFUN C:FUX (/ nam len *error* nam xlis filnam num sub blnam xpath gnupth)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   Remove the filename extension.                                        
 ; 
  (setq nam (strcase (getvar "dwgname") t))
  (if (= (substr nam (- (setq len (strlen nam)) 3)) ".dwg")
        (setq nam (substr nam 1 (- len 4))))
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk)
  (setq nam (strcase (getvar "dwgname") t))
  (if regist (regist (strcat "***** Error in Fux.lsp, File: " nam)))
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Get a list of xrefs.                                                  
 ; 
 (setq xlis (contx))
 ; Ŀ
 ;   Find the data file.                                                   
 ; 
  (setq filnam "c:\\Xinfo.txt")
  (cond ((null (findfile filnam))
         (regist (strcat nam ": Data file " filnam " not found.")))
 ; Ŀ
 ;   Find the data file, get the appropriate file name.                    
 ;   The xref name will not have an extension.                             
 ; 
        (xlis
         (setq num 0)
         (while (setq sub (nth num xlis))
                (setq num (1+ num))
                (setq blnam (car sub))
                (setq xpath (cadr sub))
                (cond ((null (setq gnupth (finxr filnam blnam)))
                       (regist (strcat nam ": No New Location For " blnam)))
                      ((null (setq gnupth (strcase gnupth))))
                      ((not (equal gnupth (strcase xpath)))
                       (command "xref" "path" blnam gnupth))))))
 (princ))