 ; Ŀ
 ;   Get: Get entity data.                                                 
 ;   Getx: Get entity data and extended entity data.                       
 ;   Copyright 1991, 2005, 2007, 2011, 2013, 2017 by Rocket Software Ltd.  
 ;   Get at those deeper levels of reality or totally lose contact,        
 ;   depending on your perspective.                                        
 ; 

 ; Ŀ
 ;   Subroutine Alphx - find the sublist in which the leading string is    
 ;   the lowest number.                                                    
 ;   Argument: Nexlst, a list.                                             
 ;   Typically called by Horix.                                            
 ;   Calls nothing, returns a sublist.                                     
 ; 
 (DEFUN ALPHX (nexlst / num neth first)
  (setq num 0)
  (while (setq neth (nth num nexlst))
         (if (= (type neth) 'LIST) (setq neth (car neth)))
         (if (or (null first) (< neth first))
             (setq first neth))
         (setq num (1+ num)))
 first)
 ; Ŀ
 ;   Alphx end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Horix - put a list in numerical order.  If an element is   
 ;   a list it is alphabetized by first element, numbers are not           
 ;   converted to strings.                                                 
 ;   Arguments: Liss, a list.                                              
 ;   Calls Alpho, returns the list, reordered.                             
 ; 
 (DEFUN HORIX (liss / low sub neth hrzlst newlst orderd)
  (while liss
        (setq low (alphx liss))                   ; lowest leading number
        (while (and liss (setq sub (nth 0 liss)))
               (if (= (type sub) 'LIST) (setq neth (car sub)))
               (if (equal low neth)
                   (setq hrzlst (append hrzlst (list sub)))
                   (setq newlst (append newlst (list sub))))
               (setq liss (cdr liss)))             ; remove 1st ent from list
        (setq orderd (append orderd hrzlst))       ; add lev sublst to levels
        (setq hrzlst ())                           ; set to () for next loop
        (setq liss newlst)                         ; liss reconstituted
        (setq newlst ()))                          ; empty new list & reuse
  orderd)
 ; Ŀ
 ;   Horix end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Prinl - print a list, one element at a time.               
 ;   Arguments: Alist, a list.                                             
 ;              Ordr, if T, reorder the list.                              
 ;   Calls nothing.                                                        
 ;   Returns the original list, ordered by the first number in each sub.   
 ; 
 (DEFUN PRINL (alist ordr / suba num)
  (setq num 0)
  (if ordr (setq alist (horix alist)))
  (while (setq suba (nth num alist))
         (setq num (1+ num))
         (print suba))
 alist)
 ; Ŀ
 ;   Prinl end.                                                            
 ; 

 ; Ŀ
 ;   Getx.                                                                 
 ; 
 (DEFUN C:GETX (/ nst aa bb ntt exdat)
  (if (/= (type st) 'ENAME)
      (progn
            (while (null aa)
            (setq aa (entsel "Select entity:")))
            (prinl (entget (setq st (car aa))) t)
            (princ)
            (setq bb (entget st (list "*")))
            (if (setq exdat (assoc -3 bb))
                (prinl exdat nil)
                (write-line "\nNo extended data found.")))
      (progn
            (redraw st)
            (setq nst (car (entsel "Select entity or <Return> for next.")))
            (if nst
                (progn
                     (setq st (cdar (prinl (entget nst) t)))
                     (princ)
                     (setq bb (entget st (list "*")))
                     (if (setq exdat (assoc -3 bb))
                         (prinl exdat nil)
                         (write-line "\nNo extended data found.")))
                (progn
                     (if (setq ntt (entnext st))
                         (progn
                              (setq st (cdar (prinl (entget ntt) t)))
                              (princ)
                              (setq bb (entget st (list "*")))
                              (if (setq exdat (assoc -3 bb))
                              (prinl exdat nil)
                              (write-line "\nNo extended data found."))
                              (redraw st 3))
                         (write-line "There are no more entities."))))))
 (princ))

 ; Ŀ
 ;   Get.                                                                  
 ; 
 (DEFUN C:GET (/ nst aa ntt)
  (if (/= (type st) 'ENAME)
      (progn
            (while (null aa)
            (setq aa (entsel "Select entity:")))
            (setq elist (entget (setq st (car aa))))
            (prinl elist t))
      (progn
            (redraw st)
            (setq nst (car (entsel "Select entity or <Return> for next.")))
            (if nst
                (setq st (cdar (prinl (entget nst) t)))
                (progn
                      (if (setq ntt (entnext st))
                          (progn
                                (setq st (cdar (prinl (entget ntt) t)))
                                (redraw st 3))
                          (write-line "There are no more entities."))))))
 (princ))