 ; Ŀ
 ;   Hash - make a hatch out of a set of lines.                            
 ;   Copyright 2007, 2011 by Rocket Software Ltd.                          
 ;   Hi-diddly-Hey!  (Added by Samuel)                                     
 ; 

 ; Ŀ
 ;   Distz: list the distances between the points in a list.               
 ;   Arguments: Plist, a list of points.                                   
 ;   Returns a list of distances.                                          
 ;   Currently not called.                                                 
 ; 
 (DEFUN DISTZ (plist / pa pb dislis)
  (while (and (setq pa (car plist))
              (setq pb (cadr plist)))
         (setq plist (cdr plist))
         (setq dislis (append dislis (list (distance pa pb)))))
 dislis)
 ; Ŀ
 ;   Distz end.                                                            
 ; 

 ; Ŀ
 ;   Goto - grdraw an arrow.                                               
 ;   Arguments: aa, the point to which the arrow points.                   
 ;              bb, the other end of the arrow                             
 ;              colo, the arrow colour.                                    
 ;              hi, highlight the arrow if /= 0.                           
 ;   Notes:                                                                
 ;   1. any negative colour is equivalent to xor colour - dashed white -   
 ;      which erases itself on overwrite.                                  
 ;   2. 0 erases whatever is under it, and is undocumented.                
 ;   3. Highlighting must be turned on in the first grdraw call in the     
 ;      routine, and can't be turned off in the routine.                   
 ;   These may just be anomalies in this video system.                     
 ; 
 (DEFUN GOTO (aa bb colo hi / rad basic dist bhasic ang pa pb1 pb2)
  (setq rad (/ (getvar "viewsize") 20))
  (setq basic (/ (setq dist (distance aa bb)) 4))
  (if (> basic rad) (setq basic rad))
  (if (> basic (* dist 0.75)) (setq basic (* dist 0.75)))
  (setq bhasic (/ basic 2.25))
  (setq ang (angle aa bb))
  (setq pa (polar aa ang basic))
  (setq pb1 (polar pa (+ ang (/ pi 2)) bhasic))
  (setq pb2 (polar pa (+ ang (* pi 1.5)) bhasic))
  (grdraw aa pb1 colo hi) ; hilight must be in first call, doesn't turn off
  (grdraw pb1 pb2 colo)
  (grdraw aa pb2 colo)
  (grdraw bb pa colo)
 ; (grdraw aa pa 0) ; erase line within arrowhead
 (princ))
 ; Ŀ
 ;   Goto end.                                                             
 ; 

 ; Ŀ
 ;   Test program for Lacey which also illustrates the list structure.     
 ; 
 (defun c:test (/ lisyx)
  (setq lisyx '(((139.153 42.1687 0.0)
                 (140.862 42.1687 0.0)
                 (150.862 42.1687 0.0)
                 (153.138 42.1687 0.0))
                ((138.878 41.9277 0.0)
                 (140.816 41.9277 0.0)
                 (150.816 41.9277 0.0)
                 (153.184 41.9277 0.0))
                ((138.582 41.6867 0.0)
                 (140.789 40.6000 0.0) 
                 (150.789 41.6867 0.0)
                 (153.211 41.6867 0.0))))
  (print (lacey lisyx ()))
 (princ))
 ; Ŀ
 ;   Test end.                                                             
 ; 

 ; Ŀ
 ;   Lacey: find the smallest Y co-ordinate in a list of lists ...         
 ;   Arguments: Plist, a list of lists of lists ...                        
 ;              Miny, a lowest number or nil.                              
 ;   Recursive.                                                            
 ;   Returns a modified list.                                              
 ; 
 (DEFUN LACEY (plist miny / sub)
  (while (setq sub (car plist))
         (setq plist (cdr plist))
         (if (member (type (cadr sub)) '(real int))
             (if miny
                 (setq miny (min miny (cadr sub)))
                 (setq miny (cadr sub)))
             (setq miny (lacey sub miny))))
 miny)
 ; Ŀ
 ;   Lacey end.                                                            
 ; 

 ; Ŀ
 ;   Leftx: find the smallest X co-ordinate in a list of lists ...         
 ;   Arguments: Plist, a list of lists of lists ...                        
 ;              Minx, a lowest number or nil.                              
 ;   Recursive.                                                            
 ;   Returns a modified list.                                              
 ; 
 (DEFUN LEFTX (plist minx / sub)
  (while (setq sub (car plist))
         (if (member (type sub) '(real int))
             (progn
                  (if minx
                      (setq minx (min minx sub))
                      (setq minx sub))
                  (setq plist nil))    ; stop the loop if not a list of lists
             (progn
                  (setq minx (leftx sub minx))
                  (setq plist (cdr plist)))))
 minx)
 ; Ŀ
 ;   Leftx end.                                                            
 ; 

 ; Ŀ
 ;   Obdis: sort a list of points into order away from a basepoint.        
 ;   Arguments: Plist, a list of point lists.                              
 ;              ll, a basepoint.                                           
 ;   Returns a modified list.                                              
 ; 
 (DEFUN OBDIS (plist ll / sub savlis minlis ordlst)
  (while plist
         (while (setq sub (car plist))
                (setq plist (cdr plist))
                (if (or (null minlis)
                        (< (distance ll sub) (distance ll minlis))) 
                    (progn
                         (if minlis
                             (setq savlis (cons minlis savlis)))
                         (setq minlis sub))
                    (setq savlis (cons sub savlis))))
         (setq plist savlis)
         (setq savlis nil)
         (setq ordlst (append ordlst (list minlis)))
         (setq minlis nil))
 ordlst)
 ; Ŀ
 ;   Obdis end.                                                            
 ; 

 ; Ŀ
 ;   Pastry: make a point list into a pattern string.                      
 ;   Arguments: Sub, a list of points.                                     
 ;              Minx, the minimum x point.                                 
 ;              Miny, the minimum y point.                                 
 ;              Xsize, the pattern x cell size.                            
 ;              Ysize, the pattern y cell size.                            
 ;              Precis, the number of decimal places in measurements.      
 ;   Calls Splish, and Rt0s.                                               
 ;   Returns a pattern line string.                                        
 ; 
 (DEFUN PASTRY (sub minx miny xsize ysize precis / ll angg orig origx origy
                                           dashes sub dstr dash cstr patlis)
  (setq ll (list minx miny))
 ; Ŀ
 ;   The hatch pattern line format is:                                     
 ;   Angle,x-origin,y-origin,x-displacement,y-displacement,dash_1-6        
 ;   Angle - the line angle away from its origin.                          
 ;   X origin - an offset from the pattern origin which is taken as 0,0.   
 ;   Y origin - the same.                                                  
 ;   X displacement - the displacement of the hatch pattern along the      
 ;                    line in the next copy of the line.  (Usually 0.)     
 ;   Y displacement - how far the next copy of this line is away at a      
 ;                    right angle to the line.                             
 ;   Up to six dashes: if there are none then the line is solid and of     
 ;   infinite length.  If any are listed then positive is solid, - is      
 ;   negative, and 0 is a dot: 5,-1,0,-1 = 5 dash, 1 space, dot, 1 space.  
 ; 
  (setq angg (angle (car sub) (last sub)))
 ; Ŀ
 ;   Make sure Angg is less than 2pi.                                      
 ; 
  (setq angg (rem angg (* pi 2)))
  (if (equal angg (* pi 2) 0.0000001)
      (setq angg 0))
 ; Ŀ
 ;   Mark the origin of each list; if there are more than four segments    
 ;   (i.e. > five points) mark it in red.  (The pattern format only allows 
 ;   six dashes and spaces and we're adding a final spacer dash.)          
 ;   Later: Splish takes care of this but it's still here because it       
 ;   looks nice.                                                           
 ; 
  (setq orig (car sub))
  (if (> (length sub) 5)
      (goto orig ll 1 0)
      (goto orig ll 4 0))
 ; Ŀ
 ;   Adjust the offsets to put the theoretical origin at 0,0.              
 ; 
  (setq origx (- (car orig) minx))
  (setq origy (- (cadr orig) miny))
 ; Ŀ
 ;   Call splish to get a list of lists of distances, + and -.             
 ; 
  (setq dashes (splish sub xsize))
 ; Ŀ
 ;   Make the list of dash lists into a list of + and - strings.           
 ;   Each line will have the same offset - and other initial data - as     
 ;   the first line.                                                       
 ; 
  (while (setq sub (car dashes))
         (setq dashes (cdr dashes))
         (setq dstr "")
         (while (setq dash (car sub))
                (setq sub (cdr sub))
                (setq dash (rt0s dash 2 precis))
                (setq dstr (strcat dstr "," dash)))
 ; Ŀ
 ;   Make the text string for the .pat file.                               
 ; 
         (setq cstr (strcat (rt0s angg 2 precis)   ","  ; angle
                            (rt0s origx 2 precis)  ","  ; x origin
                            (rt0s origy 2 precis)  ","  ; y origin
                            "0"                    ","  ; x displacement
                            (rt0s ysize 2 precis)       ; y displacement
                            dstr))                      ; dash lengths string
 ; Ŀ
 ;   Save the string to the pattern line list.                             
 ; 
         (setq patlis (append patlis (list cstr))))
 patlis)
 ; Ŀ
 ;   Pastry end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Peach: see if two lines are parallel, perpendicular        
 ;   colinear, or convergent.                                              
 ; 
 (DEFUN PEACH (lin1 lin2 / dimscl l1 l2 ang1 ang2 lin210 lin211 hyp1p1 hyp1p2
                            fuzz hyp2p1 hyp2p2 inter1 inter2 dist1 dist2 join)
 ; Ŀ
 ;   Load Misps.lsp, which contains the ps/ms scaling subroutines.         
 ; 
  (if (or (null wasp) (null misps))
      (if (null (load "misps" ()))
          (prompt "\n** The File Misps.lsp Is Not Available. **\n")))
 ; Ŀ
 ;   Get the scale, depending on which space we are in and other things.   
 ; 
  (if misps
      (setq dimscl (misps))
      (setq dimscl (getvar "dimscale")))
 ; Ŀ
 ;   Extract entity data from the two lines.                               
 ; 
  (setq l1 (entget lin1))
  (setq l2 (entget lin2))
 ; Ŀ
 ;   Find their angles.                                                    
 ; 
  (setq ang1 (angle (cdr (assoc 10 l1)) (cdr (assoc 11 l1))))
  (setq ang2 (angle (setq lin210 (cdr (assoc 10 l2)))
                    (setq lin211 (cdr (assoc 11 l2)))))
 ; Ŀ
 ;   Make two theoretical lines perpendicular to line 1, each starting at  
 ;   one of its endpoints and with a nominal length of 10 units.           
 ; 
  (setq hyp1p1 (cdr (assoc 10 l1)))
  (setq hyp1p2 (polar hyp1p1 (+ ang1 (/ pi 2)) 10))
  (setq hyp2p1 (cdr (assoc 11 l1)))
  (setq hyp2p2 (polar hyp2p1 (+ ang1 (/ pi 2)) 10))
 ; Ŀ
 ;   Now find the intersection of each hypothetical line with line2.       
 ; 
  (setq inter1 (inters lin210 lin211 hyp1p1 hyp1p2 ()))
  (setq inter2 (inters lin210 lin211 hyp2p1 hyp2p2 ()))
 ; Ŀ
 ;   And thus find the distances between lines 1 and 2 at the ends of      
 ;   line 1.                                                               
 ; 
  (if inter1 (setq dist1 (distance hyp1p1 inter1)))
  (if inter2 (setq dist2 (distance hyp2p1 inter2)))
  (setq fuzz (* dimscl 0.000001))                            ; fuzz factor
  (cond ((and (= dist1 0) (= dist2 0))                       ; colinear
         (setq join T))
        ((and (equal dist1 0 fuzz) (equal dist2 0 fuzz))     ; fairly colinear
         (setq join T))
        ((or (null inter1) (null inter2))                    ; perpendicular
         (setq join ()))
        ((equal dist1 dist2 fuzz)                            ; parallel
         (setq join ()))
        (T                                                   ; converge
         (setq join ())))
  join)
 ; Ŀ
 ;   Peach end.                                                            
 ; 

 ; Ŀ
 ;   Rt0s: Convert a number to a string and don't drop an initial zero.    
 ;   Arguments: Dash, a number.                                            
 ;              Mode, the output mode (2 = decimal.)                       
 ;              Precis, the desired number of decimal places.              
 ;   Returns a string.                                                     
 ; 
 (DEFUN RT0S (dash mode precis)
  (setq dash (rtos dash mode precis))
  (if (= (substr dash 1 1) ".")
      (setq dash (strcat "0" dash)))
 dash)
 ; Ŀ
 ;   Rt0s end.                                                             
 ; 

 ; Ŀ
 ;   Splish - split a point list into lists of six or less numbers.        
 ;   Arguments: Dlis, a list of points.                                    
 ;              Cellx, the cell x size.                                    
 ;   Calls nothing, returns a list of lists of numbers.                    
 ; 
 (DEFUN SPLISH (dlis cellx / front ispace pos pa pb cdist totlen endis gnulis
                                                 malist sub gnusub vala valb)
 ; Ŀ
 ;   Pattern line length is set by the total of the offset from 0, the     
 ;   lengths of all the dashes and spaces, and a final end space to pad    
 ;   it to the x cell size.                                                
 ;   Partial lines must have their initial X offset adjusted to move them  
 ;   over to the +x, and the final space length shortened accordingly.     
 ;   The length of the dash string isn't the same as the cell size since   
 ;   the starting point is moved +x by the x base amount.                  
 ; 
 ; Ŀ
 ;   Get the base point.                                                   
 ; 
  (setq front (car dlis))
  (setq ispace -1)
  (setq pos 0)
  (while (and (setq pa (nth pos dlis))
              (setq pb (nth (1+ pos) dlis)))
         (setq pos (1+ pos))
         (setq ispace (- ispace))
         (setq cdist (* ispace (distance pa pb)))
 ; Ŀ
 ;   If the new sublist is long enough add it to the master list and       
 ;   start another one.                                                    
 ; 
         (cond ((= (length gnulis) 5)
                (setq totlen (distance front pa))
                (setq endis (- cellx totlen))
                (setq gnulis (append gnulis (list (- endis))))
                (setq malist (append malist (list gnulis)))
                (setq gnulis (list (- (distance front pa)) cdist)))
 ; Ŀ
 ;   Else add the current value to gnulist.                                
 ;   If the sign matches that of the previous then add them, otherwise     
 ;   add it as another value in the list.                                  
 ; 
               (t
                (setq gnulis (append gnulis (list cdist))))))
 ; Ŀ
 ;   Add the last Gnulis to malist.  (There will be one.)                  
 ; 
  (setq totlen (distance front (last dlis)))
  (setq endis (- cellx totlen))
  (setq gnulis (append gnulis (list (- endis))))
  (setq malist (append malist (list gnulis)))
 ; Ŀ
 ;   Reprocess the list: if two adacent values in a sublist have the same  
 ;   sign then add them together.                                          
 ; 
  (setq gnulis ())
  (while (setq sub (car malist))
         (setq malist (cdr malist))
         (setq gnusub ())
         (setq pos 0)
         (while (setq vala (nth pos sub))
                (setq valb (nth (setq pos (1+ pos)) sub))
                (if (and valb (or (and (minusp vala)
                                       (minusp valb))
                                  (and (not (minusp vala))
                                       (not (minusp valb)))))
                    (progn
                         (setq vala (+ vala valb))
                         (setq pos (1+ pos))))
                (setq gnusub (append gnusub (list vala))))
         (setq gnulis (append gnulis (list gnusub))))
 gnulis)
 ; Ŀ
 ;   Splish end.                                                           
 ; 

 ; Ŀ
 ;   Tez - test program for Splish.                                        
 ; 
 (defun c:tez (/ lisyx)
  (write-line "\nTotal distance for each sublist is 23.")
  (setq lisyx '((1 1) (2 1) (3 1) (4 1) (5 1) (6 1) (7 1) (8 1) (9 1)
                (10 1) (11 1) (12 1) (13 1) (14 1) (15 1) (16 1)))
  (print (setq liss (splish lisyx 24 1)))
  (while (setq sub (car liss))
         (setq liss (cdr liss))
         (setq tota 0)
         (while (setq vala (car sub))
                (setq tota (+ tota (abs vala)))
                (setq sub (cdr sub)))
         (print tota))
 (princ))
 ; Ŀ
 ;   Test end.                                                             
 ; 

 ; Ŀ
 ;   Hash.                                                                 
 ; 
 (DEFUN C:HASH (/ ss xsizep ysizep enam sub num subnam malist gnusub entt
                   gnulis minx miny insp ll lr ul ur precis angg orig origx
                   origy dashes totlen front dstr sign dash cstrs strlis pana
                                                                panama fn stra)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   Get a selection set of lines.                                         
 ; 
  (prompt "Select lines or <All>: ")
  (if (null (setq ss (ssget '((0 . "line")))))
      (setq ss (ssget "x" '((0 . "line")))))
 ; Ŀ
 ;   Get X and Y pattern sizes.                                            
 ; 
  (if xsize
      (setq xsizep (getdist (strcat "\nPattern X Size <"
                                    (rtos xsize 2 2) ">: ")))
      (setq xsizep (getdist "Pattern X Size: ")))
  (if xsizep (setq xsize xsizep))
  (if (or xsizep (null ysize)) (setq ysize xsize))
  (if (setq ysizep (getdist (strcat "\nPattern Y Size <"
                                    (rtos ysize 2 2) ">: ")))
      (setq ysize ysizep))
 ; Ŀ
 ;   Sort the ss into a list of enames: ((line colinear_line-p ...) ...)   
 ; 
  (while (setq enam (ssname ss 0))
         (ssdel enam ss)
         (setq sub (list enam))
         (setq num 0)
         (while (setq subnam (ssname ss num))
                (if (peach enam subnam)
                    (progn
                         (setq sub (cons subnam sub))
                         (ssdel subnam ss))
                    (setq num (1+ num))))
         (setq malist (cons sub malist)))
 ; Ŀ
 ;   Make the list into a list of points: ((endpt endpt) ...)              
 ;   Note that overlapping lines will screw this up.                       
 ; 
  (while (setq sub (car malist))
         (setq malist (cdr malist))
         (setq gnusub ())
         (while (setq enam (car sub))
                (setq sub (cdr sub))
                (setq entt (entget enam))
                (setq gnusub (cons (cdr (assoc 10 entt)) gnusub))
                (setq gnusub (cons (cdr (assoc 11 entt)) gnusub)))
         (setq gnulis (append gnulis (list gnusub))))
 ; Ŀ
 ;   Find the minimum x and y co-ordinates.                                
 ;   This will be the insertion point of the hatch.                        
 ;   Allow the user to override this in case they want to make several     
 ;   hatches and combine them into one.                                    
 ;   If the base point is inside the hatch strange things will happen.     
 ; 
  (setq minx (leftx gnulis nil))
  (setq miny (lacey gnulis nil))
  (setq ll (list minx miny))
  (if (setq insp (getpoint ll "Lower Left Hatch Base <Current>: "))
      (progn
           (setq minx (car insp))
           (setq miny (cadr insp))
           (setq ll insp)))
 ; Ŀ
 ;   Put each sublist in order away from the basepoint.                    
 ; 
  (setq malist ())
  (while (setq sub (car gnulis))
         (setq gnulis (cdr gnulis))
         (setq sub (obdis sub ll))
         (setq malist (cons sub malist)))
 ; Ŀ
 ;   Mark the pattern area.                                                
 ; 
  (grdraw ll (setq lr (polar ll 0 xsize)) 1)
  (grdraw ll (setq ul (polar ll (/ pi 2) ysize)) 1)
  (grdraw ul (setq ur (polar lr (/ pi 2) ysize)) 1)
  (grdraw ur lr 1)
 ; Ŀ
 ;   Malist is now a list of lists of point lists.                         
 ;   For each sublist, get the angle, origin (the first point list) and    
 ;   make the sublist into a list of dash and gap lengths.                 
 ;   The X and Y offsets are the pattern dimensions Xsize and Ysize.       
 ; 
  (setq num 0)
  (while (setq sub (nth num malist))
         (setq num (1+ num)) 
 ; Ŀ
 ;   Make the pattern line strings.                                        
 ; 
         (setq cstrs (pastry sub minx miny xsize ysize 6))
         (setq strlis (append strlis cstrs)))
 ; Ŀ
 ;   Get a name for the file and the pattern (which must be the same       
 ;   if there is only one pattern in the file.)                            
 ; 
  (setq pana (getstring "\nPattern Name: "))
  (setq panama (strcat (getvar "dwgprefix") pana ".pat"))
 ; Ŀ
 ;   Write the pattern file.                                               
 ; 
  (setq num 0)
  (setq fn (open panama "w"))
  (write-line (strcat "*" pana) fn)
  (while (setq stra (nth num strlis))
         (setq num (1+ num))
         (write-line stra fn))
  (close fn)
  (write-line (strcat "\nPattern file " panama " written."))
 (princ))