 ; Ŀ
 ;   Htt - isometric heat trace drawer with automatic radii.               
 ;   A6 - isometric array.                                                 
 ;   Copyright 1994, 2010 - 2011 by Rocket Software Ltd.                   
 ;   Just what are the evolutionary forces on a goldfish?                  
 ; 

 ; Ŀ
 ;   Tuna - find the inside angle between two lines.                       
 ; 
 (DEFUN TUNA (ang1 ang2 / angg)
  (if (> ang1 ang2)
      (setq angg (- ang1 ang2))
      (setq angg (- ang2 ang1)))
  (if (> angg pi)
      (setq angg (abs (- angg (* 2 pi)))))
  angg)
 ; Ŀ
 ;   Tuna end.                                                             
 ; 

 ; Ŀ
 ;   Codton - fillet the lines and draw the welds.                         
 ; 
 (DEFUN CODTON (enta entb / plast dimsc lina linb tena elvna tenb elvnb lenga
                                      lengb pa ang1 ang2 p1 p2 angg fil elast)
  (setq plast (entlast))
  (setq dimsc (getvar "dimscale"))
  (setq lina (entget enta))
  (setq linb (entget entb))
  (setq tena  (cdr (assoc 10 lina)))
  (setq elvna (cdr (assoc 11 lina)))
  (setq tenb  (cdr (assoc 10 linb)))
  (setq elvnb (cdr (assoc 11 linb)))
  (setq lenga (distance tena elvna))
  (setq lengb (distance tenb elvnb))
  (if (setq pa (inters tena elvna tenb elvnb nil))
      (progn
           (if (< (distance pa tena) (distance pa elvna))
               (setq ang1 (angle tena elvna))
               (setq ang1 (angle elvna tena)))
           (if (< (distance pa tenb) (distance pa elvnb))
               (setq ang2 (angle tenb elvnb))
               (setq ang2 (angle elvnb tenb)))
           (setq p1 (polar pa ang1 (* dimsc 5)))
           (setq p2 (polar pa ang2 (* dimsc 5)))
 ; Ŀ
 ;   Call tuna to find the angle, set Filletrad accordingly.               
 ; 
           (setq angg (tuna ang1 ang2))
           (if (> angg (/ pi 2))
               (progn
                    (setq fil 5)
                    (setvar "filletrad" (* dimsc 5)))
               (progn
                    (setq fil 2)
                    (setvar "filletrad" (* dimsc 2))))
 ; Ŀ
 ;   See if the lines are long enough to fillet at the current radius and  
 ;   angle. If fil = 5 then the angle was 120 and lines at least 2.89     
 ;   units long are required.  If fil = 2 then the angle was 60 and 3.46  
 ;   will be removed from the end of each line by the fillet command.      
 ; 
           (if (or (and (= fil 2)
                        (> lenga (* 3.5 dimsc))
                        (> lengb (* 3.5 dimsc)))
                   (and (= fil 5)
                        (> lenga (* 3 dimsc))
                        (> lengb (* 3 dimsc))))
               (command "fillet" (list enta p1) (list entb p2)))))
 ; Ŀ
 ;   If a new entity was created, return its entity name.                  
 ; 
 (if (not (equal plast (setq elast (entlast))))
     elast))
 ; Ŀ
 ;   Codton end.                                                           
 ; 

 ; Ŀ
 ;   A6 - make an iso-array.                                               
 ; 
 (DEFUN C:A6 (/ *error* osmo ss pa)
  (setvar "cmdecho" 0)
  (command ".undo" "be")
  (setq osmo (getvar "osmode"))
  (setvar "osmode" 0)
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
  (defun *error* (shk)
   (setvar "osmode" osmo)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (write-line shk))
  (princ))
 ; Ŀ
 ;   Get some stuff.                                                       
 ; 
  (prompt "Select Stuff To Array: ")
  (setq ss (ssget))
 ; Ŀ
 ;   A centre point.                                                       
 ; 
  (setq pa (getpoint "Centre Point: "))
 ; Ŀ
 ;   Do it.                                                                
 ; 
  (if (and ss pa)
      (command "array" ss "" "P" pa 6 360 "Y"))
  (*error* nil)
 (princ))

 ; Ŀ
 ;   Htt.                                                                  
 ; 
 (DEFUN C:HTT (/ *error* snast ison pa aa elast ss lena angg dang segs excess
                             osmo enam0 pb pb1 pb2 prelast llast nunam isopl)
  (setvar "cmdecho" 0)
  (command ".undo" "be")
  (setq osmo (getvar "osmode"))
  (setvar "osmode" 0)
  (malaya "trace")
 ; Ŀ
 ;   Previously Sailfish, now a local error handler.                       
 ; 
  (defun *error* (shk)
 ; Ŀ
 ;   Make all the lines and arcs into a polyline.                          
 ; 
   (if (and ss (> (sslength ss) 1))
       (command ".pedit" (ssname ss 0) "y" "j" ss "" ""))
 ; Ŀ
 ;   Clean up some other settings.                                         
 ; 
   (if snast (setvar "snapstyl" snast))
   (setvar "osmode" osmo)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if (and shk (/= shk "Function cancelled"))
       (write-line shk))
  (princ))
 ; Ŀ
 ;   Make sure Iso is on.                                                  
 ; 
  (if (= (setq snast (getvar "snapstyl")) 0)
      (progn
           (initget 0 "Yes No")
           (setq ison (getkword "Shouldn't Iso be on? <Y>: "))
           (if (or (null ison) (= ison "Yes"))
               (setvar "snapstyl" 1))))
 ; Ŀ
 ;   Get a start point or switch to the next isoplane if one wasn't        
 ;   indicated.                                                            
 ; 
  (while (null (setq pa (getpoint "Start: ")))
         (setq isopl (getvar "snapisopair"))
         (if (= isopl 2)
             (setvar "snapisopair" 0)
             (setvar "snapisopair" (1+ isopl))))
 ; Ŀ
 ;   Draw some lines.                                                      
 ; 
  (while T
         (setq aa (getpoint pa))
         (if aa
             (progn
                  (command "line" pa aa "")
                  (setq enam0 (setq elast (entlast)))
                  (if ss
                     (ssadd elast ss)
                     (setq ss (ssadd elast)))
 ; Ŀ
 ;   Add heater sections: say ten unit ends and twenty between, so each    
 ;   segment takes forty units.                                            
 ; 
                  (setq lena (distance pa aa))
                  (setq angg (angle pa aa))
                  (setq dang (* angg (/ 180 pi)))
                  (setq segs (fix (/ lena 40)))
                  (if (not (zerop segs))
                      (setq excess (/ (rem lena (* 40 segs)) segs)))
 ; Ŀ
 ;   If there is only one heater segment ...                               
 ; 
                  (cond ((= segs 1)
                         (setq pb (polar pa angg (/ lena 2)))
                         (setq pb1 (polar pb angg 10))
                         (setq pb2 (polar pb angg -10))
                         (command ".break" (list elast pb1) "f" pb1 pb2)
                         (ssadd (setq elast (entlast)) ss)
                         (command ".insert" "zigzag" pb 1 "" dang)
                         (command "explode" "l")
                         (ssadd (entlast) ss))
                        ((> segs 1)
                         (setq pb (polar pa angg (+ 20 (/ excess 2))))
                         (setq pb1 (polar pb angg 10))
                         (setq pb2 (polar pb angg -10))
                         (command ".break" (list elast pb1) pb2)
                         (ssadd (setq elast (entlast)) ss)
                         (command ".insert" "zigzag" pb 1 "" dang)
                         (command "explode" "l")
                         (ssadd (entlast) ss)
                         (repeat (1- segs)
                                (setq pb (polar pb angg (+ 40 excess)))
;                                (setq linam (car (nentselp pb)))
                                (setq pb1 (polar pb angg 10))
                                (setq pb2 (polar pb angg -10))
                                (command ".break" (list elast pb1) pb2)
                                (ssadd (setq elast (entlast)) ss)
                                (command ".insert" "zigzag" pb 1 "" dang)
                                (command "explode" "l")
                                (ssadd (entlast) ss))))
 ; Ŀ
 ;   Fillet the lines.                                                     
 ; 
                  (if llast (setq prelast llast))
                  (setq llast elast)
 ; Ŀ
 ;   Draw some temporary markers.                                          
 ; 
                  (if (and nil enam0 prelast)
                      (progn
                           (grdraw '(0 0) (cdr (assoc 10 (entget enam0))) 1)
                           (grdraw '(0 0) (cdr (assoc 11 (entget enam0))) 1)
                           (grdraw '(0 0) (cdr (assoc 10 (entget prelast))) 2)
                           (grdraw '(0 0)
                                    (cdr (assoc 11 (entget prelast))) 2)))
 ; Ŀ
 ;   Call Codton to make the fillets.                                      
 ; 
                  (if (and enam0 prelast)
                      (setq nunam (codton enam0 prelast)))
                  (if nunam (ssadd nunam ss))
                  (setq pa aa))
 ; Ŀ
 ;   If the user didn't select a point then flip to the next isoplane.     
 ; 
             (progn
                  (setq isopl (getvar "snapisopair"))
                  (if (= isopl 2)
                      (setvar "snapisopair" 0)
                      (setvar "snapisopair" (1+ isopl))))))
 ; Ŀ
 ;   Clean up and end.  You can't get here without an error.               
 ; 
 (princ))
