 ; Ŀ
 ;   Idle - try to erase all clouds and all Rev triangles.                 
 ;   Copyright 1994, 1997, 2001, 2008, 2011, 2017 by Rocket Software Ltd.  
 ;   Just ease back on the revs there, Bob.                                
 ; 

 ; Ŀ
 ;   Isc: Cloud test.                                                      
 ;   Calls Ficl.                                                           
 ; 
 (defun c:isc ()
  (if (ficl (car (entsel "Cloud to test: ")))
      (prompt "That was a cloud.")
      (prompt "That was not a cloud."))
 (princ))
 ; Ŀ
 ;   Isc end.                                                              
 ; 

 ; Ŀ
 ;   Isk: Cloud test.                                                      
 ;   Calls Ickl.                                                           
 ; 
 (defun c:isk ()
  (if (ickl (car (entsel "Cloud to test: ")))
      (prompt "That was a cloud.")
      (prompt "That was not a cloud."))
 (princ))
 ; Ŀ
 ;   Isk end.                                                              
 ; 

 ; Ŀ
 ;   Ficl - see if a polyline is a cloud - all segments have bulges.       
 ;   Arguments: Enam, a polyline or lwpolyline entity name.                
 ;   Returns t if it's a cloud, else nil.                                  
 ; 
 (DEFUN FICL (enam / typ entt num nobulg flat sub)
  (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
  (cond ((= typ "POLYLINE")
         (setq segs 0)
         (while (and (null nobulg)
                     (/= "SEQEND" (cdr (assoc 0 (setq entt (entget (setq enam
                                                         (entnext enam))))))))
                (setq segs (1+ segs))
                (if (or (not (assoc 42 entt))
                        (= (cdr (assoc 42 entt)) 0))
                    (setq nobulg T))))
        ((= typ "LWPOLYLINE")
         (setq num 0)
         (setq segs 0)
         (while (and (null nobulg)
                     (setq sub (nth num entt)))
                (setq num (1+ num))
                (cond ((= (car sub) 10)
                       (setq segs (1+ segs))
                       (if flat
                           (setq nobulg t)
                           (setq flat t)))
                      ((and (= (car sub) 42)
                            (/= (cdr sub) 0))
                       (setq flat nil))))))
 ; Ŀ
 ;   If Nobulg is not set and there were > 2 segments, it was a cloud.     
 ;   Two segments with equal bulges may be a polyline circle.              
 ; 
 (and (null nobulg) (> segs 2)))
 ; Ŀ
 ;   Ficl end.                                                             
 ; 

 ; Ŀ
 ;   Ickl - see if a polyline is a cloud - the number of segments is       
 ;   no greater than two more than the number of bulges.                   
 ;   Arguments: Enam, a polyline or lwpolyline entity name.                
 ;   Returns t if it's a cloud, else nil.                                  
 ; 
 (DEFUN ICKL (enam / typ entt num nobulg flat sub bulgs)
  (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
  (setq bulgs 0)
  (cond ((= typ "POLYLINE")
         (setq segs 0)
         (while (and (null nobulg)
                     (/= "SEQEND" (cdr (assoc 0 (setq entt (entget (setq enam
                                                         (entnext enam))))))))
                (setq segs (1+ segs))
                (if (and (assoc 42 entt) (/= (cdr (assoc 42 entt)) 0))
                    (setq bulgs (1+ bulgs)))))
        ((= typ "LWPOLYLINE")
         (setq num 0)
         (setq segs 0)
         (while (and (null nobulg)
                     (setq sub (nth num entt)))
                (setq num (1+ num))
                (cond ((= (car sub) 10)
                       (setq segs (1+ segs)))
                      ((and (= (car sub) 42)
                            (/= (cdr sub) 0))
                       (setq bulgs (1+ bulgs)))))))
 ; Ŀ
 ;   See if it looked like a polyline.                                     
 ;   Modify this - allow ten percent non-bulged sections, minimum two.     
 ; 
  (setq flats (max 2 (fix (/ segs 10))))
 ; (print segs)
 ; (print bulgs)
 (if (and (>= segs 2) (> bulgs (- segs flats))) t))
 ; Ŀ
 ;   Ickl end.                                                             
 ; 

 ; Ŀ
 ;   Idle.                                                                 
 ; 
 (DEFUN C:IDLE (/ ss enam num cnum)
  (setvar "cmdecho" 0)
  (command ".undo" "be")
 ; Ŀ
 ;   Look for clouds to erase.                                             
 ; 
  (if (setq ss (ssget "X" '((-4 . "<or") (8 . "revise")
                                         (8 . "g-clouds")
                                         (8 . "clouds")
                                         (8 . "e-contin")
                                         (8 . "ei cloud")
                                         (8 . "upi cloud")
                                         (8 . "upi revision*")
                                         (8 . "border*")
                                         (8 . "a-revise") (-4 . "or>")
                            (-4 . "<or") (0 . "polyline")
                                         (0 . "lwpolyline") (-4 . "or>"))))
      (progn
           (setq num 0)
           (setq cnum 0)
           (while (setq enam (ssname ss num))
                  (setq num (1+ num))
                  (if (ickl enam)
                      (progn
                           (setq cnum (1+ cnum))
                           (entdel enam))))
           (prompt (strcat "\nClouds Erased: " (itoa cnum)))))
 ; Ŀ
 ;   And rev triangles.                                                    
 ;   Note that Revision isn't included here because it is often used as    
 ;   a name for a rev triangle and just as often for a rev area block.     
 ; 
  (if (setq ss (ssget "X" '((-4 . "<or") (8 . "revise")
                                         (8 . "0")
                                         (8 . "g-clouds")
                                         (8 . "clouds")
                                         (8 . "e-contin")
                                         (8 . "ei cloud")
                                         (8 . "upi cloud")
                                         (8 . "upi revision*")
                                         (8 . "border*")
                                         (8 . "a-revise") (-4 . "or>")
                        (2 . "rev,revtri,revtri-1,rev_triangle,rev delta,revtag"))))
      (progn
           (prompt (strcat "\nRev Triangles Erased: " (itoa (sslength ss))))
           (command "erase" ss "")))
  (command ".undo" "end")
 (princ))