 ; Ŀ
 ;   Jod - make a prototype Jobdata.txt file.                              
 ;   Copyright 2011 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Jod - extract the data, write the file.                    
 ;   Arguments: Hau, a value flag.                                         
 ;                   "Mt"  =  empty all attributes (##).                   
 ;                   "Val" =  use existing values.                         
 ;                   "V2"  =  use existing values, empty if "".            
 ;              Com, comment out all lines.                                
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN JOD (hau com / enampt enam prefa fn ff num header stra vala tagg)
  (setq hau (strcase hau t))
 ; Ŀ
 ;   Make the header line list.                                            
 ; 
  (setq header (list
     " ; This is a sample configuration file for Halon.lsp, which"
     " ; contains complete instructions on writing these files."
     " ; Each section (there can be more than one) begins with the line:"
     " ; Block     |  Block_name"
     " ; Followed by several lines:"
     " ; Attribute |  New_value"
     " ; ## as a new value empties the attribute"
     " ; Anything after a semicolon is a comment and is ignored."
     " ; Jod.lsp can write these files for you."
     ""))
 ; Ŀ
 ;   Get a block entity.                                                   
 ; 
  (if (setq enampt (entsel "Select A Block To Write: "))
      (progn
           (setq enam (car enampt))
 ; Ŀ
 ;   Open the file to write to.                                            
 ; 
           (setq prefa (getvar "dwgprefix"))
           (setq fn (strcat prefa "Jobdata.txt"))
           (setq ff (open fn "w"))
 ; Ŀ
 ;   Write the header text.                                                
 ; 
           (setq num 0)
           (while (setq stra (nth num header))
                  (setq num (1+ num))
                  (write-line stra ff))
 ; Ŀ
 ;   Write the block name line.                                            
 ; 
           (setq blnam (cdr (assoc 2 (entget enam))))
           (write-line (strcat "BLOCK         | " blnam) ff)
 ; Ŀ
 ;   Add the rest of the attribute lines.                                  
 ; 
           (while (/= "SEQEND" (cdr (assoc 0 (setq entt
                                      (entget (setq enam (entnext enam)))))))
                  (setq vala (cdr (assoc 1 entt)))
                  (setq tagg (cdr (assoc 2 entt)))
                  (while (< (strlen tagg) 14)
                         (setq tagg (strcat tagg " ")))
                  (cond ((= hau "mt")
                         (setq tagg (strcat tagg "| ##")))
                        ((= hau "val")
                         (setq tagg (strcat tagg "| " vala)))
                        ((= hau "v2")
                         (if (member vala '("" " " "  " "   "))
                             (setq vala "##"))
                         (setq tagg (strcat tagg "| " vala))))
                  (if com (setq tagg (strcat "; " tagg)))
                  (write-line tagg ff))
           (if ff (close ff))))
 (princ))
 ; Ŀ
 ;   Jod end.                                                              
 ; 

 ; Ŀ
 ;   Jodc.                                                                 
 ; 
 (DEFUN C:JODC ()
  (jod "val" t)
 (princ))

 ; Ŀ
 ;   Jode.                                                                 
 ; 
 (DEFUN C:JODE ()
  (jod "v2" t)
 (princ))

 ; Ŀ
 ;   Jod.                                                                  
 ; 
 (DEFUN C:JOD ()
  (jod "val" nil)
 (princ))