 ; Ŀ
 ;   Jump - put a dot on the end of certain lines.                         
 ;   Copyright 2014 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Memphis - See if an argument is a member of a list, allows a fuzz     
 ;   factor.                                                               
 ;   Arguments: King, the thing to check for membership.                   
 ;              Prisc, a list.                                             
 ;              Fuzz, a fuzz factor.                                       
 ;   Returns the list starting with the first matching element, or nil.    
 ;   Note that (equal "a" "a" 0.01) is ok - the fuzz factor is ignored.    
 ; 
 (DEFUN MEMPHIS (king prisc fuzz / sub num bubba)
  (setq num 0)
  (while (setq sub (car prisc))
         (setq num (1+ num))
         (if (equal king sub fuzz)
             (setq bubba prisc))
         (setq prisc (cdr prisc)))
 bubba)
 ; Ŀ
 ;   Memphis end.                                                          
 ; 

 ; Ŀ
 ;   Subroutine Ploen - Get the length and segments from a polyline.       
 ;   Arguments, Enam, a polyline ename.                                    
 ;   Calls nothing.                                                        
 ;   Returns: (segments length closedp)                                    
 ; 
 (DEFUN PLOEN (enam / totlen segs entt closed pa pasav pb)
  (setq totlen 0)
  (setq segs -1)
  (setq entt (entget enam))
  (setq closed (if (= 1 (logand 1 (cdr (assoc 70 entt)))) t))
  (while (/= "SEQEND" (cdr (assoc 0 (setq entt (entget
                                               (setq enam (entnext enam)))))))
         (setq segs (1+ segs))
         (setq pa (cdr (assoc 10 entt)))
         (if (null pasav) (setq pasav pa))
             (if (and pa pb)
                 (setq totlen (+ totlen (distance pa pb))))
         (setq pb pa))
  (if closed (setq totlen (+ totlen (distance pa pasav))))
 (list segs totlen closed))
 ; Ŀ
 ;   Subroutine Ploen end.                                                 
 ; 

 ; Ŀ
 ;   Subroutine Plend - Get the ends of a single segment polyline.         
 ;   Arguments, Enam, a polyline ename.                                    
 ;   Calls nothing.                                                        
 ;   Returns a list: (end another_end)                                     
 ; 
 (DEFUN PLEND (enam / entt pa pb)
  (setq entt (entget enam))
  (setq pa (cdr (assoc 10 (entget (setq enam (entnext enam))))))
  (setq pb (cdr (assoc 10 (entget (setq enam (entnext enam))))))
 (list pa pb))
 ; Ŀ
 ;   Subroutine Plend end.                                                 
 ; 

 ; Ŀ
 ;   Jump.                                                                 
 ; 
 (DEFUN C:JUMP (/ osna *error* lila num ss enam plist enamel ends pa pb ptlist)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq osna (getvar "osmode"))
  (setvar "osmode" 0) 
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
  (defun *error* (shk)
   (setvar "osmode" osna) 
   (command "undo" "end")
   (if shk (print shk))
  (princ))
 ; Ŀ
 ;   Make a list of jumper line lengths.                                   
 ; 
  (setq lila '(0.4488 0.5984 0.2992 0.1496 2.5433))
 ; Ŀ
 ;   Get all the polylines in the drawing.                                 
 ; 
  (setq num 0)
  (if (setq ss (ssget "x" (list (cons 0 "polyline"))))
      (while (setq enam (ssname ss num))
             (setq num (1+ num))
 ; Ŀ
 ;   Make a list of single segment ones or appropriate lengths.            
 ; 
             (setq plist (ploen enam))
             (if (and (= (car plist) 1)
                      (null (caddr plist))
                      (memphis (cadr plist) lila 0.002))
                 (setq enamel (cons enam enamel)))))
 ; Ŀ
 ;   Get the end points of each one, put a dot on each.                    
 ;   Unless they're in the used points list.                               
 ; 
  (setq num 0)
  (while (setq enam (nth num enamel))
         (setq num (1+ num))
         (setq ends (plend enam))
         (setq pa (car ends))
         (setq pb (cadr ends))
         (grdraw pa pb 1)
         (if (not (member pa ptlist))
             (progn
                  (setq ptlist (cons pa ptlist))
                  (command ".insert" "dot" pa 0.013224 "" "")))
         (if (not (member pb ptlist))
             (progn
                  (setq ptlist (cons pb ptlist))
                  (command ".insert" "dot" pb 0.013224 "" ""))))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
  (*error* ())
 (princ))