 ; Ŀ
 ;   Junc - junction box maker.                                            
 ;   Jut - just draw the terminal strip.                                   
 ;   Copyright 1993, 1994, 1998, 2001, 2005, 2012 by Rocket Software Ltd.  
 ;   A better routine than you might think.                                
 ; 

 ; Ŀ
 ;   Subroutine Inico - draw the incoming cable.                           
 ;   Arguments: Pa, the top end of the cable.                              
 ;              Num, the number of terminals.                              
 ;   Calls nothing, Returns nothing.                                       
 ; 
 (DEFUN INICO (pa num / pa2 pa1 pc)
 ; Ŀ
 ;   Add the cable back to the control panel.                              
 ; 
  (setvar "clayer" "field")
  (setq pa2 (polar pa (* pi 1.5) (+ 20 (* num 5))))
  (command ".line" pa pa2 "")
 ; Ŀ
 ;   Line break and text.                                                  
 ; 
  (setvar "clayer" "misc")
  (command ".insert" "linebrk" pa2 "1" "" 0)
  (setvar "clayer" "text")
  (command ".text" "c" (polar pa2 (* pi 1.5) 5) 2.5 0 "CONT. ON DWG.")
  (command ".text" "" "XXX")
 ; Ŀ
 ;   And a wiretag.                                                        
 ; 
  (setq pa1 (polar pa2 (/ pi 2) 10))
  (command ".pline" (setq pc (polar pa1 0 2.5))
                    (setq pc (polar pc (/ pi 2) 1.25))
                    (setq pc (polar pc pi 5))
                    (setq pc (polar pc (* pi 1.5) 1.25))
                    (setq pc (polar pc 0 10)) "")
  (setq pc (polar (polar pc (* pi 1.5) 2.5) 0 12.5))
  (setvar "clayer" "misc")
  (command ".insert" "cabletag" pc "1" "" 0 "CC-XXX")
 (princ))
 ; Ŀ
 ;   Inico end.                                                            
 ; 

 ; Ŀ
 ;   Ldwire - draw a pair of left-hand-side discrete wires.                
 ;   Arguments: Pa, the terminal block insertion point                     
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN LDWIRE (pa / pb pc ptx pd pe)
  (setvar "clayer" "misc")
  (setq pb (polar pa pi 12.5))
  (setq pc (polar pa pi 22.5))
  (setq ptx (polar pa pi 35))
  (setq pd (polar pa pi 47.5)) 
  (setq pe (polar pa pi 55)) 
  (setvar "clayer" "field")
  (command "line" pb pc "")
  (command "line" pd pe "")
  (command "arc" pe
                 "c"
                 (polar pe (* pi 1.5) 2.5)
                 (polar (polar pe pi 2.5) (* pi 1.5) 2.5))
  (setvar "clayer" "text")
  (command ".text" "m" ptx "2.5" "0" "XXX-1")
  (setq pa (polar pa (* pi 1.5) 5))
  (setq pb (polar pa pi 12.5))
  (setq pc (polar pa pi 22.5))
  (setq ptx (polar pa pi 35))
  (setq pd (polar pa pi 47.5)) 
  (setq pe (polar pa pi 55)) 
  (setvar "clayer" "field")
  (command "line" pb pc "")
  (command "line" pd pe "")
  (command "arc" pe
                 "c"
                 (polar pe (* pi 1.5) 2.5)
                 (polar (polar pe pi 2.5) (* pi 1.5) 2.5))
  (setvar "clayer" "text")
  (command ".text" "m" ptx "2.5" "0" "XXX-2")
 (princ))
 ; Ŀ
 ;   Ldwire end.                                                           
 ; 

 ; Ŀ
 ;   Lpend - draw the end of a pair of left-hand-side analog wires.        
 ;   Arguments: Pa, the terminal block insertion point                     
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN LPEND (pa / pd pe)
 ; Ŀ
 ;   Make the top line and end arc.                                        
 ; 
  (setq pd (polar pa pi 62.5)) 
  (setq pe (polar pa pi 70)) 
  (setvar "clayer" "field")
  (command "line" pd pe "")
  (command "arc" pe
                 "c"
                 (polar pe (* pi 1.5) 2.5)
                 (polar (polar pe pi 2.5) (* pi 1.5) 2.5))
 (princ))
 ; Ŀ
 ;   Lpend end.                                                            
 ; 

 ; Ŀ
 ;   Plair - draw half a pair of analog wires.                             
 ;   Arguments: Pa, the terminal block insertion point                     
 ;              Lor, "L" or "R" - Left or Right.                           
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN PLAIR (pa lor / angg pb pc ptx pd pe)
  (setq angg (if (= lor "L") pi 0))
 ; Ŀ
 ;   Make the top line and text.                                           
 ; 
  (setq pb (polar pa angg 12.5))
  (setq pc (polar pa angg 37.5))
  (setq ptx (polar pa angg 50))
  (setvar "clayer" "field")
  (command "line" pb pc "")
  (setvar "clayer" "text")
  (command ".text" "m" ptx "2.5" "0" "XXXXX")
 ; Ŀ
 ;   Make the top wire colour text entity.                                 
 ; 
  (setq ptx (polar (polar pa angg 23.75) (/ pi 2) 1))
  (command ".text" "c" ptx "2" "0" "WHT")
 ; Ŀ
 ;   Make the second polyline and several arcs.                            
 ; 
  (setvar "clayer" "field")
  (setq pa (polar pa (* pi 1.5) 5))
  (setq pb (polar pa angg 12.5))
  (setq pc (polar pa angg 27.5))
  (setq pd (polar (polar pa angg 30) (/ pi 2) 2.5))
  (setq pe (polar (polar pa angg 32.5) (/ pi 2) 5))
  (command "pline" pb pc "arc" pd "arc" pe "")
 ; Ŀ
 ;   Make the bottom wire colour text entity.                              
 ; 
  (setvar "clayer" "text")
  (setq ptx (polar (polar pa angg 23.75) (/ pi 2) 1))
  (command ".text" "c" ptx "2" "0" "BLK")
 (princ))
 ; Ŀ
 ;   Plair end.                                                            
 ; 

 ; Ŀ
 ;   Rdwire - draw a pair of right-hand-side discrete wires.               
 ;   Arguments: Pa, the terminal block insertion point                     
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN RDWIRE (pa / pb pc ptx pd pe pbrac)
  (setvar "clayer" "misc")
  (setq pb (polar pa 0 12.5))
  (setq pc (polar pa 0 22.5))
  (setq ptx (polar pa 0 35))
  (setq pd (polar pa 0 47.5)) 
  (setq pe (polar pa 0 67.5)) 
  (setvar "clayer" "field")
  (command "line" pb pc "")
  (command "line" pd pe "")
  (setvar "clayer" "misc")
  (command ".insert" "linebrk" pe "1" "" 90)
  (setvar "clayer" "text")
  (command ".text" "m" ptx "2.5" "0" "XXX-1")
  (setq pbrac (polar (polar pe (* pi 1.5) 2.5) 0 2.5))
  (setq pa (polar pa (* pi 1.5) 5))
  (setvar "clayer" "misc")
  (setq pb (polar pa 0 12.5))
  (setq pc (polar pa 0 22.5))
  (setq ptx (polar pa 0 35))
  (setq pd (polar pa 0 47.5)) 
  (setq pe (polar pa 0 67.5)) 
  (setvar "clayer" "field")
  (command "line" pb pc "")
  (command "line" pd pe "")
  (command ".insert" "linebrk" pe "1" "" 90)
  (setvar "clayer" "text")
  (command ".text" "m" ptx "2.5" "0" "XXX-2")
 ; Ŀ
 ;   Make the bracket and end text.                                        
 ; 
  (zagra pbrac 0 1)
  (command ".text" "ml" (polar pbrac 0 5) "2.5" "0" "XXXXX")
 (princ))
 ; Ŀ
 ;   Rdwire end.                                                           
 ; 

 ; Ŀ
 ;   Rpend - draw the right end of a right-hand-side analog wire.          
 ;   Arguments: Pa, the terminal block insertion point                     
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN RPEND (pa / pb pc)
  (setq pb (polar pa 0 62.5))
  (setq pc (polar pa 0 82.5))
  (setvar "clayer" "field")
  (command "line" pb pc "")
  (setvar "clayer" "misc")
  (command ".insert" "linebrk" pc "1" "" 90)
  (setvar "clayer" "text")
  (command ".text" "ml" (polar pc 0 2.5) "2.5" "0" "XXXXX")
 (princ))
 ; Ŀ
 ;   Rpend end.                                                            
 ; 

 ; Ŀ
 ;   Thriad - draw the third wire for an analog triad.                     
 ;   Arguments: Pa, the terminal block insertion point                     
 ;              Lor, "L" or "R" - Left or Right.                           
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN THRIAD (pa lor / angg pb pc pd pe ptx)
  (setq angg (if (= lor "L") pi 0))
 ; Ŀ
 ;   Make the polyline with arc.                                           
 ; 
  (setvar "clayer" "field")
  (setq pa (polar pa (* pi 1.5) 10))
  (setq pb (polar pa angg 12.5))
  (setq pc (polar pa angg 27.5))
  (setq pd (polar (polar pa angg 30) (/ pi 2) 2.5))
  (setq pe (polar pd (/ pi 2) 5))
  (command "pline" pb pc "arc" pd "line" pe "")
 ; Ŀ
 ;   Make the bottom wire colour text entity.                              
 ; 
  (setvar "clayer" "text")
  (setq ptx (polar (polar pa angg 23.75) (/ pi 2) 1))
  (command ".text" "c" ptx "2" "0" "RED")
 (princ))
 ; Ŀ
 ;   Thriad end.                                                           
 ; 

 ; Ŀ
 ;   Zagra - draw a bracket.                                               
 ;   Arguments: Pa, a point.                                               
 ;              Right, the angle from the open side towards the peak.      
 ;              Scal, the overall scale, based on a base size of 7.5.      
 ;   Calls nohing, returns nothing.                                        
 ; 
 (DEFUN ZAGRA (pa right scal / up down ptop pctop pup1 pup2 pcpup ppeak
                                    pcpbas down2 down1 pcbas pbas rdeg ldeg)
  (setq up (+ right (/ pi 2)))
  (setq down (+ right (* pi 1.5)))
 ; Ŀ
 ;   Make the points.                                                      
 ; 
  (setq ptop (polar pa up (* 3.75 scal)))
  (setq pctop (polar pa up (* 2.5 scal)))
  (setq pup1 (polar pctop right 1.25))
  (setq pup2 (polar pa up (* 1.25 scal)))
  (setq pup2 (polar pup2 right 1.25))
  (setq pcpup (polar pup2 right 1.25))
  (setq ppeak (polar pa right 2.5))
  (setq pcpbas (polar ppeak down 1.25))
  (setq down2 (polar pa down (* 1.25 scal)))
  (setq down2 (polar down2 right 1.25))
  (setq down1 (polar down2 down (* 1.25 scal)))
  (setq pcbas (polar pa down (* 2.5 scal)))
  (setq pbas (polar pa down (* 3.75 scal)))
 ; Ŀ
 ;   Make it.                                                              
 ; 
  (setq rdeg (* right (/ 180 pi)))
  (setq ldeg (* (+ right pi) (/ 180 pi)))
  (command "pline" ptop "arc"  "d" rdeg pup1
                        "line" pup2
                        "arc"  ppeak
                        "arc"  "d" ldeg down2
                        "line" down1
                        "arc"  pbas "")
 (princ))
 ; Ŀ
 ;   Zagra end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Junc.                                                      
 ;   Argument: Ol, t = draw the box and incoming cable, nil = don't.       
 ; 
 (DEFUN JUNC (ol / osmo suni *error* pa insp num ht wid stap pb txpt stav
                                                                   termno pa1)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq osmo (getvar "osmode"))
  (setvar "osmode" 0)
  (setq suni (getvar "insunits"))
  (setvar "insunits" 0)
 ; Ŀ
 ;   Make an error handler.                                                
 ; 
  (defun *error* (shk)
   (setvar "osmode" osmo)
   (setvar "insunits" suni)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (print shk))
  (princ))
 ; Ŀ
 ;   Set up the layers.                                                    
 ; 
  (if (null c:malaya) (load "malaya"))
  (malaya "field")
  (malaya "misc")
  (malaya "text")
 ; Ŀ
 ;   See what type of JB this is.                                          
 ; 
  (initget 0 "Discrete Pairs Triads")
  (setq insp (getkword "JB Type: analog Pairs/analog Triads/<Discrete>: "))
 ; Ŀ
 ;   Get the number of pairs.                                              
 ; 
  (cond ((or (null insp) (= insp "Discrete"))
         (setq insp "Discrete")
         (setq num (getint "Number of Pairs <12>: "))
         (if (null num) (setq num 12)))
        ((= insp "Pairs")
         (setq num (getint "Number of Analog Pairs <12>: "))
         (if (null num) (setq num 12)))
        ((= insp "Triads")
         (setq num (getint "Number of Analog Triads <12>: "))
         (if (null num) (setq num 12)))
        (t (write-line "Impossible error.  Please check your reality.")))
 ; Ŀ
 ;   Get a start point.                                                    
 ; 
  (setq pa (getpoint "JB Start: "))
 ; Ŀ
 ;   Get the box height and with and the start point for terminals.        
 ;   Actually this isn't that difficult.                                   
 ; 
  (cond ((= insp "Discrete")
         (setq ht (+ 27.5 (* num 10)))
         (setq wid 125)
         (setq stap (polar (polar pa 0 67.5) (* pi 1.5) 17.5)))
        ((= insp "Pairs")
         (setq ht (+ 27.5 (* num 15)))
         (setq wid 155)
         (setq stap (polar (polar pa 0 82.5) (* pi 1.5) 17.5)))
        ((= insp "Triads")
         (setq ht (+ 27.5 (* num 20)))
         (setq wid 155)
         (setq stap (polar (polar pa 0 82.5) (* pi 1.5) 17.5))))
 ; Ŀ
 ;   Draw the box, install the header text.                                
 ; 
  (if ol
     (progn
           (setvar "clayer" "misc")
           (command ".pline" pa
                             (setq pb (polar pa 0 wid))
                             (polar pb (* pi 1.5) ht)
                             (polar pa (* pi 1.5) ht)
                             "c")
           (command ".change" "l" "" "p" "colour" "cyan" "")
           (setq txpt (polar (polar pa 0 (/ wid 2)) (/ pi 2) 7.5))
           (setvar "clayer" "text")
           (command ".text" "j" "c" txpt 2.5 0 "JB-XXX-X")
           (if (= insp "Discrete")
               (command ".text" "" "XXXXX JUNCTION BOX")
               (command ".text" "" "ANALOG JUNCTION BOX")))
 ; Ŀ
 ;   If we're just drawing the terminal strip, de-adjust the insertion.    
 ; 
     (setq stap pa))
 ; Ŀ
 ;   Install the lamicoid header block.                                    
 ; 
  (setvar "clayer" "misc")
  (command "insert" "terminal-lamicoid" stap "1" "" "0" "TS-1")
  (setq stap (polar stap (* pi 1.5) 2.5))
  (setq stav stap)
 ; Ŀ
 ;   Make the terminal strip.                                              
 ; 
  (setvar "clayer" "misc")
  (setq termno 1)
  (repeat (cond ((= insp "Triads")
                 (* 4 num))
                ((= insp "Pairs")
                 (* 3 num))
                ((= insp "Discrete")
                 (* 2 num)))
          (command "insert" "jb-terminal" stap "1" "" "" (itoa termno))
          (setq stap (polar stap (* pi 1.5) 5))
          (setq termno (1+ termno)))
 ; Ŀ
 ;   Make the incoming cable.                                              
 ; 
  (if ol
      (progn
           (setq pa1 (polar (polar pa 0 10) (* pi 1.5) 22.5))
           (inico pa1 termno)))
 ; Ŀ
 ;   Install the wiring.                                                   
 ;   Discrete pairs.                                                       
 ; 
  (setq pa stav)
  (cond ((= insp "Discrete")
         (repeat num
                (ldwire pa)
                (rdwire pa)
                (setq pa (polar pa (* pi 1.5) 10))))
 ; Ŀ
 ;   Analog pairs.                                                         
 ; 
        ((= insp "Pairs")
         (repeat num
                (plair pa "L")  ; left side base with shields
                (lpend pa)      ; left side final line and arc
                (plair pa "R")  ; right side base with shields
                (rpend pa)      ; right side final line and device text
                (command "-insert" "shield2" (polar (polar pa pi 12.5)
                                                    (* pi 1.5) 10) -1 1 0)
                (command ".change" "l" "" "p" "colour" "magenta" "la" "misc" "")
                (command "-insert" "shield2" (polar (polar pa 0 12.5)
                                                    (* pi 1.5) 10) 1 1 0)
                (command ".change" "l" "" "p" "colour" "magenta" "la" "misc" "")
                (setq pa (polar pa (* pi 1.5) 15))))
 ; Ŀ
 ;   Analog triads.                                                        
 ;   Note that these are just pairs with another rung below them and       
 ;   a larger shield block.                                                
 ; 
        ((= insp "Triads")
          (repeat num
                (plair pa "L")  ; left side base with shields
                (lpend pa)      ; left side final line and arc
                (plair pa "R")  ; right side base with shields
                (rpend pa)      ; right side final line and device text
                (thriad pa "L") ; left side third conductor
                (thriad pa "R") ; right side third conductor
                (command "-insert" "shield3" (polar (polar pa pi 12.5)
                                                    (* pi 1.5) 15) -1 1 0)
                (command ".change" "l" "" "p" "colour" "magenta" "la" "misc" "")
                (command "-insert" "shield3" (polar (polar pa 0 12.5)
                                                    (* pi 1.5) 15) 1 1 0)
                (command ".change" "l" "" "p" "colour" "magenta" "la" "misc" "")
                (setq pa (polar pa (* pi 1.5) 20)))))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
  (*error* ())
 (princ))
 ; Ŀ
 ;   Subroutine Junc end.                                                  
 ; 

 ; Ŀ
 ;   Junc.                                                                 
 ; 
 (DEFUN C:JUT ()
  (junc ())
 (princ))

 ; Ŀ
 ;   Junc.                                                                 
 ; 
 (DEFUN C:JUNC ()
  (junc t)
 (princ))
