 ; Ŀ
 ;   Ldr - Lisp load and run.                                              
 ;   Copyright 1994, 2010, 2014 by Rocket Software Ltd.                    
 ;   The possibilities for good are endless, but dare we use it?           
 ; 

 ; Ŀ
 ;   Amuk - load and run a routine.                                        
 ;   Argument: Lnam, a lisp name.                                          
 ;   Calls nothing.                                                        
 ;   Returns the routine name if it could be loaded, else nil.             
 ;   Could modify this to run the name returned by load, if any.           
 ; 
 (DEFUN AMUK (lnam / fn)
 ; Ŀ
 ;   If we can load the routine, run it.                                   
 ; 
  (cond ((setq fn (load lnam ()))
         (eval (read (strcat "(C:" lnam ")"))))
 ; Ŀ
 ;   If it couldn't be loaded, see if it already is, run it, but warn      
 ;   the user - Lrd is supposed to be primarily a load utility.            
 ; 
        ((eval (read (strcat "c:" lnam)))
         (write-line (strcat "\n*** " lnam " run but can't be reloaded. ***"))
         (eval (read (strcat "(c:" lnam ")"))))
 ; Ŀ
 ;   Else print an apology.                                                
 ; 
        (t
         (write-line (strcat "\n ***" lnam " is not available. ***"))))
 fn)
 ; Ŀ
 ;   Amuk end.  Which may or may not be a good thing.                      
 ; 

 ; Ŀ
 ;   Lget - get a string by keyboard entry or entity selection at the      
 ;   same prompt.                                                          
 ;   Argument: Prom, a prompt string.                                      
 ;   Calls nothing.                                                        
 ;   Returns a list:                                                       
 ;   (string  selection_point  entity_name  parent_ename  return_entered). 
 ;   Any or all of these can be nil.                                       
 ; 
 (DEFUN LGET (prom / ppstr goon aa pa reta pstr enampt enam typ entt pname)

  (if (and prom (= (type prom) 'STR))
      (prompt prom)
      (prompt "\nEnter Text or Select an Example: "))
 ; Ŀ
 ;   Use grread to get points so can also accept keyboard input.           
 ; 
  (setq ppstr "")
  (setq goon t)
  (while (and goon (setq aa (grread () 4 0)))
         (cond ((= (car aa) 3)                             ; a point
                (setq goon ())                             ; leave loop
                (setq pa (cadr aa)))                       ; save point
               ((equal aa (list 2 13))                     ; Keyboard <Return>
                (setq reta t)
                (setq goon ()))                            ; leave looop
               ((equal (car aa) 25)                        ; Mouse <Return>
                (setq reta t)
                (setq goon ()))                            ; leave looop
               ((equal aa (list 6 0))                      ; Digitizer <Return>
                (setq reta t)
                (setq goon ()))                            ; leave looop
               ((equal aa (list 2 2))                      ; F9
                (setvar "snapmode" (abs (1- (getvar "snapmode")))))
               ((equal aa (list 2 15))                     ; F8
                (setvar "orthomode" (abs (1- (getvar "orthomode")))))
               ((equal (car aa) 2)                         ; a keypress
                (setq ppstr (strcat ppstr (setq aa (chr (cadr aa)))))
                (princ aa))))
 ; Ŀ
 ;   If a point was selected, and some letters were entered, first         
 ;   explain that this is a bad idea, then use whatever was at the point.  
 ; 
  (if (null pa)
      (if (/= ppstr "")
          (setq pstr ppstr))
      (progn
           (if (/= ppstr "") (prompt "\nPoint override. "))
 ; Ŀ
 ;   See if there was anything at the point.                               
 ; 
           (setq enampt (nentselp pa))
           (setq enam (car enampt))
           (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
 ; Ŀ
 ;   Look for a parent entity name.                                        
 ; 
           (cond ((= (type (caar (reverse enampt))) 'ENAME)
                  (setq pname (caar (reverse enampt))))
                 ((= typ "ATTRIB")
                  (setq pname (cdr (assoc 330 entt)))))
 ; Ŀ
 ;   Decide what to do.  There are several cases.                          
 ;   If there's nothing at the pick point and ppstr contains something,    
 ;   use that.                                                             
 ; 
           (cond ((and (null enampt) (/= ppstr ""))
                  (setq pstr ppstr))
 ; Ŀ
 ;   There's a text or attribute entity.                                   
 ; 
                 ((member typ '("TEXT" "ATTRIB"))
                  (setq pstr (cdr (assoc 1 entt))))
 ; Ŀ
 ;   An attdef.  Use the displayed value - assoc 2.                        
 ; 
                 ((= typ "ATTDEF")
                  (setq pstr (cdr (assoc 2 entt))))
 ; Ŀ
 ;   Anything else but ppstr contains a string.                            
 ; 
                 ((/= ppstr "")
                  (setq pstr ppstr)))))
 (list pstr pa enam pname reta))
 ; Ŀ
 ;   Lget end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Nopx - get the base name for a lisp.                       
 ; 
 (DEFUN NOPX (afa / pos)
 ; Ŀ
 ;   Set pointer Pos to the end of the string.                             
 ; 
  (setq pos (strlen afa))                            ; start at end of string
 ; Ŀ
 ;   Remove the path.                                                      
 ; 
  (while (< 0 pos)
          (if (or (= (substr afa pos 1) (chr 92))   ; if char = \
                  (= (substr afa pos 1) ":"))       ; or char = :
              (progn
                   (setq afa (substr afa (1+ pos))) ; then set afa to all after
                   (setq pos 1)))                   ;  and set pos to first
         (setq pos (1- pos)))                       ; set pos to previous
 ; Ŀ
 ;   And remove the extension if one was entered.                          
 ; 
  (if (and (> (strlen afa) 4)
           (= (strcase (substr afa (- (strlen afa) 3))) ".LSP"))
      (setq afa (substr afa 1 (- (strlen afa) 4))))
 afa)
 ; Ŀ
 ;   Subroutine Nopx end.                                                  
 ; 

 ; Ŀ
 ;   Subroutine Piano - read and run a program stored in a block.          
 ;   Arguments: Enam, the block entity name.                               
 ;              Pa, the pick point.                                        
 ;   There are five local variables, loc1-5.                               
 ;   Nonlocal names can be used as desired.                                
 ; 
 (DEFUN PIANO (enam pa / entt enam afa qui loc1 loc2 loc3 loc4 loc5)
  (if (and enam
          (setq entt (entget enam))
          (= (cdr (assoc 0 entt)) "INSERT")
          (= (cdr (assoc 66 entt)) 1))
 ; Ŀ
 ;   Apparently you can step through a deleted entity.                     
 ;   Qui stops execution if set from the program in the block.             
 ; 
      (while (and (/= (cdr (assoc 0 (setq entt (entget
                                 (setq enam (entnext enam)))))) "SEQEND")
                  (null qui))
             (setq afa (cdr (assoc 1 entt)))
             (while (= (substr afa 1 1) " ")
                    (setq afa (substr afa 2)))
             (if (and afa (not (equal (substr afa 1 1) ";")))
                 (eval (read afa))))
      (write-line "\nNo Suitable Entity Selected."))
 (princ))
 ; Ŀ
 ;   Subroutine Piano end.                                                 
 ; 

 ; Ŀ
 ;   Ldr.                                                                  
 ; 
 (DEFUN C:LDR (/ str dalis strp pa enam pname enta)
 ; Ŀ
 ;   Make the prompt string.                                               
 ; 
  (if ff
      (progn
           (if (and (> (strlen ff) 4)
                    (= (strcase (substr ff (- (strlen ff) 3))) ".LSP"))
               (setq ff (substr ff 1 (- (strlen ff) 4))))
           (setq str (strcat "File to load <" ff ">: ")))
      (setq str "File to load: "))
 ; Ŀ
 ;   Ask for a lisp name.  Or something else.                              
 ; 
  (setq dalis (lget str))
  (if (setq strp (car dalis))   ; name string
      (setq strp (nopx strp)))  ; remove path and .lsp extensio
  (setq pa (cadr dalis))        ; entity selection point
  (setq enam (caddr dalis))     ; entity name
  (setq pname (cadddr dalis))   ; parent entity name
  (setq enta (nth 4 dalis))     ; return entered flag
 ; Ŀ
 ;   If a string was Entered, run it.                                      
 ;   If there is no string but there was an Enter, use the default.        
 ;   If a string came From An Entity - there's no Enter - then use it,     
 ;   but if it won't load then run the block.                              
 ;   If there's a parent name, run the block.                              
 ; 
 ; Ŀ
 ;   If there's a string in Strp it's the lisp name.  Lget doesn't return  
 ;   "" under any circumstances.  If Enta is set then the string was       
 ;   entered manually, so run it.                                          
 ; 
  (cond ((and strp enta)
         (setq ff strp)
         (amuk strp))
 ; Ŀ
 ;   If there's no string but Enta is T then use the default string.       
 ; 
        (enta
         (setq strp ff)
         (amuk strp))
 ; Ŀ
 ;   If a string came from an entity - there's no Enter - then use it,     
 ;   but if it won't load then run the block.                              
 ; 
        ((and strp (null enta))
         (if (and (null (amuk strp)) pa pname)
             (piano pname pa)
             (setq ff strp)))  ; save the name as the default
 ; Ŀ
 ;   Last chance - try to run the block with piano.                        
 ; 
        ((and pa pname)
         (piano pname pa)))
 (princ))