 ; Ŀ
 ;   Loff - freeze all layers named in a list.  Allows wild cards.         
 ;   Copyright 2011 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Frelay - freeze a layer.                                              
 ;   Arguments: Lanam, the existing layer name.                            
 ;   Calls nothing, which it knows personally.                             
 ; 
 (DEFUN FRELAY (lanam)
  (command "-layer" "f" lanam "")
 (princ))
 ; Ŀ
 ;   Frelay end.                                                           
 ; 

 ; Ŀ
 ;   Membwc - see if a list contains any strings matching a wild card.     
 ;   Arguments: Pata, the match string.                                    
 ;              Nalis, the list to match.                                  
 ;   Calls nothing.                                                        
 ;   Returns a list of matching strings.                                   
 ; 
 (DEFUN MEMBWG (pata nalis / num sub retlis)
  (setq pata (strcase pata))
  (setq num 0)
  (while (setq sub (nth num nalis))
         (setq num (1+ num))
         (setq sub (strcase sub))
         (if (wcmatch sub pata)
             (setq retlis (cons sub retlis))))
 retlis)
 ; Ŀ
 ;   Membwc end.                                                           
 ; 

 ; Ŀ
 ;   Loff.                                                                 
 ; 
 (DEFUN C:LOFF (/ lalist rew laydat lanams stra lalist frlis lanam)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   Make the list of layer names to turn off.                             
 ; 
  (setq lalist (list "def*" "ab" "hidden"))
 ; Ŀ
 ;   Get a list of all layers in the drawing.                              
 ; 
  (setq rew t)
  (while (setq laydat (tblnext "layer" rew))
         (setq rew nil)
         (setq lanams (cons (cdr (assoc 2 laydat)) lanams)))
 ; Ŀ
 ;   If any names in the list to turn off match any in the layer name      
 ;   list, turn them off.                                                  
 ; 
  (while (setq stra (car lalist))
         (setq lalist (cdr lalist))
         (setq frlis (membwg stra lanams))
         (while (setq lanam (car frlis))
                (setq frlis (cdr frlis))
                (frelay lanam)))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
  (command "undo" "end")
 (princ))