 ; Ŀ
 ;   Lx - extract an attribute from a block without exploding it, or       
 ;   copy text from a text entity or out of a block or xref.               
 ;   Copyright 1995, 2010, 2014 by Rocket Software Ltd.                    
 ;   If you have to ask, you wouldn't understand.                          
 ; 

 ; Ŀ
 ;   Cvo - mark a point passed as the only argument.                       
 ; 
 (DEFUN CVO (pa rad colo / reps pa angg incr)
  (setq reps 32)
  (setq angg (/ pi 4))
  (setq incr (* 2.5 (/ pi reps)))
  (setq crad (/ rad 2))
 ; Ŀ
 ;   The main loop.                                                        
 ; 
  (repeat reps
          (setq rad (* rad 1.1))
          (setq pb (polar pa angg rad))
          (ici pb crad 16 colo)
          (setq pb (polar pa angg (- rad)))
          (ici pb crad 16 colo)
          (setq crad (* crad 0.95))
          (setq angg (+ angg incr)))
 (princ))
 ; Ŀ
 ;   Cvo end.                                                              
 ; 

 ; Ŀ
 ;   Cvox - mark a point with twin spirals.                                
 ;   Arguments: Pa, a centrepoint.                                         
 ; 
 (DEFUN CVOX (pa / ss num enam)
  (setq rad (/ (getvar "viewsize") 200))
  (cvo pa rad 7)
  (mark pa (* rad 12) 131)
 (princ))
 ; Ŀ
 ;   Cvo end.                                                              
 ; 

 ; Ŀ
 ;   Subroutine Ici - grdraw circle maker.                                 
 ; 
 (DEFUN ICI (pa radd reps colo / angg incr pa1 pa2)
  (setq angg 0)
  (setq incr (/ pi (/ reps 2)))
  (setq pa1 (polar pa angg radd))
  (repeat reps
          (setq angg (+ angg incr))
          (setq pa2 (polar pa angg radd))
          (grdraw pa1 pa2 colo)
          (setq pa1 pa2))
 (princ))
 ; Ŀ
 ;   Ici end.                                                              
 ; 

 ; Ŀ
 ;   Fando - see if a string contains a substring.                         
 ;   Takes three arguments:  Loc, the substring.                           
 ;                           Txt, the string.                              
 ;                           Cas, if this is non-nil then the search       
 ;                                is non-case-sensitive.                   
 ;   Returns T if the substring was present, nil otherwise.                
 ; 
 (DEFUN FANDO (loc txt cas / ln sta chflg)
  (if cas 
      (progn
           (setq loc (strcase loc t))
           (setq txt (strcase txt t))))
  (setq ln (strlen loc))
  (setq sta 1)
  (while (= ln (strlen (setq st (substr txt sta ln))))
         (if (= st loc) (setq chflg T))
         (setq sta (1+ sta)))
 chflg) 
 ; Ŀ
 ;   Fando end.                                                            
 ; 

 ; Ŀ
 ;   Lerx - error handler.                                                 
 ; 
 (DEFUN Lerx (shk /)
  (setq *error* esav)
  (if shk (write-line shk))
  (setvar "snapmode" snapp)
 (princ))
 ; Ŀ
 ;   Lerx end.                                                             
 ; 

 ; Ŀ
 ;   Mark - mark a point.                                                  
 ;   Arguments: Pa - the point to mark.                                    
 ;              Rad - the marker segment length.                           
 ;              Colo - the marker grdraw line colour.                      
 ; 
 (DEFUN MARK (pa rad colo /)
  (grdraw (polar pa (/ pi 4) rad) (polar pa (* 1.25 pi) rad) colo)
  (grdraw (polar pa (* pi 0.75) rad) (polar pa (* pi 1.75) rad) colo)
 (princ))
 ; Ŀ
 ;   Mark end.                                                             
 ; 

 ; Ŀ
 ;   Spit - returns the insertion point of the text entity whose data was  
 ;   passed as its sole argument.  Note that this is not necessarily the   
 ;   same as the 10 association code.                                      
 ; 
 (DEFUN SPIT (entt / xjust yjust)
  (setq xjust (cdr (assoc 72 entt)))
  (setq yjust (cdr (assoc 73 entt)))
  (if (or (/= xjust 0) (/= yjust 0))
      (cdr (assoc 11 entt))
      (cdr (assoc 10 entt))))
 ; Ŀ
 ;   Spit end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Suck - copy an attribute as a text entity.                 
 ;   Programming note: for mtext and multiline attributes the ten and      
 ;   eleven points may not be on the same line, so the new text may        
 ;   be strangely rotated - this seems to take precedence over the fifty   
 ;   sublist.                                                              
 ;   Probably fixing this for mtext would require code to check for        
 ;   alignment and make a new ten or eleven code.                          
 ;   This seems to work fine for all multiline attributes.                 
 ;   I have no idea why it doesn't work for mtext.                         
 ; 
 (DEFUN SUCK (entt / bbf nn sub asonum oklis)
  (setq oklis '(1 7 10 11 40 41 50 51 67 71 72))
  (setq bbf (list (cons 0 "TEXT")))
  (setq nn 0)
  (while (setq sub (nth nn entt))
         (setq asonum (car sub))
         (cond ((member asonum oklis)
                (if (setq suba (assoc asonum bbf))
                    (if (= asonum 1)
                        (setq bbf (subst sub suba bbf)))
                    (setq bbf (cons sub bbf))))
               ((= 74 asonum)
                (setq bbf (cons (cons 73 (cdr sub)) bbf)))
               ((= 8 asonum)
                (if (= (cdr sub) "0")
                    (setq bbf (cons (cons 8 "TEXT") bbf))
                    (setq bbf (cons sub bbf)))))
         (setq nn (1+ nn)))
 (setq bbf (reverse bbf)))
 ; Ŀ
 ;   Suck end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Txsuck - duplicate a text entity.                          
 ; 
 (DEFUN TXSUCK (entt / bbf nn sublst asonum)
  (setq nn 0)
  (while (setq sublst (nth nn entt))
         (setq asonum (car sublst))
         (cond ((= 8 asonum)
                (if (or (fando "|" (cdr sublst) ())
                        (= (cdr sublst) "0"))
                    (setq bbf (cons (cons 8 "Text2") bbf))
                    (setq bbf (cons sublst bbf))))
               ((= 7 asonum)
                (if (fando "|" (cdr sublst) ())
                    (setq bbf (cons (cons 7 "STANDARD") bbf))
                    (setq bbf (cons sublst bbf))))
               ((not (or (= -1 asonum)
                         (= 5 asonum)))
                (setq bbf (cons sublst bbf))))
         (setq nn (1+ nn)))
 (setq bbf (reverse bbf)))
 ; Ŀ
 ;   Txsuck end.                                                           
 ; 

 ; Ŀ
 ;   Lk: suck and kill.  An interesting concept.                           
 ; 
 (DEFUN C:LK (/ *error* shk enam entt snapp pa ensav)
  (setvar "cmdecho" 0)
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
 ; Ŀ
 ;   Make a nice local error handler.                                      
 ; 
  (defun *error* (shk)
   (if shk (print shk))
   (setvar "snapmode" snapp)
  (princ))
 ; Ŀ
 ;   Get an attribute.                                                     
 ; 
  (if (setq enam (car (nentsel "Attribute to extract: ")))
      (setq ensav (setq entt (entget enam)))
      (write-line "\nNothing selected."))
  (if (and entt (or (and (= (cdr (assoc 0 entt)) "ATTRIB")
                         (setq entt (suck entt)))
                    (and (= (cdr (assoc 0 entt)) "TEXT")
                         (setq entt (txsuck entt)))))
      (progn
           (if (entmake entt)
 ; Ŀ
 ;   Empty the attribute.                                                  
 ; 
               (progn
                    (entmod (subst (cons 1 "") (assoc 1 ensav) ensav))
                    (cvox (cdr (assoc 10 entt))))
               (write-line "\nSuck Failure.")))
      (if entt
          (write-line "\nYou must select an attribute or text.")))
 ; Ŀ
 ;   End neatly.                                                           
 ; 
  (*error* nil)
 (princ))

 ; Ŀ
 ;   Lx: the innertube-like haemovore.                                     
 ; 
 (DEFUN C:LX (/ esav *error* enam entt snapp pa)
  (setq esav *error*)
  (setq *error* lerx)
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
  (if (setq enam (car (nentsel "Attribute to suck: ")))
      (setq entt (entget enam))
      (write-line "\nNothing selected."))
  (if (and entt (or (and (= (cdr (assoc 0 entt)) "ATTRIB")
                         (setq entt (suck entt)))
                    (and (= (cdr (assoc 0 entt)) "TEXT")
                         (setq entt (txsuck entt)))))
      (progn
           (if (entmake entt)
               (progn
                    (setq pa (spit (entget (entlast))))
                    (command "move" "l" "" pa)
                    (setvar "snapmode" snapp)
                    (while (/= 0 (getvar "cmdactive"))
                           (command pause))
                    (redraw enam))
               (write-line "\nIncomplete suck - program aborted.")))
      (if entt
          (write-line "\nYou must select an attribute or text.")))
  (setvar "snapmode" snapp)
  (setq *error* esav)
 (princ))

(prompt "C:LX/C:LK")
(princ)
