 ; Ŀ
 ;   Misps: get a scale factor: 1 in unscaled PS                           
 ;                              Dimscale in scaled PS                      
 ;                              Dimscale in MS                             
 ;                              Dimscale in a vport.                       
 ;   If the global variable Scalps is t the PS scale is also dimscale.     
 ;   Copyright 2009, 2010, 2013 by Rocket Software Ltd.                    
 ;                                                                         
 ; 

; (setq scalps t) ; uncomment to force all to dimscale

 ; Ŀ
 ;   Subroutine Gpasc - see if paper space is scaled.                      
 ;   If there is text in paper space and its average height is > 2.5       
 ;   then the drawing is scaled, in which case the calling program will    
 ;   assume that paper space is scaled at dimscale.                        
 ;   Failing this, if there are blocks in ps and they're scaled on         
 ;   average to more than 1 then assume paper space is scaled.             
 ;   Takes no Arguments.                                                   
 ;   Calls nothing.                                                        
 ;   Returns: T, ps is scaled, or nil, it's not (or it's empty.)           
 ; 
 (DEFUN GPASC (/ ss num toth enam hite avscal totasc scal)
  (cond ((setq ss (ssget "x" (list (cons 0 "text") (cons 67 1))))
         (setq num 0)
         (setq toth 0)
         (while (and (setq enam (ssname ss num))
                     (< num 10))
                (setq num (1+ num))
                (setq hite (cdr (assoc 40 (entget enam))))
                (setq toth (+ hite toth)))
         (setq avscal (/ toth num 2.5)))
        ((setq ss (ssget "x" (list (cons 0 "insert") (cons 67 1))))
         (setq num 0)
         (setq totasc 0)
         (while (and (setq enam (ssname ss num))
                     (< num 10))
                (setq num (1+ num))
                (setq scal (cdr (assoc 41 (entget enam))))
                (setq totasc (+ scal totasc)))
         (setq avscal (/ totasc num))))
 (if (equal avscal 1 0.5) nil t))
 ; Ŀ
 ;   Gpasc end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Wasp - are we in the Model Space Tab, Paper Space, or      
 ;   a viewport in Paper Space?                                            
 ;   Brooks no Arguments.                                                  
 ;   Calls nothing.                                                        
 ;   Returns: 1 - Model space.                                             
 ;            2 - Paper space.                                             
 ;            3 - A Viewport in Paper Space.                               
 ; 
 (DEFUN WASP ()
  (cond ((= (getvar "tilemode") 1) 1)
        ((= (getvar "cvport") 1) 2)
        (t 3)))
 ; Ŀ
 ;   Wasp end.                                                             
 ; 

 ; Ŀ
 ;   Misps.                                                                
 ;   The variable Scalps must be global.                                   
 ; 
 (defun MISPS (/ scaalf scapa)
  (setq scaalf (getvar "dimscale"))
  (setq scapa (wasp))
  (cond (scalps scaalf)  ; scalps is set so always dimscale
        ((= scapa 1)     ; ms
         scaalf)
        ((= scapa 2)     ; ps
         (if (gpasc)     ; ps looks scaled
             scaalf      ; then dimscale
             1.0))       ; else 1
        ((= scapa 3)     ; viewport in ps
         scaalf)
        (t scaalf)))     ; no idea - use dimscale

(princ)