 ; Ŀ
 ;   Muxr - find xrefs with multiple insertions.                           
 ;   Muxx - find xrefs with multiple insertions and erase all but one.     
 ;   Copyright 2011 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Contx - Find all referenced xref definitions in the block tables.     
 ;   Takes no arguments.                                                   
 ;   Returns a list of lists: ((Blockname Filename)...)                    
 ; 
 (DEFUN CONTX (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (and (= 4 (logand 4 sevnt)) (= 32 (logand 32 sevnt)))
             (setq namlst (append namlst (list (list (cdr (assoc 2 bldat))
                                                   (cdr (assoc 1 bldat))))))))
 namlst)
 ; Ŀ
 ;   Contx end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Cstar - draw an individual grstar (centred).               
 ;   Takes four arguments: centre point, side length, rotation (radians),  
 ;   and colour.  Returns nothing, but draws a star.                       
 ; 
 (DEFUN CSTAR (pa sidlen rota colo / anginc angg hafang pb)
  (setq px pa)
  (setq pa (polar pa (+ rota (/ pi 2)) (* sidlen 1.37638192)))
  (setq anginc (* 1.6 pi))
  (setq angg (+ rota (* 1.6 pi)))
  (setq hafang (* 0.8 pi))
  (repeat 5
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg anginc))
         (setq pa pb)
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg hafang))
         (setq pa pb))
 (princ))
 ; Ŀ
 ;   Subroutine Cstar end.                                                 
 ; 

 ; Ŀ
 ;   Subroutine Muxr - find and optionally kill multiple xref insertions.  
 ;   Arguments: Kill, kill extras if they are the same as the first.       
 ; 
 (DEFUN MUXR (kill / rad xnames num sub blnam ss subnum enam pa ppa prota rota
                                                             pscal scal strota)
  (setvar "cmdecho" 0)
  (setq rad (/ (getvar "viewsize") 65))
  (setq strota (/ pi 3))
  (setq xnames (contx))
  (setq num 0)
  (while (setq sub (nth num xnames))  
         (setq num (1+ num))
         (setq blnam (car sub))
         (if (and (setq ss (ssget "x" (list (cons 2 blnam))))         
                  (< 1 (sslength ss)))
             (progn
                  (setq subnum 0)
                  (setq ppa ())
                  (setq prota ())
                  (setq pscal ())
                  (while (setq enam (ssname ss subnum))
                         (setq subnum (1+ subnum))
                         (setq entt (entget enam))
                         (setq pa (cdr (assoc 10 entt)))
                         (setq rota (cdr (assoc 50 entt)))
                         (setq scal (cdr (assoc 41 entt)))
                         (if ()
                             (progn
                                  (write-line "\n----------")
                                  (print pa)
                                  (print ppa)
                                  (print (equal ppa pa))
                                  (write-line "\n----------")
                                  (print scal)
                                  (print pscal)
                                  (print (equal pscal scal))
                                  (write-line "\n----------")
                                  (print rota)
                                  (print prota)
                                  (print (equal prota rota))
                                  (write-line "\n----------")))
                         (if (and kill
                                  ppa   (equal ppa pa)
                                  rota  (equal prota rota)
                                  pscal (equal pscal scal))
                             (progn
                                  (entdel enam)
                                  (write-line "\nIdentical Insert Erased.")))
                         (setq ppa pa)      ; compares to last, not any
                         (setq prota rota)  ;
                         (setq pscal scal)  ;
                         (cstar pa rad strota 1)
                         (setq strota (+ strota 0.2)))
                  (prompt (strcat "\n" (itoa subnum)
                                  " copies of " blnam
                                  " found.")))))
  (if (null subnum)
      (prompt "\nNo multiply inserted xrefs found."))
 (princ))
 ; Ŀ
 ;   Subroutine Muxr end.                                                  
 ; 

 ; Ŀ
 ;   Muxx - find and kill multiple xref insertions.                        
 ; 
 (DEFUN C:MUXX ()
  (muxr t)
 (princ))

 ; Ŀ
 ;   Muxr - find multiple xref insertions.                                 
 ; 
 (DEFUN C:MUXR ()
  (muxr ())
 (princ))