 ; Ŀ
 ;   Change text heights to match the closest one in a list.               
 ;   Copyright 2014 by Rocket Software Ltd.                                
 ;   Apparently "close enough" does not mean ten decimal places.           
 ; 

 ; Ŀ
 ;   Subroutine Cstar - draw an individual grstar (centred).               
 ;   Takes four arguments: centre point, side length, rotation (radians),  
 ;   and colour.  Returns nothing, but draws a star.                       
 ; 
 (DEFUN CSTAR (pa sidlen rota colo / anginc angg hafang pb)
  (setq px pa)
  (setq pa (polar pa (+ rota (/ pi 2)) (* sidlen 1.37638192)))
  (setq anginc (* 1.6 pi))
  (setq angg (+ rota (* 1.6 pi)))
  (setq hafang (* 0.8 pi))
  (repeat 5
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg anginc))
         (setq pa pb)
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg hafang))
         (setq pa pb))
 (princ))
 ; Ŀ
 ;   Subroutine Cstar end.                                                 
 ; 

 ; Ŀ
 ;   Nearx - find the closest value in a list to a given value.            
 ;   Arguments: Numlis, a list of numbers, in increasing order.            
 ;              Num, a number.                                             
 ;   Returns the closest number, if two are equidistant then the lesser.   
 ; 
 (DEFUN NEARX (numlis num / low hi nearst)
 ; Ŀ
 ;   If num is < (car numlis) then return that.                            
 ; 
  (if (<= num (car numlis))
      (setq nearst (car numlis))
 ; Ŀ
 ;   Else find the numbers above and below num.                            
 ; 
      (while (setq low (car numlis))
             (setq hi (cadr numlis))
             (setq numlis (cdr numlis))
             (if (or (and (<= low num)
                          (null hi))
                     (and (<= low num)
                          (> hi num)))
 ; Ŀ
 ;   Decide which one is closer.                                           
 ; 
                 (if (or (null hi)
                         (<= (- num low) (- hi num)))
                     (setq nearst low)
                     (setq nearst hi)))))
 nearst)
 ; Ŀ
 ;   Nearx end.                                                            
 ; 

 ; Ŀ
 ;   Neth.                                                                 
 ; 
 (DEFUN C:NETH (/ hlist num ss enam entt pa ht gnuht)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   Make a list of acceptable text heights.                               
 ; 
  (setq hlist '(2.5 3 3.5 5 6))
 ; Ŀ
 ;   Get some text and attdef entities.                                    
 ; 
  (setq num 0)
  (write-line "Text to Standardize Height or <Return> for all: ")
  (if (null (setq ss (ssget '((0 . "text,attdef")))))
            (setq ss (ssget "x" '((0 . "text,attdef")))))
 ; Ŀ
 ;   Check and possibly fix heights.                                       
 ; 
  (while (and ss (setq enam (ssname ss num)))
         (setq num (1+ num))
         (setq entt (entget enam))
         (setq pa (cdr (assoc 10 entt)))
         (setq ht (cdr (setq asoc40 (assoc 40 entt))))
         (setq gnuht (nearx hlist ht))
         (if (/= ht gnuht)
             (progn
                  (entmod (subst (cons 40 gnuht) asoc40 entt))
                  (cstar pa ht 0 8)
                  (cstar pa gnuht 0 (fix gnuht)))))
 (princ))