 ; Ŀ
 ;   Noth: remove xref paths.                                              
 ;   Copyright 2010, 2011, 2012, 2014 by Rocket Software Ltd.              
 ;                                                                         
 ; 

 ; Ŀ
 ;   Contx - Find all referenced xref definitions in the block tables.     
 ;   Takes no arguments.                                                   
 ;   Returns a list of lists: ((Blockname Filename)...)                    
 ; 
 (DEFUN CONTX (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (and (= 4 (logand 4 sevnt)) (= 32 (logand 32 sevnt)))
             (setq namlst (append namlst (list (list (cdr (assoc 2 bldat))
                                                   (cdr (assoc 1 bldat))))))))
 namlst)
 ; Ŀ
 ;   Contx end.                                                            
 ; 

 ; Ŀ
 ;   Goget - Find a file in ... allx, copy to the current dir.             
 ;   Arguments: Fnam, a file name.                                         
 ;   Calls nothing, Returns nothing.                                       
 ; 
 (DEFUN GOGET (fnam / frefz fnama fnamb)
  (setq frefz "x:\\Projects\\COG (Connacher Oil & Gas)\\COG0009 - Connacher Drawing Titleblock Project\\Z-Drive\\allx\\")
 ; Ŀ
 ;   Make the search filename with path, and the destination name.         
 ; 
  (setq fnama (findfile (strcat frefz fnam ".dwg")))
  (setq fnamb (strcat (getvar "dwgprefix") fnam ".dwg"))
 ; Ŀ
 ;   Copy the file or log an error.                                        
 ; 
  (cond ((and fnama (not (findfile fnamb)))
         (command "shell" (strcat "copy \"" fnama "\" \"" fnamb "\""))
         (command "delay" 250)
         (regist (strcat fnam ", Copied")))
        ((findfile fnamb)
         (regist fnam))
        ((null fnama)
         (regist (strcat "***" fnam ", Not found."))))
 (princ))
 ; Ŀ
 ;   Goget end.                                                            
 ; 

 ; Ŀ
 ;   Snoth - Noth a single xref by name.                                   
 ; 
 (DEFUN C:SNOTH (/ *error* fnam xlist num xname patha len nam)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk / fnam)
  (setq fnam (getvar "dwgname"))
  (if regist (regist (strcat "***** Error in Snoth.lsp, File: " fnam)))
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Save xref layer settings in the local drawing.                        
 ; 
  (setvar "visretain" 1)
 ; Ŀ
 ;   Get a list of all xrefs.                                              
 ; 
  (if (setq xlist (contx))
      (if regist (regist (strcat "* Single Xref Repathed In Drawing "
                                 (nopath) ":"))))
 ; Ŀ
 ;   Get an xref name.                                                     
 ; 
  (if (and (setq xname (getstring t "Xref Name: "))
           (setq xname (assoc xname xlist)))
      (progn
           (print xname)
 ; Ŀ
 ;   Get the block name and path.                                          
 ; 
           (setq patha (cadr xname))  ; xref path with block name .dwg
           (setq xname (car xname))   ; xref block name
 ; Ŀ
 ;   If the file with the block name can't be found in the current         
 ;   directory then look for it in Allx.                                   
 ; 
           (if (null (findfile (strcat (getvar "dwgprefix") xname ".dwg")))
               (goget xname))
 ; Ŀ
 ;   If the file with the block name can be found in the current           
 ;   directory then repath the xref.                                       
 ; 
           (if (findfile (strcat (getvar "dwgprefix") xname ".dwg"))
               (progn
                    (command "xref" "path" xname xname)
                    (xreg "1" 26 t)
                    (if regist (regist (strcat xname " pathed locally."))))
               (progn
                    (write-line (strcat "**" xname " not found. **"))
                    (if regist (regist (strcat "**" xname " not found.")))))))
 ; Ŀ
 ;   Add an end marker the the register file.                              
 ; 
  (if (and xlist regist) (regist "Xrefs End"))
  (command "undo" "end")
 (princ))

 ; Ŀ
 ;   Noth.                                                                 
 ; 
 (DEFUN C:NOTH (/ *error* fnam xlist num xname patha len nam)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk / fnam)
  (setq fnam (getvar "dwgname"))
  (if regist (regist (strcat "***** Error in Noth.lsp, File: " fnam)))
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Save xref layer settings in the local drawing.                        
 ; 
  (setvar "visretain" 1)
 ; Ŀ
 ;   Get a list of all xrefs.                                              
 ; 
  (if (setq xlist (contx))
      (if regist (regist (strcat "* Xrefs repathed in drawing "
                                 (nopath) ":"))))
 ; Ŀ
 ;   Repath each one.                                                      
 ; 
  (setq num 0)
  (while (and xlist (setq xname (nth num xlist)))
         (setq num (1+ num))
 ; Ŀ
 ;   Get the block name and path.                                          
 ; 
         (setq patha (cadr xname))  ; xref path with block name .dwg
         (setq xname (car xname))   ; xref block name
 ; Ŀ
 ;   If the file with the block name can't be found in the current         
 ;   directory then look for it in Allx.                                   
 ; 
         (if (null (findfile (strcat (getvar "dwgprefix") xname ".dwg")))
             (goget xname))
 ; Ŀ
 ;   If the file with the block name can be found in the current           
 ;   directory then repath the xref.                                       
 ; 
         (if (findfile (strcat (getvar "dwgprefix") xname ".dwg"))
             (progn
                  (command "xref" "path" xname xname)
                  (xreg "1" 26 t)
                  (if regist (regist (strcat xname " pathed locally."))))
             (progn
                  (write-line (strcat "**" xname " not found. **"))
                  (if regist (regist (strcat "**" xname " not found."))))))
 ; Ŀ
 ;   Add an end marker the the register file.                              
 ; 
  (if (and xlist regist) (regist "Xrefs End"))
  (command "undo" "end")
 (princ))