 ; Ŀ
 ;   Numf: print sequential numbers to a text file.                        
 ;   Copyright 1992, 1994 by Rocket Software                               
 ;   See if it really is possible to count up to a million.                
 ; 

 ; Ŀ
 ;   Nerf - error handler.                                                 
 ; 
 (DEFUN NERF (shk / pos entt enam sublst vall)
  (setq *error* esav)
  (if fn (close fn))
  (if (/= shk "Function cancelled") (write-line (strcat "\n" shk)))
  (if t1
     (progn
          (setq s (getvar "date"))
          (setq t2 (* 86400.0 (- s (fix s))))
          (setq elapse (- t2 t1))
          (prompt (strcat "Elapsed time: " (mint elapse) "\n"))))
 (princ))
 ; Ŀ
 ;   Nerf end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Uno - takes a number as an argument, returns the English   
 ;   equivalent.                                                           
 ; 
 (DEFUN UNO (str / cycle whole nos set2 set3 set4
                          str last3 strn one two thr lne num ok)
  (setvar "cmdecho" 0)
  (setq cycle 0)
  (setq whole "")
  (setq nos (list "" "one" "two" "three" "four"
                   "five" "six" "seven" "eight" "nine"))
  (setq set2 (list "ten" "eleven" "twelve" "thirteen" "fourteen"
                   "fifteen" "sixteen" "seventeen" "eighteen" "nineteen"))
  (setq set3 (list "" "" "twenty" "thirty" "forty" "fifty" "sixty"
                   "seventy" "eighty" "ninety"))
  (setq set4 (list "" "thousand" "million" "billion" "trillion" "quadrillion"
                   "pentillion" "hexillion" "heptillion" "octillion"
                   "nonillion" "decillion" "zillion" "bazillion"))
  (while (> (strlen str) 0)
  (while (< (strlen str) 3) (setq str (strcat "0" str)))
  (setq last3 (substr str (- (strlen str) 2)))
  (if (> (strlen str) 3) (setq str (substr str 1 (- (strlen str) 3)))
                         (setq str ""))
 ; Ŀ
 ;   Process next three.                                                   
 ; 
  (setq strn "")
  (setq one (substr last3 1 1))
  (setq two (substr last3 2 1))
  (setq thr (substr last3 3 1))
  (if (/= one "0") (setq strn (strcat (nth (read one) nos) " hundred")))
  (cond ((= two "1") (setq strn (strcat strn 
                                        (if (/= strn "") " and " "")
                                        (nth (read thr) set2))))
        ((= two "0"))
        (t (setq strn (strcat strn 
                              (if (= strn "") "" " and ")
                              (nth (read two) set3)))))
  (if (/= two "1")
      (setq strn (strcat strn
                   (if (and (/= strn "") (= two "0") (/= thr "0")) " and " "")
                   (if (and (/= strn "") (/= two "0")
                            (/= two "1") (/= thr "0")) " " "")
                   (nth (read thr) nos))))
 ; Ŀ
 ;   Add "and" for example in one thousand and sixty two but not in 0062.  
 ;   (And only do this for the last three digits, that is if cycle = 0.)   
 ; 
  (if (and (/= str "") (= one "0") (/= strn "") (= cycle 0))
      (progn
            (setq lne (strlen str))
            (setq num 1)
            (setq ok ())
            (while (<= num lne)
                   (if (/= (substr str num 1) "0") (setq ok t))
                   (setq num (1+ num)))
            (if ok (setq strn (strcat "and " strn)))))
 ; Ŀ
 ;   Process three end.                                                    
 ; 
  (setq whole (strcat strn 
                      (if (= strn "")
                          "" 
                          (strcat " " (nth cycle set4) " "))
                      whole))
  (setq cycle (1+ cycle)))
 whole)
 ; Ŀ
 ;   One end.                                                              
 ; 

 ; Ŀ
 ;   Mint - Convert seconds to hours, minutes and seconds.                 
 ; 
 (DEFUN MINT (sec / hours mins)
  (setq hours (itoa (fix (/ sec 3600))))
  (setq sec (rem sec 3600))
  (setq mins (itoa (fix (/ sec 60))))
  (setq sec (itoa (fix (rem sec 60))))
  (if (= (strlen hours) 1) (setq hours (strcat "0" hours)))
  (if (= (strlen mins) 1) (setq mins (strcat "0" mins)))
  (if (= (strlen sec) 1) (setq sec (strcat "0" sec)))
  (strcat hours ":" mins ":" sec))
 ; Ŀ
 ;   Mint end.                                                             
 ; 

 ; Ŀ
 ;   Numf - the main sponge.                                               
 ; 
 (DEFUN C:NUMF (/ nump topp namp fn)
  (setq esav *error*)                    ; save the previous error handler
  (setq *error* nerf)                    ; and install the new one
  (if (/= (type num) 'REAL) (setq num 1.0))
  (setq nump (getreal (strcat "Start number <" (rtos num 2 0) ">: ")))
  (if nump (setq num nump))
  (if (/= (type topnum) 'REAL) (setq topnum 100.0))
  (setq topp (getreal (strcat "Greatest number <" (rtos topnum 2 0) ">: ")))
  (if topp (setq topnum topp))
  (if (or (/= (type namm) 'STR)
          (= namm ""))
          (setq namm "Numbers.txt"))
  (setq namp (getstring (strcat "Filename <" namm ">: ")))
  (if (/= namp "") (setq namm namp))
  (setq fn (open namm "w"))
 ; Ŀ
 ;   Start the timer.                                                      
 ; 
  (setq s (getvar "date"))
  (setq t1 (* 86400.0 (- s (fix s))))                ; start time for timer
 ; Ŀ
 ;   Write the file.                                                       
 ; 
  (while (<= num topnum)
         (if (= (rem num 100) 0) (grtext -2 (rtos num 2 0)))
         (write-line (uno (rtos num 2 0)) fn)
         (setq num (1+ num)))
  (close fn)
 ; Ŀ
 ;   Calculate elapsed time.                                               
 ; 
  (setq s (getvar "date"))
  (setq t2 (* 86400.0 (- s (fix s))))
  (setq elapse (- t2 t1))
 ; Ŀ
 ;   And print it.                                                         
 ; 
  (prompt (strcat "Elapsed time: " (mint elapse)))
  (setq *error* esav)                     ; restore the original error handler
 (princ))