 ; Ŀ
 ;   Nxp - partially open the next drawing.                                
 ;   Copyright 1995, 2006, 2015, 2018 by Rocket Software Ltd.              
 ;   Maybe not all that earth-shaking.                                     
 ; 

 ; Ŀ
 ;   Drexd - get the name of the file after the current one.               
 ;   Arguments: Dira, T = Forward, nil = Backwards.                        
 ;   Returns a filename with path.                                         
 ; 
 (DEFUN DREXD (dira / pref fils fnam dwgnam sub num)
  (setq pref (getvar "dwgprefix"))
  (setq fils (vl-directory-files pref "*.dwg" 1))
 ; Ŀ
 ;   Put the filename list in alphabetical order.                          
 ; 
  (setq fils (vl-sort fils '<))
  (if (not dira) (setq fils (reverse fils)))
 ; Ŀ
 ;   Find the drawing after the current one.                               
 ; 
  (setq dwgnam (getvar "dwgname"))
  (setq num 0)
  (while (and fils (setq sub (nth num fils)))
         (setq num (1+ num))
         (if (equal sub dwgnam)
             (progn
                  (setq fnam (nth num fils))
                  (setq num (1+ (length fils))))))
  (if (null fnam)
      (setq fnam (car fils)))
 (if fnam (strcat pref fnam)))
 ; Ŀ
 ;   Drexd end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Nexp - write a script to partially open a drawing.         
 ;   Arguments: Fnam, the filename, ideally with a path.                   
 ;              Sava, "Y" or "N" - save changes if asked.                  
 ;   Returns T if need to restart/remake the file, nil otherwise.          
 ; 
 (DEFUN NEXP (fnam sava / scrnam fn ook)
  (setvar "cmdecho" 0)
  (setvar "sdi" 1)
  (if (/= (getvar "sdi") 1)
      (prompt "*Caution: SDI is not set - you are opening multiple drawings."))
 ; Ŀ
 ;   Open and write the script file.                                       
 ; 
  (setq scrnam (strcat (getvar "dwgprefix") "paro.scr"))
  (if (setq fn (open scrnam "w"))
      (progn
           (setq ook t)
           (write-line "-partialopen" fn)  
 ; Ŀ
 ;   Really want to discard all changes to drawing?                        
 ;   So N = No = save, Y= Yes = discard.                                   
 ;   A dbmod of 32 doesn't ask to save changes, anything else does.        
 ; 
           (if (> (rem (getvar "dbmod") 32) 0)
               (write-line sava fn)
               (princ))
 ; Ŀ
 ;   Add the rest of the commands.                                         
 ; 
           (write-line (strcat "\"" fnam "\"") fn)
           (write-line "" fn)
           (write-line "*" fn)
           (write-line "y" fn)
;          (write-line "" fn)
 ; Ŀ
 ;   Close the script file.                                                
 ; 
           (close fn)))
 ; Ŀ
 ;   If ook is t then return the script file name.                         
 ; 
 scrnam)
 ; Ŀ
 ;   Nexp end.                                                             
 ; 

 ; Ŀ
 ;   Nxp - partialopen the next file, save changes (if any).               
 ; 
 (DEFUN C:NXP (/ fnam scrnam)
  (if (setq fnam (drexd t))
      (progn
           (setq scrnam (nexp fnam "n"))
           (command "script" scrnam))
      (prompt "No Next File."))
 (princ))