 ; Ŀ
 ;   Obso - insert an obsolete stamp.                                      
 ;   Copyright 1996, 1998, 2000, 2002, 2003 by Rocket Software Ltd.        
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Lam - find or make the appropriate layer for permit        
 ;   stamps.  These come on a variety of layers, so this routine           
 ;   arbitrarily puts it on either Tblock or Titleblock, with preference   
 ;   given to Tblock, which shows up in more of our stamps and beavers.    
 ;   Lam doesn't claim to be smarter than the user, having only seven      
 ;   lines of code.  Human equivalence takes nine.                         
 ; 
 (DEFUN LAM ()
  (cond ((and (tblsearch "layer" "tblock") (null (layp "tblock")))
         (command "layer" "s" "tblock" ""))
        ((and (tblsearch "layer" "titleblock") (null (layp "titleblock")))
         (command "layer" "s" "titleblock" ""))
        ((null (layp "tblock"))
         (command "layer" "m" "tblock" ""))
        (t (command "layer" "s" "0" "")))
 (princ))
 ; Ŀ
 ;   Lam end.                                                              
 ; 

 ; Ŀ
 ;   Layp - see if a layer is off, locked, or frozen.                      
 ;   Takes one argument, a layer name.                                     
 ;   Returns a list of conditions or nil - It's ok or doesn't exist.       
 ; 
 (DEFUN LAYP (lanam / llist sev col frizp lockp offp stalst)
  (if (setq llist (tblsearch "layer" lanam))
      (progn
           (setq sev (cdr (assoc 70 llist)))
           (setq col (cdr (assoc 62 llist)))
           (if (= (logand sev 1) 1) (setq stalst (list "frozen")))
           (if (= (logand sev 4) 4) (setq stalst (cons "locked" stalst)))
           (if (minusp col) (setq stalst (cons "off" stalst)))))
 stalst)
 ; Ŀ
 ;   Layp end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Putsch - install a block in a position expressed as an     
 ;   offset from the insertion point of another block and at a matching    
 ;   scale.  Got that?                                                     
 ;   Arguments: Enam, the main (typically tb) block ename.                 
 ;              Blnam, the name of the block to insert.                    
 ;              Xoff, the X offset from the block insertion point.         
 ;              Yoff, the Y offset.                                        
 ;              Bscal, the block scale relative to the tb scale.           
 ;              Xrefp, T if the block is to xrefed, nil if inserted.       
 ;   Does nothing if the block name is nil.                                
 ;   Returns nothing, calls your mama.                                     
 ; 
 (DEFUN PUTSCH (enam blnam xoff yoff bscal xrefp / osna dsxp dsyp entt pa ds)
  (setq osna (getvar "osmode"))
  (setvar "osmode" 0) 
  (if (and blnam (/= blnam ""))
      (progn
           (setq entt (entget enam))
           (setq pa (cdr (assoc 10 entt)))
           (setq ds (cdr (assoc 41 entt)))
           (setq dsxp (+ (car pa) (* xoff ds)))
           (setq dsyp (+ (cadr pa) (* yoff ds)))
           (if (and xrefp (/= xrefp ""))
               (command ".-xref" "attach" blnam (list dsxp dsyp)
                                                (* ds bscal) "" "")
               (command ".insert" blnam (list dsxp dsyp) (* ds bscal) "" ""))
           (while (= 1 (getvar "cmdactive")) (command ""))))
  (setvar "osmode" osna) 
 (princ))
 ; Ŀ
 ;   Subroutine Putsch end.                                                
 ; 

 ; Ŀ
 ;   Obso.                                                                 
 ; 
 (DEFUN C:OBSO (/ ss)
  (setvar "cmdecho" 0)
  (setvar "filedia" 0) 
  (if (setq ss (ssget "x" (list (cons 2 "obsolete"))))
      (command ".erase" ss ""))
 ; Ŀ
 ;   Gemini Corp tb Gca1tb.                                                
 ; 
  (cond ((setq ss (ssget "X" (list (cons 2 "GCA1TB"))))
         (lam)
         (putsch (ssname ss 0) "obsolete" 0 0 1 nil))
 ; Ŀ
 ;   Grizzly: Gca1tb.                                                      
 ; 
        ((setq ss (ssget "X" (list (cons 2 "Grizzly-TB"))))
         (setq enam (ssname ss 0))
         (setvar "clayer" (cdr (assoc 8 (entget enam))))
         (putsch enam "obsolete" 0 0 1 nil)))
 ; Ŀ
 ;   End neatly.                                                           
 ; 
  (setvar "filedia" 1) 
 (princ))