 ; Ŀ
 ;   Pid: add a prefix and/or suffix to text strings, block, or attdefs.   
 ;   Copyright 1991, 2003, 2004, 2007 - 2011 by Rocket Software Ltd.       
 ;   As in conversation, a single space is taken as an empty string.       
 ; 

 ; Ŀ
 ;   Atc - count the attributes in a block.                                
 ;   Takes one argument, an insertion ename.                               
 ;   Returns a number or nil.                                              
 ;   Note that the number of attributes in a block is not necessarily      
 ;   the same as the number in the matching block definition.              
 ; 
 (DEFUN ATC (enam / entt num)
  (if (and (setq entt (entget enam))
           (= (cdr (assoc 0 entt)) "INSERT")
           (assoc 66 entt))
      (progn
           (setq num 0)
           (while (/= "SEQEND" (cdr (assoc 0
                                    (entget (setq enam (entnext enam))))))
                  (setq num (1+ num)))))
 num)
 ; Ŀ
 ;   Atc end.                                                              
 ; 

 ; Ŀ
 ;   Foap - find the zero based position of an attribute in a block.       
 ;   Takes one argument, aprompt string.                                   
 ;   Returns a number or nil.                                              
 ; 
 (DEFUN FOAP (proma / enampt enam blnam blopt entt attnam atenam num fini)
  (if (and (setq enampt (entsel proma))
           (setq enam (car enampt))
           (setq blnam (cdr (assoc 2 (entget enam))))
           (setq blopt (cadr enampt))
           (setq entt (entget (car (nentselp blopt))))
           (setq attnam (cdr (assoc 2 entt)))
           (setq atenam (cdr (assoc -1 entt))))
      (progn
           (setq num 0)
           (while (/= "SEQEND" (cdr (assoc 0
                                    (entget (setq enam (entnext enam))))))
                  (if (equal atenam enam) (setq fini num))
                  (setq num (1+ num)))))
 fini)
 ; Ŀ
 ;   Foap end.                                                             
 ; 

 ; Ŀ
 ;   Pid.                                                                  
 ; 
 (DEFUN C:PID (/ preft sufft ss poszz num enam typ entt stra cc)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   Get a prefix.                                                         
 ; 
  (if pref 
      (progn
           (setq preft (getstring t (strcat "\nPrefix <" pref ">: ")))
           (if (/= preft "") (setq pref preft)))
      (setq pref (getstring t "\nPrefix: ")))
  (if (= pref " ") (setq pref ""))
 ; Ŀ
 ;   And a suffix.                                                         
 ; 
  (if suff 
      (progn
           (setq sufft (getstring t (strcat "\nSuffix <" suff ">: ")))
           (if (/= sufft "") (setq suff sufft)))
      (setq suff (getstring t "\nSuffix: ")))
  (if (= suff " ") (setq suff ""))
 ; Ŀ
 ;   Get some entities.                                                    
 ; 
  (write-line "\nSelect Blocks and text: ")
  (setq ss (ssget '((-4 . "<or") (0 . "text")
                                 (-4 . "<and") (0 . "insert") (66 . 1)
                                  (-4 . "and>")
                                 (0 . "attdef") (-4 . "or>"))))
 ; Ŀ
 ;   If the first source entity (assumed to be typical) is a block         
 ;   and has more than one attribute then ask which one to replace.        
 ;   This returns a position number.                                       
 ; 
  (if (and ss (> (atc (ssname ss 0)) 1))
      (progn
           (setq poszz (foap (strcat "\nThose blocks have more than one "
                                   "attribute.  Please select one <First>:")))
           (if poszz
               (setq poszz (1+ poszz))
               (setq poszz 1)))
      (setq poszz 1))
 ; Ŀ
 ;   Change the entities.                                                  
 ; 
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq num (1+ num))
         (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
         (cond ((= "TEXT" typ)
                (setq stra (cdr (assoc 1 entt)))
                (setq cc (strcat pref stra suff))
                (entmod (subst (cons 1 cc) (cons 1 stra) entt)))
               ((= "ATTDEF" typ)
                (setq stra (cdr (assoc 2 entt)))
                (setq cc (strcat pref stra suff))
                (entmod (subst (cons 2 cc) (cons 2 stra) entt)))
               ((= "INSERT" typ)
                (repeat poszz (setq enam (entnext enam)))
                (setq entt (entget enam))
                (setq stra (cdr (assoc 1 entt)))
                (setq cc (strcat pref stra suff))
                (entmod (subst (cons 1 cc) (cons 1 stra) entt)))))
  (command "undo" "end")
 (princ))