 ; Ŀ
 ;   Ppel - replace an ellipse entity with a polyline ellipse.             
 ;   Copyright 2016 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Cstar - draw an individual grstar (centred).               
 ;   Takes four arguments: centre point, side length, rotation (radians),  
 ;   and colour.  Returns nothing, but draws a star.                       
 ; 
 (DEFUN CSTAR (pa sidlen rota colo / anginc angg hafang pb)
  (setq pa (polar pa (+ rota (/ pi 2)) (* sidlen 1.37638192)))
  (setq anginc (* 1.6 pi))
  (setq angg (+ rota anginc))
  (setq hafang (* 0.8 pi))
  (repeat 5
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg anginc))
         (setq pa pb)
         (setq pb (polar pa angg sidlen))
         (grdraw pa pb colo)
         (setq angg (- angg hafang))
         (setq pa pb))
 (princ))
 ; Ŀ
 ;   Subroutine Cstar end.                                                 
 ; 

 ; Ŀ
 ;   Subroutine Grcirc - grdraw circle maker.                              
 ; 
 (DEFUN GRCIRC (pa radd colo reps / angg incr pa1 pa2)
  (setq angg 0)
  (setq incr (/ pi (/ reps 2)))
  (setq pa1 (polar pa angg radd))
  (repeat reps
          (setq angg (+ angg incr))
          (setq pa2 (polar pa angg radd))
          (grdraw pa1 pa2 colo)
          (setq pa1 pa2))
 (princ))
 ; Ŀ
 ;   Grcirc end.                                                           
 ; 

 ; Ŀ
 ;   Ppel.                                                                 
 ; 
 (DEFUN C:PPEL (/ snapp peli *error* enampt entt enam cen elv ratio stapar
                  endpar axend1 axend2 angg angg2 axlen1 axlen2 axend3 linlpa
                                           linlpb linapa linbpa end1 end2 ell)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
  (setq peli (getvar "pellipse"))
  (setvar "pellipse" 1)
 ; Ŀ
 ;   Make the new local error handler, turn off snap.                      
 ; 
  (defun *error* (shk)
   (setvar "snapmode" snapp)
   (setvar "pellipse" peli)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (print shk))
  (princ))
 ; Ŀ
 ;   Get en ellipse entity.                                                
 ; 
  (if (and (setq enampt (entsel))
           (setq entt (entget (setq enam (car enampt))))
           (= (cdr (assoc 0 entt)) "ELLIPSE")
           (setq cen (cdr (assoc 10 entt)))
           (setq elv (cdr (assoc 11 entt)))
           (setq ratio (cdr (assoc 40 entt)))
 ; Ŀ
 ;   Note that the start and end parameters are not the angles             
 ;   of the start and end points.                                          
 ; 
           (setq stapar (cdr (assoc 41 entt)))   ; start parameter
           (setq endpar (cdr (assoc 42 entt))))  ; end parameter
 ; Ŀ
 ;   Get the axis lengths, endpoints and angles.                           
 ; 
      (progn
           (setq axend1 (list (+ (car cen) (car elv))
                             (+ (cadr cen) (cadr elv))))
           (setq axend2 (list (- (car cen) (car elv))
                             (- (cadr cen) (cadr elv))))
           (setq angg (angle axend2 axend1))
           (setq angg2 (+ angg (/ pi 2)))
           (setq axlen1 (distance cen axend1))
           (setq axlen2 (* ratio axlen1))
           (setq axend3 (polar cen angg2 axlen2))
 ; Ŀ
 ;   Mark the top end of the major axis.                                   
 ; 
           (cstar axend1 (/ axlen1 10) angg 7)
;           (prompt (strcat "Ellipse major axis angle is: "
;                           (rtos (* angg (/ 180 pi)) 2 2)))
 ; Ŀ
 ;   Draw the axes and major and minor axis circles.                       
 ; 
           (grdraw axend1 axend2 8)
           (grdraw cen axend3 8)
           (grcirc cen axlen1 8 45)
           (grcirc cen axlen2 8 45)
 ; Ŀ
 ;   You can't use the Arc version of the ellipse command to draw a        
 ;   partial ellipse when pellipse = 1 - when making a pline ellipse.      
 ;   So we have to find the endpoints and trim the ellipse there.          
 ;   (See https://forums.autodesk.com/t5/net/dxf-ellipse/td-p/2439751)     
 ; 
 ; Ŀ
 ;   Draw a line L at the start parameter angle to hit the inner circle    
 ;   (diameter = minor axis) and the outer circle (diameter = major axis). 
 ;   The start parameter angle is relative to the ellipse angle.           
 ; 
           (setq stapar (+ stapar (- angg2 (/ pi 2))))
           (setq linlpa (polar cen stapar axlen1))  ; outer circle
           (setq linlpb (polar cen stapar axlen2))  ; inner circle
           (grdraw cen linlpb 2)
           (grdraw linlpb linlpa 1)
 ; Ŀ
 ;   Draw line A = from the intersection (on the line) of the minor        
 ;   circle and line L (linlpa), and at the ellipse angle.                 
 ;   The other end will be Linapa.                                         
 ; 
           (setq linapa (polar linlpa angg2 10))
           (grdraw linapa linlpa 1)
 ; Ŀ
 ;   Draw line B = from the intersection of the major circle and line L    
 ;   and line L (linlpb), at the ellipse angle + pi/2 radians.             
 ; 
           (setq linbpa (polar linlpb angg 10))
           (grdraw linbpa linlpb 2)
 ; Ŀ
 ;   The intersection of lines A and B, even if not on either line         
 ;   (i.e. extended intersection) is the endpoint of the ellipse.          
 ; 
           (setq end1 (inters linlpa linapa linlpb linbpa nil))
           (grdraw cen end1 3)
 ; Ŀ
 ;   Do the other end.                                                     
 ; 
           (setq endpar (+ endpar (- angg2 (/ pi 2))))
           (setq linlpa (polar cen endpar axlen1))  ; outer circle
           (setq linlpb (polar cen endpar axlen2))  ; inner circle
           (grdraw cen linlpb 2)
           (grdraw linlpb linlpa 1)
           (setq linapa (polar linlpa angg2 10))
           (grdraw linapa linlpa 1)
           (setq linbpa (polar linlpb angg 10))
           (grdraw linbpa linlpb 2)
           (setq end2 (inters linlpa linapa linlpb linbpa nil))
           (grdraw end1 end2 3)
 ; Ŀ
 ;   Erase the ellipse, make a new one.                                    
 ; 
;           (entdel enam)
           (command ".ellipse" "c" cen axend1 axlen2)
 ; Ŀ
 ;   Break the new ellipse.                                                
 ; 
           (setq ell (entlast))
           (command ".break" (list ell end1) "f" end2 end1)))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
  (*error* nil)
 (princ))
