 ; Ŀ
 ;   Pupa - rev up an Apache "revesions" title block.  Ffs.                
 ;   Copyright 2002, 2009, 2010, 2014 by Rocket Software Ltd.              
 ;   History is written by the survivors, so if you like to write,         
 ;   try to survive.                                                       
 ; 

 ; Ŀ
 ;   Tach - deduce a new rev based on the existing one and a flag.         
 ;   Arguments: Toprev, the previous (existing) rev string.                
 ;              Flag, the new rev or flag.                                 
 ;   Returns a new rev.                                                    
 ; Ĵ
 ;   The Flag value controls how the rev will be incremented.              
 ; Ĵ
 ;   *    A is revved to B, 0 becomes 1.                                  
 ;        If there's no existing rev the first one will be A.             
 ; Ĵ
 ;   #    The next rev is forced to a number: A becomes 0, 1 becomes 2.   
 ;        A first rev will be inserted as 0.                              
 ; Ĵ
 ;   @    Add an A: 9 - 9A.                                               
 ;        If there was a trailing character, increment it.                
 ;        First rev: A.  For some reason.                                 
 ;        If the previous rev was a letter ... increment it.              
 ;        I am not responsible for the actions of idiots.                 
 ; Ĵ
 ;   >    Increment the character: 9A - 9B.                               
 ;        If there wasn't one, add an A.                                  
 ;        First rev: 1A.                                                  
 ;        Note that this and @ are identical.  Except the first rev.      
 ; Ĵ
 ;   >>   Go to the next number and A: 9 - 10A.                           
 ;        If there was a character, replace it with A.                    
 ;        First rev: 1A.                                                  
 ; Ĵ
 ;   <    Ditch the character: 9A - 9.                                    
 ;        First rev: 1.                                                   
 ;        If the rev is just characters, go to 1.                         
 ; Ĵ
 ;   <<   Ditch the character, go to the next number: 9A - 10.            
 ;        First rev: 1.                                                   
 ; Ĵ
 ;   Anything else is used as written, the previous rev doesn't matter.    
 ; 
 (DEFUN TACH (toprev flag / liss)
 ; Ŀ
 ;   Cond: Take care of all the "no previous rev" cases first.             
 ; 
  (cond ((or (null toprev) (member toprev '("." "..." "-" "" " " "  " "   ")))
         (setq revaso '(("*" "A") ("#" "0") ("@" "A") (">" "1A")
                        (">>" "1A") ("<" "1") ("<<" "1")))
         (if (null (setq toprev (cadr (assoc flag revaso))))
             (setq toprev "A")))
 ; Ŀ
 ;   The flag is * then go to the next letter or number.                   
 ; 
        ((equal flag "*")
         (cond ((= (strcase toprev) (strcase toprev t))
                (setq toprev (itoa (1+ (read toprev)))))
               (T (setq toprev (chr (1+ (ascii toprev)))))))
 ; Ŀ
 ;   The flag is #: if the previous rev was a number then go to the next   
 ;   number, if a letter then go to 0.                                     
 ; 
        ((equal flag "#")
         (cond ((= (strcase toprev) (strcase toprev t))
                (setq toprev (itoa (1+ (read toprev)))))
               (T (setq toprev "0"))))
 ; Ŀ
 ;   The flag is @: add an "A" to the previous rev if there isn't one,     
 ;   if there is a character then increment it.                            
 ;   This is the same as >, so they're combined.                           
 ; 
        ((member flag '("@" ">"))
 ; Ŀ
 ;   Monster splits a string into (letter number letter) so if the         
 ;   first part is a number the initial string will be "".                 
 ; 
         (setq liss (monster toprev))
         (if (= (car liss) "")
             (setq liss (cdr liss)))
         (cond ((and (= (length liss) 1)
                     (/= (strcase (car liss)) (strcase (car liss) t)))
                (setq toprev (alph (car liss))))
               ((= (length liss) 2)
                (setq toprev (strcat (car liss) (alph (cadr liss)))))
               (t
                (setq toprev (strcat (car liss) "A")))))
 ; Ŀ
 ;   The flag is >>: increment the number, replace the trailing            
 ;   character with "A".                                                   
 ; 
        ((equal flag ">>")
         (setq liss (monster toprev))
 ; Ŀ
 ;   If it's just a character go to 1A.                                    
 ; 
         (if (= (length liss) 1)
             (setq toprev "1A")
             (progn
                  (if (= (car liss) "")
                      (setq liss (cdr liss)))
                  (setq toprev (strcat (itoa (1+ (read (car liss)))) "A")))))
 ; Ŀ
 ;   The flag is <: ditch any trailing characters.                         
 ; 
        ((equal flag "<")
         (setq liss (monster toprev))
 ; Ŀ
 ;   If it's just a character go to 1.                                     
 ; 
         (if (= (length liss) 1)
             (setq toprev "1")
             (progn
                  (if (= (car liss) "")
                      (setq liss (cdr liss)))
                  (setq toprev (car liss)))))
 ; Ŀ
 ;   The flag is <<: ditch any trailing characters, increment the number.  
 ; 
        ((equal flag "<<")
         (setq liss (monster toprev))
 ; Ŀ
 ;   If it's just a character go to 1.                                     
 ; 
         (if (= (length liss) 1)
             (setq toprev "1")
             (progn
                  (if (= (car liss) "")
                      (setq liss (cdr liss)))
                  (setq toprev (itoa (1+ (read (car liss))))))))
 ; Ŀ
 ;   Otherwise put in the value as is.                                     
 ; 
        (T (setq toprev flag)))
 toprev)
 ; Ŀ
 ;   Tach end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Alph - increment a character string.                       
 ;   Takes one argument, a string.  Returns the incremented version.       
 ;   Caution: doesn't work with number strings: "9" becomes ":".           
 ; 
 (DEFUN ALPH (cname / pos char base cnamp)
  (setq cname (strcase cname))
  (setq pos (strlen cname))
  (while (and (>= pos 1)
              (setq char (substr cname pos 1))
              (<= 90 (ascii char)))
         (setq pos (1- pos)))
 ; Ŀ
 ;   If no non-z characters were found, set all to A and add an A to the   
 ;   left end of the string.                                               
 ; 
  (cond ((= pos 0)
         (setq base "")
         (repeat (1+ (strlen cname))
                 (setq base (strcat base "A")))
         (setq cname base))
 ; Ŀ
 ;   If a non-Z was found, everything to the right of it becomes an A,     
 ;   and it is incremented.                                                
 ; 
        (T (setq cnamp cname)
           (setq cname (strcat (substr cname 1 (1- pos))
                               (chr (1+ (ascii (substr cname pos 1))))))
           (setq base "")
           (repeat (strlen (substr cnamp (1+ pos)))
                   (setq base (strcat base "A")))
           (setq cname (strcat cname base))))
 cname)
 ; Ŀ
 ;   Subroutine Alph end.                                                  
 ; 

 ; Ŀ
 ;   Blint - place new values into a block starting at a given attribute.  
 ;   Arguments: Enam, the attribute name at which to start.                
 ;              Vlasta, the list of new values.                            
 ;   Caution: doesn't check to see if there are attributes available.      
 ; 
 (DEFUN BLINT (enam vlasta / gnuval entt)
  (while (setq gnuval (car vlasta))
         (setq vlasta (cdr vlasta))
         (setq entt (entget enam))
         (entmod (subst (cons 1 gnuval) (assoc 1 entt) entt))
         (setq enam (entnext enam)))
  (entupd enam)
 (princ))
 ; Ŀ
 ;   Blint end.                                                            
 ; 

 ; Ŀ
 ;   Exstr - extract a number of attribute values, return them as a list   
 ;   with the ename of the next following attribute as the first element.  
 ;   Arguments: Enam, the entity name of the first attribute to extract.   
 ;              Num, the number of attributes to extract.                  
 ;                                                                         
 ;   Calls nothing.  But has good intentions otherwise.                    
 ;   Returns a list: (next_ename string1 string2 ... string_num)           
 ; 
 (DEFUN EXSTR (enam num / vall malist)
  (repeat num (setq vall (cdr (assoc 1 (entget enam))))
              (setq enam (entnext enam))
              (setq malist (cons vall malist)))
  (cons enam (reverse malist)))
 ; Ŀ
 ;   Exstr end.                                                            
 ; 

 ; Ŀ
 ;   Fudge - If a title block rev area is full, delete the lowest rev      
 ;   line of data and shuffle the rest down.                               
 ;   Arguments: Enam, the ename of the block insertion.                    
 ;              Numlin, the number of rev lines.                           
 ;              Atsper, the number of attributes per line.                 
 ;              Revpos, the 0 based position of the first rev attribute.   
 ;   Returns a list: the ename of the first attribute in the first empty   
 ;   rev line and the highest rev number.                                  
 ;   Note that the first empty rev is found before the list is compacted,  
 ;   so if there are gaps something may be overwritten when data is moved  
 ;   into the previously empty atts marked as the first empty rev line.    
 ;   This so far isn't a major problem but should be fixed.                
 ; 
 (DEFUN FUDGE (enam numlin atsper revpos / esav esav1 revlst rsave llist sub meta
                                                           toprev entt vall)
  (setq enam (entnext enam)) ; first ename after the insert
 ; Ŀ
 ;   Find the first rev line.                                              
 ; 
  (repeat revpos (setq enam (entnext enam)))
 ; Ŀ
 ;   Save the first rev number ename as the reapplication start point.     
 ; 
  (setq esav1 enam)
 ; Ŀ
 ;   Extract the next Numlin lines into a list of value lists.             
 ;   Ignore any rev line which does not begin with a legitimate value.     
 ; 
  (repeat numlin (setq revlst (exstr enam atsper))
 ; Ŀ
 ;   Save the ename for the first attribute on the current rev line in     
 ;   case it is the first empty rev.                                       
 ; 
                 (setq esav enam)
                 (setq enam (car revlst))     ; next ename after extracted ones
                 (setq revlst (cdr revlst))   ; list of extracted strings
 ; Ŀ
 ;   The %%32 is for Apache drawings.  No idea what's going on here.       
 ; 
                 (if (member (car revlst) '("" " " "-" "..." "." "%%32"))
                     (if (null rsave) (setq rsave esav))
                     (progn
                          (setq toprev (car revlst))
                          (setq llist (append llist (list revlst))))))
 ; Ŀ
 ;   If there are Numlin lines, ditch the first one and reinstall them.    
 ;   The ename returned as the starting point for the new rev is thus the  
 ;   one in Esav.                                                          
 ;   Otherwise the correct value is the one in Rsave.                      
 ; 
  (if (= (length llist) numlin)
      (progn
           (setq llist (cdr llist))
 ; Ŀ
 ;   Make the thing back into one meta-list.                               
 ; 
           (while (setq sub (car llist))
                  (setq llist (cdr llist))
                  (setq meta (append meta sub)))
 ; Ŀ
 ;   Pad it out to full length with spaces.                                
 ; 
           (while (< (length meta) (* numlin atsper))
                  (setq meta (append meta (list ""))))
 ; Ŀ
 ;   Reinstall it.                                                         
 ; 
           (while (and (/= (cdr (assoc 0 (setq entt (entget esav1)))) "SEQEND")
                       (setq vall (car meta)))
                  (setq meta (cdr meta))
                  (entmod (subst (cons 1 vall) (assoc 1 entt) entt))
                  (setq esav1 (entnext esav1)))
           (setq rsave esav)))
 (list rsave toprev))
 ; Ŀ
 ;   Fudge end.                                                            
 ; 

 ; Ŀ
 ;   Guru - update a unique attribute in a block.                          
 ;   Arguments: Rev, the new string.                                       
 ;              Enam, the tb ename.                                        
 ;              Atnam, the attribute tag.                                  
 ;   Calls nothing, returns nothing, doesn't get involved.                 
 ; 
 (DEFUN GURU (rev enam atnam / ss esav stop enam entt tagg)
  (while (/= atnam (cdr (assoc 2 (entget (setq enam (entnext enam)))))))
  (setq entt (entget enam))
  (entmod (subst (cons 1 rev) (assoc 1 entt) entt))
  (entupd enam)
 (princ))
 ; Ŀ
 ;   Guru end.                                                             
 ; 

 ; Ŀ
 ;   Monster - returns a list of strings, alternating between numbers and  
 ;   letters. The first string is always a character string - if the       
 ;   first character is a number then the first string will be empty (""). 
 ;   A period is a decimal point if preceded by a number.                  
 ; 
 (DEFUN MONSTER (string / chastr pre ascnum posi this asc last strlist)
  (setq chastr "")
  (setq pre "c")
  (setq ascnum (list 48 49 50 51 52 53 54 55 56 57))
  (setq posi 1)
  (while (/= "" (setq this (substr string posi 1)))
       (setq asc (ascii this))
       (cond ((member asc ascnum)         ; if char is a number
              (setq last "n"))
             ((= asc 46)                  ; if char is a .
              (if (= last "c")
                  (setq last "c")
                  (setq last "n")))
             (T                           ; otherwise it must be a letter
               (setq last "c")))
 ; Ŀ
 ;   If pre = last then strcat This onto chastr.                           
 ;   If not then append chastr onto strlist and set chastr to this.        
 ; 
       (if (equal pre last)
           (setq chastr (strcat chastr this))
           (progn
                (if strlist
                   (setq strlist (append strlist (list chastr)))
                   (setq strlist (list chastr)))
                (setq chastr this)))
       (setq pre last)
       (setq posi (1+ posi)))
  (if chastr (setq strlist (append strlist (list chastr))))
  strlist)
 ; Ŀ
 ;   Monster end.                                                          
 ; 

 ; Ŀ
 ;   Nurp - replace a value at a given position in a block.                
 ;   Arguments: Enam, the block insertion ename.                           
 ;              Atpos, the zero based position of the att. to replace.     
 ;              Gnuval, the new value.                                     
 ;   Caution: doesn't check to see if there is an attribute available.     
 ;   Note: Nurp is not currently used.                                     
 ; 
 (DEFUN NURP (enam atpos gnuval / entt)
  (setq enam (entnext enam))
  (repeat atpos (setq enam (entnext enam)))
  (setq entt (entget enam))
  (entmod (subst (cons 1 gnuval) (assoc 1 entt) entt))
  (entupd enam)
 (princ))
 ; Ŀ
 ;   Nurp end.                                                             
 ; 

 ; Ŀ
 ;   Pupa.                                                                 
 ; 
 (DEFUN C:PUPA (/ vlasta ss tbnam rbnam mtrev toprev)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   The list Vlasta contains the values for the new rev line in the       
 ;   order in which they will appear in the block.                         
 ; 
  (setq vlasta '("@" "14.10.24" "SW" "ISSUED FOR BID" "SRL" "HrH" ""))
 ; Ŀ
 ;   Get the title block and rev block enames.                             
 ; 
  (if (and (setq ss (ssget "X" (list (cons 2 "DRAWING_DESC."))))
           (setq tbnam (ssname ss 0))
           (setq ss (ssget "X" (list (cons 2 "REVESIONS"))))
           (setq rbnam (ssname ss 0)))
      (progn
 ; Ŀ
 ;   If the rev area is full remove a rev.                                 
 ;   Save the returned ename - the first empty attribute on the first      
 ;   empty rev line.                                                       
 ; 
           (setq mtrev (fudge rbnam 10 7 0))
           (setq toprev (cadr mtrev))
           (setq mtrev (car mtrev))
 ; Ŀ
 ;   Increment the rev based on the last one and the flag in Vlasta.       
 ; 
           (setq toprev (tach toprev (car vlasta)))
 ; Ŀ
 ;   Now put the new rev back into the block.                              
 ; 
           (blint mtrev (append (list toprev) (cdr vlasta)))
 ; Ŀ
 ;   Update the rev in the main title block.                               
 ; 
           (guru toprev tbnam "X")))
 (princ))