 ; Ŀ
 ;   PWI - re-width all clouds.                                            
 ;   Copyright 1994, 1997, 2001, 2008, 2011 by Rocket Software Ltd.        
 ;                                                                         
 ; 

 ; Ŀ
 ;   Ickl - see if a polyline is a cloud - the number of segments is       
 ;   no greater than two more than the number of bulges.                   
 ;   Arguments: Enam, a polyline or lwpolyline entity name.                
 ;   Returns t if it's a cloud, else nil.                                  
 ; 
 (DEFUN ICKL (enam / typ entt num nobulg flat sub bulgs)
  (setq typ (cdr (assoc 0 (setq entt (entget enam)))))
  (setq bulgs 0)
  (cond ((= typ "POLYLINE")
         (setq segs 0)
         (while (and (null nobulg)
                     (/= "SEQEND" (cdr (assoc 0 (setq entt (entget (setq enam
                                                         (entnext enam))))))))
                (setq segs (1+ segs))
                (if (and (assoc 42 entt) (/= (cdr (assoc 42 entt)) 0))
                    (setq bulgs (1+ bulgs)))))
        ((= typ "LWPOLYLINE")
         (setq num 0)
         (setq segs 0)
         (while (and (null nobulg)
                     (setq sub (nth num entt)))
                (setq num (1+ num))
                (cond ((= (car sub) 10)
                       (setq segs (1+ segs)))
                      ((and (= (car sub) 42)
                            (/= (cdr sub) 0))
                       (setq bulgs (1+ bulgs)))))))
 ; Ŀ
 ;   See if it looked like a polyline.                                     
 ;   Modify this - allow ten percent non-bulged sections, minimum two.     
 ; 
  (setq flats (max 2 (fix (/ segs 10))))
 ; (print segs)
 ; (print bulgs)
 (if (and (>= segs 2) (> bulgs (- segs flats))) t))
 ; Ŀ
 ;   Ickl end.                                                             
 ; 

 ; Ŀ
 ;   PWI.                                                                  
 ; 
 (DEFUN C:PWI (/ ss enam num cnum)
  (setvar "cmdecho" 0)
  (command ".undo" "be")
 ; Ŀ
 ;   Load Misps.lsp, which contains the ps/ms scaling subroutines.         
 ; 
  (if (or (null wasp) (null misps))
      (if (null (load "misps" ()))
          (prompt "\n** The File Misps.lsp Is Not Available. **\n")))
  (setq pwid (* 0.75 (misps)))
 ; Ŀ
 ;   Look for clouds.                                                      
 ; 
  (if (setq ss (ssget "X" '((-4 . "<or") (8 . "revise")
                                         (8 . "g-clouds")
                                         (8 . "clouds")
                                         (8 . "e-contin")
                                         (8 . "border*")
                                         (8 . "a-revise") (-4 . "or>")
                            (-4 . "<or") (0 . "polyline")
                                         (0 . "lwpolyline") (-4 . "or>"))))
      (progn
           (setq num 0)
           (setq cnum 0)
           (while (setq enam (ssname ss num))
                  (setq num (1+ num))
                  (if (ickl enam)
                      (progn
                           (setq cnum (1+ cnum))
                           (command "pedit" enam "w" pwid ""))))
           (prompt (strcat "\nClouds Widthed: " (itoa cnum)))))
  (command ".undo" "end")
 (princ))