 ; Ŀ
 ;   Radar - find a file in directories above the current one and the      
 ;   their subdirectories.                                                 
 ;   Copyright 2008, 2012, 2013 by Rocket Software Ltd.                    
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Asdic - search subdirectories for a file.                  
 ;   Arguments: Dirnam, a directory name.                                  
 ;              Filnam, a file name.                                       
 ;              Dirig, do not search this directory.                       
 ;                     Note that this must be the entire path, not just    
 ;                     a single directory name.                            
 ;              Depth, the current depth in the local tree.                
 ;   Returns a filename with path or nil.                                  
 ;   Recursive.                                                            
 ; 
 (DEFUN ASDIC (dirnam filnam dirig depth / sub found foundp dirlis num)
 ; (print depth)
(print dirnam)
 ; Ŀ
 ;   See if the directory contains the desired file.                       
 ;   The documentation for Vl-directory-files is wrong in several ways:    
 ;   - An empty match pattern crashes and does not default to "*.*".       
 ;   - The returned file list is not - as implied - in upper case.         
 ;   - The number of arguments does not appear to be variable.             
 ;   Search on a specific file name isn't case sensitive.                  
 ; 
  (if (vl-directory-files dirnam filnam 1)
      (setq found (strcat dirnam filnam))
 ; Ŀ
 ;   Else check every subdirectory.                                        
 ; 
      (progn
           (setq dirlis (vl-directory-files dirnam "*.*" -1))
           (setq num 0)
           (while (and (null found)
                       (setq sub (nth num dirlis)))
                  (setq num (1+ num))
                  (if (and (not (member sub '("." "..")))
                           (/= dirig (setq sdir (strcat dirnam sub "\\")))
                           (setq foundp (asdic sdir filnam dirig (1+ depth))))
                      (setq found foundp)))))
 found)
 ; Ŀ
 ;   Subroutine Asdic end.                                                 
 ; 

 ; Ŀ
 ;   Dstep - remove the last level from a path.                            
 ;   Arguments: Stra, a path string.                                       
 ;   Returns a truncated path or "".                                       
 ; 
 (DEFUN DSTEP (stra / pos)
 ; Ŀ
 ;   The last character will probably be a backslash, therefore remove     
 ;   it so that it doesn't stop the loop.                                  
 ; 
  (setq pos (strlen stra))
  (if (and (/= pos 0)
           (member (substr stra pos 1) '("/" "\\")))
      (setq stra (substr stra 1 (1- pos))))
 ; Ŀ
 ;   Remove the next step.                                                 
 ; 
  (setq pos (strlen stra))
  (while (and (/= pos 0)
              (not (member (substr stra pos 1) '("/" "\\"))))
         (setq pos (1- pos)))
  (setq stra (substr stra 1 pos))
 stra)
 ; Ŀ
 ;   Dstep end.                                                            
 ; 

 ; Ŀ
 ;   Radar.                                                                
 ; 
 (defun c:radar (/ dirac filnam)
 ; Get the current directory
 ; Step up one, Asdic except what was the current one
 ; repeat until we're at the root or ... some other stopping point.
 ; Maybe only climb a certain number of times, put in a stop here file ...
 ; Also add the ability to search a directory dump file.
 ; Which is the stop file.

  (setq dirac "c:\\tempura\\")
  (setq filnam "tempxxx.dwg")
  (setq predir "")
  (while (and (null (setq filnamp (asdic dirac filnam predir 0)))
              (setq predir dirac)
              (/= "" (setq dirac (dstep dirac))))
         (print dirac))
  (print filnamp)
 (princ))