 ; Ŀ
 ;   Rover - install a wall break symbol.                                  
 ;   Copyright 1996 by Rocket Software Ltd.                                
 ;   Dogs - the first mass produced consumer goods.                        
 ; 

 ; Ŀ
 ;   Subroutine Ipl - decide which isoplane a line most nearly lies in.    
 ;   Takes the line entity name as an argument, returns the plane number   
 ;   in the same format used by the snapisopair system variable.           
 ; 
 (DEFUN IPL (enam / entt ten elv angg pair)
  (setq entt (entget enam))
  (setq ten (cdr (assoc 10 entt)))
  (setq elv (cdr (assoc 11 entt)))
  (setq angg (angle ten elv))
  (cond ((or (and (>= angg 0)
                  (<= angg (/ pi 3)))
             (and (>= angg pi)
                  (<= angg (* pi (/ 4 3.0)))))
         (setq pair 0))
        ((or (and (>= angg (/ pi 3))
                  (<= angg (* pi (/ 2 3.0))))
             (and (>= angg (* pi (/ 4 3.0)))
                  (<= angg (* pi (/ 5 3.0)))))
         (setq pair 1))
        ((or (and (>= angg (* pi (/ 2 3.0)))
                  (<= angg pi))
             (and (>= angg (* pi (/ 5 3.0)))
                  (<= angg (* pi 2))))
         (setq pair 2))))
 ; Ŀ
 ;   Ipl end.                                                              
 ; 

 ; Ŀ
 ;   Subroutine Rarc0 - draw the penetration symbol in the 0 isoplane.     
 ;   Takes a point as its sole argument and draws the symbol as a          
 ;   polyline which may be edited as a single unit without the routine     
 ;   being dependent on external block files.                              
 ; 
 (DEFUN RARC0 (pa / data dimscl num dat ten tenx teny)
  (setq data (list
  '((0 . "POLYLINE") (40 . 0.0) (41 . 0.0))
  '((0 . "VERTEX") (10 -1.428 -2.824 0.0) (42 . 0.0071201))
  '((0 . "VERTEX") (10 -1.265 -3.001 0.0) (42 . 0.0723411))
  '((0 . "VERTEX") (10 0.0 -4.0 0.0)      (42 . 0.0))
  '((0 . "VERTEX") (10 0.0 -7.0 0.0)      (42 . 0.0))
  '((0 . "VERTEX") (10 0.0 -4.0 0.0)      (42 . 0.106617))
  '((0 . "VERTEX") (10 1.435 -4.461 0.0)  (42 . 0.156851))
  '((0 . "VERTEX") (10 2.45 -4.242 0.0)   (42 . 0.156851))
  '((0 . "VERTEX") (10 3.147 -3.473 0.0)  (42 . 0.106617))
  '((0 . "VERTEX") (10 3.464 -2.0 0.0)    (42 . 0.0))
  '((0 . "VERTEX") (10 6.062 -3.5 0.0)    (42 . 0.0))
  '((0 . "VERTEX") (10 3.464 -2.0 0.0)    (42 . 0.0723411))
  '((0 . "VERTEX") (10 3.232 -0.405 0.0)  (42 . 0.0587519))
  '((0 . "VERTEX") (10 2.45 1.415 0.0)    (42 . 0.0587519))
  '((0 . "VERTEX") (10 1.265 3.002 0.0)   (42 . 0.0723411))
  '((0 . "VERTEX") (10 0.0 4.0 0.0)       (42 . 0.0))
  '((0 . "VERTEX") (10 0.0 7.0 0.0)       (42 . 0.0))
  '((0 . "VERTEX") (10 0.0 4.0 0.0)       (42 . 0.106617))
  '((0 . "VERTEX") (10 -1.435 4.462 0.0)  (42 . 0.156851))
  '((0 . "VERTEX") (10 -2.449 4.243 0.0)  (42 . 0.156851))
  '((0 . "VERTEX") (10 -3.146 3.474 0.0)  (42 . 0.106617))
  '((0 . "VERTEX") (10 -3.464 2.0 0.0)    (42 . 0.0))
  '((0 . "VERTEX") (10 -6.062 3.5 0.0)    (42 . 0.0))
  '((0 . "VERTEX") (10 -3.464 2.0 0.0)    (42 . 0.0723411))
  '((0 . "VERTEX") (10 -3.232 0.406 0.0)  (42 . 0.0071201))
  '((0 . "VERTEX") (10 -3.16 0.176 0.0)   (42 . 0.0587519))
  '((0 . "SEQEND"))))
  (setq dimscl (getvar "dimscale"))
  (setq num 0)
  (while (setq dat (nth num data))
         (setq ten (cadr dat))
         (if (= (car ten) 10)
             (progn
                  (setq tenx (cadr ten))
                  (setq teny (caddr ten))
                  (setq tenx (list 10 (+ (* dimscl tenx) (car pa))
                                      (+ (* dimscl teny) (cadr pa))))
                  (setq dat (list (car dat) tenx (caddr dat)))))
         (entmake dat)
         (setq num (1+ num)))
 (princ))
 ; Ŀ
 ;   Rarc0 end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Rarc1 - draw the penetration symbol in the 1 isoplane.     
 ; 
 (DEFUN RARC1 (pa / data dimscl num dat ten tenx teny)
  (setq data (list
  '((0 . "POLYLINE") (40 . 0.0) (41 . 0.0))
  '((0 . "VERTEX") (10 -2.0 2.58851 0.0) (42 . 0.0708205))
  '((0 . "VERTEX") (10 -3.4641 2.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 -6.06218 3.5 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 -3.4641 2.0 0.0) (42 . 0.106617))
  '((0 . "VERTEX") (10 -4.58119 0.988098 0.0) (42 . 0.156851))
  '((0 . "VERTEX") (10 -4.89898 0.0 0.0) (42 . 0.156851))
  '((0 . "VERTEX") (10 -4.58119 -0.988098 0.0) (42 . 0.106617))
  '((0 . "VERTEX") (10 -3.4641 -2.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 -6.06218 -3.5 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 -3.4641 -2.0 0.0) (42 . 0.0723411))
  '((0 . "VERTEX") (10 -1.96708 -2.59649 0.0) (42 . 0.0587519))
  '((0 . "VERTEX") (10 0.0 -2.82843 0.0) (42 . 0.0587519))
  '((0 . "VERTEX") (10 1.96708 -2.59649 0.0) (42 . 0.0723411))
  '((0 . "VERTEX") (10 3.4641 -2.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 6.06218 -3.5 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 3.4641 -2.0 0.0) (42 . 0.106617))
  '((0 . "VERTEX") (10 4.58119 -0.988098 0.0) (42 . 0.156851))
  '((0 . "VERTEX") (10 4.89898 0.0 0.0) (42 . 0.156851))
  '((0 . "VERTEX") (10 4.58119 0.988098 0.0) (42 . 0.106617))
  '((0 . "VERTEX") (10 3.4641 2.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 6.06218 3.5 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 3.4641 2.0 0.0) (42 . 0.0708205))
  '((0 . "VERTEX") (10 2.0 2.58851 0.0) (42 . 0.0587519))
  '((0 . "SEQEND"))))
  (setq dimscl (getvar "dimscale"))
  (setq num 0)
  (while (setq dat (nth num data))
         (setq ten (cadr dat))
         (if (= (car ten) 10)
             (progn
                  (setq tenx (cadr ten))
                  (setq teny (caddr ten))
                  (setq tenx (list 10 (+ (* dimscl tenx) (car pa))
                                      (+ (* dimscl teny) (cadr pa))))
                  (setq dat (list (car dat) tenx (caddr dat)))))
         (entmake dat)
         (setq num (1+ num)))
 (princ))
 ; Ŀ
 ;   Rarc1 end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Rarc2 - draw the penetration symbol in the 2 isoplane.     
 ; 
 (DEFUN RARC2 (pa / data dimscl num dat ten tenx teny)
  (setq data (list
  '((0 . "POLYLINE") (40 . 0.0) (41 . 0.0))
  '((0 . "VERTEX") (10 3.16027 0.175417 0.0) (42 . 0.0071201))
  '((0 . "VERTEX") (10 3.23216 0.405294 0.0) (42 . 0.0723411))
  '((0 . "VERTEX") (10 3.4641 2.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 6.06218 3.5 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 3.4641 2.0 0.0) (42 . 0.106617))
  '((0 . "VERTEX") (10 3.14631 3.47338 0.0) (42 . 0.156851))
  '((0 . "VERTEX") (10 2.44949 4.24264 0.0) (42 . 0.156851))
  '((0 . "VERTEX") (10 1.43488 4.46148 0.0) (42 . 0.106617))
  '((0 . "VERTEX") (10 0.0 4.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 0.0 7.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 0.0 4.0 0.0) (42 . 0.0723411))
  '((0 . "VERTEX") (10 -1.26509 3.00178 0.0) (42 . 0.0587519))
  '((0 . "VERTEX") (10 -2.44949 1.41421 0.0) (42 . 0.0587519))
  '((0 . "VERTEX") (10 -3.23216 -0.405294 0.0) (42 . 0.0723411))
  '((0 . "VERTEX") (10 -3.4641 -2.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 -6.06218 -3.5 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 -3.4641 -2.0 0.0) (42 . 0.106617))
  '((0 . "VERTEX") (10 -3.14631 -3.47338 0.0) (42 . 0.156851))
  '((0 . "VERTEX") (10 -2.44949 -4.24264 0.0) (42 . 0.156851))
  '((0 . "VERTEX") (10 -1.43488 -4.46148 0.0) (42 . 0.106617))
  '((0 . "VERTEX") (10 0.0 -4.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 0.0 -7.0 0.0) (42 . 0.0))
  '((0 . "VERTEX") (10 0.0 -4.0 0.0) (42 . 0.0723411))
  '((0 . "VERTEX") (10 1.26509 -3.00178 0.0) (42 . 0.0071201))
  '((0 . "VERTEX") (10 1.42822 -2.82458 0.0) (42 . 0.0587519))
  '((0 . "SEQEND"))))
  (setq dimscl (getvar "dimscale"))
  (setq num 0)
  (while (setq dat (nth num data))
         (setq ten (cadr dat))
         (if (= (car ten) 10)
             (progn
                  (setq tenx (cadr ten))
                  (setq teny (caddr ten))
                  (setq tenx (list 10 (+ (* dimscl tenx) (car pa))
                                      (+ (* dimscl teny) (cadr pa))))
                  (setq dat (list (car dat) tenx (caddr dat)))))
         (entmake dat)
         (setq num (1+ num)))
 (princ))
 ; Ŀ
 ;   Rarc2 end.                                                            
 ; 

 ; Ŀ
 ;   Rover - the instinctive maker of holes...                             
 ; 
 (DEFUN C:ROVER (/ dimscl radd incr pa pb linam pair)
  (setvar "cmdecho" 0)
  (setq dimscl (getvar "dimscale"))
  (setq radd (* 4 dimscl))
  (setq incr (/ pi 6))
  (setq pa (getpoint "Penetration: "))
  (if (setq pb (osnap pa "Intersec"))
      (setq pa pb)
      (if (setq pb (osnap pa "Nearest"))
          (setq pa pb)))
  (setq linam (car (entsel "Line: ")))
  (setq pair (ipl linam))
  (cond ((= pair 0)
         (rarc0 pa)
         (command "break" (list linam pa)
                          (polar pa incr (* dimscl 2.8284))))
        ((= pair 1)
         (rarc1 pa)
         (command "break" (list linam pa)
                          (polar pa (* incr 9) (* dimscl 2.8284))))
        ((= pair 2)
         (rarc2 pa)
         (command "break" (list linam pa)
                          (polar pa (* incr 5) (* dimscl 2.8284)))))
 (princ))