 ; Ŀ
 ;   Sarbl - chgtext for Connacher-tb title blocks.                        
 ;   But only in the main title area.                                      
 ;   Copyright 1995, 1997, 1998, 2004, 2010, 2013 by Rocket Software Ltd.  
 ;   If knowledge is power then why are idiots so dangerous?               
 ; 

 ; Ŀ
 ;   Mark - mark a point.                                                  
 ;   Arguments: Pa - the point to mark.                                    
 ;              Rad - the marker segment length.                           
 ;              Colo - the marker grdraw line colour.                      
 ; 
 (DEFUN MARK (pa rad colo /)
  (grdraw (polar pa (/ pi 4) rad) (polar pa (* 1.25 pi) rad) colo)
  (grdraw (polar pa (* pi 0.75) rad) (polar pa (* pi 1.75) rad) colo)
 (princ))
 ; Ŀ
 ;   Mark end.                                                             
 ; 

 ; Ŀ
 ;   Chug - string substitution engine.  Takes the search string, the      
 ;   replacement string, and the target string as arguments, and returns   
 ;   the (possibly modified) target string and the number of changes made. 
 ; 
 (DEFUN CHUG (oldstr newstr exstr / pos chnum changd newlen chunk)
  (setq pos 1)
  (setq chnum 0)
  (setq changd ())
  (setq newlen (strlen newstr))
  (setq oldlen (strlen oldstr))
  (while (= oldlen (strlen (setq chunk (substr exstr pos oldlen))))
         (if (= chunk oldstr)
             (progn
                  (setq exstr (strcat (substr exstr 1 (1- pos))
                                       newstr
                                      (substr exstr (+ pos oldlen))))
                  (setq changd t)
                  (setq chnum (1+ chnum))
                  (setq pos (+ pos newlen)))
             (setq pos (1+ pos))))
 (list exstr chnum))
 ; Ŀ
 ;   Chug - end.                                                           
 ; 

 ; Ŀ
 ;   Blach - change one substring to another in an ss of blocks.           
 ;   Arguments: ss, the selection set of blocks.                           
 ;              cc - the old string                                        
 ;              dd - the new string                                        
 ;   Calls Chug, returns nothing.                                          
 ; 
 (DEFUN BLACH (ss cc dd / rad num esub chg txt altr tagg)
  (setq rad (/ (getvar "viewsize") 45))
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq esub (entnext enam))
         (setq num (1+ num))
         (setq chg ())
         (while (/= "SEQEND" (cdr (assoc 0 (setq entt (entget esub)))))
                (setq tagg (cdr (assoc 2 entt)))
                (setq txt (cdr (assoc 1 entt)))
                (setq altr (chug cc dd txt))
                (if (and (= (substr tagg 1 5) "TITLE")
                         (> (cadr altr) 0))        ; if any changes made
                    (progn
                         (setq chg T)
                         (setq newtxt (car altr))
                         (mark (cdr (assoc 10 entt)) rad 7)
                         (entmod (subst (cons 1 newtxt) (assoc 1 entt) entt))))
                (setq esub (entnext esub)))
         (if chg (entupd enam)))
 (princ))
 ; Ŀ
 ;   Multch end.                                                           
 ; 

 ; Ŀ
 ;   Sarbl.                                                                
 ; 
 (DEFUN C:SARBL (/ picks *error* ccp chlin chnum dd notouch rad hi ss len
                     num changs strch enam txt entt altr mods newtxt pa chaags
                                                             attch esub chg)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   This turns off group selection - otherwise entities in groups may     
 ;   be changed twice with bad things happening as a result.               
 ; 
  (setq picks (getvar "pickstyle"))
  (setvar "pickstyle" 0)
 ; Ŀ
 ;   Something is bound to go wrong.                                       
 ; 
  (defun *error* (shk)
   (setvar "pickstyle" picks)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (print shk))
  (princ))
 ; Ŀ
 ;   This next section is the one to edit.                                 
 ;   The format is ("existing string" "new string"), each line will do     
 ;   one search and replace, in the order they are in here.                
 ;                                                                         
 ;   Watch out for cascades: A to B, B to C, C to D gives all D.           
 ;   C to D, B to C, A to B works properly.                                
 ;   Also 1 to 5, 10 to 20 gives 10 to 50 instead of 10 to 20.             
 ;   10 to 20, 1 to 5 still doesn't work, but 10 to *20*, 1 to 5,          
 ;   and then *20* to 20 can be used if you are careful.                   
 ;   For text the longest common substring should be used - watch for      
 ;   the combination SP to JF which results in SPARE to JFARE.             
 ;   And keep backups, because you can't catch everything.                 
 ; 
  (setq chlist '(

                ("PANEL DRAWINGS" "")
                (" DRAWINGS" "")
                (" DRAWING" "")
                ("DRAWING" "")

))
 ; Ŀ
 ;   End of search and replace string section.                             
 ;   Get an ss of blocks to sar.                                           
 ; 
  (if (setq ss (ssget "X" (list (cons 66 1) (cons 2 "connacher-tb"))))
      (progn
           (setq num 0)
           (while (setq sub (nth num chlist))
                  (setq num (1+ num))
                  (setq oldstr (car sub))
                  (setq newstr (cadr sub))
                  (blach ss oldstr newstr))))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
  (*error* ())
 (princ))
