 ; Ŀ
 ;   Schplit: create one new drawing for each layout tab in a drawing,     
 ;   name each one filename + tab name.                                    
 ;   Copyright 2011, 2012 by Rocket Software Ltd.                          
 ;                                                                         
 ; 
 (DEFUN C:SCHPLIT (/ *error* fnam len lcount lali ctab lanum)
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk / fnam)
  (setq fnam (getvar "dwgname"))
  (if regist (regist (strcat "***** Error in Schplit.lsp, File: " fnam)))
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Make sure the destination directory is available.                     
 ; 
  (if (null (findfile "c:\\condwgs"))
      (progn
           (write-line "Directory C:\\Condwgs Isn't Available.")
           (write-line "See file Schplit.lsp.")
           (exit)))
 ; Ŀ
 ;   Get into paper space, just to save trouble later.                     
 ; 
  (setvar "tilemode" 0)
 ; Ŀ
 ;   Get the file name.                                                    
 ; 
  (setq fnam (getvar "dwgname"))
  (if (= (substr (strcase fnam t) (- (setq len (strlen fnam)) 3)) ".dwg")
      (setq fnam (substr fnam 1 (- len 4))))
 ; Ŀ
 ;   Count the layout tabs.                                                
 ;   (Layoutlist) returns a list of all tabs except model space.           
 ; 
  (setq lcount (length (setq lali (layoutlist))))
 ; Ŀ
 ;   If there is only 1 layout tab then save to the save directory as      
 ;   name + tab name.                                                      
 ; 
  (cond ((= lcount 1)
         (setq ctab (getvar "ctab"))
         (command ".save" (strcat "c:\\condwgs\\" fnam "-" ctab))
         (regist (strcat "Drawing renamed to " fnam "-" ctab ".")))
 ; Ŀ
 ;   If there is >1 layout then save one copy of the drawing for each      
 ;   name + tab name.                                                      
 ; 
        ((> lcount 1)
         (setq lanum 0)
         (while (setq ctab (nth lanum lali))
                (setq lanum (1+ lanum))
                (setvar "ctab" ctab)
                (if (ssget "x" (list (cons 410 ctab)
                                     (cons 2 "*tb*")))
                    (progn
                         (command ".save" (strcat "c:\\condwgs\\"
                                                   fnam "-" ctab))
                         (regist (strcat "Drawing created: "
                                          fnam "-" ctab "."))
                         (xreg "1" 14 t))))))
 (princ))