 ; Ŀ
 ;   Slib - Make slides of a directory.                                    
 ;   Copyright 2000, 2013 by Rocket Software Ltd.                          
 ;   Also the street slang for an almost-used-up bar of soap.              
 ; 

 ; Ŀ
 ;   Dirge - get a list of filenames.                                      
 ;   Arguments: Defa, nil = use defaults for path and file pattern,        
 ;                    T = ask for everything.                              
 ;   Returns a list: the path, and a list of filenames with paths.         
 ; 
 (DEFUN DIRGE (defa / pat prefa pref fils num fnam nulis)
 ; Ŀ
 ;   Set the drawing pattern.                                              
 ; 
  (if (or (null defa)
          (= "" (setq pat (getstring "Pattern <*.dwg>: "))))
      (setq pat "*.dwg"))
 ; Ŀ
 ;   Get the drawing path.                                                 
 ; 
  (setq prefa (getvar "dwgprefix"))
  (if (or (null defa)
          (= "" (setq pref (getstring (strcat "Directory <" prefa ">: ")))))
      (setq pref prefa))
 ; Ŀ
 ;   Get a list of matching files.                                         
 ; 
  (setq fils (vl-directory-files pref pat 1))
 ; Ŀ
 ;   Put the filename list in alphabetical order.                          
 ; 
  (if fils (setq fils (vl-sort fils '<)))
  (setq num 0)
  (while (and fils (setq fnam (nth num fils)))
         (setq num (1+ num))
         (setq fnam (strcat pref fnam))
         (setq nulis (cons fnam nulis)))
 (list prefa (reverse nulis)))
 ; Ŀ
 ;   Dirge end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Vu - unlock all viewports.                                 
 ;   Takes no arguments, calls nothing.                                    
 ;   Returns t if everything went ok, nil if not.                          
 ; 
 (DEFUN VU (/ unlo)
  (if (= (strcase (getvar "ctab") t) "model")
      (prompt "\n* You Can't Unlock Viewports From Model Space. *")
      (progn
           (command ".mview" "L" "off" "all" "")
           (setq unlo t)))
 unlo)
 ; Ŀ
 ;   Subroutine Vu end.                                                    
 ; 

 ; Ŀ
 ;   Subroutine Vl - lock all viewports.                                   
 ;   Takes no arguments, calls nothing.                                    
 ;   Returns t if everything went ok, nil if not.                          
 ; 
 (DEFUN VL ()
  (if (= (strcase (getvar "ctab") t) "model")
      (prompt "\n* You Can't Lock Viewports From Model Space. *")
      (progn
           (command ".mview" "L" "on" "all" "")
           (setq vlo t)))
 vlo)
 ; Ŀ
 ;   Subroutine Vl end.                                                    
 ; 

 ; Ŀ
 ;   Slib.                                                                 
 ; 
 (DEFUN C:SLIB (/ dwglst dwg dwgbas)
  (setvar "cmdecho" 0)
  (setq dwgnam (strcase (vl-filename-base (getvar "dwgname")) t))
 ; Ŀ
 ;   Make an error handler.                                                
 ; 
  (defun *error* (shk)
   (write-line shk)
   (vl)
  (princ))
 ; Ŀ
 ;   Get a list of files in the current directory.                         
 ; 
  (setq dwglst (cadr (dirge nil)))
  (vu)
  (while (setq dwg (car dwglst))
         (setq dwglst (cdr dwglst))
         (if (/= (setq dwgbas (strcase (vl-filename-base dwg) t)) dwgnam)
             (progn
                  (print dwg)
                  (command "erase" "all" "")
                  (command ".insert" dwg "0,0" "1" "" "0")
                  (while (= 1 (getvar "cmdactive"))
                         (command ""))
                  (command ".zoom" "e")
                  (command ".zoom" "0.95x")
                  (command ".mslide" dwgbas))))
  (vl)
 (princ))