 ; Ŀ
 ;   Sq - space invaders maker.                                            
 ;   Copyright 2009 by Rocket Software Ltd.                                
 ;   Is it better to suggest that future uses may appear, or that a        
 ;   thing is worthwhile even if no practical use is likely?               
 ; 

 ; Ŀ
 ;   Pixiz - find the pixel size in drawing units.                         
 ;   Takes no arguments, calls nothing, returns a distance.                
 ; 
 (DEFUN PIXIZ (/ vsize scsize)
  (setq vsize (getvar "viewsize"))       ; view height in dwg units
  (setq scsize (getvar "screensize"))    ; view width and height in pixels
 (/ vsize (cadr scsize)))                ; 1 pixel in dwg units
 ; Ŀ
 ;   Pixiz end.                                                            
 ; 

 ; Ŀ
 ;   Sq - make a grblock.                                                  
 ;   Arguments: Pa, the upper left point.                                  
 ;              Rad, the side length.                                      
 ;              Colo, the colour.                                          
 ;              Disa, the length of a pixel in drawing units.              
 ;   Calls nothing, returns nothing.                                       
 ; 
 (DEFUN SQ (pul rad colo disa / reps pll)
  (setq pll (polar pul (* pi 1.5) rad))
 ; Ŀ
 ;   Grdraw the box.                                                       
 ; 
  (setq reps (fix (/ rad disa)))
  (repeat reps
          (grdraw pul pll colo)
          (setq pul (polar pul 0 disa))
          (setq pll (polar pll 0 disa)))
 (princ))
 ; Ŀ
 ;   Sq end.                                                               
 ; 

 ; Ŀ
 ;   Vad - draw a single invader.                                          
 ;   Arguments: Pa, a base point.                                          
 ;              Rad, the side length.                                      
 ;              Colo, the colour.                                          
 ;              Disa, the length of a pixel in drawing units.              
 ;              Vpat, the invader pattern.                                 
 ;              Vpat0, the existing invader pattern or nil.                
 ;              Offs, the offset of this  penis  from the previous one     
 ;              in multiples of Rad.                                       
 ;   Calls Sq.                                                             
 ;   Returns Nothing.                                                      
 ; 
 (DEFUN VAD (pa rad colo disa vpat vpat0 offs / lisnum sub0 sub num pos pa0)
  (setq pa0 pa)
 ; Ŀ
 ;   Part 1: for each value in Vpat, if there isn't a matching one in      
 ;   Vpat0 (offset by -Offs) then draw it.                                 
 ; 
  (setq lisnum 0)
  (while (setq sub (nth lisnum vpat))
         (if vpat0 (setq sub0 (nth lisnum vpat0)))
         (setq lisnum (1+ lisnum))
         (setq num 0)
         (while (setq pos (nth num sub))
                (setq num (1+ num))
                (if (or (null sub0)
                        (not (member (+ pos offs) sub0)))
                    (sq (polar pa 0 (* rad pos)) rad colo disa)))
         (setq pa (polar pa (* pi 1.5) rad)))
 ; Ŀ
 ;   Part 2: for each value in Vpat0, if there isn't a matching one in     
 ;   Vpat (offset by Offs) then undraw it.                                 
 ; 
  (setq pa pa0)
  (setq lisnum 0)
  (while (and vpat0 (setq sub0 (nth lisnum vpat0)))
         (setq sub (nth lisnum vpat))
         (setq lisnum (1+ lisnum))
         (setq num 0)
         (while (setq pos (nth num sub0))
                (setq num (1+ num))
                (if (not (member (- pos offs) sub))
                    (sq (polar pa 0 (* rad (- pos offs))) rad colo disa)))
         (setq pa (polar pa (* pi 1.5) rad)))
 (princ))
 ; Ŀ
 ;   Vad.                                                                  
 ; 

 ; Ŀ
 ;   Sq.                                                                   
 ; 
 (DEFUN C:SQ (/ colo rad disa pa vad1a vad1b)
  (setq colo -1)
  (setq rad (/ (getvar "viewsize") 100))
  (setq disa (pixiz))                     ; drawing units per pixel
  (setq rad (* disa (fix (/ rad disa))))
  (setq pa (getpoint "Target: "))
 ; Ŀ
 ;   Patterns.                                                             
 ; 
  (setq vad1a '((4 5) (3 4 5 6) (2 3 4 5 6 7) (1 2 4 5 7 8)
                (1 2 3 4 5 6 7 8) (2 4 5 7) (1 8) (2 7)))
  (setq vad1b '((4 5) (3 4 5 6) (2 3 4 5 6 7) (1 2 4 5 7 8)
                (1 2 3 4 5 6 7 8) (3 6) (2 4 5 7) (1 3 6 8)))
  (setq vad2a '((3 9) (4 8) (3 4 5 6 7 8 9) (2 3 5 6 7 9 10)
                (1 2 3 4 5 6 7 8 9 10 11) (1 2 3 4 5 6 7 8 9 10 11)
                (1 3 9 11) (4 5 7 8)))
  (setq vad2b '((3 9) (1 4 8 11) (1 3 4 5 6 7 8 9 11) (1 2 3 5 6 7 9 10 11)
                (1 2 3 4 5 6 7 8 9 10 11) (2 3 4 5 6 7 8 9 10)
                (3 9) (2 10)))
  (setq vad3a '((5 6 7 8) (2 3 4 5 6 7 8 9 10 11) (1 2 3 4 5 6 7 8 9 10 11 12)
                (1 2 3 6 7 10 11 12) (1 2 3 4 5 6 7 8 9 10 11 12)
                (3 4 5 8 9 10) (2 3 6 7 10 11)
                (3 4 9 10)))
  (setq vad3b '((5 6 7 8) (2 3 4 5 6 7 8 9 10 11) (1 2 3 4 5 6 7 8 9 10 11 12)
                (1 2 3 6 7 10 11 12) (1 2 3 4 5 6 7 8 9 10 11 12)
                (3 4 5 8 9 10) (3 4 6 7 9 10)
                (1 2 11 12)))
  (setq pbb pa)
  (vad pa rad colo disa vad1a nil 0)
  (repeat 32
   (command "delay" 84)
   (setq pa (polar pa 0 rad))
   (vad pa rad colo disa vad1b vad1a 1)
   (command "delay" 84)
   (setq pa (polar pa 0 rad))
   (vad pa rad colo disa vad1a vad1b 1))
  (vad pa rad colo disa vad1a nil 0)       ; final erase
  (setq pa pbb)
  (vad pa rad colo disa vad2a nil 0)
  (repeat 32
   (command "delay" 100)
   (setq pa (polar pa 0 rad))
   (vad pa rad colo disa vad2b vad2a 1)
   (command "delay" 100)
   (setq pa (polar pa 0 rad))
   (vad pa rad colo disa vad2a vad2b 1))
  (vad pa rad colo disa vad2a nil 0)       ; final erase
  (setq pa pbb)
  (vad pa rad colo disa vad3a nil 0)
  (repeat 32
   (command "delay" 100)
   (setq pa (polar pa 0 rad))
   (vad pa rad colo disa vad3b vad3a 1)
   (command "delay" 100)
   (setq pa (polar pa 0 rad))
   (vad pa rad colo disa vad3a vad3b 1))
  (vad pa rad colo disa vad3a nil 0)       ; final erase
 (princ))