 ; Ŀ
 ;   Subx - find xrefs in subdirectories, repath there.                    
 ;   Copyright 2011 - 2018 by Rocket Software Ltd.                         
 ;   May need editing.  Which the nice people at Rocket can do for you.    
 ;   What human invention ofers more ways to screw up that xrefs?          
 ;   Except guns, drugs, fast cars, glue, and the opposite sex.            
 ;   But if we leave out fun things, xrefs are pretty much on top.         
 ; 

 ; Ŀ
 ;   Xclis - Find all xref definitions in the block tables.                
 ;   Takes no arguments.                                                   
 ;   Returns a list of lists of strings:                                   
 ;   (("Blockname" "Status" "Filename") ...)                               
 ; 
 (DEFUN XCLIS (/ rew bldat sevnt reso blnam blpth namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (= 4 (logand 4 sevnt))
             (progn
                  (if (= 32 (logand 32 sevnt))
                      (setq reso ", Resolved")
                      (setq reso ", ** Not Resolved **"))
                  (setq reso (strcat reso " (" (itoa sevnt) "), "))
                  (setq blnam (cdr (assoc 2 bldat)))
                  (setq blpth (cdr (assoc 1 bldat)))
                  (setq namlst (cons (list blnam reso blpth) namlst)))))
 namlst)
 ; Ŀ
 ;   Xclis end.                                                            
 ; 

 ; Ŀ
 ;   Duche - check a list ((filename name_and_ path) ...) for duplicates.  
 ;   Arguments: Listn, a list.                                             
 ;   Calls nothing.                                                        
 ;   Returns a list.                                                       
 ; 
 (DEFUN DUCHE (listn / sub nama gnu sublis gnusub duplis)
  (while (setq sub (car listn))
         (setq listn (cdr listn))
         (setq nama (car sub))
         (if (setq gnu (assoc nama listn))
             (progn
                  (if (setq sublis (assoc nama duplis))
                      (progn
                           (setq gnusub (append sublis (list (cadr gnu))))
                           (setq duplis (subst gnusub sublis duplis)))
                      (progn
                           (setq gnusub (append sub (list (cadr gnu))))
                           (setq duplis (cons gnusub duplis)))))))
 duplis)
 ; Ŀ
 ;   Duche end.                                                            
 ; 

 ; Ŀ
 ;   Lime - get a list of files in a directory and its subdirectories.     
 ;   Arguments: Cdir, the directory in which to begin.                     
 ;              Patt, the wild card file name pattern.                     
 ;              Sport, if t then alphabetize the file names.               
 ;   Calls nothing, returns a list of filenames, each with a path.         
 ; 
 (DEFUN LIME (cdir patt sport / filist delist dirp gnulst nxdir gnudi nulist
                                                                      nufils)
  (setq filist (vl-directory-files cdir patt 1))
  (if (and sport filist)
      (setq filist (vl-sort filist '<)))
  (setq filist (mapcar '(lambda (fnam) (strcat cdir fnam)) filist))
  (setq delist (vl-directory-files cdir nil -1))
  (if sport (setq delist (vl-sort delist '<)))
  (while (setq dirp (car delist))
         (setq delist (cdr delist))
         (if (not (member dirp '("." "..")))
             (setq gnulst (append gnulst (list dirp)))))
  (setq delist (mapcar '(lambda (dnam) (strcat cdir dnam "\\")) gnulst))
  (while (setq nxdir (car delist))
         (setq delist (cdr delist))
         (setq gnudi (vl-directory-files nxdir nil -1))
         (if (and sport gnudi)
             (setq gnudi (vl-sort gnudi '<)))
         (setq nulist ())
         (while (setq dirp (car gnudi))
                (setq gnudi (cdr gnudi))
                (if (not (member dirp '("." "..")))
                    (setq nulist (append nulist (list dirp)))))
         (setq gnudi (mapcar '(lambda (dnam) (strcat nxdir dnam "\\")) nulist))
         (setq delist (append delist gnudi))
         (setq nufils (vl-directory-files nxdir patt 1))
         (if (and sport nufils)
             (setq nufils (vl-sort nufils '<)))
         (setq nufils (mapcar '(lambda (fnam) (strcat nxdir fnam)) nufils))
         (setq filist (append filist nufils)))
 filist)
 ; Ŀ
 ;   Lime end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Nopth - remove the path from a filename.                   
 ; 
 (DEFUN NOPTH (tt / pos)
  (setq pos (strlen tt))                          ; start at end of the string
  (while (< 0 pos)
          (if (or (= (substr tt pos 1) (chr 92))  ; if char = \
                  (= (substr tt pos 1) ":"))      ; if char = :
             (progn
                   (setq tt (substr tt (1+ pos))) ; then set tt to all after
                   (setq pos 1)))                 ;  and set pos to first
         (setq pos (1- pos)))                     ; set pos to previous
  tt)
 ; Ŀ
 ;   Nopth end.                                                            
 ; 

 ; Ŀ
 ;   Plinth: print each sublist in a list, one per line.                   
 ;   Arguments: Pint, a list.                                              
 ;   Recursive, returns nothing.                                           
 ; 
 (DEFUN PLINTH (pint / rint num)
  (setq num -1)
  (foreach rint pint
           (if (= (type rint) 'str)
               (if (zerop (setq num (1+ num)))
                   (write-line (strcat "\n" rint))
                   (write-line rint))
               (plinth rint)))
 (princ))
 ; Ŀ
 ;   Plinth end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Pthonl - remove everything but the path from a filename.   
 ; 
 (DEFUN PTHONL (tt / pos)
  (setq pos (strlen tt))                          ; start at end of the string
  (while (< 0 pos)
          (if (or (= (substr tt pos 1) (chr 92))  ; if char = \
                  (= (substr tt pos 1) ":"))      ; if char = :
             (progn
                   (setq tt (substr tt 1 pos))    ; then set tt to all before
                   (setq pos 1)))                 ;  and set pos to first
         (setq pos (1- pos)))                     ; set pos to previous
  tt)
 ; Ŀ
 ;   Pthonl end.                                                           
 ; 

 ; Ŀ
 ;   Splip - make a list of path\name into (name path\name) ...)           
 ;   Arguments: Alist, a list.                                             
 ;   Calls nopth.                                                          
 ;   Returns a list.                                                       
 ; 
 (DEFUN SPLIP (alist / num sub nama malist)
  (setq num 0)
  (while (and alist (setq sub (nth num alist)))
         (setq num (1+ num))
         (setq nama (nopth sub))
         (setq malist (cons (list nama sub) malist)))
 malist)
 ; Ŀ
 ;   Splip end.                                                            
 ; 

 ; Ŀ
 ;   Subx.                                                                 
 ; 
 (DEFUN C:SUBX (/ cdir *error* nam xrlis num xname lis gnu sub)
  (setvar "cmdecho" 0)
  (setq cdir (getvar "dwgprefix"))
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk)
  (setq nam (strcase (getvar "dwgname") t))
  (if regist (regist (strcat "***** Error in Subx.lsp, File: " nam)))
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Get a list of xrefs.                                                  
 ; 
  (setq xrlis (xclis))
 ; Ŀ
 ;   See if each one is available in a subdir.                             
 ;   This isn't strictly necessary as the xref files are going to be       
 ;   placed in a single directory, but it's more insanity resistant.       
 ; 
  (setq num 0)
  (while (and xrlis (setq xname (nth num xrlis)))
         (setq num (1+ num))
         (setq xname (car xname))
         (setq lis (lime cdir (strcat xname ".dwg") nil))
 ; Ŀ
 ;   Make lis from a flat name list into ((name name_and_path) ...)        
 ; 
         (setq lis (splip lis))
 ; Ŀ
 ;   Check for duplicates.                                                 
 ; 
         (if (setq gnu (duche lis))
             (plinth gnu)
             (write-line "No Duplicate Xref Files Found."))
 ; Ŀ
 ;   Re-path the xref.                                                     
 ; 
         (if (setq sub (car lis))
             (progn
                  (command ".xref" "path" xname (cadr sub))
                  (xreg "1" 27 t))
             (progn
                  (if regist (regist (strcat "*** Can't Find File For Xref: "
                                             xname)))
                  (write-line (strcat "Can't find file for " xname)))))
 (princ))