 ; Ŀ
 ;   Term - put an arrowhead on a line.                                    
 ;   Copyright 1994, 2001, 2010, 2011 by Rocket Software Ltd.              
 ;   Rocket - the barnacles of software.                                   
 ; 

 ; Ŀ
 ;   Emp - error handler.                                                  
 ; 
 (DEFUN EMP (shk /)
  (setq *error* esav)
  (setvar "osmode" osmo)
  (setvar "snapmode" snapp)
  (setvar "blipmode" blip)
  (command ".undo" "end")
  (if shk (write-line shk))
 (princ))
 ; Ŀ
 ;   Emp end.                                                              
 ; 

 ; Ŀ
 ;   Subroutine Term - put an arrowhead on a line.                         
 ;   Argument: Scalf, a scale factor.                                      
 ; 
 (DEFUN TERM (scalf / esav osmo snapp *error* blip disc lin ept layy aa bb
                                                                 ang s1 s2)
  (setvar "cmdecho" 0)
  (command ".undo" "be")
  (setq esav *error*)
  (setq *error* emp)
  (setq osmo (getvar "osmode"))
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
  (setq blip (getvar "blipmode"))
  (setvar "blipmode" 0)
 ; Ŀ
 ;   Load Misps.lsp, which contains the ps/ms scaling subroutines.         
 ; 
  (if (or (null wasp) (null misps))
      (if (null (load "misps" ()))
          (prompt "\n** The File Misps.lsp Is Not Available. **\n")))
 ; Ŀ
 ;   Get the scale, depending on which space we are in and other things.   
 ; 
  (if misps
      (setq disc (misps))
      (setq disc (getvar "dimscale")))
  (setq disc (* disc scalf (getvar "dimasz")))
  (setq ept (entsel "Pick a line: "))
  (if ept (setq lin (entget (car ept))))
  (if (= (cdr (assoc 0 lin)) "LINE")
      (progn
           (setq ept (cadr ept))
           (setq aa (cdr (assoc 10 lin)))
           (setq bb (cdr (assoc 11 lin)))
           (if (> (distance aa ept) (distance bb ept))
               (progn (setq ept aa) (setq aa bb) (setq bb ept)))
           (setq ang (angle aa bb))
           (setq s1 (polar aa ang disc))
           (setq s2 (polar s1 (+ ang (/ pi 2)) (/ disc 6)))
           (setq s1 (polar s2 (+ ang (* pi 1.5)) (/ disc 3)))
           (setvar "osmode" 0)
           (command "solid" s1 s2 aa "" "")
           (setvar "osmode" osmo)
           (setq entt (entget (entlast)))
           (cond ((and (assoc 62 entt) (assoc 62 lin))
                  (setq entt (subst (assoc 62 lin) (assoc 62 entt) entt)))
                 ((assoc 62 lin)
                  (setq entt (append entt (list (assoc 62 lin))))))
           (entmod (subst (assoc 8 lin) (assoc 8 entt) entt))))
  (emp ())
 (princ))
 ; Ŀ
 ;   Subroutine Term end.                                                  
 ; 

 ; Ŀ
 ;   T4.  (T3 is taken.)                                                   
 ; 
 (DEFUN C:T4 ()
  (term 4)
 (princ))

 ; Ŀ
 ;   T2.                                                                   
 ; 
 (DEFUN C:T2 ()
  (term 2)
 (princ))

 ; Ŀ
 ;   Term.                                                                 
 ; 
 (DEFUN C:TERM ()
  (term 1)
 (princ))