 ; Ŀ
 ;   Tile - repeatedly reblock a block for tesselations.                   
 ;   Copyright 2014, 2015 by Rocket Software Ltd.                          
 ;   Each time Tile is run it makes everything in the drawing which is     
 ;   not a block into the block Tess, with an insertion point of 0,0.      
 ;   The blocked entities are not changed.                                 
 ;   This can be used to incrementally make a tesselation.                 
 ;   Further elaborations are possible but would require more inputs ...   
 ;   Possibly a single shot selection of a block for insertion and name.   
 ;                                                                         
 ; 
 (DEFUN C:TILE (/ *error* pa ss blnam)
  (setvar "cmdecho" 0)
  (command ".undo" "be")
  (defun *error* (shk)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
   (if shk (print shk))
  (princ))
  (setq blnam "tess")  ; block name
  (setq pa "0,0")      ; base point
 ; Ŀ
 ;   Get everything in the drawing which isn't a block insertion.          
 ; 
  (setq ss (ssget "x" '((-4 . "<not") (0 . "insert") (-4 . "not>"))))
 ; Ŀ
 ;   See if the block already exists, in either case reblock it.           
 ; 
  (if (tblsearch "block" blnam)
      (command ".block" blnam "Y" pa ss "")
      (command ".block" blnam pa ss ""))
 ; Ŀ
 ;   Get the entities back.                                                
 ; 
  (command "oops")
 ; Ŀ
 ;   End neatly.                                                           
 ; 
  (command ".undo" "end")
 (princ))
