 ; Ŀ
 ;   Lcta - also does attributes.                                          
 ;   Tlay - put text, mtext, multileaders, etc. on the text layer.         
 ;   Copyright 2014, 2015 by Rocket Software Ltd.                          
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Relt - relayer text and attdefs in the block tables.       
 ; 
 (DEFUN RELT (gnulay / reww blok enam entt num goon nxt)
  (setq gnulay (strcase gnulay))
  (setq reww t)
  (while (setq blok (tblnext "block" reww))           ; head entity from table
         (setq reww ())
         (grtext -2 (cdr (assoc 2 blok)))
         (setq enam (cdr (assoc -2 blok)))            ; first ename after head
         (while (and enam (setq entt (entget enam)))
                (setq num 0)
                (setq goon t)
 ;               (if (member (cdr (assoc 0 entt)) '("ATTDEF" "TEXT" "MTEXT"))
 ; Just attdefs for now
                (if (member (cdr (assoc 0 entt)) '("ATTDEF"))
                    (while (and goon (setq nxt (nth num entt)))
                           (setq num (1+ num))
                           (if (and (= (car nxt) 8)
                                    (/= (strcase (cdr nxt)) gnulay))
                               (progn
                                    (setq goon ())
                                    (entmod (subst (cons 8 gnulay)
                                                   nxt entt))))))
                (setq enam (entnext enam))))
 (princ))
 ; Ŀ
 ;   Relt end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Upblot - relayer attributes in block insertions.           
 ; 
 (DEFUN UPBLOT (gnulay / ss len num enam entt asoc8)
  (setq gnulay (strcase gnulay))
  (if (setq ss (ssget "X" (list (cons 0 "INSERT") (cons 66 1))))
      (progn
           (setq len (strcat "/" (itoa (sslength ss))))
           (setq num 0)           
           (while (setq enam (ssname ss num))
                  (grtext -2 (strcat (itoa (setq num (1+ num))) len))
                  (while (/= "SEQEND" (cdr (assoc 0 (setq entt (entget (setq
                                                     enam (entnext enam)))))))
                         (if (and (setq asoc8 (assoc 8 entt))
                                  (/= (strcase (cdr asoc8)) gnulay))
                             (entmod (subst (cons 8 gnulay) asoc8 entt)))))))
 (princ))
 ; Ŀ
 ;   Upblot end.                                                           
 ; 

 ; Ŀ
 ;   Tlay - put text on the text layer.                                    
 ;   Copyright 2014, 2015 by Rocket Software Ltd.                          
 ;                                                                         
 ; 
 (DEFUN C:TLAY (/ *error* ss num enam entt cola)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (if shk (write-line shk))
 (princ))
 ; Ŀ
 ;   Make the text layer.                                                  
 ; 
  (if (null (tblsearch "layer" "text"))
      (command ".layer" "n" "text" "c" "2" "text" ""))
 ; Ŀ
 ;   Get all text entities.                                                
 ; 
  (setq ss (ssget "x" (list (cons 0 "text,mtext"))))
 ; Ŀ
 ;   Relayer them.                                                         
 ; 
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq num (1+ num))
         (setq entt (entget enam))
         (if (setq cola (assoc 62 entt))
             (setq entt (subst (cons 62 256) cola entt)))
         (entmod (subst (cons 8 "text") (assoc 8 entt) entt)))
  (if ss (command ".change" ss "" "p" "c" "bylayer" ""))
 ; Ŀ
 ;   Restore sysvars, end.                                                 
 ; 
  (*error* ())
 (princ))

 ; Ŀ
 ;   Lcta.                                                                 
 ; 
 (DEFUN C:LCTA (/ *error* ss num enam entt cola)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *error* (shk)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (if shk (write-line shk))
 (princ))
 ; Ŀ
 ;   Make the text layer.                                                  
 ; 
  (if (null (tblsearch "layer" "text"))
      (command ".layer" "n" "text" "c" "2" "text" ""))
 ; Ŀ
 ;   Get all text entities.                                                
 ; 
  (setq ss (ssget "x" (list (cons 0 "text,mtext,multileader"))))
 ; Ŀ
 ;   Relayer them.                                                         
 ; 
  (setq num 0)
  (while (and ss (setq enam (ssname ss num)))
         (setq num (1+ num))
         (setq entt (entget enam))
         (if (setq cola (assoc 62 entt))
             (setq entt (subst (cons 62 256) cola entt)))
         (entmod (subst (cons 8 "text") (assoc 8 entt) entt)))
  (if ss (command ".change" ss "" "p" "c" "bylayer" ""))
 ; Ŀ
 ;   Call Relt to relayer text, mtext and attdefs in the block tables.     
 ; 
  (relt "text")
 ; Ŀ
 ;   Relayer attributes in block insertions - these are not automatically  
 ;   updated when the block tables are changed.                            
 ; 
  (upblot "text")
 ; Ŀ
 ;   Restore sysvars, end.                                                 
 ; 
  (*error* ())
 (princ))
