 ; Ŀ
 ;   Tv - neatly rearrange a column of text.                               
 ;   Copyright 1999, 2002, 2005, 2006, 2010 by Rocket Software Ltd.        
 ;   Sloth hunting - it's fast and exciting.  Well, not really...          
 ; 

 ; Ŀ
 ;   Subroutine CI - grdraw circle maker.                                  
 ;   Arguments: Pa, the circle centre point.                               
 ;              Radd, the radius.                                          
 ;              Colo, the grdraw colour.                                   
 ; 
 (DEFUN CI (pa radd colo / reps angg incr pa1 pa2)
  (setq reps 32)
  (setq angg 0)
  (setq incr (/ pi (/ reps 2)))
  (setq pa1 (polar pa angg radd))
  (repeat reps
          (setq angg (+ angg incr))
          (setq pa2 (polar pa angg radd))
          (grdraw pa1 pa2 colo)
          (setq pa1 pa2))
 (princ))
 ; Ŀ
 ;   Ci end.                                                               
 ; 

 ; Ŀ
 ;   Cron - returns the corners of a text entity.                          
 ;   Arguments: Enam, a text entity ename.                                 
 ;              Offdis, the offset distance.                               
 ;   Rewritten 2010.10.10.                                                 
 ; 
 (DEFUN CRON (enam offdis / aa bb rota cc dd bheigt bwidth llangg lldist ll ul
                                                    lr ur xmax xmin ymax ymin)
  (setq aa (entget enam))
 ; Ŀ
 ;   The textbox function returns...hang on...from the notes below, a      
 ;   list containing the offset of the lower left point of the text from   
 ;   the 10 association point - typically 0,0,0 - and the offset of the    
 ;   upper right point from the ten point.  These are assumining that the  
 ;   text isn't obliqued or rotated, so if it is the program must adjust   
 ;   accordingly.  This program won't bother with obliquing, rotation is   
 ;   allowed.                                                              
 ; 
  (setq bb (textbox aa))
  (setq rota (cdr (assoc 50 aa)))
  (setq cc (car bb))                    ; ll offset from 10 of text
  (setq dd (cadr bb))                   ; ur offset from 10 of text
  (setq bheigt (- (cadr dd) (cadr cc)))
  (setq bwidth (- (car dd) (car cc)))
  (setq llangg (angle (list 0 0) cc))
  (setq lldist (distance (list 0 0) cc))
 ; Ŀ
 ;   Extract the real corner points of the text.                           
 ; 
  (setq ll (polar (cdr (assoc 10 aa)) (+ llangg rota) lldist))
  (setq ul (polar ll (+ rota (/ pi 2)) bheigt))
  (setq lr (polar ll rota bwidth))
  (setq ur (polar lr (+ rota (/ pi 2)) bheigt))
 ; Ŀ
 ;   Find the maximum and minimum X and Y points.  These may not be the    
 ;   same as the corners of the text box, since the text may be rotated.   
 ; 
  (setq xmax (max (car ul) (car ll) (car ur) (car lr)))
  (setq xmin (min (car ul) (car ll) (car ur) (car lr)))
  (setq ymax (max (cadr ul) (cadr ll) (cadr ur) (cadr lr)))
  (setq ymin (min (cadr ul) (cadr ll) (cadr ur) (cadr lr)))
  (setq xmax (+ xmax offdis))
  (setq xmin (- xmin offdis))
  (setq ymax (+ ymax offdis))
  (setq ymin (- ymin offdis))
 ; Ŀ
 ;   And return the max and min x and y list.                              
 ; 
 (list xmax xmin ymax ymin))
 ; Ŀ
 ;   Cron end.                                                             
 ; 

 ; Ŀ
 ;   Grout - Text/Attdef grdraw outliner.                                  
 ;   Arguments: SS, a selection set of textlike things.                    
 ;              Gbox, the grdraw colour, if nil then don't draw a box.     
 ;              Offdis, the offset distance for text.                      
 ;   Returns a list of four corner points, cw from top left.               
 ;   Rewritten 2010.10.10 to take Offdis as an argument.                   
 ; 
 (DEFUN GROUT (ss gbox offdis / num enam typ entt mxlst xmax xmin ymax ymin
                                                                ul ur lr ll)
  (setq num 0)
 ; Ŀ
 ;   Process selection set.                                                
 ; 
  (while (and ss (setq enam (ssname ss num)))
         (grtext -2 (itoa (setq num (1+ num))))
         (setq typ (cdr (assoc 0 (entget enam))))
         (if (= typ "INSERT")
             (while (/= (setq typ (cdr (assoc 0 (setq entt (entget
                                                (setq enam (entnext enam)))))))
                        "SEQEND")
                    (if (and (= typ "ATTRIB")
                             (/= (cdr (assoc 1 entt)) "")
                             (/= (cdr (assoc 1 entt)) " "))
                        (progn
                             (setq mxlst (cron enam offdis))
                             (if xmax
                                 (setq xmax (max xmax (car mxlst)))
                                 (setq xmax (car mxlst)))
                             (if xmin
                                 (setq xmin (min xmin (cadr mxlst)))
                                 (setq xmin (cadr mxlst)))
                             (if ymax
                                 (setq ymax (max ymax (caddr mxlst)))
                                 (setq ymax (caddr mxlst)))
                             (if ymin
                                 (setq ymin (min ymin (cadddr mxlst)))
                                 (setq ymin (cadddr mxlst)))))))
         (if (or (= typ "TEXT") (= typ "ATTDEF"))
             (progn
                  (setq mxlst (cron enam 0))
                  (if xmax
                      (setq xmax (max xmax (car mxlst)))
                      (setq xmax (car mxlst)))
                  (if xmin
                      (setq xmin (min xmin (cadr mxlst)))
                      (setq xmin (cadr mxlst)))
                  (if ymax
                      (setq ymax (max ymax (caddr mxlst)))
                      (setq ymax (caddr mxlst)))
                  (if ymin
                      (setq ymin (min ymin (cadddr mxlst)))
                      (setq ymin (cadddr mxlst))))))
 ; Ŀ
 ;   Make the corner point coordinates.                                    
 ; 
  (setq ul (list xmin ymax))
  (setq ur (list xmax ymax))
  (setq lr (list xmax ymin))
  (setq ll (list xmin ymin))
 ; Ŀ
 ;   Now draw the polyline around the outer extent points.                 
 ; 
  (if gbox
      (progn
           (grdraw ul ur gbox)
           (grdraw ur lr gbox)
           (grdraw lr ll gbox)
           (grdraw ll ul gbox)))
 (list ul ur lr ll))
 ; Ŀ
 ;   Grout end.                                                            
 ; 

 ; Ŀ
 ;   Movex - move an ss from one point to another while rotating it 360    
 ;   degrees.                                                              
 ;   Arguments: Pa, a base point.                                          
 ;              Gnupt, a new point.                                        
 ;              Ss, an ss of entities to move.                             
 ;              Jumps, the number of jumps in which to move the ss.        
 ;              Draw, the draw decorations flag.  If this is not true or   
 ;                    jumps = 1 then no temporary markers are drawn.       
 ;   Returns nothing of use.                                               
 ; 
 (DEFUN MOVEX (pa gnupt ss jumps draw / jumps dist angg rangl)
  (setq rad (/ (getvar "viewsize") 25))
  (setq dist (/ (distance pa gnupt) jumps))
  (setq angg (angle pa gnupt))
  (setq rangl angg)
  (repeat jumps
          (if (and draw (> jumps 1))
              (progn
                   (ci (polar pa (+ rangl (/ pi 2)) (* 1.5 rad)) (/ rad 2) 4)
                   (ci (polar pa (+ rangl (/ pi 2)) (* 7 dist)) dist 4)))
          (setq rangl (+ rangl (/ (* pi 4) jumps)))
          (command ".move" ss "" "0,0" (polar (list 0 0) angg dist))
          (if (> jumps 1) (command ".rotate" ss "" pa (/ 360.0 jumps)))
          (setq pa (polar pa angg dist))))
 ; Ŀ
 ;   Movex end.                                                            
 ; 

 ; Ŀ
 ;   VVB - vertically respace a column of text.                            
 ;   Takes two arguments - an ss and a centre point y coordinate.          
 ;   Returns nothing.                                                      
 ; 
 (DEFUN VVB (ss yins incr / txa enn nna ya txb yb txh yy nn yins)
  (while (setq txa (ssname ss 0))             ; first entity name
         (setq enn 1)                         ; entity to test - initialize
         (setq nna (entget txa))              ; the whole thing
         (setq ya (cdr (assoc 10 nna)))       ; Y insertion
 ; Ŀ
 ;   Find the highest entity.                                              
 ; 
         (while (setq txb (ssname ss enn))                 ; next entity
                (setq yb (cdr (assoc 10 (entget txb))))    ; Y insertion
                (if (> (cadr yb) (cadr ya))                ; if txb highest
                    (progn
                         (setq txa txb)                    ; next becomes txa
                         (setq nna (entget txa))           ; get whole thing
                         (setq ya (cdr (assoc 10 nna)))))  ; and Y insertion
                (setq enn (1+ enn)))                       ; next entity
 ; Ŀ
 ;   And move it.                                                          
 ; 
         (if (or (= (cdr (assoc 72 nna)) 2)
                 (= (cdr (assoc 72 nna)) 4)
                 (= (cdr (assoc 72 nna)) 1))
             (progn
                   (if (= (cdr (assoc 72 nna)) 4)
                       (progn
                             (setq txh (cdr (assoc 40 (entget (ssname ss 0)))))
                             (setq yy (cdr (assoc 11 nna)))
                             (setq nn (list (car yy) (+ (/ txh 2) yins)))
                             (command "move" txa "" yy nn))
                       (progn
                             (setq yy (cdr (assoc 11 nna)))
                             (setq nn (list (car yy) yins))
                             (command "move" txa "" yy nn))))
             (progn
                   (setq yy (cdr (assoc 10 nna)))
                   (setq nn (list (car yy) yins))
                   (command "move" txa "" yy nn)))
 ; Ŀ
 ;   Increment insertion point, remove entity from ss, loop.               
 ; 
         (setq yins (- yins incr))
         (ssdel txa ss))
 (princ))
 ; Ŀ
 ;   VVB end.                                                              
 ; 

 ; Ŀ
 ;   VBCX - centre rejustify a column of text.                             
 ;   Not currently used.                                                   
 ;   Saved in case need to make centre rather than middle rejustify the    
 ;   text, or if want to middle one line and centre > 1.                   
 ;   Takes two arguments - an ss and a centre point x coordinate.          
 ;   Returns zilch.                                                        
 ; 
 (DEFUN VBCX (ss xa / xa num enam entt pty)
  (setq num 0)
  (while (setq enam (ssname ss num))
         (setq num (1+ num))
         (setq entt (entget enam))
         (setq pty (cddr (assoc 10 entt)))
         (setq pa (cons xa pty))
         (setq entt (subst (cons 72 1) (assoc 72 entt) entt))
         (if (= typ "ATTDEF")
             (setq entt (subst (cons 74 0) (assoc 74 entt) entt))
             (setq entt (subst (cons 73 0) (assoc 73 entt) entt)))
         (entmod (subst (cons 11 pa) (assoc 11 entt) entt)))
 (princ))
 ; Ŀ
 ;   Vbcx end.                                                             
 ; 

 ; Ŀ
 ;   VBM - Centre rejustify a column of text.                              
 ;   Arguments: ss, the set of entities to rejustify.                      
 ;              Xa, the midlpoint x coordinate.                            
 ; 
 (DEFUN VBM (ss xa / num enam entt ten pty pa sp)
  (setq num 0)
  (while (setq enam (ssname ss num))
         (setq num (1+ num))
         (setq entt (entget enam))            ; get entity data
         (setq ten (cdr (assoc 10 entt)))     ; save 10 point
         (if (= typ "ATTDEF")
             (setq entt (subst (cons 74 0) (assoc 74 entt) entt))
             (setq entt (subst (cons 73 0) (assoc 73 entt) entt)))
         (entmod (subst (cons 72 4) (assoc 72 entt) entt))  ; change
         (setq entt (entget enam))            ; get changed edata
         (setq new10 (cdr (assoc 10 entt)))   ; new 10 point
         (setq dist (distance ten new10))     ; distance moved
         (setq angl (angle new10 ten))        ; and angle
         (setq new11 (cdr (assoc 11 entt)))   ; new middle point
         (setq new11 (polar new11 angl dist)) ; move middle as 10 was
         (entmod (subst (cons 11 new11) (assoc 11 entt) entt))
         (setq entt (entget enam))            ; get entity data
         (setq pty (cddr (assoc 11 entt)))    ; final middle y coord
         (setq pa (cons xa pty))              ; final middle point
         (entmod (subst (cons 11 pa) (assoc 11 entt) entt)))
 (princ))
 ; Ŀ
 ;   VBM end.                                                              
 ; 

 ; Ŀ
 ;   St1 - timer start.                                                    
 ; 
 (DEFUN ST1 (/ s)
  (setq s (getvar "date"))
  (setq t1 (* 86400.0 (- s (fix s))))
 (princ))
 ; Ŀ
 ;   St1 end.                                                              
 ; 

 ; Ŀ
 ;   Ct1 - timer end.                                                      
 ; 
 (DEFUN CT1 (/ s t2)
  (setq s (getvar "date"))
  (setq t2 (* 86400.0 (- s (fix s))))
 (rtos (- t2 t1) 2 1))
 ; Ŀ
 ;   Ct1 end.                                                              
 ; 

 ; Ŀ
 ;   Subroutine Tv - middle justify and, vertically respace, and move the  
 ;   centre of a block of text to a point.                                 
 ;   Arguments: ss, the ss of text/attdefs to neaten.                      
 ;              Ssav, another ss of the same things.                       
 ;              Cenu, the desired (new) centre point.                      
 ;              Incr, the vertical spacing distance.                       
 ;              Jumps, the number of jumps in which to move the ss.        
 ;              Draw, the draw decorations flag.  If this is not true or   
 ;                    jumps = 1 then no temporary markers are drawn.       
 ;   Calls Grout, Vbm, Vvb, and Movex.                                     
 ;   Returns nothing.                                                      
 ; 
 (DEFUN TV (ss ssav cenu incr jumps draw / osmo cc rr xa ya intime ptlist
                                           ptlst2 ul lr dista curcen mtime)
 ; Ŀ
 ;   Outline the text, save the corner points.                             
 ; 
  (setq ptlist (grout ss nil 0.5))
 ; Ŀ
 ;   Middle rejustify the ss.                                              
 ; 
  (vbm ss (cadr (assoc 10 (entget (ssname ss 0)))))
 ;(vbcx ss (cadr (assoc 10 (entget (ssname ss 0)))))
 ; Ŀ
 ;   And vertically respace it.                                            
 ; 
  (vvb ss (caddr (assoc 10 (entget (ssname ss 0)))) incr)
 ; Ŀ
 ;   Get the new corner points, don't outline the text.                    
 ; 
  (setq ptlst2 (grout ssav nil 0.5))
 ; Ŀ
 ;   Get the new overall text ss centre point.                             
 ; 
  (setq ul (car ptlst2))
  (setq lr (caddr ptlst2))
  (setq dista (distance ul lr))
  (setq curcen (list (/ (+ (car ul) (car lr)) 2)
                     (/ (+ (cadr ul) (cadr lr)) 2)))
 ; Ŀ
 ;   Move the new ss centre point to the box centre.                       
 ; 
  (movex curcen cenu ssav jumps draw)
 (princ))
 ; Ŀ
 ;   Subroutine Tv end.                                                    
 ; 

 ; Ŀ
 ;   Tv.                                                                   
 ; 
 (DEFUN C:TV (/ *error* ss blip ssav osmo cc rr xa ya cenu incr intime ptlist
                                             ptlst2 ul lr dista curcen mtime)
  (setvar "cmdecho" 0)
  (st1)
  (command "undo" "be")
  (setq osmo (getvar "osmode"))
  (setq blip (getvar "blipmode"))
  (setvar "blipmode" 0)
 ; Ŀ
 ;   Make an error handler.                                                
 ; 
  (defun *error* (shk)
   (if shk (write-line shk))
   (setvar "osmode" osmo)
   (setvar "blipmode" blip)
   (if (type command-s)
       (command-s ".undo" "end")
       (command ".undo" "end"))
  (princ))
 ; Ŀ
 ;   Get an ss of text and/or attdefs.                                     
 ; 
  (prompt "Pick text/attdefs to neaten: ")
  (if (setq ss (ssget '((-4 . "<or")
                        (0 . "text")
                        (0 . "attdef")
                        (-4 . "or>"))))
      (progn
           (setq ssav (ssget "p"))
 ; Ŀ
 ;   Find the desired vertical and horizontal centre point coordinates.    
 ; 
           (setvar "osmode" 32)
           (setq cc (getpoint "Pick corner 1: "))
           (setq rr (getpoint cc
                             "\nOther corner or <Return> to centre on 1:"))
           (if rr 
               (progn
                    (setq xa (/ (+ (car cc) (car rr)) 2))
                    (setq ya (/ (+ (cadr cc) (cadr rr)) 2)))
               (progn
                    (setq xa (car cc))
                    (setq ya (cadr cc))))
           (setq cenu (list xa ya))          ; new (desired) centre point
           (setvar "osmode" 0)
 ; Ŀ
 ;   Line spacing.                                                         
 ; 
           (setq incr (* 1.65 (cdr (assoc 40 (entget (ssname ss 0))))))
 ;         (setq incrp (getdist (list xa ya)
 ;                        (strcat "\nLine spacing <" (rtos incr 2 2) ">:")))
 ;         (if incrp (setq incr incrp))
 ; Ŀ
 ;   Save the data input time, restart the timer.                          
 ; 
           (setq intime (ct1))
           (st1)
 ; Ŀ
 ;   Call tv to rearrange things.                                          
 ; 
           (tv ss ssav cenu incr 60 t)))
 ; Ŀ
 ;   Calculate elapsed time, print the value.                              
 ; 
  (setq mtime (ct1))
  (write-line (strcat "\nOperator time: " intime " seconds, Program time: "
                      mtime " seconds."))
 ; Ŀ
 ;   Clean up and end.                                                     
 ; 
  (*error* ())
 (princ))
