 ; Ŀ
 ;   Global text size changer for specified sizes.                         
 ;   Copyright 1990, 2001, 2014 by Rocket Software Ltd.                    
 ;   Software that does what you actually want - and sometimes more.       
 ; 

 ; Ŀ
 ;   Cindi - mark each entity in an ss.                                    
 ;   Arguments: Ss, a selection set.                                       
 ;              Rad - the marker segment length.                           
 ;              Colo - the marker grdraw line colour.                      
 ; 
 (DEFUN CINDI (ss rad colo / len num so pa)
  (setq len (strcat "/" (itoa (sslength ss))))
  (setq num 0)
  (while (setq so (ssname ss num))
         (setq num (1+ num))
         (grtext -2 (strcat (itoa num) len))
         (setq pa (cdr (assoc 10 (entget so))))
         (mark pa rad colo))
 (princ))
 ; Ŀ
 ;   Cindi end.                                                            
 ; 

 ; Ŀ
 ;   Mark - mark a point.                                                  
 ;   Arguments: Pa - the point to mark.                                    
 ;              Rad - the marker segment length.                           
 ;              Colo - the marker grdraw line colour.                      
 ; 
 (DEFUN MARK (pa rad colo /)
  (grdraw (polar pa (/ pi 4) rad) (polar pa (* 1.25 pi) rad) colo)
  (grdraw (polar pa (* pi 0.75) rad) (polar pa (* pi 1.75) rad) colo)
 (princ))
 ; Ŀ
 ;   Mark end.                                                             
 ; 

 ; Ŀ
 ;   Radget - get a marker length.                                         
 ;   Arguments: Pt, the drag line start point.                             
 ;   Returns a real.                                                       
 ; 
 (DEFUN RADGET (pt / rad)
  (if (null pt) (setq pt (getvar "viewctr")))
  (if (null (setq rad (getdist pt "\nMarker length (<Return> for preset): ")))
      (setq rad (/ (getvar "viewsize") 25)))
 rad)
 ; Ŀ
 ;   Radget end.                                                           
 ; 

 ; Ŀ
 ;   Txs.                                                                  
 ; 
 (DEFUN C:TXS ( / ss num ohh nhh txa nn rad numth)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   Get the height to change.                                             
 ; 
  (setq ohh (getdist (strcat "Text height to change (in your opinion)"
                             " or <Return> to Select: ")))
  (if (null ohh)
      (progn
           (setq ohh (cdr (assoc 40 (entget (car (entsel "Example Text: "))))))
           (princ (rtos ohh))))
 ; Ŀ
 ;   Mark all text of the original height.                                 
 ; 
  (if (setq ss (ssget "X" (list (cons 0 "text,attdef") (cons 40 ohh))))
      (progn
           (setq rad (radget ()))
           (cindi ss rad 1)
 ; Ŀ
 ;   Get the new height.                                                   
 ; 
           (setq nhh (getdist "\nDesired height: "))
           (setq num 0)
           (setq numth 0)
           (while (setq txa (ssname ss num))
                  (setq num (1+ num))
                  (setq nn (entget txa))
                  (if (entmod (subst (cons 40 nhh) (assoc 40 nn) nn))
                      (progn
                           (setq numth (1+ numth))
                           (mark (cdr (assoc 10 nn)) (* rad 0.6) 2)))))
      (write-line "No Text Of That Height Found."))
 ; Ŀ
 ;   Sum up and end.                                                       
 ; 
  (cond ((< 0 num) (write-line (strcat (itoa num) "/"
                               (itoa numth) " line"
                               (if (< 0 numth) "s" "")
                               " resized.")))
        ((= 0 num) (write-line "No text of that height found.")))
 (princ))