 ; Ŀ
 ;   UD - Update dimension settings.                                       
 ;   Copyright 2001 by Rocket Software Ltd.                                
 ;   This is the complete set of dimvars from R15/2000i.                   
 ;   Those which don't seem relevant are commented out.                    
 ;                                                                         
 ;   This is a separate routine so that the settings can be updated        
 ;   with one command, but drawings which do not match these settings      
 ;   but which are alright aren't scrambled.                               
 ;                                                                         
 ; 
 (DEFUN C:UD ()
 ;(setvar "dimadec" 0)        ; angular dim. decimals
 ;(setvar "dimalt" 0)         ; on = display alternate units
 ;(setvar "dimaltd" 2)        ; decimal places in alternate units
 ;(setvar "dimaltf" 25.4000)  ; units x this = alternate units
 ;(setvar "dimaltrnd" 0.00)   ; alternate units roundoff
 ;(setvar "dimalttd" 2)       ; alternate units tolerances decimal places
 ;(setvar "dimalttz" 0)       ; zero suppression in tolerances
 ;(setvar "dimaltu" 2)        ; alternate units format (sci, decimal, etc.)
 ;(setvar "dimaltz" 0)        ; zero suppression in alternate units
 ;(setvar "dimapost" "")      ; alternate units pre/suffix ;(except angular)
  (setvar "dimaso" 1)         ; dims created as associative if on (1)
  (setvar "dimassoc" 2)       ; make real associative dimensions (2002+)
  (setvar "dimasz" 2.50)      ; arrowhead size
 ;(setvar "dimatfit" 3)       ; what to do if text & arrows won't fit
 ;(setvar "dimaunit" 0)       ; units format for angular
 ;(setvar "dimazin" 2)        ; angular units zero suppression ;(2=no trailing)
  (setvar "dimblk" "")        ; weird arrowhead block name
 ;(setvar "dimblk1" "")       ; arrowhead block 1 if 2 different used
 ;(setvar "dimblk2" "")       ; arrowhead block 2 if 2 different used
 ;(setvar "dimcen" 0)         ; centre mark sizefor circle dims ;(0 = none)
 ;(setvar "dimclrd" 0)        ; dim line, arrowhead, and leader colour
 ;(setvar "dimclre" 0)        ; extension line colour
 ;(setvar "dimclrt" 0)        ; dim text colour
 ;(setvar "dimdec" 4)         ; decimal places in main text
 ;(setvar "dimdle" 0.00)      ; dim line past ext line dist for oblique strokes
 ;(setvar "dimdli" 0.38)      ; line to line spacing in baseline dimensions
 ;(setvar "dimdsep" ".")      ; decimal separator if units are decimal
 ;(setvar "dimexe" 0.18)      ; extension line past dim line distance
 ;(setvar "dimexo" 0.06)      ; extension line end to origin point distance
 ;(setvar "dimfit" 3)         ; obsolete
 ;(setvar "dimfrac" 0)        ; 0 = horiz, 1 = diag, 3 = not stacked fractions
  (setvar "dimgap" 1)         ; text to dim line break, used in fit decision
 ;(setvar "dimjust" 0)        ; horizontal dim text justification
 ;(setvar "dimldrblk" "")     ; leader arrowhead blocks
 ;(setvar "dimlfac" 1.0000)   ; linear dim scale factor - used for PS?
 ;(setvar "dimlim" 0)         ; generate dimension limits as default text...?
 ;(setvar "dimlunit" 2)       ; dimension units - scientific, decimal, etc.
 ;(setvar "dimlwd" -2)        ; dim linewt: -3:bylay,-2:byblk, other =x 1/100mm
 ;(setvar "dimlwe" -2)        ; extension line lineweight - as above
 ;(setvar "dimpost" "")       ; "prefix<>suffix"
 ;(setvar "dimrnd" 0.00)      ; round off to this value ;(linear only)
 ;(setvar "dimsah" 0)         ; display arrowhead blocks
 ;(setvar "dimscale" 1.00)    ; don't mess with this - it varies by drawing
 ;(setvar "dimsd1" 0)         ; suppress first part of dimension line
 ;(setvar "dimsd2" 0)         ; suppress second part of dimension line
 ;(setvar "dimse1" 0)         ; suppress first extension line
 ;(setvar "dimse2" 0)         ; suppress second extension line
  (setvar "dimsho" 1)         ; update text as dimension is dragged - very good
 ;(setvar "dimsoxd" 0)        ; suppress dimension lines outside extens. lines?
 ;(setvar "dimstyle" "Standard") ; read only - change with dimstyle command
  (setvar "dimtad" 1)         ; text above dimension line - 1=above, 0=centre
 ;(setvar "dimtdec" 4)        ; primary units tolerance decimal places
 ;(setvar "dimtfac" 1.0000)   ; fraction and tolerance scale factor
  (setvar "dimtih" 1)         ; on=horiz. text, off=align with dim line
 ;(setvar "dimtix" 0)         ; force text inside dimension even if no room
 ;(setvar "dimtm" 0.00)       ; minimum tolerance limit
 ;(setvar "dimtmove" 0)       ; 0=move text with dim:1=add leader,2=move freely
 ;(setvar "dimtofl" 0)        ; draw dim line even if arrowheads are outside
 ;(setvar "dimtoh" 1)         ; if text outside dimension: off=align, on=horiz
 ;(setvar "dimtol" 0)         ; append tolerances to dimension
 ;(setvar "dimtolj" 1)        ; vert pos for tolerances 0:bottom,1:mid,2:top
 ;(setvar "dimtp" 0.00)       ; upper tolerance limit
 ;(setvar "dimtsz" 0.00)      ; oblique stroke size: 0=arrowheads, >0 = size
 ;(setvar "dimtvp" 0.0000)    ; text pos rel. to dim line if Dimtad off (1=on)
 ;(setvar "dimtxsty" "Standard") ; dimension text style
  (setvar "dimtxt" 2.5)       ; text height
 ;(setvar "dimtzin" 0)        ; tolerance zero suppression
 ;(setvar "dimunit" 2)        ; obsolete
 ;(setvar "dimupt" 0)         ; cursor positions dim text as well as dim line
  (setvar "dimzin" 8)         ; zero suppression - also affects rtos and angtos
 (princ))