 ; Ŀ
 ;   Vino - replace one att. in several blocks with sequential numbers.    
 ;   Vint - replace the string in several text entities with seq. numbers. 
 ;   Modified - now understands rows and columns.                          
 ;   Copyright 2000, 2002, 2003, 2011, 2013, 2015 by Rocket Software Ltd.  
 ;   Is any of this true?                                                  
 ; 

 ; Ŀ
 ;   Blog - get entities by row and column.                                
 ;   Arguments: Etyp, the entity type to get.                              
 ;   Calls Collx and Delis.                                                
 ;   Returns a list of entity names in spatial order.                      
 ; 
 (DEFUN BLOG (etyp / enampt enam entt blnam ss malist num sub gnulis)
 ; Ŀ
 ;   If we're doing blocks, get an example one.                            
 ; 
  (if (and (= (strcase etyp) "INSERT")
           (setq enampt (entsel "Example Block or <All>: "))
           (setq enam (car enampt))
           (setq entt (entget enam))
           (= (cdr (assoc 0 entt)) "INSERT")
           (= (cdr (assoc 66 entt)) 1))
      (setq blnam (cdr (assoc 2 entt))))
  (cond ((and entt (= (cdr (assoc 66 entt)) 1))
         (princ blnam))
        ((and entt (/= (cdr (assoc 66 entt)) 1))
         (write-line "That Block Didn't Have Any Attributes.")))
 ; Ŀ
 ;   Get entities.                                                         
 ; 
  (cond ((and blnam (= (strcase etyp) "INSERT"))
         (setq ss (ssget (list (cons 0 etyp) (cons 2 blnam)))))
        (t
         (setq ss (ssget (list (cons 0 etyp))))))
  (if ss
      (progn
 ; Ŀ
 ;   Call Collx to extract the entities into rows.                         
 ; 
          (setq malist (collx ss (getvar "dimscale")))
 ; Ŀ
 ;   Flatten the list of lists into one overall list, remove numbers.      
 ; 
          (setq num 0)
          (while (setq sub (nth num malist))
                 (setq num (1+ num))
                 (setq sub (reverse sub))
                 (setq gnulis (cons sub gnulis)))
          (setq malist (delis (reverse gnulis)))
          (setq num 0)
          (setq gnulis ())
          (while (setq sub (nth num malist))
                 (setq num (1+ num))
                 (if (= (type sub) 'ename)
                     (setq gnulis (cons sub gnulis))))))
 gnulis)
 ; Ŀ
 ;   Blog end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Collx: sort entities into rows.         2013.06.25         
 ;   This is hacky and could be combined with Colly to make a row or       
 ;   column sorter.                                                        
 ;   Text is sorted on the insertion, other entity types by ten point.     
 ;   Arguments: ss, an ss of entities to rowise.                           
 ;              Slop, a maximum acceptable slop distance.                  
 ;                                                                         
 ;   Calls: Horiz/Lowest, Vtol/Spit, Spit, and Liss.                       
 ;   Returns a list of lists: each sublist contains all the enames in a    
 ;   row in horizontal order, preceded by the average row y position.      
 ; 
 (DEFUN COLLX (ss slop / num enam entt ten xpos xlist xa totalx numofx sub
                                                                column malist)
 ; Ŀ
 ;   Make the ((y_insert ename) ...) list.                                 
 ; 
  (setq num 0)
  (while (setq enam (ssname ss num))
         (setq num (1+ num))
         (setq entt (entget enam))
         (if (member (cdr (assoc 0 entt)) '("TEXT" "ATTDEF"))
             (setq ten (spit entt))
             (setq ten (cdr (assoc 10 entt))))
         (setq xpos (cadr ten))
         (setq xlist (cons (list xpos enam) xlist)))
 ; Ŀ
 ;   Order the list Xlist by first value.                                  
 ; 
  (setq xlist (horiz xlist))
 ; Ŀ
 ;   Columnise:                                                            
 ;   Add to the first sublist until reach the cutoff difference in X pos,  
 ;   then start a new sublist, continue until run out of sublists.         
 ; 
  (setq xa (caar xlist))
  (setq num 0)
  (setq totalx 0)
  (setq numofx 0)
  (while (setq sub (nth num xlist))
         (setq num (1+ num))
         (setq xpos (car sub))
 ; Ŀ
 ;   If the y position is still within the y slop distance of the first    
 ;   one in the row, add the ename to the current row sublist.             
 ; 
         (if (<= (abs (- xpos xa)) slop)
             (progn
                  (setq numofx (1+ numofx))
                  (setq totalx (+ totalx xpos))
                  (setq column (cons (cadr sub) column)))
 ; Ŀ
 ;   If the x position is outside the slop distance then start a new       
 ;   column sublist.                                                       
 ; 
             (progn
                  (setq column (vtol (liss column) "x" t))
                  (setq column (cons (/ totalx numofx) column))
                  (setq malist (append malist (list column)))
                  (setq totalx xpos)
                  (setq numofx 1)
                  (setq xa xpos)
                  (setq column (list (cadr sub))))))
 ; Ŀ
 ;   There last column won't by definition set off the distance checker,   
 ;   so add it to malist.                                                  
 ; 
  (setq column (vtol (liss column) "x" t))
  (setq column (cons (/ totalx numofx) column))
  (setq malist (append malist (list column)))
 ; Ŀ
 ;   Return the list of lists.                                             
 ; 
 malist)
 ; Ŀ
 ;   Subroutine collx end.                                                 
 ; 

 ; Ŀ
 ;   Delis - make a list of lists of lists ... into a single list.         
 ;   Arguments: Alist, a list.                                             
 ;   Calls only itself (recursive.)                                        
 ;   Returns a list.                                                       
 ;   Updated January 30th, 2009 - the previous version is buggy.           
 ; 
 (DEFUN DELIS (alist / sub malist)
  (while (setq sub (car alist))
         (setq alist (cdr alist))
         (if (= (type sub) 'LIST)
             (setq malist (append malist (delis sub)))
             (setq malist (append malist (list sub)))))
 malist)
 ; Ŀ
 ;   Delis end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Horiz - put a list in order by the first number in each    
 ;   sublist.  Takes one argument, a list, which it returns in order       
 ;   from smallest to largest first element.                               
 ;   Rehashed 2007.10.02: the first number may not be a string.            
 ; 
 (DEFUN HORIZ (nexlst / low lowp nxtsub hrzlst newlst orderd)
  (while nexlst
        (setq low (lowest nexlst))                 ; lowest leading number
        (while (and nexlst (setq nxtsub (nth 0 nexlst)))
               (setq lowp (car nxtsub))
               (if (= 'str (type lowp)) (setq lowp (read lowp)))
               (if (equal low lowp)
                   (setq hrzlst (append hrzlst (list nxtsub)))
                   (setq newlst (append newlst (list nxtsub))))
               (setq nexlst (cdr nexlst)))          ; remove 1st ent from list
        (setq orderd (append orderd hrzlst))        ; add lev sublst to levels
        (setq hrzlst ())                            ; set to () for next loop
        (setq nexlst newlst)                        ; nexlst reconstituted
        (setq newlst ()))                           ; empty new list & reuse
  orderd)
 ; Ŀ
 ;   Horiz end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Liss: make a list of entity names into an ss.              
 ;   Arguments: Liz, a list of enames.                                     
 ;   Returns an ss.                                                        
 ; 
 (DEFUN LISS (liz / num ss enam)
  (setq num 0)
  (setq ss (ssadd))
  (while (setq enam (nth num liz))
         (ssadd enam ss)
         (setq num (1+ num)))
 ss)
 ; Ŀ
 ;   Subroutine Liss end.                                                  
 ; 

 ; Ŀ
 ;   Subroutine Lowest - find the smallest leading number in a sublist     
 ;   of the list Nexlst which is the sole argument.                        
 ;   Revised 2007.10.02 - leading numbers can be ints, reals, or number    
 ;   strings.                                                              
 ; 
 (DEFUN LOWEST (nexlst / num minlst neth carna)
  (setq num 0)
  (setq minlst (list min))
  (while (setq neth (nth num nexlst))
         (setq carna (car neth))
         (if (= 'str (type carna)) (setq carna (read carna)))
         (if neth (setq minlst (append minlst (list carna))))
         (setq num (1+ num)))
  (eval minlst))
 ; Ŀ
 ;   Lowest end.                                                           
 ; 

 ; Ŀ
 ;   Spit - returns the insertion point of the text entity whose data was  
 ;   passed as its sole argument.  Note that this is not necessarily the   
 ;   same as the 10 association code.                                      
 ; 
 (DEFUN SPIT (entt / xjust yjust)
  (setq xjust (cdr (assoc 72 entt)))
  (setq yjust (cdr (assoc 73 entt)))
  (if (or (/= xjust 0) (/= yjust 0))
      (cdr (assoc 11 entt))
      (cdr (assoc 10 entt))))
 ; Ŀ
 ;   Spit end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Vtol: returns a list of enames ordered entity position.    
 ;   Arguments: Ss, a selection set of entities to order.                  
 ;              Dir, a direction - if this is either "X" or "Y" then the   
 ;                   entities are assumed to be arrayed in that direction, 
 ;                   if anything else then the routine uses the direction  
 ;                   in which they are most spread out.                    
 ;              Insa, if T and the entity is text or an attribute then     
 ;                    sort based on the insertion point rather than the    
 ;                    ten point.                                           
 ;                                                                         
 ;   This is the latest version: 2006.10.05, which sorts text by           
 ;   insertion point rather than ten point and in which setting the        
 ;   direction to nil doesn't cause a crash.                               
 ;   Also it works with attdefs as well as text.                           
 ;   It should replace all other uses of Vtol and Stol.                    
 ;                                                                         
 ;   Revamped 2009.07.28 to use Apply rather than Eval Cons 'Max List etc. 
 ;   This is less elegant but removes the 256 entity limitation.           
 ;   Also added the ability to sort by either ten point or insertion.      
 ;                                                                         
 ; 
 (DEFUN VTOL (ss dir insa / xposnam yposnam numm ent entt ten xpos ypos xx yy
                            pn maxx minx maxy miny xdif ydif poslst posnam
                                                       direct pos lastt order)
  (setq xposnam ())                      ; initialize (xpos & name list) list
  (setq yposnam ())                      ; initialize (ypos & name list) list
 ; Ŀ
 ;   Now see if the entities are arranged horizontally or vertically.      
 ; 
  (setq numm 0)                             ; start at the ss beginning again
  (while (setq ent (ssname ss numm))
         (setq entt (entget ent))
         (if (and insa (member (cdr (assoc 0 entt)) '("TEXT" "ATTDEF")))
             (setq ten (spit entt))
             (setq ten (cdr (assoc 10 entt))))
         (setq xpos (car ten))
         (setq ypos (cadr ten))
         (setq xx (append xx (list xpos)))  ; add x insert to list
         (setq yy (append yy (list ypos)))  ; and y to y list
 ; Ŀ
 ;   Also make the position and name list.  Have to make one for the X     
 ;   values and one for the Ys and use the appropriate one later.          
 ; 
         (setq pn (cons xpos ent))
         (setq xposnam (append xposnam (list pn)))
         (setq pn (cons ypos ent))
         (setq yposnam (append yposnam (list pn)))
         (setq numm (1+ numm)))             ; next entity
 ; Ŀ
 ;   Now evaluate the four lists.  The result will be the max and min      
 ;   values for the X and Y lists.                                         
 ; 
  (setq maxx (apply 'max xx))
  (setq minx (apply 'min xx))
  (setq maxy (apply 'max yy))
  (setq miny (apply 'min yy))
  (setq xdif (- maxx minx))
  (setq ydif (- maxy miny))
 ; Ŀ
 ;   Set direction variables to match whichever direction was given in     
 ;   the argument, if it was nil then deduce a direction.                  
 ; 
  (cond ((and (= (type dir) 'STR)
              (= (strcase dir) "X"))
          (setq poslst xx)                ; positions from X coord list
          (setq posnam xposnam)           ; position & ename list with X coord
          (setq direct 'min))             ; edit from smallest to largest X
        ((and (= (type dir) 'STR)
              (= (strcase dir) "Y"))
         (setq poslst yy)
         (setq posnam yposnam)
         (setq direct 'max))
        (T
 ; Ŀ
 ;   The default case: figure it out yourself.                             
 ;   Set vert to T if vertical, nil if horizontal.                         
 ;   If not sure, assume vertical.                                         
 ;   Could set strip to Quit and thus do so...                             
 ; 
         (cond ((> xdif ydif)             ; if (Xmax - Xmin) > (Ymax - Ymin)
                (setq poslst xx)          ; positions from X coord list
                (setq posnam xposnam)     ; position & ename list with X coord
                (setq direct 'min))       ; edit from smallest to largest X
               ((< xdif ydif)
                (setq poslst yy)
                (setq posnam yposnam)
                (setq direct 'max))
               (T                         ; if not sure then call it vertical
                (setq poslst yy)
                (setq posnam yposnam)
                (setq direct 'max)))))
 ; Ŀ
 ;   Now make the list of enames in order by increasing X or decreasing Y  
 ;   coordinate depending on whether the array is horizontal or vertical.  
 ;   Already Have Posnam: a list of (list position ename).                 
 ;   Using the original list of either x or y positions, get the first or  
 ;   last as appropriate, extract the ename from Posnam using              
 ;   (cdr (assoc (largest Y or smallest X) posnam))                        
 ;   and append the ename to the end of the enames in order list: Order.   
 ;   Then remove that position from the position list.                     
 ; 
  (while (> (length poslst) 0)
 ; Ŀ
 ;   Get the largest Y or smallest X value in the position list.           
 ; 
         (setq maxx (apply direct poslst))
 ; Ŀ
 ;   Having found Maxx, want to remove that value from poslst.             
 ;   Get the list from Maxx on, and the position of Maxx within the list.  
 ; 
         (setq pos (- (length poslst)
                      (length (setq lastt (member maxx poslst)))))
 ; Ŀ
 ;   Get the list after maxx.                                              
 ; 
         (setq lastt (cdr lastt))
 ; Ŀ
 ;   And add the list members before maxx.                                 
 ;   One could use (cdr (member (reverse poslist))) but if there were two  
 ;   values the same in the list this would result in a longer rather      
 ;   than a shorter poslist.                                               
 ; 
         (setq pos (1- pos))     ; subtract one: nth is zero based
         (while (>= pos 0)
                (setq lastt (append (list (nth pos poslst)) lastt))
                (setq pos (1- pos)))
         (setq poslst lastt)      ; poslst becomes lastt
 ; Ŀ
 ;   Now get the matching ename from posnam and add it to the end of the   
 ;   order list.                                                           
 ; 
         (setq order (append order (list (cdr (assoc maxx posnam)))))
 ; Ŀ
 ;   If there are two entities with the same position then assoc will      
 ;   always return the first one.  Must delete the first one each time -   
 ;   subst (nil) for it.                                                   
 ; 
         (setq posnam (subst (list nil) (assoc maxx posnam) posnam)))
 order)
 ; Ŀ
 ;   Vtol end.                                                             
 ; 

 ; Ŀ
 ;   Blocked: subroutine to edit the terminal strip numbers.               
 ;   Order is the list of enames in order by position.                     
 ;   (Actually that part makes no sense in the current context...)         
 ; 
 (DEFUN BLOCKED (order attnam stanum incrmt pref suff / ppref pos enam esava
                                                                   ent vis)
  (setq pos 0)
  (while (setq esava (setq enam (nth pos order)))
         (setq pos (1+ pos))
         (setq ent (entget enam))
         (while (/= "SEQEND" (cdr (assoc 0 ent)))
                (if (and (= (cdr (assoc 0 ent)) "ATTRIB")
                         (or (= (cdr (assoc 2 ent)) attnam) ; if att to change
                             (= attnam " ")))               ; or change all
                    (progn
 ; Ŀ
 ;   Make the new number string.                                           
 ; 
                         (setq strnum (strcat pref (enoo stanum 2) suff))
                         (entmod (subst (cons 1 strnum) (assoc 1 ent) ent))
                         (setq stanum (+ incrmt stanum))))
                (setq ent (entget (setq enam (entnext enam)))))
         (entupd esava))
 stanum)
 ; Ŀ
 ;   Blocked end.                                                          
 ; 

 ; Ŀ
 ;   Subroutine Defau - return all tiles to their default values.          
 ; 
 (DEFUN DEFAU ()
  (set_tile "start" "1")
  (set_tile "increment" "1")
  (set_tile "prefix" "")
  (set_tile "suffix" ""))
 ; Ŀ
 ;   Defau end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Enok: see whether the various edit box values are ok.      
 ;   If so and the callback was the result of an <Enter> (Reason = 1),     
 ;   then return a list of the edit box values.                            
 ;   The Ok button returns two numbers: a 2 immediately followed by a 1.   
 ;   They are interpreted sequentially - the 2 doesn't block the 1.        
 ;                                                                         
 ;   Conditions for accepting the dialog box contents:                     
 ;   1. The Start box contains a number, and                               
 ;   2. the Increment box contains a number.                               
 ;   Anything is acceptable in the prefix and suffix boxes.                
 ; 
 (DEFUN ENOK (reason / start incr typs typi prefa suffa retlst)
  (setq start (get_tile "start"))
  (setq incr (get_tile "increment"))
  (setq typs (type (read start)))
  (setq typi (type (read incr)))
  (setq prefa (get_tile "prefix"))
  (setq suffa (get_tile "suffix"))
  (cond ((not (or (= typs 'INT) (= typs 'REAL)))
         (set_tile "enotext" "Start value is not a number."))
        ((not (or (= typi 'INT) (= typi 'REAL)))
         (set_tile "vinotext" "Increment value is not a number."))
        (t
         (set_tile "vinotext" "")
         (if (= reason 1)
             (progn
                  (setq retlst (list start incr prefa suffa))
                  (done_dialog)))))
 retlst)
 ; Ŀ
 ;   Enok end.                                                             
 ; 

 ; Ŀ
 ;   Enoo - trailing zero remover.                                         
 ;   Arguments: Num, a number.                                             
 ;              Placo, the number of decimal places to look for.           
 ;   Returns a string without zeros after the decimal point.               
 ; 
 (DEFUN ENOO (num placo / strnum strnump pnum lasdig)
  (if (equal (read (rtos num 2 placo)) 0) "0"
      (progn
           (setq strnump (setq strnum (rtos num 2 placo)))
           (setq pnum strnump)        ; for while initialization
           (while (= strnump pnum)
                  (setq pnum (substr strnump 1 (1- (strlen strnump))))
                  (setq lasdig (substr strnump (strlen strnump)))
                  (if (equal lasdig "0") (setq strnump pnum)))
           (if (equal lasdig ".") pnum strnum))))
 ; Ŀ
 ;   Enoo end.                                                             
 ; 

 ; Ŀ
 ;   Subroutine Enox - call a dialog box to get various values.            
 ; 
 (DEFUN ENOX (start incra prefa suffa / enolst)
  (setq dcl_id (load_dialog "vino.dcl"))
  (new_dialog "vino" dcl_id)            ; must come before data for box
  (action_tile "edit_ok" "(setq enolst (enok 1))")
  (action_tile "defaults" "(defau)")
  (action_tile "start" "(setq enolst (enok $reason))")
  (action_tile "increment" "(setq enolst (enok $reason))")
  (action_tile "prefix" "(setq enolst (enok $reason))")
  (action_tile "suffix" "(setq enolst (enok $reason))")
  (set_tile "start" start)
  (set_tile "increment" incra)
  (set_tile "prefix" prefa)
  (set_tile "suffix" suffa)
  (start_dialog)
  (unload_dialog dcl_id)
 enolst)
 ; Ŀ
 ;   Enox end.                                                             
 ; 

 ; Ŀ
 ;   Tocked: subroutine to edit the terminal strip numbers.                
 ;   Order is the list of enames in order by position.                     
 ;   (Actually that part makes no sense in the current context...)         
 ; 
 (DEFUN TOCKED (order stanum incrmt pref suff / ppref pos enam esava
                                                                   ent vis)
  (setq pos 0)
  (while (setq enam (nth pos order))
         (setq pos (1+ pos))
         (setq ent (entget enam))
 ; Ŀ
 ;   Make the new number string.                                           
 ; 
         (setq strnum (strcat pref (enoo stanum 2) suff))
         (entmod (subst (cons 1 strnum) (assoc 1 ent) ent))
         (setq stanum (+ incrmt stanum)))
 stanum)
 ; Ŀ
 ;   Tocked end.                                                           
 ; 

 ; Ŀ
 ;   Batter - replacement error handler.  Restores original values to      
 ;   attributes if something goes wrong.                                   
 ; 
 (DEFUN BATTER (shk / pos entt enam sublst vall)
  (setvar "snapmode" snapp)
  (setvar "pickstyle" picks)
  (setvar "osmode" osna)
  (if (and shk esav main)
      (progn
           (setq pos 0)
           (setq entt (entget (setq enam esav)))
           (while (/= (cdr (assoc 0 entt)) "SEQEND")
                  (setq enam (entnext enam))
                  (setq entt (entget enam))
                  (setq sublst (nth pos main))
                  (setq vall (cadr sublst))
                  (setq pos (1+ pos))
                  (entmod (subst (cons 1 vall) (assoc 1 entt) entt)))
           (entupd esav)))
  (command "undo" "end")
  (if shk (print shk))
 (princ))
 ; Ŀ
 ;   Batter end.                                                           
 ; 

 ; Ŀ
 ;   Vint - replace text with sequential numbers.                          
 ; 
 (DEFUN C:VINT (/ *error* snapp order enolst)
  (command "undo" "be")
  (setq *error* batter)
 ; Ŀ
 ;   Turn off group selection - otherwise entities in groups may           
 ;   be changed twice with bad things happening as a result.               
 ; 
  (setq picks (getvar "pickstyle"))
  (setvar "pickstyle" 0)
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
  (setq osna (getvar "osmode"))
  (setvar "osmode" 0)
  (setq order (blog "text"))             ; returns a list ordered by position
 ; Ŀ
 ;   Make default data values if there are no global ones.                 
 ; 
  (if (/= (type stanum) 'REAL) (setq stanum 1.0))
  (if (/= (type incrmt) 'REAL) (setq incrmt 1.0))
  (if (/= (type pref) 'STR) (setq pref ""))
  (if (/= (type suff) 'STR) (setq suff ""))
 ; Ŀ
 ;   Call the dialog box to get new values.                                
 ; 
  (if (setq enolst (enox (rtos stanum 2) (rtos incrmt 2) pref suff))
      (progn
           (setq stanum (float (read (nth 0 enolst))))
           (setq incrmt (read (nth 1 enolst)))
           (setq pref (nth 2 enolst))
           (setq suff (nth 3 enolst))
 ; Ŀ
 ;   Now call tocked to edit the text.                                     
 ; 
           (setq stanum (tocked order stanum incrmt pref suff))))
  (*error* nil)
 (princ))

 ; Ŀ
 ;   Vino.                                                                 
 ; 
 (DEFUN C:VINO (/ esav *error* snapp order main enam entt tagg vall sublst
                                                         attnam pos enolst)
  (command "undo" "be")
 ; Ŀ
 ;   Install the new error handler.                                        
 ; 
  (setq *error* batter)
 ; Ŀ
 ;   Turn off group selection - otherwise entities in groups may           
 ;   be changed twice with bad things happening as a result.               
 ; 
  (setq picks (getvar "pickstyle"))
  (setvar "pickstyle" 0)
  (setq snapp (getvar "snapmode"))
  (setvar "snapmode" 0)
  (setq osna (getvar "osmode"))
  (setvar "osmode" 0)
 ; Ŀ
 ;   Get a list of inserts ordered by position.                            
 ; 
  (setq order (blog "insert"))
  (setq main ())                   ; list of attribute values to restore
 ; Ŀ
 ;   Use the first insert in the ordered list Order to display the         
 ;   attribute tag names and ask which one to edit.                        
 ; 
  (while (and (car order)
              (null (assoc 66 (entget (car order)))))
         (setq order (cdr order)))
  (if (setq enam (car order))
      (setq entt (entget (setq esav enam))))
 ; Ŀ
 ;   Step through the insert, substituting the tag names for attribute     
 ;   values, save the original values so they can be restored.             
 ; 
  (if (and (= (cdr (assoc 0 entt)) "INSERT")
           (assoc 66 entt))
      (progn
           (while (/= (cdr (assoc 0 entt)) "SEQEND")
                  (setq enam (entnext enam))
                  (setq entt (entget enam))
                  (setq tagg (cdr (assoc 2 entt)))
                  (setq vall (cdr (assoc 1 entt)))
                  (if (and tagg vall)
                      (progn
                           (setq sublst (list tagg vall))
                           (setq main (append main (list sublst)))
                           (entmod (subst (cons 1 tagg)
                                          (cons 1 vall) entt)))))
           (entupd esav)
 ; Ŀ
 ;   Prompt for an attribute to edit, get the tag.                         
 ; 
           (if (setq attnam (nentsel
                            "\nAttribute to edit or <Return> for all: "))
               (progn
                    (setq attnam (cdr (assoc 2 (entget (car attnam)))))
                    (princ attnam))
               (progn
                    (setq attnam " ")
                    (write-line "Changing all attributes.")))
 ; Ŀ
 ;   Restore the original values to the block from the list Main.          
 ; 
           (setq entt (entget (setq enam esav)))
           (setq pos 0)
           (while (/= (cdr (assoc 0 entt)) "SEQEND")
                  (setq enam (entnext enam))
                  (setq entt (entget enam))
                  (setq sublst (nth pos main))
                  (setq vall (cadr sublst))
                  (setq pos (1+ pos))
                  (entmod (subst (cons 1 vall) (assoc 1 entt) entt)))
           (entupd esav)
 ; Ŀ
 ;   Make default data values if there are no global ones.                 
 ; 
           (if (/= (type stanum) 'REAL) (setq stanum 1.0))
           (if (/= (type incrmt) 'REAL) (setq incrmt 1.0))
           (if (/= (type pref) 'STR) (setq pref ""))
           (if (/= (type suff) 'STR) (setq suff ""))
 ; Ŀ
 ;   Call the dialog box to get new values.                                
 ; 
           (if (setq enolst (enox (rtos stanum 2) (rtos incrmt 2) pref suff))
               (progn
                    (setq stanum (float (read (nth 0 enolst))))
                    (setq incrmt (read (nth 1 enolst)))
                    (setq pref (nth 2 enolst))
                    (setq suff (nth 3 enolst))
 ; Ŀ
 ;   Now call blocked to edit the insertions.                              
 ; 
                    (if attnam 
                       (setq stanum (blocked order attnam stanum incrmt pref
                                             suff))
                       (prompt "*** No blocks with attributes. ***"))))))
 ; Ŀ
 ;   End so the pigs aren't killed by the impact.                          
 ; 
  (*error* nil)
 (princ))