 ; Ŀ
 ;   Wcasoc and Wcosac - assoc with wild cards.                            
 ;   Copyright 2010 - 2012 by Rocket Software Ltd.                         
 ;   A function could be written which allows wild cards in either the     
 ;   match string or the list.  Is this either useful or wise?             
 ; 

 ; Ŀ
 ;   WcAsoc - Assoc function with wild cards.                              
 ;   Arguments: Carra, a hypothetical leading string.                      
 ;              Lisa, a list of lists, possibly containing wild cards.     
 ;   In other words this thing is backwards - the leading string should    
 ;   contain the wild cards.                                               
 ;              Casa, case sensitive-p: t = yes, nil = no.                 
 ;   Won't crash if the leading atom in each list isn't a string, but      
 ;   may be baffled.                                                       
 ;   Returns a sublist or nil.                                             
 ; 
 (DEFUN WCASOC (carra lisa casa / sub num aso str)
  (if (null casa) (setq carra (strcase carra)))
  (setq num 0)
  (while (and (null aso) (setq sub (nth num lisa)))
         (setq num (1+ num))
         (setq str (car sub))
         (if (= (type str) 'STR)
             (progn
                  (if (null casa) (setq str (strcase str)))
                  (if (wcmatch carra str)
                      (setq aso sub)))))
 aso)
 ; Ŀ
 ;   WcAsoc end.                                                           
 ; 

 ; Ŀ
 ;   Wcosac - the other assoc function with wild cards.                    
 ;   Arguments: Carra, a leading string which may contain wild cards.      
 ;              Lisa, a list of lists.                                     
 ;              Casa, case sensitive-p: t = yes, nil = no.                 
 ;   Won't crash if the leading atom in each list isn't a string, but      
 ;   may be baffled.                                                       
 ;   Returns a sublist or nil.                                             
 ; 
 (DEFUN WCOSAC (carra lisa casa / sub num aso str)
  (if (null casa) (setq carra (strcase carra)))
  (setq num 0)
  (while (and (null aso) (setq sub (nth num lisa)))
         (setq num (1+ num))
         (setq str (car sub))
         (if (= (type str) 'STR)
             (progn
                  (if (null casa) (setq str (strcase str)))
                  (if (wcmatch str carra)
                      (setq aso sub)))))
 aso)
 ; Ŀ
 ;   Wcosac end.                                                           
 ; 

 ; Ŀ
 ;   Wcasoc - test function.                                               
 ; 
 (DEFUN C:WCASOC ()
  (setvar "cmdecho" 0)
  (setq lista '(("aaa*" 11) ("bbb*" 22) ("ccc" 33) ("dddd" 44)))
  (setq macth "aaabb")
  (print (wcasoc macth lista nil))
  (print (wcosac macth lista nil))
  (setq lista '(("aaa" 11) ("bbb" 22) ("ccc" 33) ("dddd" 44)))
  (setq macth "*a")
  (print (wcosac macth lista nil))
 (princ))