 ; Ŀ
 ;   Wrat - write attribute tags from a selected block to a file.          
 ;   Crat - write tags from a selected block and the block definition.     
 ;   Copyright 2011 by Rocket Software Ltd.                                
 ;   Note that the attributes in a block insertion aren't always the same  
 ;   those in the definition.                                              
 ; 

 ; Ŀ
 ;   Subroutine Grat - get a list of attribute tags from a block insert.   
 ;   Arguments: Enam, an insertion ename.                                  
 ;              Lcase, if t then lower case the tags.                      
 ;   Calls nothing, returns a list.                                        
 ; 
 (DEFUN GRAT (enam lcase / entt tagg atlas)
  (if (= (cdr (assoc 66 (entget enam))) 1)           ; if entities follow
      (while (/= (cdr (assoc 0 (setq entt (entget
                                    (setq enam (entnext enam)))))) "SEQEND")
             (setq tagg (cdr (assoc 2 entt)))
             (if lcase (setq tagg (strcase tagg t)))
             (setq atlas (cons tagg atlas))))
 (reverse atlas))
 ; Ŀ
 ;   Subroutine Grat end.                                                  
 ; 

 ; Ŀ
 ;   Maxstr - returns the length of the longest string in a list.          
 ;   Arguments: Llist, a list of strings.                                  
 ;   Returns a number.                                                     
 ; 
 (DEFUN MAXSTR (llist / num sub len maxlen)
  (setq num 0)
  (while (setq sub (nth num llist))
         (setq num (1+ num))
         (setq len (strlen sub))
         (if (or (null maxlen) (> len maxlen))
             (setq maxlen len)))
 maxlen)
 ; Ŀ
 ;   Maxstr end.                                                           
 ; 

 ; Ŀ
 ;   Subroutine Trag - get a list of att tags from a block definition.     
 ;   Arguments: Blnam, a block name.                                       
 ;              Lcase, if t then lower case the tags.                      
 ;   Calls nothing, returns a list.                                        
 ; 
 (DEFUN TRAG (blnam lcase / blok namm entt tagg atlas)
  (if (setq blok (tblsearch "block" blnam))       ; get head entity
      (progn
           (setq namm (cdr (assoc -2 blok)))      ; first ename after head
           (while namm                            ; while there is an entity
                  (setq entt (entget namm))       ; the whole thing
                  (if (= (cdr (assoc 0 entt)) "ATTDEF")
                      (progn
                           (setq tagg (cdr (assoc 2 entt)))
                           (if lcase (setq tagg (strcase tagg t)))
                           (setq atlas (cons tagg atlas))))
                  (setq namm (entnext namm)))))   ; next subentity ename
 (reverse atlas))
 ; Ŀ
 ;   Subroutine Trag end.                                                  
 ; 

 ; Ŀ
 ;   Wrat.                                                                 
 ; 
 (DEFUN C:WRAT (/ enampt enam entt blnam dira fn ff)
  (if (setq enampt (entsel "Block Insertion to File: "))
      (progn
           (setq enam (car enampt))
           (setq entt (entget enam))
           (setq blnam (cdr (assoc 2 entt)))
           (setq dira (getvar "dwgprefix"))
           (setq fn (strcat dira blnam ".txt"))
           (setq ff (open fn "a"))
           (write-line (strcase blnam) ff)
           (if (= (cdr (assoc 66 entt)) 1)           ; if entities follow
               (while (/= (cdr (assoc 0 (setq entt (entget
                                       (setq enam (entnext enam)))))) "SEQEND")
                      (write-line (strcase (cdr (assoc 2 entt)) t) ff)))
           (write-line "\n\n" ff)
           (if ff (close ff))))
 (princ))

 ; Ŀ
 ;   Crat.                                                                 
 ; 
 (DEFUN C:CRAT (/ enampt enam entt blnam atlist maxlen inlist dira fn ff num
                                                                    suba subi)
  (if (setq enampt (entsel "Block Insertion to File: "))
      (progn
           (setq enam (car enampt))
           (setq entt (entget enam))
           (setq blnam (cdr (assoc 2 entt)))
 ; Ŀ
 ;   Get the tag names from the insertion.                                 
 ; 
           (setq atlist (grat enam t))
           (setq maxlen (maxstr atlist))
 ; Ŀ
 ;   Get the tag names from the bloc tables.                               
 ; 
           (setq inlist (trag blnam t))
 ; Ŀ
 ;   Open a file, add the block name.                                      
 ; 
           (setq dira (getvar "dwgprefix"))
           (setq fn (strcat dira blnam ".txt"))
           (setq ff (open fn "a"))
           (write-line (strcase blnam) ff)
           (write-line "*Insert : Definition*" ff)
 ; Ŀ
 ;   Write the attribute tags in pairs.                                    
 ; 
           (setq num 0)
           (while (and (or (setq suba (nth num atlist))   ; one or the other
                           (setq subi (nth num inlist)))  ; but would rather
                       (or (setq subi (nth num inlist))   ; have both
                           (setq suba (nth num atlist)))) ; so check
                  (setq num (1+ num))
                  (if (null suba) (setq suba ""))
                  (if (null subi) (setq subi ""))
                  (while (< (strlen suba) maxlen)
                         (setq suba (strcat suba " ")))
                  (write-line (strcat suba " : " subi) ff))
           (write-line "\n\n" ff)
           (if ff (close ff))))
 (princ))

(princ)
