 ; Ŀ
 ;   Wzx: repath xrefs.                                                    
 ;   Copyright 2010 by Rocket Software Ltd.                                
 ;                                                                         
 ; 

 ; Ŀ
 ;   Chug - string substitution engine.  Takes the search string, the      
 ;   replacement string, and the target string as arguments, and returns   
 ;   the (possibly modified) target string and the number of changes made. 
 ; 
 (DEFUN CHUG (oldstr newstr exstr / pos chnum changd newlen oldlen chunk)
  (setq pos 1)
  (setq chnum 0)
  (setq changd ())
  (setq newlen (strlen newstr))
  (setq oldlen (strlen oldstr))
  (while (= oldlen (strlen (setq chunk (substr exstr pos oldlen))))
         (if (= chunk oldstr)
             (progn
                  (setq exstr (strcat (substr exstr 1 (1- pos))
                                       newstr
                                      (substr exstr (+ pos oldlen))))
                  (setq changd t)
                  (setq chnum (1+ chnum))
                  (setq pos (+ pos newlen)))
             (setq pos (1+ pos))))
 (list exstr chnum))
 ; Ŀ
 ;   Chug end.                                                             
 ; 

 ; Ŀ
 ;   Contx - Find all referenced xref definitions in the block tables.     
 ;   Takes no arguments.                                                   
 ;   Returns a list of lists: ((Blockname Filename)...)                    
 ; 
 (DEFUN CONTX (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (or (= 4 (logand 4 sevnt)) (= 8 (logand 8 sevnt)))
             (setq namlst (append namlst (list (list (cdr (assoc 2 bldat))
                                                   (cdr (assoc 1 bldat))))))))
 namlst)
 ; Ŀ
 ;   Contx end.                                                            
 ; 

 ; Ŀ
 ;   Wzx.                                                                  
 ; 
 (DEFUN C:WZX (/ xlist num xname patha gnupth)
  (setvar "cmdecho" 0)
 ; Ŀ
 ;   Save xref layer settings in the local drawing.                        
 ; 
  (setvar "visretain" 1)
 ; Ŀ
 ;   Get a list of all xrefs.                                              
 ; 
  (setq xlist (contx))
 ; Ŀ
 ;   Repath each one.                                                      
 ; 
  (setq num 0)
  (while (setq xname (nth num xlist))
         (setq num (1+ num))
 ; Ŀ
 ;   Get the block name and path.                                          
 ; 
         (setq patha (cadr xname))
         (setq xname (car xname))
 ; Ŀ
 ;   Make the new path string.                                             
 ; 
         (setq gnupth (chug "3d models" "4599 3d models" (strcase patha t)))
         (if (> (cadr gnupth) 0)
             (command "xref" "path" xname (car gnupth))))
 (princ))