 ; Ŀ
 ;   Xdir - if an xref is missing look for a copy in a specfied            
 ;   directory, make the directory if required, copy the file there.       
 ;   Copyright 2013 by Rocket Software Ltd.                                
 ;                                                                         
 ; 
 (DEFUN C:XDIR (/ rew bldat blnam nampth blpath sevnt)
  (setvar "cmdecho" 0)
  (setq rew t)
 ; Ŀ
 ;   Step through the block tables, only process unresolved Xrefs.         
 ; 
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
 ; Ŀ
 ;   If it's an xref and unresolved, fix it.                               
 ; 
         (if (and (= 4 (logand 4 sevnt))
                  (/= 32 (logand 32 sevnt)))
             (progn
                  (setq blnam (cdr (assoc 2 bldat)))
                  (write-line blnam)
                  (setq nampth (cdr (assoc 1 bldat)))
                  (setq blpath (vl-filename-directory nampth))
 ; Ŀ
 ;   If it's on the H: (or other) drive use the same place on M:.          
 ; 
                  (cond ((and (/= (strcat (substr blpath 1 1)) "M")
                              (= (substr blpath 2 1) ":"))
                         (setq blpath (strcat "M" (substr blpath 2)))
                         (setq nampth (strcat "M" (substr nampth 2))))
 ; Ŀ
 ;   If it doesn't have a path, put it in the current directory.           
 ; 
                        ((= blpath "")
                         (setq pref (getvar "dwgprefix"))
                         (setq blpath pref)
                         (setq nampth (strcat pref nampth)))
 ; Ŀ
 ;   If it has a relative path assume it's straight off the current        
 ;   directory.  (But check later.)                                        
 ; 
                        ((= (substr blpath 1 1) ".")
                         (setq pref (getvar "dwgprefix"))
                         (setq blpath (strcat pref (substr blpath 3)))
                         (setq nampth (strcat pref (substr nampth 3)))))
 ; Ŀ
 ;   Kill trailing backslashes, if any.                                    
 ; 
                  (if (= (substr blpath (strlen blpath)) "\\")
                      (setq blpath (substr blpath 1 (1- (strlen blpath)))))
 ; Ŀ
 ;   If the xref directory doesn't exist then make it.                     
 ; 
                  (if (null (findfile blpath))
                      (vl-mkdir blpath))
 ; Ŀ
 ;   Quit if the destination file exists.                                  
 ; 
                  (cond ((findfile nampth)
                         (print (strcat nampth " already exists.")))
 ; Ŀ
 ;   Quit if the file isn't available.                                     
 ; 
                        ((null (findfile (strcat "C:\\xrfs\\" blnam ".dwg")))
                         (write-line (strcat "\n" blnam
                                             " is not in c:\\xrfs.")))
 ; Ŀ
 ;   If the file is available in c:\xrfs and isn't in the final location   
 ;   then copy it there.                                                   
 ;   The xcopy command format is:                                          
 ;   (command "shell" "xcopy "c:\xana.lsp" "c:\tempura\"")                 
 ;   Shell and the command are in different double quotes, file names      
 ;   are in their own double quotes and also in the overall Xcopy ones,    
 ;   and you can't put the filename in the destination string or Xcopy     
 ;   will ask each time if it's a directory or a file.                     
 ;   (The destination should end with a backslash.)                        
 ; 
                        ((and (null (findfile nampth))
                              (findfile (strcat "C:\\xrfs\\" blnam ".dwg")))
                         (command "shell"
                                  (strcat "xcopy "
                                          "\"" "c:\\xrfs\\" blnam ".dwg\""
                                          " \"" blpath "\\\""))
                         (command "delay" 500)))
 ; Ŀ
 ;   If the file is where it should be then reload it.                     
 ;   Do this even if it wasn't just copied into place.                     
 ; 
                  (if (findfile nampth)
                      (progn
                           (prompt (strcat "\nUpdating " blnam "\n"))
                           (command "xref" "r" blnam))
                      (prompt (strcat "\nXref File "
                                       blnam " Is Missing.\n"))))))
 (princ))