 ; Ŀ
 ;   Xlis - write the names of all referenced xrefs to a file.             
 ;   Copyright 1997, 1998, 2000, 2011 by Rocket Software                   
 ;   Technology - fun stuff you could do if you didn't have more sense.    
 ; 

 ; Ŀ
 ;   Contx - Find all referenced xref definitions in the block tables.     
 ;   Takes no arguments.                                                   
 ;   Returns a list of lists: ((Blockname Filename)...)                    
 ; 
 (DEFUN CONTX (/ rew bldat sevnt namlst)
  (setq rew t)
  (while (setq bldat (tblnext "block" rew))
         (setq rew ())
         (setq sevnt (cdr (assoc 70 bldat)))
         (if (and (= 4 (logand 4 sevnt)) (= 32 (logand 32 sevnt)))
             (setq namlst (append namlst (list (list (cdr (assoc 2 bldat))
                                                   (cdr (assoc 1 bldat))))))))
 namlst)
 ; Ŀ
 ;   Contx end.                                                            
 ; 

 ; Ŀ
 ;   Nopath - returns the drawing name without the path or the extension.  
 ; 
 (DEFUN NOPATH (/ tt pos ff)
 ; Ŀ
 ;   Save this next bit in case we want the path too.                      
 ; 
 ; (setq tt (strcat (getvar "dwgprefix") (getvar "dwgname")))
 ; Ŀ
 ;   Get drawing name with path and set pointer Pos to end of string.      
 ; 
  (setq pos (strlen (setq tt (getvar "dwgname"))))  ; start at end of string
 ; Ŀ
 ;   Remove the path.                                                      
 ; 
  (while (< 0 pos)
          (if (or (= (substr tt pos 1) (chr 92))    ; if char = \
                  (= (substr tt pos 1) ":"))        ; if char = :
             (progn
                   (setq tt (substr tt (1+ pos)))   ; then set tt to all after
                   (setq pos 1)))                   ;  and set pos to first
         (setq pos (1- pos)))                       ; set pos to previous
 ; Ŀ
 ;   Remove the extension.                                                 
 ; 
  (if (= (substr (strcase tt t) (- (setq len (strlen tt)) 3)) ".dwg")
          (setq tt (substr tt 1 (- len 4))))
  tt)
 ; Ŀ
 ;   Nopath end.                                                           
 ; 

 ; Ŀ
 ;   Xlis.                                                                 
 ; 
 (DEFUN C:XLIS (/ xlst fn sub stra)
  (setvar "cmdecho" 0)
  (setq xlst (contx))
  (setq stra (nopath))
  (while (setq sub (car xlst))
         (setq xlst (cdr xlst))
         (setq stra (strcat stra "," (car sub))))
  (setq fn (open "c:/xrefs.csv" "a"))
  (write-line stra fn)
  (close fn)
 (princ))