 ; Ŀ
 ;   Zen - move entities from Rocket layers to a different standard.       
 ;   Copyright 1994, 1997, 2002, 2005, 2011, 2012 by Rocket Software Ltd.  
 ;                                                                         
 ; 

 ; Ŀ
 ;   Subroutine Callm - relayer block subentities in the block tables.     
 ; 
 (DEFUN CALLM (laylst / reww blok enam entt num goon nxt cdrnxt laysub)
  (setq reww t)
  (while (setq blok (tblnext "block" reww))           ; head entity from table
         (setq reww ())
         (grtext -2 (cdr (assoc 2 blok)))
         (setq enam (cdr (assoc -2 blok)))            ; first ename after head
         (while (and enam (setq entt (entget enam)))
                (setq num 0)
                (setq goon t)
                (while (and goon (setq nxt (nth num entt)))
                       (setq num (1+ num))
                       (if (and (= (car nxt) 8)
                                (setq cdrnxt (strcase (cdr nxt) t))
                                (setq laysub (cadr (assoc cdrnxt laylst))))
                           (progn
                                (setq goon ())
                                (entmod (subst (cons 8 laysub) nxt entt)))))
                (setq enam (entnext enam))))
 (princ))
 ; Ŀ
 ;   Callm end.                                                            
 ; 

 ; Ŀ
 ;   Subroutine Frenzy - relayer attributes in block insertions.           
 ; 
 (DEFUN FRENZY (laylst / ss len num enam esav entt asoc8 layy laysub gnulay)
  (if (setq ss (ssget "X" (list (cons 0 "INSERT") (cons 66 1))))
      (progn
           (setq len (strcat "/" (itoa (sslength ss))))
           (setq num 0)           
           (while (setq enam (setq esav (ssname ss num)))
                  (grtext -2 (strcat (itoa (setq num (1+ num))) len))
                  (while (/= "SEQEND" (cdr (assoc 0 (setq entt (entget (setq
                                                     enam (entnext enam)))))))
                         (if (and (setq asoc8 (assoc 8 entt))
                                  (setq layy (strcase (cdr asoc8) t))
                                  (setq laysub (assoc layy laylst)))
                             (progn
                                  (setq gnulay (cons 8 (cadr laysub)))
                                  (entmod (subst gnulay asoc8 entt)))))
                  (entupd esav))))
 (princ))
 ; Ŀ
 ;   Frenzy end.                                                           
 ; 

 ; Ŀ
 ;   Zen.                                                                  
 ; 
 (DEFUN C:ZEN (/ *error* laylst num sublst newlay oldlay ss)
  (setvar "cmdecho" 0)
  (command "undo" "be")
 ; Ŀ
 ;   Make a local error handler.                                           
 ; 
 (defun *terror* (shk /)
  (if shk (write-line shk))
  (if (type command-s)
      (command-s ".undo" "end")
      (command ".undo" "end"))
 (princ))
 ; Ŀ
 ;   Make sure Malaya is loaded.                                           
 ; 
 (if (null (load "malaya" ()))
     (progn
          (prompt "Unable to load Malaya.lsp")
          (exit)))
 ; Ŀ
 ;   Make a list of lists of old and new layers.                           
 ;   The format is: (Existing_Layer  New_Layer)                            
 ;   Existing layer names must be in lower case.                           
 ; 
  (setq laylst (list 

                     '("medium"           "Equipment")
                     '("eequip"           "Equipment")
                     '("equip"            "Equipment")
                     '("e_equipment"      "Equipment")
                     '("e_field_wiring"   "Field_Wiring")
                     '("e-misc"           "Misc")
                     '("e-symbols"        "Symbols")
                     '("text1"            "Text")
                     '("e-text1"          "Text")
                     '("e-text2"          "Text2")
                     '("e-text3"          "Text3")
                     '("vport"            "VP")

))
 ; Ŀ
 ;   Step through the list, fix each layer.                                
 ; 
  (setq num 0)
  (while (setq sublst (nth num laylst))
         (setq num (1+ num))
         (grtext -2 (setq oldlay (car sublst)))
         (setq newlay (cadr sublst))
 ; Ŀ
 ;   If the new layer doesn't exist then rename the old layer and make     
 ;   sure the properties are correct.                                      
 ; 
         (cond ((and (tblsearch "layer" oldlay)
                     (null (tblsearch "layer" newlay)))
                (command "rename" "layer" oldlay newlay)
                (malaya newlay))
 ; Ŀ
 ;   If the new layer exists then update the properties and move           
 ;   everything on the old layer to it.                                    
 ; 
               ((and (tblsearch "layer" oldlay)
                     (tblsearch "layer" newlay))
                (malaya newlay)
                (if (setq ss (ssget "X" (list (cons 8 oldlay))))
                    (command "change" ss "" "P" "La" newlay "")))))
 ; Ŀ
 ;   Now go through the block tables, change any subentity on an old       
 ;   layer to the corresponding new one.                                   
 ; 
  (callm laylst)
 ; Ŀ
 ;   Relayer attributes in block insertions - these are not automatically  
 ;   updated when the block tables are changed.                            
 ; 
  (frenzy laylst)
 ; Ŀ
 ;   Purge each old layer.                                                 
 ; 
  (setq num 0)
  (while (setq sublst (nth num laylst))
         (setq num (1+ num))
         (grtext -2 (setq oldlay (car sublst)))
         (command "-purge" "layer" oldlay "n"))
 ; Ŀ
 ;   End neatly.                                                           
 ; 
  (command "undo" "end")
 (princ))